// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph.CallRecords
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Call Record.
    /// </summary>
    [JsonConverter(typeof(Microsoft.Graph.DerivedTypeConverter<CallRecord>))]
    public partial class CallRecord : Microsoft.Graph.Entity
    {
    
        /// <summary>
        /// Gets or sets end date time.
        /// UTC time when the last user left the call. The DateTimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("endDateTime")]
        public DateTimeOffset? EndDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets join web url.
        /// Meeting URL associated to the call. May not be available for a peerToPeer call record type.
        /// </summary>
        [JsonPropertyName("joinWebUrl")]
        public string JoinWebUrl { get; set; }
    
        /// <summary>
        /// Gets or sets last modified date time.
        /// UTC time when the call record was created. The DatetimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("lastModifiedDateTime")]
        public DateTimeOffset? LastModifiedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets modalities.
        /// List of all the modalities used in the call. Possible values are: unknown, audio, video, videoBasedScreenSharing, data, screenSharing, unknownFutureValue.
        /// </summary>
        [JsonPropertyName("modalities")]
        public IEnumerable<Modality> Modalities { get; set; }
    
        /// <summary>
        /// Gets or sets organizer.
        /// The organizing party's identity.
        /// </summary>
        [JsonPropertyName("organizer")]
        public Microsoft.Graph.IdentitySet Organizer { get; set; }
    
        /// <summary>
        /// Gets or sets participants.
        /// List of distinct identities involved in the call.
        /// </summary>
        [JsonPropertyName("participants")]
        public IEnumerable<Microsoft.Graph.IdentitySet> Participants { get; set; }
    
        /// <summary>
        /// Gets or sets start date time.
        /// UTC time when the first user joined the call. The DatetimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("startDateTime")]
        public DateTimeOffset? StartDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets type.
        /// Indicates the type of the call. Possible values are: unknown, groupCall, peerToPeer, unknownFutureValue.
        /// </summary>
        [JsonPropertyName("type")]
        public CallType? Type { get; set; }
    
        /// <summary>
        /// Gets or sets version.
        /// Monotonically increasing version of the call record. Higher version call records with the same ID includes additional data compared to the lower version.
        /// </summary>
        [JsonPropertyName("version")]
        public Int64? Version { get; set; }
    
        /// <summary>
        /// Gets or sets sessions.
        /// List of sessions involved in the call. Peer-to-peer calls typically only have one session, whereas group calls typically have at least one session per participant. Read-only. Nullable.
        /// </summary>
        [JsonPropertyName("sessions")]
        public ICallRecordSessionsCollectionPage Sessions { get; set; }

        /// <summary>
        /// Gets or sets sessionsNextLink.
        /// </summary>
        [JsonPropertyName("sessions@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string SessionsNextLink { get; set; }
    
    }
}

