// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph.CallRecords
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type PstnCallLogRow.
    /// </summary>
    [JsonConverter(typeof(Microsoft.Graph.DerivedTypeConverter<PstnCallLogRow>))]
    public partial class PstnCallLogRow
    {

        /// <summary>
        /// Gets or sets callDurationSource.
        /// The source of the call duration data. If the call uses a third-party telecommunications operator via the Operator Connect Program, the operator may provide their own call duration data. In this case, the property value is operator. Otherwise, the value is microsoft.
        /// </summary>
        [JsonPropertyName("callDurationSource")]
        public PstnCallDurationSource? CallDurationSource { get; set; }
    
        /// <summary>
        /// Gets or sets calleeNumber.
        /// Number dialed in E.164 format.
        /// </summary>
        [JsonPropertyName("calleeNumber")]
        public string CalleeNumber { get; set; }
    
        /// <summary>
        /// Gets or sets callerNumber.
        /// Number that received the call for inbound calls or the number dialed for outbound calls. E.164 format.
        /// </summary>
        [JsonPropertyName("callerNumber")]
        public string CallerNumber { get; set; }
    
        /// <summary>
        /// Gets or sets callId.
        /// Call identifier. Not guaranteed to be unique.
        /// </summary>
        [JsonPropertyName("callId")]
        public string CallId { get; set; }
    
        /// <summary>
        /// Gets or sets callType.
        /// Whether the call was a PSTN outbound or inbound call and the type of call such as a call placed by a user or an audio conference.
        /// </summary>
        [JsonPropertyName("callType")]
        public string CallType { get; set; }
    
        /// <summary>
        /// Gets or sets charge.
        /// Amount of money or cost of the call that is charged to your account.
        /// </summary>
        [JsonPropertyName("charge")]
        public Decimal? Charge { get; set; }
    
        /// <summary>
        /// Gets or sets conferenceId.
        /// ID of the audio conference.
        /// </summary>
        [JsonPropertyName("conferenceId")]
        public string ConferenceId { get; set; }
    
        /// <summary>
        /// Gets or sets connectionCharge.
        /// Connection fee price.
        /// </summary>
        [JsonPropertyName("connectionCharge")]
        public Decimal? ConnectionCharge { get; set; }
    
        /// <summary>
        /// Gets or sets currency.
        /// Type of currency used to calculate the cost of the call (ISO 4217).
        /// </summary>
        [JsonPropertyName("currency")]
        public string Currency { get; set; }
    
        /// <summary>
        /// Gets or sets destinationContext.
        /// Whether the call was domestic (within a country or region) or international (outside a country or region) based on the user's location.
        /// </summary>
        [JsonPropertyName("destinationContext")]
        public string DestinationContext { get; set; }
    
        /// <summary>
        /// Gets or sets destinationName.
        /// Country or region dialed.
        /// </summary>
        [JsonPropertyName("destinationName")]
        public string DestinationName { get; set; }
    
        /// <summary>
        /// Gets or sets duration.
        /// How long the call was connected, in seconds.
        /// </summary>
        [JsonPropertyName("duration")]
        public Int32? Duration { get; set; }
    
        /// <summary>
        /// Gets or sets endDateTime.
        /// Call end time.
        /// </summary>
        [JsonPropertyName("endDateTime")]
        public DateTimeOffset? EndDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets id.
        /// Unique call identifier. GUID.
        /// </summary>
        [JsonPropertyName("id")]
        public string Id { get; set; }
    
        /// <summary>
        /// Gets or sets inventoryType.
        /// User's phone number type, such as a service of toll-free number.
        /// </summary>
        [JsonPropertyName("inventoryType")]
        public string InventoryType { get; set; }
    
        /// <summary>
        /// Gets or sets licenseCapability.
        /// The license used for the call.
        /// </summary>
        [JsonPropertyName("licenseCapability")]
        public string LicenseCapability { get; set; }
    
        /// <summary>
        /// Gets or sets operator.
        /// The telecommunications operator which provided PSTN services for this call. This may be Microsoft, or it may be a third-party operator via the Operator Connect Program.
        /// </summary>
        [JsonPropertyName("operator")]
        public string Operator { get; set; }
    
        /// <summary>
        /// Gets or sets startDateTime.
        /// Call start time.
        /// </summary>
        [JsonPropertyName("startDateTime")]
        public DateTimeOffset? StartDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets tenantCountryCode.
        /// Country code of the tenant, ISO 3166-1 alpha-2.
        /// </summary>
        [JsonPropertyName("tenantCountryCode")]
        public string TenantCountryCode { get; set; }
    
        /// <summary>
        /// Gets or sets usageCountryCode.
        /// Country code of the user, ISO 3166-1 alpha-2.
        /// </summary>
        [JsonPropertyName("usageCountryCode")]
        public string UsageCountryCode { get; set; }
    
        /// <summary>
        /// Gets or sets userDisplayName.
        /// Display name of the user.
        /// </summary>
        [JsonPropertyName("userDisplayName")]
        public string UserDisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets userId.
        /// Calling user's ID in Graph. GUID. This and other user info will be null/empty for bot call types (ucap_in, ucap_out).
        /// </summary>
        [JsonPropertyName("userId")]
        public string UserId { get; set; }
    
        /// <summary>
        /// Gets or sets userPrincipalName.
        /// UserPrincipalName (sign-in name) in Azure Active Directory. This is usually the same as user's SIP Address, and can be same as user's e-mail address.
        /// </summary>
        [JsonPropertyName("userPrincipalName")]
        public string UserPrincipalName { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
