// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph.CallRecords
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Segment.
    /// </summary>
    public partial class Segment : Microsoft.Graph.Entity
    {
    
        /// <summary>
        /// Gets or sets callee.
        /// Endpoint that answered this segment.
        /// </summary>
        [JsonPropertyName("callee")]
        public Endpoint Callee { get; set; }
    
        /// <summary>
        /// Gets or sets caller.
        /// Endpoint that initiated this segment.
        /// </summary>
        [JsonPropertyName("caller")]
        public Endpoint Caller { get; set; }
    
        /// <summary>
        /// Gets or sets end date time.
        /// UTC time when the segment ended. The DateTimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("endDateTime")]
        public DateTimeOffset? EndDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets failure info.
        /// Failure information associated with the segment if it failed.
        /// </summary>
        [JsonPropertyName("failureInfo")]
        public FailureInfo FailureInfo { get; set; }
    
        /// <summary>
        /// Gets or sets media.
        /// Media associated with this segment.
        /// </summary>
        [JsonPropertyName("media")]
        public IEnumerable<Media> Media { get; set; }
    
        /// <summary>
        /// Gets or sets start date time.
        /// UTC time when the segment started. The DateTimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("startDateTime")]
        public DateTimeOffset? StartDateTime { get; set; }
    
    }
}

