// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph.CallRecords
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type CallRecordSessionsCollectionRequestBuilder.
    /// </summary>
    public partial class CallRecordSessionsCollectionRequestBuilder : Microsoft.Graph.BaseRequestBuilder, ICallRecordSessionsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new CallRecordSessionsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="Microsoft.Graph.IBaseClient"/> for handling requests.</param>
        public CallRecordSessionsCollectionRequestBuilder(
            string requestUrl,
            Microsoft.Graph.IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ICallRecordSessionsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ICallRecordSessionsCollectionRequest Request(IEnumerable<Microsoft.Graph.Option> options)
        {
            return new CallRecordSessionsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ISessionRequestBuilder"/> for the specified CallRecordSession.
        /// </summary>
        /// <param name="id">The ID for the CallRecordSession.</param>
        /// <returns>The <see cref="ISessionRequestBuilder"/>.</returns>
        public ISessionRequestBuilder this[string id]
        {
            get
            {
                return new SessionRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
