// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph.CallRecords
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type SessionSegmentsCollectionRequestBuilder.
    /// </summary>
    public partial class SessionSegmentsCollectionRequestBuilder : Microsoft.Graph.BaseRequestBuilder, ISessionSegmentsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new SessionSegmentsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="Microsoft.Graph.IBaseClient"/> for handling requests.</param>
        public SessionSegmentsCollectionRequestBuilder(
            string requestUrl,
            Microsoft.Graph.IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ISessionSegmentsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ISessionSegmentsCollectionRequest Request(IEnumerable<Microsoft.Graph.Option> options)
        {
            return new SessionSegmentsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ISegmentRequestBuilder"/> for the specified SessionSegment.
        /// </summary>
        /// <param name="id">The ID for the SessionSegment.</param>
        /// <returns>The <see cref="ISegmentRequestBuilder"/>.</returns>
        public ISegmentRequestBuilder this[string id]
        {
            get
            {
                return new SegmentRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
