// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph.ExternalConnectors
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ExternalConnectionItemsCollectionRequestBuilder.
    /// </summary>
    public partial class ExternalConnectionItemsCollectionRequestBuilder : Microsoft.Graph.BaseRequestBuilder, IExternalConnectionItemsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ExternalConnectionItemsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="Microsoft.Graph.IBaseClient"/> for handling requests.</param>
        public ExternalConnectionItemsCollectionRequestBuilder(
            string requestUrl,
            Microsoft.Graph.IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IExternalConnectionItemsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IExternalConnectionItemsCollectionRequest Request(IEnumerable<Microsoft.Graph.Option> options)
        {
            return new ExternalConnectionItemsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IExternalItemRequestBuilder"/> for the specified ExternalConnectionExternalItem.
        /// </summary>
        /// <param name="id">The ID for the ExternalConnectionExternalItem.</param>
        /// <returns>The <see cref="IExternalItemRequestBuilder"/>.</returns>
        public IExternalItemRequestBuilder this[string id]
        {
            get
            {
                return new ExternalItemRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
