// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph.ExternalConnectors
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ExternalConnectionOperationsCollectionRequestBuilder.
    /// </summary>
    public partial class ExternalConnectionOperationsCollectionRequestBuilder : Microsoft.Graph.BaseRequestBuilder, IExternalConnectionOperationsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ExternalConnectionOperationsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="Microsoft.Graph.IBaseClient"/> for handling requests.</param>
        public ExternalConnectionOperationsCollectionRequestBuilder(
            string requestUrl,
            Microsoft.Graph.IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IExternalConnectionOperationsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IExternalConnectionOperationsCollectionRequest Request(IEnumerable<Microsoft.Graph.Option> options)
        {
            return new ExternalConnectionOperationsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IConnectionOperationRequestBuilder"/> for the specified ExternalConnectionConnectionOperation.
        /// </summary>
        /// <param name="id">The ID for the ExternalConnectionConnectionOperation.</param>
        /// <returns>The <see cref="IConnectionOperationRequestBuilder"/>.</returns>
        public IConnectionOperationRequestBuilder this[string id]
        {
            get
            {
                return new ConnectionOperationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
