// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph.ExternalConnectors
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ExternalConnectionRequestBuilder.
    /// </summary>
    public partial class ExternalConnectionRequestBuilder : Microsoft.Graph.EntityRequestBuilder, IExternalConnectionRequestBuilder
    {

        /// <summary>
        /// Constructs a new ExternalConnectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="Microsoft.Graph.IBaseClient"/> for handling requests.</param>
        public ExternalConnectionRequestBuilder(
            string requestUrl,
            Microsoft.Graph.IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IExternalConnectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IExternalConnectionRequest Request(IEnumerable<Microsoft.Graph.Option> options)
        {
            return new ExternalConnectionRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Groups.
        /// </summary>
        /// <returns>The <see cref="IExternalConnectionGroupsCollectionRequestBuilder"/>.</returns>
        public IExternalConnectionGroupsCollectionRequestBuilder Groups
        {
            get
            {
                return new ExternalConnectionGroupsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("groups"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Items.
        /// </summary>
        /// <returns>The <see cref="IExternalConnectionItemsCollectionRequestBuilder"/>.</returns>
        public IExternalConnectionItemsCollectionRequestBuilder Items
        {
            get
            {
                return new ExternalConnectionItemsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("items"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Operations.
        /// </summary>
        /// <returns>The <see cref="IExternalConnectionOperationsCollectionRequestBuilder"/>.</returns>
        public IExternalConnectionOperationsCollectionRequestBuilder Operations
        {
            get
            {
                return new ExternalConnectionOperationsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("operations"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Schema.
        /// </summary>
        /// <returns>The <see cref="ISchemaRequestBuilder"/>.</returns>
        public ISchemaRequestBuilder Schema
        {
            get
            {
                return new SchemaRequestBuilder(this.AppendSegmentToRequestUrl("schema"), this.Client);
            }
        }
    
    }
}
