// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph.ExternalConnectors
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IIdentityRequest.
    /// </summary>
    public partial interface IIdentityRequest : Microsoft.Graph.IBaseRequest
    {
        /// <summary>
        /// Creates the specified Identity using POST.
        /// </summary>
        /// <param name="identityToCreate">The Identity to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Identity.</returns>
        System.Threading.Tasks.Task<Identity> CreateAsync(Identity identityToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Identity using POST and returns a <see cref="GraphResponse{Identity}"/> object.
        /// </summary>
        /// <param name="identityToCreate">The Identity to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Identity}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Identity>> CreateResponseAsync(Identity identityToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Identity.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Identity and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Identity.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Identity.</returns>
        System.Threading.Tasks.Task<Identity> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Identity and returns a <see cref="GraphResponse{Identity}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Identity}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Identity>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Identity using PATCH.
        /// </summary>
        /// <param name="identityToUpdate">The Identity to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="Microsoft.Graph.ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Identity.</returns>
        System.Threading.Tasks.Task<Identity> UpdateAsync(Identity identityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Identity using PATCH and returns a <see cref="GraphResponse{Identity}"/> object.
        /// </summary>
        /// <param name="identityToUpdate">The Identity to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="Microsoft.Graph.ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Identity}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Identity>> UpdateResponseAsync(Identity identityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Identity using PUT.
        /// </summary>
        /// <param name="identityToUpdate">The Identity object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Identity> PutAsync(Identity identityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Identity using PUT and returns a <see cref="GraphResponse{Identity}"/> object.
        /// </summary>
        /// <param name="identityToUpdate">The Identity object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Identity}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Identity>> PutResponseAsync(Identity identityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityRequest Expand(Expression<Func<Identity, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityRequest Select(Expression<Func<Identity, object>> selectExpression);

    }
}
