// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type AccessPackageAssignmentRequestRequirements.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<AccessPackageAssignmentRequestRequirements>))]
    public partial class AccessPackageAssignmentRequestRequirements
    {

        /// <summary>
        /// Gets or sets allowCustomAssignmentSchedule.
        /// Indicates whether the requestor is allowed to set a custom schedule.
        /// </summary>
        [JsonPropertyName("allowCustomAssignmentSchedule")]
        public bool? AllowCustomAssignmentSchedule { get; set; }
    
        /// <summary>
        /// Gets or sets isApprovalRequiredForAdd.
        /// Indicates whether a request to add must be approved by an approver.
        /// </summary>
        [JsonPropertyName("isApprovalRequiredForAdd")]
        public bool? IsApprovalRequiredForAdd { get; set; }
    
        /// <summary>
        /// Gets or sets isApprovalRequiredForUpdate.
        /// Indicates whether a request to update must be approved by an approver.
        /// </summary>
        [JsonPropertyName("isApprovalRequiredForUpdate")]
        public bool? IsApprovalRequiredForUpdate { get; set; }
    
        /// <summary>
        /// Gets or sets policyDescription.
        /// The description of the policy that the user is trying to request access using.
        /// </summary>
        [JsonPropertyName("policyDescription")]
        public string PolicyDescription { get; set; }
    
        /// <summary>
        /// Gets or sets policyDisplayName.
        /// The display name of the policy that the user is trying to request access using.
        /// </summary>
        [JsonPropertyName("policyDisplayName")]
        public string PolicyDisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets policyId.
        /// The identifier of the policy that these requirements are associated with. This identifier can be used when creating a new assignment request.
        /// </summary>
        [JsonPropertyName("policyId")]
        public string PolicyId { get; set; }
    
        /// <summary>
        /// Gets or sets schedule.
        /// Schedule restrictions enforced, if any.
        /// </summary>
        [JsonPropertyName("schedule")]
        public EntitlementManagementSchedule Schedule { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
