// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Access Review Instance Decision Item.
    /// </summary>
    public partial class AccessReviewInstanceDecisionItem : Entity
    {
    
        /// <summary>
        /// Gets or sets access review id.
        /// The identifier of the accessReviewInstance parent. Supports $select. Read-only.
        /// </summary>
        [JsonPropertyName("accessReviewId")]
        public string AccessReviewId { get; set; }
    
        /// <summary>
        /// Gets or sets applied by.
        /// The identifier of the user who applied the decision. Read-only.
        /// </summary>
        [JsonPropertyName("appliedBy")]
        public UserIdentity AppliedBy { get; set; }
    
        /// <summary>
        /// Gets or sets applied date time.
        /// The timestamp when the approval decision was applied. The DatetimeOffset type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.  Supports $select. Read-only.
        /// </summary>
        [JsonPropertyName("appliedDateTime")]
        public DateTimeOffset? AppliedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets apply result.
        /// The result of applying the decision. Possible values: New, AppliedSuccessfully, AppliedWithUnknownFailure, AppliedSuccessfullyButObjectNotFound and ApplyNotSupported. Supports $select, $orderby, and $filter (eq only). Read-only.
        /// </summary>
        [JsonPropertyName("applyResult")]
        public string ApplyResult { get; set; }
    
        /// <summary>
        /// Gets or sets decision.
        /// Result of the review. Possible values: Approve, Deny, NotReviewed, or DontKnow. Supports $select, $orderby, and $filter (eq only).
        /// </summary>
        [JsonPropertyName("decision")]
        public string Decision { get; set; }
    
        /// <summary>
        /// Gets or sets justification.
        /// Justification left by the reviewer when they made the decision.
        /// </summary>
        [JsonPropertyName("justification")]
        public string Justification { get; set; }
    
        /// <summary>
        /// Gets or sets principal.
        /// Every decision item in an access review represents a principal's access to a resource. This property represents details of the principal. For example, if a decision item represents access of User 'Bob' to Group 'Sales' - The principal is 'Bob' and the resource is 'Sales'. Principals can be of two types - userIdentity and servicePrincipalIdentity. Supports $select. Read-only.
        /// </summary>
        [JsonPropertyName("principal")]
        public Identity Principal { get; set; }
    
        /// <summary>
        /// Gets or sets principal link.
        /// Link to the principal object. For example: https://graph.microsoft.com/v1.0/users/a6c7aecb-cbfd-4763-87ef-e91b4bd509d9. Read-only.
        /// </summary>
        [JsonPropertyName("principalLink")]
        public string PrincipalLink { get; set; }
    
        /// <summary>
        /// Gets or sets recommendation.
        /// A system-generated recommendation for the approval decision based off last interactive sign-in to tenant. Recommend approve if sign-in is within thirty days of start of review. Recommend deny if sign-in is greater than thirty days of start of review. Recommendation not available otherwise. Possible values: Approve, Deny, or NoInfoAvailable. Supports $select, $orderby, and $filter (eq only). Read-only.
        /// </summary>
        [JsonPropertyName("recommendation")]
        public string Recommendation { get; set; }
    
        /// <summary>
        /// Gets or sets resource.
        /// Every decision item in an access review represents a principal's access to a resource. This property represents details of the resource. For example, if a decision item represents access of User 'Bob' to Group 'Sales' - The principal is Bob and the resource is 'Sales'. Resources can be of multiple types. See accessReviewInstanceDecisionItemResource. Read-only.
        /// </summary>
        [JsonPropertyName("resource")]
        public AccessReviewInstanceDecisionItemResource Resource { get; set; }
    
        /// <summary>
        /// Gets or sets resource link.
        /// A link to the resource. For example, https://graph.microsoft.com/v1.0/servicePrincipals/c86300f3-8695-4320-9f6e-32a2555f5ff8. Supports $select. Read-only.
        /// </summary>
        [JsonPropertyName("resourceLink")]
        public string ResourceLink { get; set; }
    
        /// <summary>
        /// Gets or sets reviewed by.
        /// The identifier of the reviewer. Supports $select. Read-only.
        /// </summary>
        [JsonPropertyName("reviewedBy")]
        public UserIdentity ReviewedBy { get; set; }
    
        /// <summary>
        /// Gets or sets reviewed date time.
        /// The timestamp when the review decision occurred. Supports $select. Read-only.
        /// </summary>
        [JsonPropertyName("reviewedDateTime")]
        public DateTimeOffset? ReviewedDateTime { get; set; }
    
    }
}

