// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type ArchivedPrintJob.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ArchivedPrintJob>))]
    public partial class ArchivedPrintJob
    {

        /// <summary>
        /// Gets or sets acquiredByPrinter.
        /// True if the job was acquired by a printer; false otherwise. Read-only.
        /// </summary>
        [JsonPropertyName("acquiredByPrinter")]
        public bool? AcquiredByPrinter { get; set; }
    
        /// <summary>
        /// Gets or sets acquiredDateTime.
        /// The dateTimeOffset when the job was acquired by the printer, if any. Read-only.
        /// </summary>
        [JsonPropertyName("acquiredDateTime")]
        public DateTimeOffset? AcquiredDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets completionDateTime.
        /// The dateTimeOffset when the job was completed, canceled or aborted. Read-only.
        /// </summary>
        [JsonPropertyName("completionDateTime")]
        public DateTimeOffset? CompletionDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets copiesPrinted.
        /// The number of copies that were printed. Read-only.
        /// </summary>
        [JsonPropertyName("copiesPrinted")]
        public Int32? CopiesPrinted { get; set; }
    
        /// <summary>
        /// Gets or sets createdBy.
        /// The user who created the print job. Read-only.
        /// </summary>
        [JsonPropertyName("createdBy")]
        public UserIdentity CreatedBy { get; set; }
    
        /// <summary>
        /// Gets or sets createdDateTime.
        /// The dateTimeOffset when the job was created. Read-only.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets id.
        /// The archived print job's GUID. Read-only.
        /// </summary>
        [JsonPropertyName("id")]
        public string Id { get; set; }
    
        /// <summary>
        /// Gets or sets printerId.
        /// The printer ID that the job was queued for. Read-only.
        /// </summary>
        [JsonPropertyName("printerId")]
        public string PrinterId { get; set; }
    
        /// <summary>
        /// Gets or sets processingState.
        /// The print job's final processing state. Read-only.
        /// </summary>
        [JsonPropertyName("processingState")]
        public PrintJobProcessingState? ProcessingState { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
