// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type AudioConferencing.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<AudioConferencing>))]
    public partial class AudioConferencing
    {

        /// <summary>
        /// Gets or sets conferenceId.
        /// The conference id of the online meeting.
        /// </summary>
        [JsonPropertyName("conferenceId")]
        public string ConferenceId { get; set; }
    
        /// <summary>
        /// Gets or sets dialinUrl.
        /// A URL to the externally-accessible web page that contains dial-in information.
        /// </summary>
        [JsonPropertyName("dialinUrl")]
        public string DialinUrl { get; set; }
    
        /// <summary>
        /// Gets or sets tollFreeNumber.
        /// </summary>
        [JsonPropertyName("tollFreeNumber")]
        public string TollFreeNumber { get; set; }
    
        /// <summary>
        /// Gets or sets tollFreeNumbers.
        /// List of toll-free numbers that are displayed in the meeting invite.
        /// </summary>
        [JsonPropertyName("tollFreeNumbers")]
        public IEnumerable<string> TollFreeNumbers { get; set; }
    
        /// <summary>
        /// Gets or sets tollNumber.
        /// </summary>
        [JsonPropertyName("tollNumber")]
        public string TollNumber { get; set; }
    
        /// <summary>
        /// Gets or sets tollNumbers.
        /// List of toll numbers that are displayed in the meeting invite.
        /// </summary>
        [JsonPropertyName("tollNumbers")]
        public IEnumerable<string> TollNumbers { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
