// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Calendar Group.
    /// </summary>
    public partial class CalendarGroup : Entity
    {
    
        /// <summary>
        /// Gets or sets change key.
        /// Identifies the version of the calendar group. Every time the calendar group is changed, ChangeKey changes as well. This allows Exchange to apply changes to the correct version of the object. Read-only.
        /// </summary>
        [JsonPropertyName("changeKey")]
        public string ChangeKey { get; set; }
    
        /// <summary>
        /// Gets or sets class id.
        /// The class identifier. Read-only.
        /// </summary>
        [JsonPropertyName("classId")]
        public Guid? ClassId { get; set; }
    
        /// <summary>
        /// Gets or sets name.
        /// The group name.
        /// </summary>
        [JsonPropertyName("name")]
        public string Name { get; set; }
    
        /// <summary>
        /// Gets or sets calendars.
        /// The calendars in the calendar group. Navigation property. Read-only. Nullable.
        /// </summary>
        [JsonPropertyName("calendars")]
        public ICalendarGroupCalendarsCollectionPage Calendars { get; set; }

        /// <summary>
        /// Gets or sets calendarsNextLink.
        /// </summary>
        [JsonPropertyName("calendars@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string CalendarsNextLink { get; set; }
    
    }
}

