// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Calendar Permission.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<CalendarPermission>))]
    public partial class CalendarPermission : Entity
    {
    
        /// <summary>
        /// Gets or sets allowed roles.
        /// List of allowed sharing or delegating permission levels for the calendar. Possible values are: none, freeBusyRead, limitedRead, read, write, delegateWithoutPrivateEventAccess, delegateWithPrivateEventAccess, custom.
        /// </summary>
        [JsonPropertyName("allowedRoles")]
        public IEnumerable<CalendarRoleType> AllowedRoles { get; set; }
    
        /// <summary>
        /// Gets or sets email address.
        /// Represents a sharee or delegate who has access to the calendar. For the 'My Organization' sharee, the address property is null. Read-only.
        /// </summary>
        [JsonPropertyName("emailAddress")]
        public EmailAddress EmailAddress { get; set; }
    
        /// <summary>
        /// Gets or sets is inside organization.
        /// True if the user in context (sharee or delegate) is inside the same organization as the calendar owner.
        /// </summary>
        [JsonPropertyName("isInsideOrganization")]
        public bool? IsInsideOrganization { get; set; }
    
        /// <summary>
        /// Gets or sets is removable.
        /// True if the user can be removed from the list of sharees or delegates for the specified calendar, false otherwise. The 'My organization' user determines the permissions other people within your organization have to the given calendar. You cannot remove 'My organization' as a sharee to a calendar.
        /// </summary>
        [JsonPropertyName("isRemovable")]
        public bool? IsRemovable { get; set; }
    
        /// <summary>
        /// Gets or sets role.
        /// Current permission level of the calendar sharee or delegate.
        /// </summary>
        [JsonPropertyName("role")]
        public CalendarRoleType? Role { get; set; }
    
    }
}

