// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type CallRecordingEventMessageDetail.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<CallRecordingEventMessageDetail>))]
    public partial class CallRecordingEventMessageDetail : EventMessageDetail
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CallRecordingEventMessageDetail"/> class.
        /// </summary>
        public CallRecordingEventMessageDetail()
        {
            this.ODataType = "microsoft.graph.callRecordingEventMessageDetail";
        }

        /// <summary>
        /// Gets or sets callId.
        /// Unique identifier of the call.
        /// </summary>
        [JsonPropertyName("callId")]
        public string CallId { get; set; }
    
        /// <summary>
        /// Gets or sets callRecordingDisplayName.
        /// Display name for the call recording.
        /// </summary>
        [JsonPropertyName("callRecordingDisplayName")]
        public string CallRecordingDisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets callRecordingDuration.
        /// Duration of the call recording.
        /// </summary>
        [JsonPropertyName("callRecordingDuration")]
        public Duration CallRecordingDuration { get; set; }
    
        /// <summary>
        /// Gets or sets callRecordingStatus.
        /// Status of the call recording. Possible values are: success, failure, initial, chunkFinished, unknownFutureValue.
        /// </summary>
        [JsonPropertyName("callRecordingStatus")]
        public CallRecordingStatus? CallRecordingStatus { get; set; }
    
        /// <summary>
        /// Gets or sets callRecordingUrl.
        /// Call recording URL.
        /// </summary>
        [JsonPropertyName("callRecordingUrl")]
        public string CallRecordingUrl { get; set; }
    
        /// <summary>
        /// Gets or sets initiator.
        /// Initiator of the event.
        /// </summary>
        [JsonPropertyName("initiator")]
        public IdentitySet Initiator { get; set; }
    
        /// <summary>
        /// Gets or sets meetingOrganizer.
        /// Organizer of the meeting.
        /// </summary>
        [JsonPropertyName("meetingOrganizer")]
        public IdentitySet MeetingOrganizer { get; set; }
    
    }
}
