// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Conditional Access Policy.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ConditionalAccessPolicy>))]
    public partial class ConditionalAccessPolicy : Entity
    {
    
        /// <summary>
        /// Gets or sets conditions.
        /// Specifies the rules that must be met for the policy to apply. Required.
        /// </summary>
        [JsonPropertyName("conditions")]
        public ConditionalAccessConditionSet Conditions { get; set; }
    
        /// <summary>
        /// Gets or sets created date time.
        /// The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets description.
        /// Not used.
        /// </summary>
        [JsonPropertyName("description")]
        public string Description { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// Specifies a display name for the conditionalAccessPolicy object.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets grant controls.
        /// Specifies the grant controls that must be fulfilled to pass the policy.
        /// </summary>
        [JsonPropertyName("grantControls")]
        public ConditionalAccessGrantControls GrantControls { get; set; }
    
        /// <summary>
        /// Gets or sets modified date time.
        /// The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Readonly.
        /// </summary>
        [JsonPropertyName("modifiedDateTime")]
        public DateTimeOffset? ModifiedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets session controls.
        /// Specifies the session controls that are enforced after sign-in.
        /// </summary>
        [JsonPropertyName("sessionControls")]
        public ConditionalAccessSessionControls SessionControls { get; set; }
    
        /// <summary>
        /// Gets or sets state.
        /// Specifies the state of the conditionalAccessPolicy object. Possible values are: enabled, disabled, enabledForReportingButNotEnforced. Required.
        /// </summary>
        [JsonPropertyName("state")]
        public ConditionalAccessPolicyState? State { get; set; }
    
    }
}

