// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type CustomTimeZone.
    /// </summary>
    public partial class CustomTimeZone : TimeZoneBase
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CustomTimeZone"/> class.
        /// </summary>
        public CustomTimeZone()
        {
            this.ODataType = "microsoft.graph.customTimeZone";
        }

        /// <summary>
        /// Gets or sets bias.
        /// The time offset of the time zone from Coordinated Universal Time (UTC). This value is in minutes. Time zones that are ahead of UTC have a positive offset; time zones that are behind UTC have a negative offset.
        /// </summary>
        [JsonPropertyName("bias")]
        public Int32? Bias { get; set; }
    
        /// <summary>
        /// Gets or sets daylightOffset.
        /// Specifies when the time zone switches from standard time to daylight saving time.
        /// </summary>
        [JsonPropertyName("daylightOffset")]
        public DaylightTimeZoneOffset DaylightOffset { get; set; }
    
        /// <summary>
        /// Gets or sets standardOffset.
        /// Specifies when the time zone switches from daylight saving time to standard time.
        /// </summary>
        [JsonPropertyName("standardOffset")]
        public StandardTimeZoneOffset StandardOffset { get; set; }
    
    }
}
