// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Device Configuration State.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<DeviceConfigurationState>))]
    public partial class DeviceConfigurationState : Entity
    {
    
        /// <summary>
        /// Gets or sets display name.
        /// The name of the policy for this policyBase
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets platform type.
        /// Platform type that the policy applies to
        /// </summary>
        [JsonPropertyName("platformType")]
        public PolicyPlatformType? PlatformType { get; set; }
    
        /// <summary>
        /// Gets or sets setting count.
        /// Count of how many setting a policy holds
        /// </summary>
        [JsonPropertyName("settingCount")]
        public Int32? SettingCount { get; set; }
    
        /// <summary>
        /// Gets or sets setting states.
        /// </summary>
        [JsonPropertyName("settingStates")]
        public IEnumerable<DeviceConfigurationSettingState> SettingStates { get; set; }
    
        /// <summary>
        /// Gets or sets state.
        /// The compliance state of the policy
        /// </summary>
        [JsonPropertyName("state")]
        public ComplianceStatus? State { get; set; }
    
        /// <summary>
        /// Gets or sets version.
        /// The version of the policy
        /// </summary>
        [JsonPropertyName("version")]
        public Int32? Version { get; set; }
    
    }
}

