// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Edition Upgrade Configuration.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<EditionUpgradeConfiguration>))]
    public partial class EditionUpgradeConfiguration : DeviceConfiguration
    {
    
        ///<summary>
        /// The EditionUpgradeConfiguration constructor
        ///</summary>
        public EditionUpgradeConfiguration()
        {
            this.ODataType = "microsoft.graph.editionUpgradeConfiguration";
        }

        /// <summary>
        /// Gets or sets license.
        /// Edition Upgrade License File Content.
        /// </summary>
        [JsonPropertyName("license")]
        public string License { get; set; }
    
        /// <summary>
        /// Gets or sets license type.
        /// Edition Upgrade License Type. Possible values are: productKey, licenseFile, notConfigured.
        /// </summary>
        [JsonPropertyName("licenseType")]
        public EditionUpgradeLicenseType? LicenseType { get; set; }
    
        /// <summary>
        /// Gets or sets product key.
        /// Edition Upgrade Product Key.
        /// </summary>
        [JsonPropertyName("productKey")]
        public string ProductKey { get; set; }
    
        /// <summary>
        /// Gets or sets target edition.
        /// Edition Upgrade Target Edition. Possible values are: windows10Enterprise, windows10EnterpriseN, windows10Education, windows10EducationN, windows10MobileEnterprise, windows10HolographicEnterprise, windows10Professional, windows10ProfessionalN, windows10ProfessionalEducation, windows10ProfessionalEducationN, windows10ProfessionalWorkstation, windows10ProfessionalWorkstationN, notConfigured, windows10Home, windows10HomeChina, windows10HomeN, windows10HomeSingleLanguage, windows10Mobile, windows10IoTCore, windows10IoTCoreCommercial.
        /// </summary>
        [JsonPropertyName("targetEdition")]
        public Windows10EditionType? TargetEdition { get; set; }
    
    }
}

