// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Fido2Authentication Method Configuration.
    /// </summary>
    public partial class Fido2AuthenticationMethodConfiguration : AuthenticationMethodConfiguration
    {
    
        ///<summary>
        /// The Fido2AuthenticationMethodConfiguration constructor
        ///</summary>
        public Fido2AuthenticationMethodConfiguration()
        {
            this.ODataType = "microsoft.graph.fido2AuthenticationMethodConfiguration";
        }

        /// <summary>
        /// Gets or sets is attestation enforced.
        /// Determines whether attestation must be enforced for FIDO2 security key registration.
        /// </summary>
        [JsonPropertyName("isAttestationEnforced")]
        public bool? IsAttestationEnforced { get; set; }
    
        /// <summary>
        /// Gets or sets is self service registration allowed.
        /// Determines if users can register new FIDO2 security keys.
        /// </summary>
        [JsonPropertyName("isSelfServiceRegistrationAllowed")]
        public bool? IsSelfServiceRegistrationAllowed { get; set; }
    
        /// <summary>
        /// Gets or sets key restrictions.
        /// Controls whether key restrictions are enforced on FIDO2 security keys, either allowing or disallowing certain key types as defined by Authenticator Attestation GUID (AAGUID), an identifier that indicates the type (e.g. make and model) of the authenticator.
        /// </summary>
        [JsonPropertyName("keyRestrictions")]
        public Fido2KeyRestrictions KeyRestrictions { get; set; }
    
        /// <summary>
        /// Gets or sets include targets.
        /// A collection of users or groups who are enabled to use the authentication method.
        /// </summary>
        [JsonPropertyName("includeTargets")]
        public IFido2AuthenticationMethodConfigurationIncludeTargetsCollectionPage IncludeTargets { get; set; }

        /// <summary>
        /// Gets or sets includeTargetsNextLink.
        /// </summary>
        [JsonPropertyName("includeTargets@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string IncludeTargetsNextLink { get; set; }
    
    }
}

