// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type FollowupFlag.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<FollowupFlag>))]
    public partial class FollowupFlag
    {

        /// <summary>
        /// Gets or sets completedDateTime.
        /// The date and time that the follow-up was finished.
        /// </summary>
        [JsonPropertyName("completedDateTime")]
        public DateTimeTimeZone CompletedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets dueDateTime.
        /// The date and time that the follow up is to be finished. Note: To set the due date, you must also specify the startDateTime; otherwise, you will get a 400 Bad Request response.
        /// </summary>
        [JsonPropertyName("dueDateTime")]
        public DateTimeTimeZone DueDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets flagStatus.
        /// The status for follow-up for an item. Possible values are notFlagged, complete, and flagged.
        /// </summary>
        [JsonPropertyName("flagStatus")]
        public FollowupFlagStatus? FlagStatus { get; set; }
    
        /// <summary>
        /// Gets or sets startDateTime.
        /// The date and time that the follow-up is to begin.
        /// </summary>
        [JsonPropertyName("startDateTime")]
        public DateTimeTimeZone StartDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
