// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type HostSecurityState.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<HostSecurityState>))]
    public partial class HostSecurityState
    {

        /// <summary>
        /// Gets or sets fqdn.
        /// Host FQDN (Fully Qualified Domain Name) (for example, machine.company.com).
        /// </summary>
        [JsonPropertyName("fqdn")]
        public string Fqdn { get; set; }
    
        /// <summary>
        /// Gets or sets isAzureAdJoined.
        /// </summary>
        [JsonPropertyName("isAzureAdJoined")]
        public bool? IsAzureAdJoined { get; set; }
    
        /// <summary>
        /// Gets or sets isAzureAdRegistered.
        /// </summary>
        [JsonPropertyName("isAzureAdRegistered")]
        public bool? IsAzureAdRegistered { get; set; }
    
        /// <summary>
        /// Gets or sets isHybridAzureDomainJoined.
        /// True if the host is domain joined to an on-premises Active Directory domain.
        /// </summary>
        [JsonPropertyName("isHybridAzureDomainJoined")]
        public bool? IsHybridAzureDomainJoined { get; set; }
    
        /// <summary>
        /// Gets or sets netBiosName.
        /// The local host name, without the DNS domain name.
        /// </summary>
        [JsonPropertyName("netBiosName")]
        public string NetBiosName { get; set; }
    
        /// <summary>
        /// Gets or sets os.
        /// Host Operating System. (For example, Windows10, MacOS, RHEL, etc.).
        /// </summary>
        [JsonPropertyName("os")]
        public string Os { get; set; }
    
        /// <summary>
        /// Gets or sets privateIpAddress.
        /// Private (not routable) IPv4 or IPv6 address (see RFC 1918) at the time of the alert.
        /// </summary>
        [JsonPropertyName("privateIpAddress")]
        public string PrivateIpAddress { get; set; }
    
        /// <summary>
        /// Gets or sets publicIpAddress.
        /// Publicly routable IPv4 or IPv6 address (see RFC 1918) at time of the alert.
        /// </summary>
        [JsonPropertyName("publicIpAddress")]
        public string PublicIpAddress { get; set; }
    
        /// <summary>
        /// Gets or sets riskScore.
        /// Provider-generated/calculated risk score of the host.  Recommended value range of 0-1, which equates to a percentage.
        /// </summary>
        [JsonPropertyName("riskScore")]
        public string RiskScore { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
