// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Identity User Flow Attribute.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<IdentityUserFlowAttribute>))]
    public partial class IdentityUserFlowAttribute : Entity
    {
    
        /// <summary>
        /// Gets or sets data type.
        /// The data type of the user flow attribute. This cannot be modified after the custom user flow attribute is created. The supported values for dataType are: string , boolean , int64 , stringCollection , dateTime.
        /// </summary>
        [JsonPropertyName("dataType")]
        public IdentityUserFlowAttributeDataType? DataType { get; set; }
    
        /// <summary>
        /// Gets or sets description.
        /// The description of the user flow attribute that's shown to the user at the time of sign-up.
        /// </summary>
        [JsonPropertyName("description")]
        public string Description { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// The display name of the user flow attribute.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets user flow attribute type.
        /// The type of the user flow attribute. This is a read-only attribute that is automatically set. Depending on the type of attribute, the values for this property will be builtIn, custom, or required.
        /// </summary>
        [JsonPropertyName("userFlowAttributeType")]
        public IdentityUserFlowAttributeType? UserFlowAttributeType { get; set; }
    
    }
}

