// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Imported Windows Autopilot Device Identity.
    /// </summary>
    public partial class ImportedWindowsAutopilotDeviceIdentity : Entity
    {
    
        /// <summary>
        /// Gets or sets assigned user principal name.
        /// UPN of the user the device will be assigned
        /// </summary>
        [JsonPropertyName("assignedUserPrincipalName")]
        public string AssignedUserPrincipalName { get; set; }
    
        /// <summary>
        /// Gets or sets group tag.
        /// Group Tag of the Windows autopilot device.
        /// </summary>
        [JsonPropertyName("groupTag")]
        public string GroupTag { get; set; }
    
        /// <summary>
        /// Gets or sets hardware identifier.
        /// Hardware Blob of the Windows autopilot device.
        /// </summary>
        [JsonPropertyName("hardwareIdentifier")]
        public byte[] HardwareIdentifier { get; set; }
    
        /// <summary>
        /// Gets or sets import id.
        /// The Import Id of the Windows autopilot device.
        /// </summary>
        [JsonPropertyName("importId")]
        public string ImportId { get; set; }
    
        /// <summary>
        /// Gets or sets product key.
        /// Product Key of the Windows autopilot device.
        /// </summary>
        [JsonPropertyName("productKey")]
        public string ProductKey { get; set; }
    
        /// <summary>
        /// Gets or sets serial number.
        /// Serial number of the Windows autopilot device.
        /// </summary>
        [JsonPropertyName("serialNumber")]
        public string SerialNumber { get; set; }
    
        /// <summary>
        /// Gets or sets state.
        /// Current state of the imported device.
        /// </summary>
        [JsonPropertyName("state")]
        public ImportedWindowsAutopilotDeviceIdentityState State { get; set; }
    
    }
}

