// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type InformationalUrl.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<InformationalUrl>))]
    public partial class InformationalUrl
    {

        /// <summary>
        /// Gets or sets logoUrl.
        /// CDN URL to the application's logo, Read-only.
        /// </summary>
        [JsonPropertyName("logoUrl")]
        public string LogoUrl { get; set; }
    
        /// <summary>
        /// Gets or sets marketingUrl.
        /// Link to the application's marketing page. For example, https://www.contoso.com/app/marketing
        /// </summary>
        [JsonPropertyName("marketingUrl")]
        public string MarketingUrl { get; set; }
    
        /// <summary>
        /// Gets or sets privacyStatementUrl.
        /// Link to the application's privacy statement. For example, https://www.contoso.com/app/privacy
        /// </summary>
        [JsonPropertyName("privacyStatementUrl")]
        public string PrivacyStatementUrl { get; set; }
    
        /// <summary>
        /// Gets or sets supportUrl.
        /// Link to the application's support page. For example, https://www.contoso.com/app/support
        /// </summary>
        [JsonPropertyName("supportUrl")]
        public string SupportUrl { get; set; }
    
        /// <summary>
        /// Gets or sets termsOfServiceUrl.
        /// Link to the application's terms of service statement. For example, https://www.contoso.com/app/termsofservice
        /// </summary>
        [JsonPropertyName("termsOfServiceUrl")]
        public string TermsOfServiceUrl { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
