// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Managed Device.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ManagedDevice>))]
    public partial class ManagedDevice : Entity
    {
    
        /// <summary>
        /// Gets or sets activation lock bypass code.
        /// Code that allows the Activation Lock on a device to be bypassed. This property is read-only.
        /// </summary>
        [JsonPropertyName("activationLockBypassCode")]
        public string ActivationLockBypassCode { get; set; }
    
        /// <summary>
        /// Gets or sets android security patch level.
        /// Android security patch level. This property is read-only.
        /// </summary>
        [JsonPropertyName("androidSecurityPatchLevel")]
        public string AndroidSecurityPatchLevel { get; set; }
    
        /// <summary>
        /// Gets or sets azure addevice id.
        /// The unique identifier for the Azure Active Directory device. Read only. This property is read-only.
        /// </summary>
        [JsonPropertyName("azureADDeviceId")]
        public string AzureADDeviceId { get; set; }
    
        /// <summary>
        /// Gets or sets azure adregistered.
        /// Whether the device is Azure Active Directory registered. This property is read-only.
        /// </summary>
        [JsonPropertyName("azureADRegistered")]
        public bool? AzureADRegistered { get; set; }
    
        /// <summary>
        /// Gets or sets compliance grace period expiration date time.
        /// The DateTime when device compliance grace period expires. This property is read-only.
        /// </summary>
        [JsonPropertyName("complianceGracePeriodExpirationDateTime")]
        public DateTimeOffset? ComplianceGracePeriodExpirationDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets compliance state.
        /// Compliance state of the device. This property is read-only. Possible values are: unknown, compliant, noncompliant, conflict, error, inGracePeriod, configManager.
        /// </summary>
        [JsonPropertyName("complianceState")]
        public ComplianceState? ComplianceState { get; set; }
    
        /// <summary>
        /// Gets or sets configuration manager client enabled features.
        /// ConfigrMgr client enabled features. This property is read-only.
        /// </summary>
        [JsonPropertyName("configurationManagerClientEnabledFeatures")]
        public ConfigurationManagerClientEnabledFeatures ConfigurationManagerClientEnabledFeatures { get; set; }
    
        /// <summary>
        /// Gets or sets device action results.
        /// List of ComplexType deviceActionResult objects. This property is read-only.
        /// </summary>
        [JsonPropertyName("deviceActionResults")]
        public IEnumerable<DeviceActionResult> DeviceActionResults { get; set; }
    
        /// <summary>
        /// Gets or sets device category display name.
        /// Device category display name. This property is read-only.
        /// </summary>
        [JsonPropertyName("deviceCategoryDisplayName")]
        public string DeviceCategoryDisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets device enrollment type.
        /// Enrollment type of the device. This property is read-only. Possible values are: unknown, userEnrollment, deviceEnrollmentManager, appleBulkWithUser, appleBulkWithoutUser, windowsAzureADJoin, windowsBulkUserless, windowsAutoEnrollment, windowsBulkAzureDomainJoin, windowsCoManagement, windowsAzureADJoinUsingDeviceAuth, appleUserEnrollment, appleUserEnrollmentWithServiceAccount, azureAdJoinUsingAzureVmExtension, androidEnterpriseDedicatedDevice, androidEnterpriseFullyManaged, androidEnterpriseCorporateWorkProfile.
        /// </summary>
        [JsonPropertyName("deviceEnrollmentType")]
        public DeviceEnrollmentType? DeviceEnrollmentType { get; set; }
    
        /// <summary>
        /// Gets or sets device health attestation state.
        /// The device health attestation state. This property is read-only.
        /// </summary>
        [JsonPropertyName("deviceHealthAttestationState")]
        public DeviceHealthAttestationState DeviceHealthAttestationState { get; set; }
    
        /// <summary>
        /// Gets or sets device name.
        /// Name of the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("deviceName")]
        public string DeviceName { get; set; }
    
        /// <summary>
        /// Gets or sets device registration state.
        /// Device registration state. This property is read-only. Possible values are: notRegistered, registered, revoked, keyConflict, approvalPending, certificateReset, notRegisteredPendingEnrollment, unknown.
        /// </summary>
        [JsonPropertyName("deviceRegistrationState")]
        public DeviceRegistrationState? DeviceRegistrationState { get; set; }
    
        /// <summary>
        /// Gets or sets eas activated.
        /// Whether the device is Exchange ActiveSync activated. This property is read-only.
        /// </summary>
        [JsonPropertyName("easActivated")]
        public bool? EasActivated { get; set; }
    
        /// <summary>
        /// Gets or sets eas activation date time.
        /// Exchange ActivationSync activation time of the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("easActivationDateTime")]
        public DateTimeOffset? EasActivationDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets eas device id.
        /// Exchange ActiveSync Id of the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("easDeviceId")]
        public string EasDeviceId { get; set; }
    
        /// <summary>
        /// Gets or sets email address.
        /// Email(s) for the user associated with the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("emailAddress")]
        public string EmailAddress { get; set; }
    
        /// <summary>
        /// Gets or sets enrolled date time.
        /// Enrollment time of the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("enrolledDateTime")]
        public DateTimeOffset? EnrolledDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets ethernet mac address.
        /// Ethernet MAC. This property is read-only.
        /// </summary>
        [JsonPropertyName("ethernetMacAddress")]
        public string EthernetMacAddress { get; set; }
    
        /// <summary>
        /// Gets or sets exchange access state.
        /// The Access State of the device in Exchange. This property is read-only. Possible values are: none, unknown, allowed, blocked, quarantined.
        /// </summary>
        [JsonPropertyName("exchangeAccessState")]
        public DeviceManagementExchangeAccessState? ExchangeAccessState { get; set; }
    
        /// <summary>
        /// Gets or sets exchange access state reason.
        /// The reason for the device's access state in Exchange. This property is read-only. Possible values are: none, unknown, exchangeGlobalRule, exchangeIndividualRule, exchangeDeviceRule, exchangeUpgrade, exchangeMailboxPolicy, other, compliant, notCompliant, notEnrolled, unknownLocation, mfaRequired, azureADBlockDueToAccessPolicy, compromisedPassword, deviceNotKnownWithManagedApp.
        /// </summary>
        [JsonPropertyName("exchangeAccessStateReason")]
        public DeviceManagementExchangeAccessStateReason? ExchangeAccessStateReason { get; set; }
    
        /// <summary>
        /// Gets or sets exchange last successful sync date time.
        /// Last time the device contacted Exchange. This property is read-only.
        /// </summary>
        [JsonPropertyName("exchangeLastSuccessfulSyncDateTime")]
        public DateTimeOffset? ExchangeLastSuccessfulSyncDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets free storage space in bytes.
        /// Free Storage in Bytes. This property is read-only.
        /// </summary>
        [JsonPropertyName("freeStorageSpaceInBytes")]
        public Int64? FreeStorageSpaceInBytes { get; set; }
    
        /// <summary>
        /// Gets or sets iccid.
        /// Integrated Circuit Card Identifier, it is A SIM card's unique identification number. This property is read-only.
        /// </summary>
        [JsonPropertyName("iccid")]
        public string Iccid { get; set; }
    
        /// <summary>
        /// Gets or sets imei.
        /// IMEI. This property is read-only.
        /// </summary>
        [JsonPropertyName("imei")]
        public string Imei { get; set; }
    
        /// <summary>
        /// Gets or sets is encrypted.
        /// Device encryption status. This property is read-only.
        /// </summary>
        [JsonPropertyName("isEncrypted")]
        public bool? IsEncrypted { get; set; }
    
        /// <summary>
        /// Gets or sets is supervised.
        /// Device supervised status. This property is read-only.
        /// </summary>
        [JsonPropertyName("isSupervised")]
        public bool? IsSupervised { get; set; }
    
        /// <summary>
        /// Gets or sets jail broken.
        /// whether the device is jail broken or rooted. This property is read-only.
        /// </summary>
        [JsonPropertyName("jailBroken")]
        public string JailBroken { get; set; }
    
        /// <summary>
        /// Gets or sets last sync date time.
        /// The date and time that the device last completed a successful sync with Intune. This property is read-only.
        /// </summary>
        [JsonPropertyName("lastSyncDateTime")]
        public DateTimeOffset? LastSyncDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets managed device name.
        /// Automatically generated name to identify a device. Can be overwritten to a user friendly name.
        /// </summary>
        [JsonPropertyName("managedDeviceName")]
        public string ManagedDeviceName { get; set; }
    
        /// <summary>
        /// Gets or sets managed device owner type.
        /// Ownership of the device. Can be 'company' or 'personal'. Possible values are: unknown, company, personal.
        /// </summary>
        [JsonPropertyName("managedDeviceOwnerType")]
        public ManagedDeviceOwnerType? ManagedDeviceOwnerType { get; set; }
    
        /// <summary>
        /// Gets or sets management agent.
        /// Management channel of the device. Intune, EAS, etc. This property is read-only. Possible values are: eas, mdm, easMdm, intuneClient, easIntuneClient, configurationManagerClient, configurationManagerClientMdm, configurationManagerClientMdmEas, unknown, jamf, googleCloudDevicePolicyController, microsoft365ManagedMdm, msSense, intuneAosp.
        /// </summary>
        [JsonPropertyName("managementAgent")]
        public ManagementAgentType? ManagementAgent { get; set; }
    
        /// <summary>
        /// Gets or sets manufacturer.
        /// Manufacturer of the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("manufacturer")]
        public string Manufacturer { get; set; }
    
        /// <summary>
        /// Gets or sets meid.
        /// MEID. This property is read-only.
        /// </summary>
        [JsonPropertyName("meid")]
        public string Meid { get; set; }
    
        /// <summary>
        /// Gets or sets model.
        /// Model of the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("model")]
        public string Model { get; set; }
    
        /// <summary>
        /// Gets or sets notes.
        /// Notes on the device created by IT Admin
        /// </summary>
        [JsonPropertyName("notes")]
        public string Notes { get; set; }
    
        /// <summary>
        /// Gets or sets operating system.
        /// Operating system of the device. Windows, iOS, etc. This property is read-only.
        /// </summary>
        [JsonPropertyName("operatingSystem")]
        public string OperatingSystem { get; set; }
    
        /// <summary>
        /// Gets or sets os version.
        /// Operating system version of the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("osVersion")]
        public string OsVersion { get; set; }
    
        /// <summary>
        /// Gets or sets partner reported threat state.
        /// Indicates the threat state of a device when a Mobile Threat Defense partner is in use by the account and device. Read Only. This property is read-only. Possible values are: unknown, activated, deactivated, secured, lowSeverity, mediumSeverity, highSeverity, unresponsive, compromised, misconfigured.
        /// </summary>
        [JsonPropertyName("partnerReportedThreatState")]
        public ManagedDevicePartnerReportedHealthState? PartnerReportedThreatState { get; set; }
    
        /// <summary>
        /// Gets or sets phone number.
        /// Phone number of the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("phoneNumber")]
        public string PhoneNumber { get; set; }
    
        /// <summary>
        /// Gets or sets physical memory in bytes.
        /// Total Memory in Bytes. This property is read-only.
        /// </summary>
        [JsonPropertyName("physicalMemoryInBytes")]
        public Int64? PhysicalMemoryInBytes { get; set; }
    
        /// <summary>
        /// Gets or sets remote assistance session error details.
        /// An error string that identifies issues when creating Remote Assistance session objects. This property is read-only.
        /// </summary>
        [JsonPropertyName("remoteAssistanceSessionErrorDetails")]
        public string RemoteAssistanceSessionErrorDetails { get; set; }
    
        /// <summary>
        /// Gets or sets remote assistance session url.
        /// Url that allows a Remote Assistance session to be established with the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("remoteAssistanceSessionUrl")]
        public string RemoteAssistanceSessionUrl { get; set; }
    
        /// <summary>
        /// Gets or sets serial number.
        /// SerialNumber. This property is read-only.
        /// </summary>
        [JsonPropertyName("serialNumber")]
        public string SerialNumber { get; set; }
    
        /// <summary>
        /// Gets or sets subscriber carrier.
        /// Subscriber Carrier. This property is read-only.
        /// </summary>
        [JsonPropertyName("subscriberCarrier")]
        public string SubscriberCarrier { get; set; }
    
        /// <summary>
        /// Gets or sets total storage space in bytes.
        /// Total Storage in Bytes. This property is read-only.
        /// </summary>
        [JsonPropertyName("totalStorageSpaceInBytes")]
        public Int64? TotalStorageSpaceInBytes { get; set; }
    
        /// <summary>
        /// Gets or sets udid.
        /// Unique Device Identifier for iOS and macOS devices. This property is read-only.
        /// </summary>
        [JsonPropertyName("udid")]
        public string Udid { get; set; }
    
        /// <summary>
        /// Gets or sets user display name.
        /// User display name. This property is read-only.
        /// </summary>
        [JsonPropertyName("userDisplayName")]
        public string UserDisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets user id.
        /// Unique Identifier for the user associated with the device. This property is read-only.
        /// </summary>
        [JsonPropertyName("userId")]
        public string UserId { get; set; }
    
        /// <summary>
        /// Gets or sets user principal name.
        /// Device user principal name. This property is read-only.
        /// </summary>
        [JsonPropertyName("userPrincipalName")]
        public string UserPrincipalName { get; set; }
    
        /// <summary>
        /// Gets or sets wi fi mac address.
        /// Wi-Fi MAC. This property is read-only.
        /// </summary>
        [JsonPropertyName("wiFiMacAddress")]
        public string WiFiMacAddress { get; set; }
    
        /// <summary>
        /// Gets or sets device compliance policy states.
        /// Device compliance policy states for this device.
        /// </summary>
        [JsonPropertyName("deviceCompliancePolicyStates")]
        public IManagedDeviceDeviceCompliancePolicyStatesCollectionPage DeviceCompliancePolicyStates { get; set; }

        /// <summary>
        /// Gets or sets deviceCompliancePolicyStatesNextLink.
        /// </summary>
        [JsonPropertyName("deviceCompliancePolicyStates@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DeviceCompliancePolicyStatesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets device configuration states.
        /// Device configuration states for this device.
        /// </summary>
        [JsonPropertyName("deviceConfigurationStates")]
        public IManagedDeviceDeviceConfigurationStatesCollectionPage DeviceConfigurationStates { get; set; }

        /// <summary>
        /// Gets or sets deviceConfigurationStatesNextLink.
        /// </summary>
        [JsonPropertyName("deviceConfigurationStates@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DeviceConfigurationStatesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets device category.
        /// Device category
        /// </summary>
        [JsonPropertyName("deviceCategory")]
        public DeviceCategory DeviceCategory { get; set; }
    
    }
}

