// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Managed Device Mobile App Configuration.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ManagedDeviceMobileAppConfiguration>))]
    public partial class ManagedDeviceMobileAppConfiguration : Entity
    {
    
        ///<summary>
        /// The internal ManagedDeviceMobileAppConfiguration constructor
        ///</summary>
        protected internal ManagedDeviceMobileAppConfiguration()
        {
            // Don't allow initialization of abstract entity types
        }
    
        /// <summary>
        /// Gets or sets created date time.
        /// DateTime the object was created.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets description.
        /// Admin provided description of the Device Configuration.
        /// </summary>
        [JsonPropertyName("description")]
        public string Description { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// Admin provided name of the device configuration.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets last modified date time.
        /// DateTime the object was last modified.
        /// </summary>
        [JsonPropertyName("lastModifiedDateTime")]
        public DateTimeOffset? LastModifiedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets targeted mobile apps.
        /// the associated app.
        /// </summary>
        [JsonPropertyName("targetedMobileApps")]
        public IEnumerable<string> TargetedMobileApps { get; set; }
    
        /// <summary>
        /// Gets or sets version.
        /// Version of the device configuration.
        /// </summary>
        [JsonPropertyName("version")]
        public Int32? Version { get; set; }
    
        /// <summary>
        /// Gets or sets assignments.
        /// The list of group assignemenets for app configration.
        /// </summary>
        [JsonPropertyName("assignments")]
        public IManagedDeviceMobileAppConfigurationAssignmentsCollectionPage Assignments { get; set; }

        /// <summary>
        /// Gets or sets assignmentsNextLink.
        /// </summary>
        [JsonPropertyName("assignments@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string AssignmentsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets device statuses.
        /// List of ManagedDeviceMobileAppConfigurationDeviceStatus.
        /// </summary>
        [JsonPropertyName("deviceStatuses")]
        public IManagedDeviceMobileAppConfigurationDeviceStatusesCollectionPage DeviceStatuses { get; set; }

        /// <summary>
        /// Gets or sets deviceStatusesNextLink.
        /// </summary>
        [JsonPropertyName("deviceStatuses@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DeviceStatusesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets device status summary.
        /// App configuration device status summary.
        /// </summary>
        [JsonPropertyName("deviceStatusSummary")]
        public ManagedDeviceMobileAppConfigurationDeviceSummary DeviceStatusSummary { get; set; }
    
        /// <summary>
        /// Gets or sets user statuses.
        /// List of ManagedDeviceMobileAppConfigurationUserStatus.
        /// </summary>
        [JsonPropertyName("userStatuses")]
        public IManagedDeviceMobileAppConfigurationUserStatusesCollectionPage UserStatuses { get; set; }

        /// <summary>
        /// Gets or sets userStatusesNextLink.
        /// </summary>
        [JsonPropertyName("userStatuses@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string UserStatusesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets user status summary.
        /// App configuration user status summary.
        /// </summary>
        [JsonPropertyName("userStatusSummary")]
        public ManagedDeviceMobileAppConfigurationUserSummary UserStatusSummary { get; set; }
    
    }
}

