// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type MediaStream.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<MediaStream>))]
    public partial class MediaStream
    {

        /// <summary>
        /// Gets or sets direction.
        /// The direction. The possible values are inactive, sendOnly, receiveOnly, sendReceive.
        /// </summary>
        [JsonPropertyName("direction")]
        public MediaDirection? Direction { get; set; }
    
        /// <summary>
        /// Gets or sets label.
        /// The media stream label.
        /// </summary>
        [JsonPropertyName("label")]
        public string Label { get; set; }
    
        /// <summary>
        /// Gets or sets mediaType.
        /// The media type. The possible value are unknown, audio, video, videoBasedScreenSharing, data.
        /// </summary>
        [JsonPropertyName("mediaType")]
        public Modality? MediaType { get; set; }
    
        /// <summary>
        /// Gets or sets serverMuted.
        /// Indicates whether the media is muted by the server.
        /// </summary>
        [JsonPropertyName("serverMuted")]
        public bool? ServerMuted { get; set; }
    
        /// <summary>
        /// Gets or sets sourceId.
        /// The source ID.
        /// </summary>
        [JsonPropertyName("sourceId")]
        public string SourceId { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
