// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Message Rule.
    /// </summary>
    public partial class MessageRule : Entity
    {
    
        /// <summary>
        /// Gets or sets actions.
        /// Actions to be taken on a message when the corresponding conditions are fulfilled.
        /// </summary>
        [JsonPropertyName("actions")]
        public MessageRuleActions Actions { get; set; }
    
        /// <summary>
        /// Gets or sets conditions.
        /// Conditions that when fulfilled, will trigger the corresponding actions for that rule.
        /// </summary>
        [JsonPropertyName("conditions")]
        public MessageRulePredicates Conditions { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// The display name of the rule.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets exceptions.
        /// Exception conditions for the rule.
        /// </summary>
        [JsonPropertyName("exceptions")]
        public MessageRulePredicates Exceptions { get; set; }
    
        /// <summary>
        /// Gets or sets has error.
        /// Indicates whether the rule is in an error condition. Read-only.
        /// </summary>
        [JsonPropertyName("hasError")]
        public bool? HasError { get; set; }
    
        /// <summary>
        /// Gets or sets is enabled.
        /// Indicates whether the rule is enabled to be applied to messages.
        /// </summary>
        [JsonPropertyName("isEnabled")]
        public bool? IsEnabled { get; set; }
    
        /// <summary>
        /// Gets or sets is read only.
        /// Indicates if the rule is read-only and cannot be modified or deleted by the rules REST API.
        /// </summary>
        [JsonPropertyName("isReadOnly")]
        public bool? IsReadOnly { get; set; }
    
        /// <summary>
        /// Gets or sets sequence.
        /// Indicates the order in which the rule is executed, among other rules.
        /// </summary>
        [JsonPropertyName("sequence")]
        public Int32? Sequence { get; set; }
    
    }
}

