// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Microsoft Store For Business App.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<MicrosoftStoreForBusinessApp>))]
    public partial class MicrosoftStoreForBusinessApp : MobileApp
    {
    
        ///<summary>
        /// The MicrosoftStoreForBusinessApp constructor
        ///</summary>
        public MicrosoftStoreForBusinessApp()
        {
            this.ODataType = "microsoft.graph.microsoftStoreForBusinessApp";
        }

        /// <summary>
        /// Gets or sets license type.
        /// The app license type. Possible values are: offline, online.
        /// </summary>
        [JsonPropertyName("licenseType")]
        public MicrosoftStoreForBusinessLicenseType? LicenseType { get; set; }
    
        /// <summary>
        /// Gets or sets package identity name.
        /// The app package identifier
        /// </summary>
        [JsonPropertyName("packageIdentityName")]
        public string PackageIdentityName { get; set; }
    
        /// <summary>
        /// Gets or sets product key.
        /// The app product key
        /// </summary>
        [JsonPropertyName("productKey")]
        public string ProductKey { get; set; }
    
        /// <summary>
        /// Gets or sets total license count.
        /// The total number of Microsoft Store for Business licenses.
        /// </summary>
        [JsonPropertyName("totalLicenseCount")]
        public Int32? TotalLicenseCount { get; set; }
    
        /// <summary>
        /// Gets or sets used license count.
        /// The number of Microsoft Store for Business licenses in use.
        /// </summary>
        [JsonPropertyName("usedLicenseCount")]
        public Int32? UsedLicenseCount { get; set; }
    
    }
}

