// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type NetworkConnection.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<NetworkConnection>))]
    public partial class NetworkConnection
    {

        /// <summary>
        /// Gets or sets applicationName.
        /// Name of the application managing the network connection (for example, Facebook, SMTP, etc.).
        /// </summary>
        [JsonPropertyName("applicationName")]
        public string ApplicationName { get; set; }
    
        /// <summary>
        /// Gets or sets destinationAddress.
        /// Destination IP address (of the network connection).
        /// </summary>
        [JsonPropertyName("destinationAddress")]
        public string DestinationAddress { get; set; }
    
        /// <summary>
        /// Gets or sets destinationDomain.
        /// Destination domain portion of the destination URL. (for example 'www.contoso.com').
        /// </summary>
        [JsonPropertyName("destinationDomain")]
        public string DestinationDomain { get; set; }
    
        /// <summary>
        /// Gets or sets destinationLocation.
        /// Location (by IP address mapping) associated with the destination of a network connection.
        /// </summary>
        [JsonPropertyName("destinationLocation")]
        public string DestinationLocation { get; set; }
    
        /// <summary>
        /// Gets or sets destinationPort.
        /// Destination port (of the network connection).
        /// </summary>
        [JsonPropertyName("destinationPort")]
        public string DestinationPort { get; set; }
    
        /// <summary>
        /// Gets or sets destinationUrl.
        /// Network connection URL/URI string - excluding parameters. (for example 'www.contoso.com/products/default.html')
        /// </summary>
        [JsonPropertyName("destinationUrl")]
        public string DestinationUrl { get; set; }
    
        /// <summary>
        /// Gets or sets direction.
        /// Network connection direction. Possible values are: unknown, inbound, outbound.
        /// </summary>
        [JsonPropertyName("direction")]
        public ConnectionDirection? Direction { get; set; }
    
        /// <summary>
        /// Gets or sets domainRegisteredDateTime.
        /// Date when the destination domain was registered. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("domainRegisteredDateTime")]
        public DateTimeOffset? DomainRegisteredDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets localDnsName.
        /// The local DNS name resolution as it appears in the host's local DNS cache (for example, in case the 'hosts' file was tampered with).
        /// </summary>
        [JsonPropertyName("localDnsName")]
        public string LocalDnsName { get; set; }
    
        /// <summary>
        /// Gets or sets natDestinationAddress.
        /// Network Address Translation destination IP address.
        /// </summary>
        [JsonPropertyName("natDestinationAddress")]
        public string NatDestinationAddress { get; set; }
    
        /// <summary>
        /// Gets or sets natDestinationPort.
        /// Network Address Translation destination port.
        /// </summary>
        [JsonPropertyName("natDestinationPort")]
        public string NatDestinationPort { get; set; }
    
        /// <summary>
        /// Gets or sets natSourceAddress.
        /// Network Address Translation source IP address.
        /// </summary>
        [JsonPropertyName("natSourceAddress")]
        public string NatSourceAddress { get; set; }
    
        /// <summary>
        /// Gets or sets natSourcePort.
        /// Network Address Translation source port.
        /// </summary>
        [JsonPropertyName("natSourcePort")]
        public string NatSourcePort { get; set; }
    
        /// <summary>
        /// Gets or sets protocol.
        /// Network protocol. Possible values are: unknown, ip, icmp, igmp, ggp, ipv4, tcp, pup, udp, idp, ipv6, ipv6RoutingHeader, ipv6FragmentHeader, ipSecEncapsulatingSecurityPayload, ipSecAuthenticationHeader, icmpV6, ipv6NoNextHeader, ipv6DestinationOptions, nd, raw, ipx, spx, spxII.
        /// </summary>
        [JsonPropertyName("protocol")]
        public SecurityNetworkProtocol? Protocol { get; set; }
    
        /// <summary>
        /// Gets or sets riskScore.
        /// Provider generated/calculated risk score of the network connection. Recommended value range of 0-1, which equates to a percentage.
        /// </summary>
        [JsonPropertyName("riskScore")]
        public string RiskScore { get; set; }
    
        /// <summary>
        /// Gets or sets sourceAddress.
        /// Source (i.e. origin) IP address (of the network connection).
        /// </summary>
        [JsonPropertyName("sourceAddress")]
        public string SourceAddress { get; set; }
    
        /// <summary>
        /// Gets or sets sourceLocation.
        /// Location (by IP address mapping) associated with the source of a network connection.
        /// </summary>
        [JsonPropertyName("sourceLocation")]
        public string SourceLocation { get; set; }
    
        /// <summary>
        /// Gets or sets sourcePort.
        /// Source (i.e. origin) IP port (of the network connection).
        /// </summary>
        [JsonPropertyName("sourcePort")]
        public string SourcePort { get; set; }
    
        /// <summary>
        /// Gets or sets status.
        /// Network connection status. Possible values are: unknown, attempted, succeeded, blocked, failed.
        /// </summary>
        [JsonPropertyName("status")]
        public ConnectionStatus? Status { get; set; }
    
        /// <summary>
        /// Gets or sets urlParameters.
        /// Parameters (suffix) of the destination URL.
        /// </summary>
        [JsonPropertyName("urlParameters")]
        public string UrlParameters { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
