// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Notebook.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<Notebook>))]
    public partial class Notebook : OnenoteEntityHierarchyModel
    {
    
        ///<summary>
        /// The Notebook constructor
        ///</summary>
        public Notebook()
        {
            this.ODataType = "microsoft.graph.notebook";
        }

        /// <summary>
        /// Gets or sets is default.
        /// Indicates whether this is the user's default notebook. Read-only.
        /// </summary>
        [JsonPropertyName("isDefault")]
        public bool? IsDefault { get; set; }
    
        /// <summary>
        /// Gets or sets is shared.
        /// Indicates whether the notebook is shared. If true, the contents of the notebook can be seen by people other than the owner. Read-only.
        /// </summary>
        [JsonPropertyName("isShared")]
        public bool? IsShared { get; set; }
    
        /// <summary>
        /// Gets or sets links.
        /// Links for opening the notebook. The oneNoteClientURL link opens the notebook in the OneNote native client if it's installed. The oneNoteWebURL link opens the notebook in OneNote on the web.
        /// </summary>
        [JsonPropertyName("links")]
        public NotebookLinks Links { get; set; }
    
        /// <summary>
        /// Gets or sets section groups url.
        /// The URL for the sectionGroups navigation property, which returns all the section groups in the notebook. Read-only.
        /// </summary>
        [JsonPropertyName("sectionGroupsUrl")]
        public string SectionGroupsUrl { get; set; }
    
        /// <summary>
        /// Gets or sets sections url.
        /// The URL for the sections navigation property, which returns all the sections in the notebook. Read-only.
        /// </summary>
        [JsonPropertyName("sectionsUrl")]
        public string SectionsUrl { get; set; }
    
        /// <summary>
        /// Gets or sets user role.
        /// Possible values are: Owner, Contributor, Reader, None. Owner represents owner-level access to the notebook. Contributor represents read/write access to the notebook. Reader represents read-only access to the notebook. Read-only.
        /// </summary>
        [JsonPropertyName("userRole")]
        public OnenoteUserRole? UserRole { get; set; }
    
        /// <summary>
        /// Gets or sets section groups.
        /// The section groups in the notebook. Read-only. Nullable.
        /// </summary>
        [JsonPropertyName("sectionGroups")]
        public INotebookSectionGroupsCollectionPage SectionGroups { get; set; }

        /// <summary>
        /// Gets or sets sectionGroupsNextLink.
        /// </summary>
        [JsonPropertyName("sectionGroups@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string SectionGroupsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets sections.
        /// The sections in the notebook. Read-only. Nullable.
        /// </summary>
        [JsonPropertyName("sections")]
        public INotebookSectionsCollectionPage Sections { get; set; }

        /// <summary>
        /// Gets or sets sectionsNextLink.
        /// </summary>
        [JsonPropertyName("sections@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string SectionsNextLink { get; set; }
    
    }
}

