// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type PermissionScope.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<PermissionScope>))]
    public partial class PermissionScope
    {

        /// <summary>
        /// Gets or sets adminConsentDescription.
        /// A description of the delegated permissions, intended to be read by an administrator granting the permission on behalf of all users. This text appears in tenant-wide admin consent experiences.
        /// </summary>
        [JsonPropertyName("adminConsentDescription")]
        public string AdminConsentDescription { get; set; }
    
        /// <summary>
        /// Gets or sets adminConsentDisplayName.
        /// The permission's title, intended to be read by an administrator granting the permission on behalf of all users.
        /// </summary>
        [JsonPropertyName("adminConsentDisplayName")]
        public string AdminConsentDisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets id.
        /// Unique delegated permission identifier inside the collection of delegated permissions defined for a resource application.
        /// </summary>
        [JsonPropertyName("id")]
        public Guid? Id { get; set; }
    
        /// <summary>
        /// Gets or sets isEnabled.
        /// When creating or updating a permission, this property must be set to true (which is the default). To delete a permission, this property must first be set to false.  At that point, in a subsequent call, the permission may be removed.
        /// </summary>
        [JsonPropertyName("isEnabled")]
        public bool? IsEnabled { get; set; }
    
        /// <summary>
        /// Gets or sets origin.
        /// </summary>
        [JsonPropertyName("origin")]
        public string Origin { get; set; }
    
        /// <summary>
        /// Gets or sets type.
        /// The possible values are: User and Admin. Specifies whether this delegated permission should be considered safe for non-admin users to consent to on behalf of themselves, or whether an administrator consent should always be required. While Microsoft Graph defines the default consent requirement for each permission, the tenant administrator may override the behavior in their organization (by allowing, restricting, or limiting user consent to this delegated permission). For more information, see Configure how users consent to applications.
        /// </summary>
        [JsonPropertyName("type")]
        public string Type { get; set; }
    
        /// <summary>
        /// Gets or sets userConsentDescription.
        /// A description of the delegated permissions, intended to be read by a user granting the permission on their own behalf. This text appears in consent experiences where the user is consenting only on behalf of themselves.
        /// </summary>
        [JsonPropertyName("userConsentDescription")]
        public string UserConsentDescription { get; set; }
    
        /// <summary>
        /// Gets or sets userConsentDisplayName.
        /// A title for the permission, intended to be read by a user granting the permission on their own behalf. This text appears in consent experiences where the user is consenting only on behalf of themselves.
        /// </summary>
        [JsonPropertyName("userConsentDisplayName")]
        public string UserConsentDisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets value.
        /// Specifies the value to include in the scp (scope) claim in access tokens. Must not exceed 120 characters in length. Allowed characters are : ! # $ % &amp; ' ( ) * + , - . / : ;  =  ? @ [ ] ^ + _  {  } ~, as well as characters in the ranges 0-9, A-Z and a-z. Any other character, including the space character, are not allowed. May not begin with ..
        /// </summary>
        [JsonPropertyName("value")]
        public string Value { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
