// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Planner Bucket.
    /// </summary>
    public partial class PlannerBucket : Entity
    {
    
        /// <summary>
        /// Gets or sets name.
        /// Name of the bucket.
        /// </summary>
        [JsonPropertyName("name")]
        public string Name { get; set; }
    
        /// <summary>
        /// Gets or sets order hint.
        /// Hint used to order items of this type in a list view. The format is defined as outlined here.
        /// </summary>
        [JsonPropertyName("orderHint")]
        public string OrderHint { get; set; }
    
        /// <summary>
        /// Gets or sets plan id.
        /// Plan ID to which the bucket belongs.
        /// </summary>
        [JsonPropertyName("planId")]
        public string PlanId { get; set; }
    
        /// <summary>
        /// Gets or sets tasks.
        /// Read-only. Nullable. The collection of tasks in the bucket.
        /// </summary>
        [JsonPropertyName("tasks")]
        public IPlannerBucketTasksCollectionPage Tasks { get; set; }

        /// <summary>
        /// Gets or sets tasksNextLink.
        /// </summary>
        [JsonPropertyName("tasks@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string TasksNextLink { get; set; }
    
    }
}

