// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Print Connector.
    /// </summary>
    public partial class PrintConnector : Entity
    {
    
        /// <summary>
        /// Gets or sets app version.
        /// The connector's version.
        /// </summary>
        [JsonPropertyName("appVersion")]
        public string AppVersion { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// The name of the connector.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets fully qualified domain name.
        /// The connector machine's hostname.
        /// </summary>
        [JsonPropertyName("fullyQualifiedDomainName")]
        public string FullyQualifiedDomainName { get; set; }
    
        /// <summary>
        /// Gets or sets location.
        /// The physical and/or organizational location of the connector.
        /// </summary>
        [JsonPropertyName("location")]
        public PrinterLocation Location { get; set; }
    
        /// <summary>
        /// Gets or sets operating system.
        /// The connector machine's operating system version.
        /// </summary>
        [JsonPropertyName("operatingSystem")]
        public string OperatingSystem { get; set; }
    
        /// <summary>
        /// Gets or sets registered date time.
        /// The DateTimeOffset when the connector was registered.
        /// </summary>
        [JsonPropertyName("registeredDateTime")]
        public DateTimeOffset? RegisteredDateTime { get; set; }
    
    }
}

