// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Print Job.
    /// </summary>
    public partial class PrintJob : Entity
    {
    
        /// <summary>
        /// Gets or sets configuration.
        /// A group of settings that a printer should use to print a job.
        /// </summary>
        [JsonPropertyName("configuration")]
        public PrintJobConfiguration Configuration { get; set; }
    
        /// <summary>
        /// Gets or sets created by.
        /// Read-only. Nullable.
        /// </summary>
        [JsonPropertyName("createdBy")]
        public UserIdentity CreatedBy { get; set; }
    
        /// <summary>
        /// Gets or sets created date time.
        /// The DateTimeOffset when the job was created. Read-only.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets is fetchable.
        /// If true, document can be fetched by printer.
        /// </summary>
        [JsonPropertyName("isFetchable")]
        public bool? IsFetchable { get; set; }
    
        /// <summary>
        /// Gets or sets redirected from.
        /// Contains the source job URL, if the job has been redirected from another printer.
        /// </summary>
        [JsonPropertyName("redirectedFrom")]
        public string RedirectedFrom { get; set; }
    
        /// <summary>
        /// Gets or sets redirected to.
        /// Contains the destination job URL, if the job has been redirected to another printer.
        /// </summary>
        [JsonPropertyName("redirectedTo")]
        public string RedirectedTo { get; set; }
    
        /// <summary>
        /// Gets or sets status.
        /// The status of the print job. Read-only.
        /// </summary>
        [JsonPropertyName("status")]
        public PrintJobStatus Status { get; set; }
    
        /// <summary>
        /// Gets or sets documents.
        /// Read-only.
        /// </summary>
        [JsonPropertyName("documents")]
        public IPrintJobDocumentsCollectionPage Documents { get; set; }

        /// <summary>
        /// Gets or sets documentsNextLink.
        /// </summary>
        [JsonPropertyName("documents@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DocumentsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets tasks.
        /// A list of printTasks that were triggered by this print job.
        /// </summary>
        [JsonPropertyName("tasks")]
        public IPrintJobTasksCollectionPage Tasks { get; set; }

        /// <summary>
        /// Gets or sets tasksNextLink.
        /// </summary>
        [JsonPropertyName("tasks@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string TasksNextLink { get; set; }
    
    }
}

