// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type ProvisioningErrorInfo.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ProvisioningErrorInfo>))]
    public partial class ProvisioningErrorInfo
    {

        /// <summary>
        /// Gets or sets additionalDetails.
        /// Additional details in case of error.
        /// </summary>
        [JsonPropertyName("additionalDetails")]
        public string AdditionalDetails { get; set; }
    
        /// <summary>
        /// Gets or sets errorCategory.
        /// Categorizes the error code. Possible values are failure, nonServiceFailure, success, unknownFutureValue
        /// </summary>
        [JsonPropertyName("errorCategory")]
        public ProvisioningStatusErrorCategory? ErrorCategory { get; set; }
    
        /// <summary>
        /// Gets or sets errorCode.
        /// Unique error code if any occurred. Learn more
        /// </summary>
        [JsonPropertyName("errorCode")]
        public string ErrorCode { get; set; }
    
        /// <summary>
        /// Gets or sets reason.
        /// Summarizes the status and describes why the status happened.
        /// </summary>
        [JsonPropertyName("reason")]
        public string Reason { get; set; }
    
        /// <summary>
        /// Gets or sets recommendedAction.
        /// Provides the resolution for the corresponding error.
        /// </summary>
        [JsonPropertyName("recommendedAction")]
        public string RecommendedAction { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
