// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Quota.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<Quota>))]
    public partial class Quota
    {

        /// <summary>
        /// Gets or sets deleted.
        /// Total space consumed by files in the recycle bin, in bytes. Read-only.
        /// </summary>
        [JsonPropertyName("deleted")]
        public Int64? Deleted { get; set; }
    
        /// <summary>
        /// Gets or sets remaining.
        /// Total space remaining before reaching the quota limit, in bytes. Read-only.
        /// </summary>
        [JsonPropertyName("remaining")]
        public Int64? Remaining { get; set; }
    
        /// <summary>
        /// Gets or sets state.
        /// Enumeration value that indicates the state of the storage space. Read-only.
        /// </summary>
        [JsonPropertyName("state")]
        public string State { get; set; }
    
        /// <summary>
        /// Gets or sets storagePlanInformation.
        /// Information about the drive's storage quota plans. Only in Personal OneDrive.
        /// </summary>
        [JsonPropertyName("storagePlanInformation")]
        public StoragePlanInformation StoragePlanInformation { get; set; }
    
        /// <summary>
        /// Gets or sets total.
        /// Total allowed storage space, in bytes. Read-only.
        /// </summary>
        [JsonPropertyName("total")]
        public Int64? Total { get; set; }
    
        /// <summary>
        /// Gets or sets used.
        /// Total space used, in bytes. Read-only.
        /// </summary>
        [JsonPropertyName("used")]
        public Int64? Used { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
