// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type RelatedContact.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<RelatedContact>))]
    public partial class RelatedContact
    {

        /// <summary>
        /// Gets or sets accessConsent.
        /// Indicates whether the user has been consented to access student data.
        /// </summary>
        [JsonPropertyName("accessConsent")]
        public bool? AccessConsent { get; set; }
    
        /// <summary>
        /// Gets or sets displayName.
        /// Name of the contact. Required.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets emailAddress.
        /// Email address of the contact.
        /// </summary>
        [JsonPropertyName("emailAddress")]
        public string EmailAddress { get; set; }
    
        /// <summary>
        /// Gets or sets mobilePhone.
        /// Mobile phone number of the contact.
        /// </summary>
        [JsonPropertyName("mobilePhone")]
        public string MobilePhone { get; set; }
    
        /// <summary>
        /// Gets or sets relationship.
        /// Relationship to the user. Possible values are: parent, relative, aide, doctor, guardian, child, other, unknownFutureValue.
        /// </summary>
        [JsonPropertyName("relationship")]
        public ContactRelationship? Relationship { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
