// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type RemoteItem.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<RemoteItem>))]
    public partial class RemoteItem
    {

        /// <summary>
        /// Gets or sets createdBy.
        /// Identity of the user, device, and application which created the item. Read-only.
        /// </summary>
        [JsonPropertyName("createdBy")]
        public IdentitySet CreatedBy { get; set; }
    
        /// <summary>
        /// Gets or sets createdDateTime.
        /// Date and time of item creation. Read-only.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets file.
        /// Indicates that the remote item is a file. Read-only.
        /// </summary>
        [JsonPropertyName("file")]
        public File File { get; set; }
    
        /// <summary>
        /// Gets or sets fileSystemInfo.
        /// Information about the remote item from the local file system. Read-only.
        /// </summary>
        [JsonPropertyName("fileSystemInfo")]
        public FileSystemInfo FileSystemInfo { get; set; }
    
        /// <summary>
        /// Gets or sets folder.
        /// Indicates that the remote item is a folder. Read-only.
        /// </summary>
        [JsonPropertyName("folder")]
        public Folder Folder { get; set; }
    
        /// <summary>
        /// Gets or sets id.
        /// Unique identifier for the remote item in its drive. Read-only.
        /// </summary>
        [JsonPropertyName("id")]
        public string Id { get; set; }
    
        /// <summary>
        /// Gets or sets image.
        /// Image metadata, if the item is an image. Read-only.
        /// </summary>
        [JsonPropertyName("image")]
        public Image Image { get; set; }
    
        /// <summary>
        /// Gets or sets lastModifiedBy.
        /// Identity of the user, device, and application which last modified the item. Read-only.
        /// </summary>
        [JsonPropertyName("lastModifiedBy")]
        public IdentitySet LastModifiedBy { get; set; }
    
        /// <summary>
        /// Gets or sets lastModifiedDateTime.
        /// Date and time the item was last modified. Read-only.
        /// </summary>
        [JsonPropertyName("lastModifiedDateTime")]
        public DateTimeOffset? LastModifiedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets name.
        /// Optional. Filename of the remote item. Read-only.
        /// </summary>
        [JsonPropertyName("name")]
        public string Name { get; set; }
    
        /// <summary>
        /// Gets or sets package.
        /// If present, indicates that this item is a package instead of a folder or file. Packages are treated like files in some contexts and folders in others. Read-only.
        /// </summary>
        [JsonPropertyName("package")]
        public Package Package { get; set; }
    
        /// <summary>
        /// Gets or sets parentReference.
        /// Properties of the parent of the remote item. Read-only.
        /// </summary>
        [JsonPropertyName("parentReference")]
        public ItemReference ParentReference { get; set; }
    
        /// <summary>
        /// Gets or sets shared.
        /// Indicates that the item has been shared with others and provides information about the shared state of the item. Read-only.
        /// </summary>
        [JsonPropertyName("shared")]
        public Shared Shared { get; set; }
    
        /// <summary>
        /// Gets or sets sharepointIds.
        /// Provides interop between items in OneDrive for Business and SharePoint with the full set of item identifiers. Read-only.
        /// </summary>
        [JsonPropertyName("sharepointIds")]
        public SharepointIds SharepointIds { get; set; }
    
        /// <summary>
        /// Gets or sets size.
        /// Size of the remote item. Read-only.
        /// </summary>
        [JsonPropertyName("size")]
        public Int64? Size { get; set; }
    
        /// <summary>
        /// Gets or sets specialFolder.
        /// If the current item is also available as a special folder, this facet is returned. Read-only.
        /// </summary>
        [JsonPropertyName("specialFolder")]
        public SpecialFolder SpecialFolder { get; set; }
    
        /// <summary>
        /// Gets or sets video.
        /// Video metadata, if the item is a video. Read-only.
        /// </summary>
        [JsonPropertyName("video")]
        public Video Video { get; set; }
    
        /// <summary>
        /// Gets or sets webDavUrl.
        /// DAV compatible URL for the item.
        /// </summary>
        [JsonPropertyName("webDavUrl")]
        public string WebDavUrl { get; set; }
    
        /// <summary>
        /// Gets or sets webUrl.
        /// URL that displays the resource in the browser. Read-only.
        /// </summary>
        [JsonPropertyName("webUrl")]
        public string WebUrl { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
