// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type ResourceVisualization.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ResourceVisualization>))]
    public partial class ResourceVisualization
    {

        /// <summary>
        /// Gets or sets containerDisplayName.
        /// A string describing where the item is stored. For example, the name of a SharePoint site or the user name identifying the owner of the OneDrive storing the item.
        /// </summary>
        [JsonPropertyName("containerDisplayName")]
        public string ContainerDisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets containerType.
        /// Can be used for filtering by the type of container in which the file is stored. Such as Site or OneDriveBusiness.
        /// </summary>
        [JsonPropertyName("containerType")]
        public string ContainerType { get; set; }
    
        /// <summary>
        /// Gets or sets containerWebUrl.
        /// A path leading to the folder in which the item is stored.
        /// </summary>
        [JsonPropertyName("containerWebUrl")]
        public string ContainerWebUrl { get; set; }
    
        /// <summary>
        /// Gets or sets mediaType.
        /// The item's media type. Can be used for filtering for a specific type of file based on supported IANA Media Mime Types. Note that not all Media Mime Types are supported.
        /// </summary>
        [JsonPropertyName("mediaType")]
        public string MediaType { get; set; }
    
        /// <summary>
        /// Gets or sets previewImageUrl.
        /// A URL leading to the preview image for the item.
        /// </summary>
        [JsonPropertyName("previewImageUrl")]
        public string PreviewImageUrl { get; set; }
    
        /// <summary>
        /// Gets or sets previewText.
        /// A preview text for the item.
        /// </summary>
        [JsonPropertyName("previewText")]
        public string PreviewText { get; set; }
    
        /// <summary>
        /// Gets or sets title.
        /// The item's title text.
        /// </summary>
        [JsonPropertyName("title")]
        public string Title { get; set; }
    
        /// <summary>
        /// Gets or sets type.
        /// The item's media type. Can be used for filtering for a specific file based on a specific type. See below for supported types.
        /// </summary>
        [JsonPropertyName("type")]
        public string Type { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
