// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Secure Score.
    /// </summary>
    public partial class SecureScore : Entity
    {
    
        /// <summary>
        /// Gets or sets active user count.
        /// Active user count of the given tenant.
        /// </summary>
        [JsonPropertyName("activeUserCount")]
        public Int32? ActiveUserCount { get; set; }
    
        /// <summary>
        /// Gets or sets average comparative scores.
        /// Average score by different scopes (for example, average by industry, average by seating) and control category (Identity, Data, Device, Apps, Infrastructure) within the scope.
        /// </summary>
        [JsonPropertyName("averageComparativeScores")]
        public IEnumerable<AverageComparativeScore> AverageComparativeScores { get; set; }
    
        /// <summary>
        /// Gets or sets azure tenant id.
        /// GUID string for tenant ID.
        /// </summary>
        [JsonPropertyName("azureTenantId")]
        public string AzureTenantId { get; set; }
    
        /// <summary>
        /// Gets or sets control scores.
        /// Contains tenant scores for a set of controls.
        /// </summary>
        [JsonPropertyName("controlScores")]
        public IEnumerable<ControlScore> ControlScores { get; set; }
    
        /// <summary>
        /// Gets or sets created date time.
        /// The date when the entity is created.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets current score.
        /// Tenant current attained score on specified date.
        /// </summary>
        [JsonPropertyName("currentScore")]
        public double? CurrentScore { get; set; }
    
        /// <summary>
        /// Gets or sets enabled services.
        /// Microsoft-provided services for the tenant (for example, Exchange online, Skype, Sharepoint).
        /// </summary>
        [JsonPropertyName("enabledServices")]
        public IEnumerable<string> EnabledServices { get; set; }
    
        /// <summary>
        /// Gets or sets licensed user count.
        /// Licensed user count of the given tenant.
        /// </summary>
        [JsonPropertyName("licensedUserCount")]
        public Int32? LicensedUserCount { get; set; }
    
        /// <summary>
        /// Gets or sets max score.
        /// Tenant maximum possible score on specified date.
        /// </summary>
        [JsonPropertyName("maxScore")]
        public double? MaxScore { get; set; }
    
        /// <summary>
        /// Gets or sets vendor information.
        /// Complex type containing details about the security product/service vendor, provider, and subprovider (for example, vendor=Microsoft; provider=SecureScore). Required.
        /// </summary>
        [JsonPropertyName("vendorInformation")]
        public SecurityVendorInformation VendorInformation { get; set; }
    
    }
}

