// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Shared Insight.
    /// </summary>
    public partial class SharedInsight : Entity
    {
    
        /// <summary>
        /// Gets or sets last shared.
        /// Details about the shared item. Read only.
        /// </summary>
        [JsonPropertyName("lastShared")]
        public SharingDetail LastShared { get; set; }
    
        /// <summary>
        /// Gets or sets resource reference.
        /// Reference properties of the shared document, such as the url and type of the document. Read-only
        /// </summary>
        [JsonPropertyName("resourceReference")]
        public ResourceReference ResourceReference { get; set; }
    
        /// <summary>
        /// Gets or sets resource visualization.
        /// Properties that you can use to visualize the document in your experience. Read-only
        /// </summary>
        [JsonPropertyName("resourceVisualization")]
        public ResourceVisualization ResourceVisualization { get; set; }
    
        /// <summary>
        /// Gets or sets sharing history.
        /// </summary>
        [JsonPropertyName("sharingHistory")]
        public IEnumerable<SharingDetail> SharingHistory { get; set; }
    
        /// <summary>
        /// Gets or sets last shared method.
        /// </summary>
        [JsonPropertyName("lastSharedMethod")]
        public Entity LastSharedMethod { get; set; }
    
        /// <summary>
        /// Gets or sets resource.
        /// Used for navigating to the item that was shared. For file attachments, the type is fileAttachment. For linked attachments, the type is driveItem.
        /// </summary>
        [JsonPropertyName("resource")]
        public Entity Resource { get; set; }
    
    }
}

