// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type SharingDetail.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<SharingDetail>))]
    public partial class SharingDetail
    {

        /// <summary>
        /// Gets or sets sharedBy.
        /// The user who shared the document.
        /// </summary>
        [JsonPropertyName("sharedBy")]
        public InsightIdentity SharedBy { get; set; }
    
        /// <summary>
        /// Gets or sets sharedDateTime.
        /// The date and time the file was last shared. The timestamp represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
        /// </summary>
        [JsonPropertyName("sharedDateTime")]
        public DateTimeOffset? SharedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets sharingReference.
        /// </summary>
        [JsonPropertyName("sharingReference")]
        public ResourceReference SharingReference { get; set; }
    
        /// <summary>
        /// Gets or sets sharingSubject.
        /// The subject with which the document was shared.
        /// </summary>
        [JsonPropertyName("sharingSubject")]
        public string SharingSubject { get; set; }
    
        /// <summary>
        /// Gets or sets sharingType.
        /// Determines the way the document was shared, can be by a 'Link', 'Attachment', 'Group', 'Site'.
        /// </summary>
        [JsonPropertyName("sharingType")]
        public string SharingType { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
