// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type StandardTimeZoneOffset.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<StandardTimeZoneOffset>))]
    public partial class StandardTimeZoneOffset
    {

        /// <summary>
        /// Gets or sets dayOccurrence.
        /// Represents the nth occurrence of the day of week that the transition from daylight saving time to standard time occurs.
        /// </summary>
        [JsonPropertyName("dayOccurrence")]
        public Int32? DayOccurrence { get; set; }
    
        /// <summary>
        /// Gets or sets dayOfWeek.
        /// Represents the day of the week when the transition from daylight saving time to standard time.
        /// </summary>
        [JsonPropertyName("dayOfWeek")]
        public DayOfWeek? DayOfWeek { get; set; }
    
        /// <summary>
        /// Gets or sets month.
        /// Represents the month of the year when the transition from daylight saving time to standard time occurs.
        /// </summary>
        [JsonPropertyName("month")]
        public Int32? Month { get; set; }
    
        /// <summary>
        /// Gets or sets time.
        /// Represents the time of day when the transition from daylight saving time to standard time occurs.
        /// </summary>
        [JsonPropertyName("time")]
        public TimeOfDay Time { get; set; }
    
        /// <summary>
        /// Gets or sets year.
        /// Represents how frequently in terms of years the change from daylight saving time to standard time occurs. For example, a value of 0 means every year.
        /// </summary>
        [JsonPropertyName("year")]
        public Int32? Year { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
