// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Teams App.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<TeamsApp>))]
    public partial class TeamsApp : Entity
    {
    
        /// <summary>
        /// Gets or sets display name.
        /// The name of the catalog app provided by the app developer in the Microsoft Teams zip app package.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets distribution method.
        /// The method of distribution for the app. Read-only.
        /// </summary>
        [JsonPropertyName("distributionMethod")]
        public TeamsAppDistributionMethod? DistributionMethod { get; set; }
    
        /// <summary>
        /// Gets or sets external id.
        /// The ID of the catalog provided by the app developer in the Microsoft Teams zip app package.
        /// </summary>
        [JsonPropertyName("externalId")]
        public string ExternalId { get; set; }
    
        /// <summary>
        /// Gets or sets app definitions.
        /// The details for each version of the app.
        /// </summary>
        [JsonPropertyName("appDefinitions")]
        public ITeamsAppAppDefinitionsCollectionPage AppDefinitions { get; set; }

        /// <summary>
        /// Gets or sets appDefinitionsNextLink.
        /// </summary>
        [JsonPropertyName("appDefinitions@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string AppDefinitionsNextLink { get; set; }
    
    }
}

