// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Terms And Conditions Acceptance Status.
    /// </summary>
    public partial class TermsAndConditionsAcceptanceStatus : Entity
    {
    
        /// <summary>
        /// Gets or sets accepted date time.
        /// DateTime when the terms were last accepted by the user.
        /// </summary>
        [JsonPropertyName("acceptedDateTime")]
        public DateTimeOffset? AcceptedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets accepted version.
        /// Most recent version number of the T&amp;C accepted by the user.
        /// </summary>
        [JsonPropertyName("acceptedVersion")]
        public Int32? AcceptedVersion { get; set; }
    
        /// <summary>
        /// Gets or sets user display name.
        /// Display name of the user whose acceptance the entity represents.
        /// </summary>
        [JsonPropertyName("userDisplayName")]
        public string UserDisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets user principal name.
        /// The userPrincipalName of the User that accepted the term.
        /// </summary>
        [JsonPropertyName("userPrincipalName")]
        public string UserPrincipalName { get; set; }
    
        /// <summary>
        /// Gets or sets terms and conditions.
        /// Navigation link to the terms and conditions that are assigned.
        /// </summary>
        [JsonPropertyName("termsAndConditions")]
        public TermsAndConditions TermsAndConditions { get; set; }
    
    }
}

