// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type UserSecurityState.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<UserSecurityState>))]
    public partial class UserSecurityState
    {

        /// <summary>
        /// Gets or sets aadUserId.
        /// AAD User object identifier (GUID) - represents the physical/multi-account user entity.
        /// </summary>
        [JsonPropertyName("aadUserId")]
        public string AadUserId { get; set; }
    
        /// <summary>
        /// Gets or sets accountName.
        /// Account name of user account (without Active Directory domain or DNS domain) - (also called mailNickName).
        /// </summary>
        [JsonPropertyName("accountName")]
        public string AccountName { get; set; }
    
        /// <summary>
        /// Gets or sets domainName.
        /// NetBIOS/Active Directory domain of user account (that is, domain/account format).
        /// </summary>
        [JsonPropertyName("domainName")]
        public string DomainName { get; set; }
    
        /// <summary>
        /// Gets or sets emailRole.
        /// For email-related alerts - user account's email 'role'. Possible values are: unknown, sender, recipient.
        /// </summary>
        [JsonPropertyName("emailRole")]
        public EmailRole? EmailRole { get; set; }
    
        /// <summary>
        /// Gets or sets isVpn.
        /// Indicates whether the user logged on through a VPN.
        /// </summary>
        [JsonPropertyName("isVpn")]
        public bool? IsVpn { get; set; }
    
        /// <summary>
        /// Gets or sets logonDateTime.
        /// Time at which the sign-in occurred. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
        /// </summary>
        [JsonPropertyName("logonDateTime")]
        public DateTimeOffset? LogonDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets logonId.
        /// User sign-in ID.
        /// </summary>
        [JsonPropertyName("logonId")]
        public string LogonId { get; set; }
    
        /// <summary>
        /// Gets or sets logonIp.
        /// IP Address the sign-in request originated from.
        /// </summary>
        [JsonPropertyName("logonIp")]
        public string LogonIp { get; set; }
    
        /// <summary>
        /// Gets or sets logonLocation.
        /// Location (by IP address mapping) associated with a user sign-in event by this user.
        /// </summary>
        [JsonPropertyName("logonLocation")]
        public string LogonLocation { get; set; }
    
        /// <summary>
        /// Gets or sets logonType.
        /// Method of user sign in. Possible values are: unknown, interactive, remoteInteractive, network, batch, service.
        /// </summary>
        [JsonPropertyName("logonType")]
        public LogonType? LogonType { get; set; }
    
        /// <summary>
        /// Gets or sets onPremisesSecurityIdentifier.
        /// Active Directory (on-premises) Security Identifier (SID) of the user.
        /// </summary>
        [JsonPropertyName("onPremisesSecurityIdentifier")]
        public string OnPremisesSecurityIdentifier { get; set; }
    
        /// <summary>
        /// Gets or sets riskScore.
        /// Provider-generated/calculated risk score of the user account. Recommended value range of 0-1, which equates to a percentage.
        /// </summary>
        [JsonPropertyName("riskScore")]
        public string RiskScore { get; set; }
    
        /// <summary>
        /// Gets or sets userAccountType.
        /// User account type (group membership), per Windows definition. Possible values are: unknown, standard, power, administrator.
        /// </summary>
        [JsonPropertyName("userAccountType")]
        public UserAccountSecurityType? UserAccountType { get; set; }
    
        /// <summary>
        /// Gets or sets userPrincipalName.
        /// User sign-in name - internet format: (user account name)@(user account DNS domain name).
        /// </summary>
        [JsonPropertyName("userPrincipalName")]
        public string UserPrincipalName { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
