// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type VerifiedDomain.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<VerifiedDomain>))]
    public partial class VerifiedDomain
    {

        /// <summary>
        /// Gets or sets capabilities.
        /// For example, 'Email', 'OfficeCommunicationsOnline'.
        /// </summary>
        [JsonPropertyName("capabilities")]
        public string Capabilities { get; set; }
    
        /// <summary>
        /// Gets or sets isDefault.
        /// true if this is the default domain associated with the tenant; otherwise, false.
        /// </summary>
        [JsonPropertyName("isDefault")]
        public bool? IsDefault { get; set; }
    
        /// <summary>
        /// Gets or sets isInitial.
        /// true if this is the initial domain associated with the tenant; otherwise, false
        /// </summary>
        [JsonPropertyName("isInitial")]
        public bool? IsInitial { get; set; }
    
        /// <summary>
        /// Gets or sets name.
        /// The domain name; for example, 'contoso.onmicrosoft.com'
        /// </summary>
        [JsonPropertyName("name")]
        public string Name { get; set; }
    
        /// <summary>
        /// Gets or sets type.
        /// For example, 'Managed'.
        /// </summary>
        [JsonPropertyName("type")]
        public string Type { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
