// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type VisualInfo.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<VisualInfo>))]
    public partial class VisualInfo
    {

        /// <summary>
        /// Gets or sets attribution.
        /// Optional. JSON object used to represent an icon which represents the application used to generate the activity
        /// </summary>
        [JsonPropertyName("attribution")]
        public ImageInfo Attribution { get; set; }
    
        /// <summary>
        /// Gets or sets backgroundColor.
        /// Optional. Background color used to render the activity in the UI - brand color for the application source of the activity. Must be a valid hex color
        /// </summary>
        [JsonPropertyName("backgroundColor")]
        public string BackgroundColor { get; set; }
    
        /// <summary>
        /// Gets or sets content.
        /// Optional. Custom piece of data - JSON object used to provide custom content to render the activity in the Windows Shell UI
        /// </summary>
        [JsonPropertyName("content")]
        public System.Text.Json.JsonDocument Content { get; set; }
    
        /// <summary>
        /// Gets or sets description.
        /// Optional. Longer text description of the user's unique activity (example: document name, first sentence, and/or metadata)
        /// </summary>
        [JsonPropertyName("description")]
        public string Description { get; set; }
    
        /// <summary>
        /// Gets or sets displayText.
        /// Required. Short text description of the user's unique activity (for example, document name in cases where an activity refers to document creation)
        /// </summary>
        [JsonPropertyName("displayText")]
        public string DisplayText { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
