// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Win32LobAppMsiInformation.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<Win32LobAppMsiInformation>))]
    public partial class Win32LobAppMsiInformation
    {

        /// <summary>
        /// Gets or sets packageType.
        /// The MSI package type. Possible values are: perMachine, perUser, dualPurpose.
        /// </summary>
        [JsonPropertyName("packageType")]
        public Win32LobAppMsiPackageType? PackageType { get; set; }
    
        /// <summary>
        /// Gets or sets productCode.
        /// The MSI product code.
        /// </summary>
        [JsonPropertyName("productCode")]
        public string ProductCode { get; set; }
    
        /// <summary>
        /// Gets or sets productName.
        /// The MSI product name.
        /// </summary>
        [JsonPropertyName("productName")]
        public string ProductName { get; set; }
    
        /// <summary>
        /// Gets or sets productVersion.
        /// The MSI product version.
        /// </summary>
        [JsonPropertyName("productVersion")]
        public string ProductVersion { get; set; }
    
        /// <summary>
        /// Gets or sets publisher.
        /// The MSI publisher.
        /// </summary>
        [JsonPropertyName("publisher")]
        public string Publisher { get; set; }
    
        /// <summary>
        /// Gets or sets requiresReboot.
        /// Whether the MSI app requires the machine to reboot to complete installation.
        /// </summary>
        [JsonPropertyName("requiresReboot")]
        public bool? RequiresReboot { get; set; }
    
        /// <summary>
        /// Gets or sets upgradeCode.
        /// The MSI upgrade code.
        /// </summary>
        [JsonPropertyName("upgradeCode")]
        public string UpgradeCode { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
