// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Windows10General Configuration.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<Windows10GeneralConfiguration>))]
    public partial class Windows10GeneralConfiguration : DeviceConfiguration
    {
    
        ///<summary>
        /// The Windows10GeneralConfiguration constructor
        ///</summary>
        public Windows10GeneralConfiguration()
        {
            this.ODataType = "microsoft.graph.windows10GeneralConfiguration";
        }

        /// <summary>
        /// Gets or sets accounts block adding non microsoft account email.
        /// Indicates whether or not to Block the user from adding email accounts to the device that are not associated with a Microsoft account.
        /// </summary>
        [JsonPropertyName("accountsBlockAddingNonMicrosoftAccountEmail")]
        public bool? AccountsBlockAddingNonMicrosoftAccountEmail { get; set; }
    
        /// <summary>
        /// Gets or sets anti theft mode blocked.
        /// Indicates whether or not to block the user from selecting an AntiTheft mode preference (Windows 10 Mobile only).
        /// </summary>
        [JsonPropertyName("antiTheftModeBlocked")]
        public bool? AntiTheftModeBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets apps allow trusted apps sideloading.
        /// Indicates whether apps from AppX packages signed with a trusted certificate can be side loaded. Possible values are: notConfigured, blocked, allowed.
        /// </summary>
        [JsonPropertyName("appsAllowTrustedAppsSideloading")]
        public StateManagementSetting? AppsAllowTrustedAppsSideloading { get; set; }
    
        /// <summary>
        /// Gets or sets apps block windows store originated apps.
        /// Indicates whether or not to disable the launch of all apps from Windows Store that came pre-installed or were downloaded.
        /// </summary>
        [JsonPropertyName("appsBlockWindowsStoreOriginatedApps")]
        public bool? AppsBlockWindowsStoreOriginatedApps { get; set; }
    
        /// <summary>
        /// Gets or sets bluetooth allowed services.
        /// Specify a list of allowed Bluetooth services and profiles in hex formatted strings.
        /// </summary>
        [JsonPropertyName("bluetoothAllowedServices")]
        public IEnumerable<string> BluetoothAllowedServices { get; set; }
    
        /// <summary>
        /// Gets or sets bluetooth block advertising.
        /// Whether or not to Block the user from using bluetooth advertising.
        /// </summary>
        [JsonPropertyName("bluetoothBlockAdvertising")]
        public bool? BluetoothBlockAdvertising { get; set; }
    
        /// <summary>
        /// Gets or sets bluetooth block discoverable mode.
        /// Whether or not to Block the user from using bluetooth discoverable mode.
        /// </summary>
        [JsonPropertyName("bluetoothBlockDiscoverableMode")]
        public bool? BluetoothBlockDiscoverableMode { get; set; }
    
        /// <summary>
        /// Gets or sets bluetooth blocked.
        /// Whether or not to Block the user from using bluetooth.
        /// </summary>
        [JsonPropertyName("bluetoothBlocked")]
        public bool? BluetoothBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets bluetooth block pre pairing.
        /// Whether or not to block specific bundled Bluetooth peripherals to automatically pair with the host device.
        /// </summary>
        [JsonPropertyName("bluetoothBlockPrePairing")]
        public bool? BluetoothBlockPrePairing { get; set; }
    
        /// <summary>
        /// Gets or sets camera blocked.
        /// Whether or not to Block the user from accessing the camera of the device.
        /// </summary>
        [JsonPropertyName("cameraBlocked")]
        public bool? CameraBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets cellular block data when roaming.
        /// Whether or not to Block the user from using data over cellular while roaming.
        /// </summary>
        [JsonPropertyName("cellularBlockDataWhenRoaming")]
        public bool? CellularBlockDataWhenRoaming { get; set; }
    
        /// <summary>
        /// Gets or sets cellular block vpn.
        /// Whether or not to Block the user from using VPN over cellular.
        /// </summary>
        [JsonPropertyName("cellularBlockVpn")]
        public bool? CellularBlockVpn { get; set; }
    
        /// <summary>
        /// Gets or sets cellular block vpn when roaming.
        /// Whether or not to Block the user from using VPN when roaming over cellular.
        /// </summary>
        [JsonPropertyName("cellularBlockVpnWhenRoaming")]
        public bool? CellularBlockVpnWhenRoaming { get; set; }
    
        /// <summary>
        /// Gets or sets certificates block manual root certificate installation.
        /// Whether or not to Block the user from doing manual root certificate installation.
        /// </summary>
        [JsonPropertyName("certificatesBlockManualRootCertificateInstallation")]
        public bool? CertificatesBlockManualRootCertificateInstallation { get; set; }
    
        /// <summary>
        /// Gets or sets connected devices service blocked.
        /// Whether or not to block Connected Devices Service which enables discovery and connection to other devices, remote messaging, remote app sessions and other cross-device experiences.
        /// </summary>
        [JsonPropertyName("connectedDevicesServiceBlocked")]
        public bool? ConnectedDevicesServiceBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets copy paste blocked.
        /// Whether or not to Block the user from using copy paste.
        /// </summary>
        [JsonPropertyName("copyPasteBlocked")]
        public bool? CopyPasteBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets cortana blocked.
        /// Whether or not to Block the user from using Cortana.
        /// </summary>
        [JsonPropertyName("cortanaBlocked")]
        public bool? CortanaBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets defender block end user access.
        /// Whether or not to block end user access to Defender.
        /// </summary>
        [JsonPropertyName("defenderBlockEndUserAccess")]
        public bool? DefenderBlockEndUserAccess { get; set; }
    
        /// <summary>
        /// Gets or sets defender cloud block level.
        /// Specifies the level of cloud-delivered protection. Possible values are: notConfigured, high, highPlus, zeroTolerance.
        /// </summary>
        [JsonPropertyName("defenderCloudBlockLevel")]
        public DefenderCloudBlockLevelType? DefenderCloudBlockLevel { get; set; }
    
        /// <summary>
        /// Gets or sets defender days before deleting quarantined malware.
        /// Number of days before deleting quarantined malware. Valid values 0 to 90
        /// </summary>
        [JsonPropertyName("defenderDaysBeforeDeletingQuarantinedMalware")]
        public Int32? DefenderDaysBeforeDeletingQuarantinedMalware { get; set; }
    
        /// <summary>
        /// Gets or sets defender detected malware actions.
        /// Gets or sets Defender’s actions to take on detected Malware per threat level.
        /// </summary>
        [JsonPropertyName("defenderDetectedMalwareActions")]
        public DefenderDetectedMalwareActions DefenderDetectedMalwareActions { get; set; }
    
        /// <summary>
        /// Gets or sets defender file extensions to exclude.
        /// File extensions to exclude from scans and real time protection.
        /// </summary>
        [JsonPropertyName("defenderFileExtensionsToExclude")]
        public IEnumerable<string> DefenderFileExtensionsToExclude { get; set; }
    
        /// <summary>
        /// Gets or sets defender files and folders to exclude.
        /// Files and folder to exclude from scans and real time protection.
        /// </summary>
        [JsonPropertyName("defenderFilesAndFoldersToExclude")]
        public IEnumerable<string> DefenderFilesAndFoldersToExclude { get; set; }
    
        /// <summary>
        /// Gets or sets defender monitor file activity.
        /// Value for monitoring file activity. Possible values are: userDefined, disable, monitorAllFiles, monitorIncomingFilesOnly, monitorOutgoingFilesOnly.
        /// </summary>
        [JsonPropertyName("defenderMonitorFileActivity")]
        public DefenderMonitorFileActivity? DefenderMonitorFileActivity { get; set; }
    
        /// <summary>
        /// Gets or sets defender processes to exclude.
        /// Processes to exclude from scans and real time protection.
        /// </summary>
        [JsonPropertyName("defenderProcessesToExclude")]
        public IEnumerable<string> DefenderProcessesToExclude { get; set; }
    
        /// <summary>
        /// Gets or sets defender prompt for sample submission.
        /// The configuration for how to prompt user for sample submission. Possible values are: userDefined, alwaysPrompt, promptBeforeSendingPersonalData, neverSendData, sendAllDataWithoutPrompting.
        /// </summary>
        [JsonPropertyName("defenderPromptForSampleSubmission")]
        public DefenderPromptForSampleSubmission? DefenderPromptForSampleSubmission { get; set; }
    
        /// <summary>
        /// Gets or sets defender require behavior monitoring.
        /// Indicates whether or not to require behavior monitoring.
        /// </summary>
        [JsonPropertyName("defenderRequireBehaviorMonitoring")]
        public bool? DefenderRequireBehaviorMonitoring { get; set; }
    
        /// <summary>
        /// Gets or sets defender require cloud protection.
        /// Indicates whether or not to require cloud protection.
        /// </summary>
        [JsonPropertyName("defenderRequireCloudProtection")]
        public bool? DefenderRequireCloudProtection { get; set; }
    
        /// <summary>
        /// Gets or sets defender require network inspection system.
        /// Indicates whether or not to require network inspection system.
        /// </summary>
        [JsonPropertyName("defenderRequireNetworkInspectionSystem")]
        public bool? DefenderRequireNetworkInspectionSystem { get; set; }
    
        /// <summary>
        /// Gets or sets defender require real time monitoring.
        /// Indicates whether or not to require real time monitoring.
        /// </summary>
        [JsonPropertyName("defenderRequireRealTimeMonitoring")]
        public bool? DefenderRequireRealTimeMonitoring { get; set; }
    
        /// <summary>
        /// Gets or sets defender scan archive files.
        /// Indicates whether or not to scan archive files.
        /// </summary>
        [JsonPropertyName("defenderScanArchiveFiles")]
        public bool? DefenderScanArchiveFiles { get; set; }
    
        /// <summary>
        /// Gets or sets defender scan downloads.
        /// Indicates whether or not to scan downloads.
        /// </summary>
        [JsonPropertyName("defenderScanDownloads")]
        public bool? DefenderScanDownloads { get; set; }
    
        /// <summary>
        /// Gets or sets defender scan incoming mail.
        /// Indicates whether or not to scan incoming mail messages.
        /// </summary>
        [JsonPropertyName("defenderScanIncomingMail")]
        public bool? DefenderScanIncomingMail { get; set; }
    
        /// <summary>
        /// Gets or sets defender scan mapped network drives during full scan.
        /// Indicates whether or not to scan mapped network drives during full scan.
        /// </summary>
        [JsonPropertyName("defenderScanMappedNetworkDrivesDuringFullScan")]
        public bool? DefenderScanMappedNetworkDrivesDuringFullScan { get; set; }
    
        /// <summary>
        /// Gets or sets defender scan max cpu.
        /// Max CPU usage percentage during scan. Valid values 0 to 100
        /// </summary>
        [JsonPropertyName("defenderScanMaxCpu")]
        public Int32? DefenderScanMaxCpu { get; set; }
    
        /// <summary>
        /// Gets or sets defender scan network files.
        /// Indicates whether or not to scan files opened from a network folder.
        /// </summary>
        [JsonPropertyName("defenderScanNetworkFiles")]
        public bool? DefenderScanNetworkFiles { get; set; }
    
        /// <summary>
        /// Gets or sets defender scan removable drives during full scan.
        /// Indicates whether or not to scan removable drives during full scan.
        /// </summary>
        [JsonPropertyName("defenderScanRemovableDrivesDuringFullScan")]
        public bool? DefenderScanRemovableDrivesDuringFullScan { get; set; }
    
        /// <summary>
        /// Gets or sets defender scan scripts loaded in internet explorer.
        /// Indicates whether or not to scan scripts loaded in Internet Explorer browser.
        /// </summary>
        [JsonPropertyName("defenderScanScriptsLoadedInInternetExplorer")]
        public bool? DefenderScanScriptsLoadedInInternetExplorer { get; set; }
    
        /// <summary>
        /// Gets or sets defender scan type.
        /// The defender system scan type. Possible values are: userDefined, disabled, quick, full.
        /// </summary>
        [JsonPropertyName("defenderScanType")]
        public DefenderScanType? DefenderScanType { get; set; }
    
        /// <summary>
        /// Gets or sets defender scheduled quick scan time.
        /// The time to perform a daily quick scan.
        /// </summary>
        [JsonPropertyName("defenderScheduledQuickScanTime")]
        public TimeOfDay DefenderScheduledQuickScanTime { get; set; }
    
        /// <summary>
        /// Gets or sets defender scheduled scan time.
        /// The defender time for the system scan.
        /// </summary>
        [JsonPropertyName("defenderScheduledScanTime")]
        public TimeOfDay DefenderScheduledScanTime { get; set; }
    
        /// <summary>
        /// Gets or sets defender signature update interval in hours.
        /// The signature update interval in hours. Specify 0 not to check. Valid values 0 to 24
        /// </summary>
        [JsonPropertyName("defenderSignatureUpdateIntervalInHours")]
        public Int32? DefenderSignatureUpdateIntervalInHours { get; set; }
    
        /// <summary>
        /// Gets or sets defender system scan schedule.
        /// Defender day of the week for the system scan. Possible values are: userDefined, everyday, sunday, monday, tuesday, wednesday, thursday, friday, saturday, noScheduledScan.
        /// </summary>
        [JsonPropertyName("defenderSystemScanSchedule")]
        public WeeklySchedule? DefenderSystemScanSchedule { get; set; }
    
        /// <summary>
        /// Gets or sets developer unlock setting.
        /// Indicates whether or not to allow developer unlock. Possible values are: notConfigured, blocked, allowed.
        /// </summary>
        [JsonPropertyName("developerUnlockSetting")]
        public StateManagementSetting? DeveloperUnlockSetting { get; set; }
    
        /// <summary>
        /// Gets or sets device management block factory reset on mobile.
        /// Indicates whether or not to Block the user from resetting their phone.
        /// </summary>
        [JsonPropertyName("deviceManagementBlockFactoryResetOnMobile")]
        public bool? DeviceManagementBlockFactoryResetOnMobile { get; set; }
    
        /// <summary>
        /// Gets or sets device management block manual unenroll.
        /// Indicates whether or not to Block the user from doing manual un-enrollment from device management.
        /// </summary>
        [JsonPropertyName("deviceManagementBlockManualUnenroll")]
        public bool? DeviceManagementBlockManualUnenroll { get; set; }
    
        /// <summary>
        /// Gets or sets diagnostics data submission mode.
        /// Gets or sets a value allowing the device to send diagnostic and usage telemetry data, such as Watson. Possible values are: userDefined, none, basic, enhanced, full.
        /// </summary>
        [JsonPropertyName("diagnosticsDataSubmissionMode")]
        public DiagnosticDataSubmissionMode? DiagnosticsDataSubmissionMode { get; set; }
    
        /// <summary>
        /// Gets or sets edge allow start pages modification.
        /// Allow users to change Start pages on Edge. Use the EdgeHomepageUrls to specify the Start pages that the user would see by default when they open Edge.
        /// </summary>
        [JsonPropertyName("edgeAllowStartPagesModification")]
        public bool? EdgeAllowStartPagesModification { get; set; }
    
        /// <summary>
        /// Gets or sets edge block access to about flags.
        /// Indicates whether or not to prevent access to about flags on Edge browser.
        /// </summary>
        [JsonPropertyName("edgeBlockAccessToAboutFlags")]
        public bool? EdgeBlockAccessToAboutFlags { get; set; }
    
        /// <summary>
        /// Gets or sets edge block address bar dropdown.
        /// Block the address bar dropdown functionality in Microsoft Edge. Disable this settings to minimize network connections from Microsoft Edge to Microsoft services.
        /// </summary>
        [JsonPropertyName("edgeBlockAddressBarDropdown")]
        public bool? EdgeBlockAddressBarDropdown { get; set; }
    
        /// <summary>
        /// Gets or sets edge block autofill.
        /// Indicates whether or not to block auto fill.
        /// </summary>
        [JsonPropertyName("edgeBlockAutofill")]
        public bool? EdgeBlockAutofill { get; set; }
    
        /// <summary>
        /// Gets or sets edge block compatibility list.
        /// Block Microsoft compatibility list in Microsoft Edge. This list from Microsoft helps Edge properly display sites with known compatibility issues.
        /// </summary>
        [JsonPropertyName("edgeBlockCompatibilityList")]
        public bool? EdgeBlockCompatibilityList { get; set; }
    
        /// <summary>
        /// Gets or sets edge block developer tools.
        /// Indicates whether or not to block developer tools in the Edge browser.
        /// </summary>
        [JsonPropertyName("edgeBlockDeveloperTools")]
        public bool? EdgeBlockDeveloperTools { get; set; }
    
        /// <summary>
        /// Gets or sets edge blocked.
        /// Indicates whether or not to Block the user from using the Edge browser.
        /// </summary>
        [JsonPropertyName("edgeBlocked")]
        public bool? EdgeBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets edge block extensions.
        /// Indicates whether or not to block extensions in the Edge browser.
        /// </summary>
        [JsonPropertyName("edgeBlockExtensions")]
        public bool? EdgeBlockExtensions { get; set; }
    
        /// <summary>
        /// Gets or sets edge block in private browsing.
        /// Indicates whether or not to block InPrivate browsing on corporate networks, in the Edge browser.
        /// </summary>
        [JsonPropertyName("edgeBlockInPrivateBrowsing")]
        public bool? EdgeBlockInPrivateBrowsing { get; set; }
    
        /// <summary>
        /// Gets or sets edge block java script.
        /// Indicates whether or not to Block the user from using JavaScript.
        /// </summary>
        [JsonPropertyName("edgeBlockJavaScript")]
        public bool? EdgeBlockJavaScript { get; set; }
    
        /// <summary>
        /// Gets or sets edge block live tile data collection.
        /// Block the collection of information by Microsoft for live tile creation when users pin a site to Start from Microsoft Edge.
        /// </summary>
        [JsonPropertyName("edgeBlockLiveTileDataCollection")]
        public bool? EdgeBlockLiveTileDataCollection { get; set; }
    
        /// <summary>
        /// Gets or sets edge block password manager.
        /// Indicates whether or not to Block password manager.
        /// </summary>
        [JsonPropertyName("edgeBlockPasswordManager")]
        public bool? EdgeBlockPasswordManager { get; set; }
    
        /// <summary>
        /// Gets or sets edge block popups.
        /// Indicates whether or not to block popups.
        /// </summary>
        [JsonPropertyName("edgeBlockPopups")]
        public bool? EdgeBlockPopups { get; set; }
    
        /// <summary>
        /// Gets or sets edge block search suggestions.
        /// Indicates whether or not to block the user from using the search suggestions in the address bar.
        /// </summary>
        [JsonPropertyName("edgeBlockSearchSuggestions")]
        public bool? EdgeBlockSearchSuggestions { get; set; }
    
        /// <summary>
        /// Gets or sets edge block sending do not track header.
        /// Indicates whether or not to Block the user from sending the do not track header.
        /// </summary>
        [JsonPropertyName("edgeBlockSendingDoNotTrackHeader")]
        public bool? EdgeBlockSendingDoNotTrackHeader { get; set; }
    
        /// <summary>
        /// Gets or sets edge block sending intranet traffic to internet explorer.
        /// Indicates whether or not to switch the intranet traffic from Edge to Internet Explorer. Note: the name of this property is misleading; the property is obsolete, use EdgeSendIntranetTrafficToInternetExplorer instead.
        /// </summary>
        [JsonPropertyName("edgeBlockSendingIntranetTrafficToInternetExplorer")]
        public bool? EdgeBlockSendingIntranetTrafficToInternetExplorer { get; set; }
    
        /// <summary>
        /// Gets or sets edge clear browsing data on exit.
        /// Clear browsing data on exiting Microsoft Edge.
        /// </summary>
        [JsonPropertyName("edgeClearBrowsingDataOnExit")]
        public bool? EdgeClearBrowsingDataOnExit { get; set; }
    
        /// <summary>
        /// Gets or sets edge cookie policy.
        /// Indicates which cookies to block in the Edge browser. Possible values are: userDefined, allow, blockThirdParty, blockAll.
        /// </summary>
        [JsonPropertyName("edgeCookiePolicy")]
        public EdgeCookiePolicy? EdgeCookiePolicy { get; set; }
    
        /// <summary>
        /// Gets or sets edge disable first run page.
        /// Block the Microsoft web page that opens on the first use of Microsoft Edge. This policy allows enterprises, like those enrolled in zero emissions configurations, to block this page.
        /// </summary>
        [JsonPropertyName("edgeDisableFirstRunPage")]
        public bool? EdgeDisableFirstRunPage { get; set; }
    
        /// <summary>
        /// Gets or sets edge enterprise mode site list location.
        /// Indicates the enterprise mode site list location. Could be a local file, local network or http location.
        /// </summary>
        [JsonPropertyName("edgeEnterpriseModeSiteListLocation")]
        public string EdgeEnterpriseModeSiteListLocation { get; set; }
    
        /// <summary>
        /// Gets or sets edge first run url.
        /// The first run URL for when Edge browser is opened for the first time.
        /// </summary>
        [JsonPropertyName("edgeFirstRunUrl")]
        public string EdgeFirstRunUrl { get; set; }
    
        /// <summary>
        /// Gets or sets edge homepage urls.
        /// The list of URLs for homepages shodwn on MDM-enrolled devices on Edge browser.
        /// </summary>
        [JsonPropertyName("edgeHomepageUrls")]
        public IEnumerable<string> EdgeHomepageUrls { get; set; }
    
        /// <summary>
        /// Gets or sets edge require smart screen.
        /// Indicates whether or not to Require the user to use the smart screen filter.
        /// </summary>
        [JsonPropertyName("edgeRequireSmartScreen")]
        public bool? EdgeRequireSmartScreen { get; set; }
    
        /// <summary>
        /// Gets or sets edge search engine.
        /// Allows IT admins to set a default search engine for MDM-Controlled devices. Users can override this and change their default search engine provided the AllowSearchEngineCustomization policy is not set.
        /// </summary>
        [JsonPropertyName("edgeSearchEngine")]
        public EdgeSearchEngineBase EdgeSearchEngine { get; set; }
    
        /// <summary>
        /// Gets or sets edge send intranet traffic to internet explorer.
        /// Indicates whether or not to switch the intranet traffic from Edge to Internet Explorer.
        /// </summary>
        [JsonPropertyName("edgeSendIntranetTrafficToInternetExplorer")]
        public bool? EdgeSendIntranetTrafficToInternetExplorer { get; set; }
    
        /// <summary>
        /// Gets or sets edge sync favorites with internet explorer.
        /// Enable favorites sync between Internet Explorer and Microsoft Edge. Additions, deletions, modifications and order changes to favorites are shared between browsers.
        /// </summary>
        [JsonPropertyName("edgeSyncFavoritesWithInternetExplorer")]
        public bool? EdgeSyncFavoritesWithInternetExplorer { get; set; }
    
        /// <summary>
        /// Gets or sets enterprise cloud print discovery end point.
        /// Endpoint for discovering cloud printers.
        /// </summary>
        [JsonPropertyName("enterpriseCloudPrintDiscoveryEndPoint")]
        public string EnterpriseCloudPrintDiscoveryEndPoint { get; set; }
    
        /// <summary>
        /// Gets or sets enterprise cloud print discovery max limit.
        /// Maximum number of printers that should be queried from a discovery endpoint. This is a mobile only setting. Valid values 1 to 65535
        /// </summary>
        [JsonPropertyName("enterpriseCloudPrintDiscoveryMaxLimit")]
        public Int32? EnterpriseCloudPrintDiscoveryMaxLimit { get; set; }
    
        /// <summary>
        /// Gets or sets enterprise cloud print mopria discovery resource identifier.
        /// OAuth resource URI for printer discovery service as configured in Azure portal.
        /// </summary>
        [JsonPropertyName("enterpriseCloudPrintMopriaDiscoveryResourceIdentifier")]
        public string EnterpriseCloudPrintMopriaDiscoveryResourceIdentifier { get; set; }
    
        /// <summary>
        /// Gets or sets enterprise cloud print oauth authority.
        /// Authentication endpoint for acquiring OAuth tokens.
        /// </summary>
        [JsonPropertyName("enterpriseCloudPrintOAuthAuthority")]
        public string EnterpriseCloudPrintOAuthAuthority { get; set; }
    
        /// <summary>
        /// Gets or sets enterprise cloud print oauth client identifier.
        /// GUID of a client application authorized to retrieve OAuth tokens from the OAuth Authority.
        /// </summary>
        [JsonPropertyName("enterpriseCloudPrintOAuthClientIdentifier")]
        public string EnterpriseCloudPrintOAuthClientIdentifier { get; set; }
    
        /// <summary>
        /// Gets or sets enterprise cloud print resource identifier.
        /// OAuth resource URI for print service as configured in the Azure portal.
        /// </summary>
        [JsonPropertyName("enterpriseCloudPrintResourceIdentifier")]
        public string EnterpriseCloudPrintResourceIdentifier { get; set; }
    
        /// <summary>
        /// Gets or sets experience block device discovery.
        /// Indicates whether or not to enable device discovery UX.
        /// </summary>
        [JsonPropertyName("experienceBlockDeviceDiscovery")]
        public bool? ExperienceBlockDeviceDiscovery { get; set; }
    
        /// <summary>
        /// Gets or sets experience block error dialog when no sim.
        /// Indicates whether or not to allow the error dialog from displaying if no SIM card is detected.
        /// </summary>
        [JsonPropertyName("experienceBlockErrorDialogWhenNoSIM")]
        public bool? ExperienceBlockErrorDialogWhenNoSIM { get; set; }
    
        /// <summary>
        /// Gets or sets experience block task switcher.
        /// Indicates whether or not to enable task switching on the device.
        /// </summary>
        [JsonPropertyName("experienceBlockTaskSwitcher")]
        public bool? ExperienceBlockTaskSwitcher { get; set; }
    
        /// <summary>
        /// Gets or sets game dvr blocked.
        /// Indicates whether or not to block DVR and broadcasting.
        /// </summary>
        [JsonPropertyName("gameDvrBlocked")]
        public bool? GameDvrBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets internet sharing blocked.
        /// Indicates whether or not to Block the user from using internet sharing.
        /// </summary>
        [JsonPropertyName("internetSharingBlocked")]
        public bool? InternetSharingBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets location services blocked.
        /// Indicates whether or not to Block the user from location services.
        /// </summary>
        [JsonPropertyName("locationServicesBlocked")]
        public bool? LocationServicesBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets lock screen allow timeout configuration.
        /// Specify whether to show a user-configurable setting to control the screen timeout while on the lock screen of Windows 10 Mobile devices. If this policy is set to Allow, the value set by lockScreenTimeoutInSeconds is ignored.
        /// </summary>
        [JsonPropertyName("lockScreenAllowTimeoutConfiguration")]
        public bool? LockScreenAllowTimeoutConfiguration { get; set; }
    
        /// <summary>
        /// Gets or sets lock screen block action center notifications.
        /// Indicates whether or not to block action center notifications over lock screen.
        /// </summary>
        [JsonPropertyName("lockScreenBlockActionCenterNotifications")]
        public bool? LockScreenBlockActionCenterNotifications { get; set; }
    
        /// <summary>
        /// Gets or sets lock screen block cortana.
        /// Indicates whether or not the user can interact with Cortana using speech while the system is locked.
        /// </summary>
        [JsonPropertyName("lockScreenBlockCortana")]
        public bool? LockScreenBlockCortana { get; set; }
    
        /// <summary>
        /// Gets or sets lock screen block toast notifications.
        /// Indicates whether to allow toast notifications above the device lock screen.
        /// </summary>
        [JsonPropertyName("lockScreenBlockToastNotifications")]
        public bool? LockScreenBlockToastNotifications { get; set; }
    
        /// <summary>
        /// Gets or sets lock screen timeout in seconds.
        /// Set the duration (in seconds) from the screen locking to the screen turning off for Windows 10 Mobile devices. Supported values are 11-1800. Valid values 11 to 1800
        /// </summary>
        [JsonPropertyName("lockScreenTimeoutInSeconds")]
        public Int32? LockScreenTimeoutInSeconds { get; set; }
    
        /// <summary>
        /// Gets or sets logon block fast user switching.
        /// Disables the ability to quickly switch between users that are logged on simultaneously without logging off.
        /// </summary>
        [JsonPropertyName("logonBlockFastUserSwitching")]
        public bool? LogonBlockFastUserSwitching { get; set; }
    
        /// <summary>
        /// Gets or sets microsoft account blocked.
        /// Indicates whether or not to Block a Microsoft account.
        /// </summary>
        [JsonPropertyName("microsoftAccountBlocked")]
        public bool? MicrosoftAccountBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets microsoft account block settings sync.
        /// Indicates whether or not to Block Microsoft account settings sync.
        /// </summary>
        [JsonPropertyName("microsoftAccountBlockSettingsSync")]
        public bool? MicrosoftAccountBlockSettingsSync { get; set; }
    
        /// <summary>
        /// Gets or sets network proxy apply settings device wide.
        /// If set, proxy settings will be applied to all processes and accounts in the device. Otherwise, it will be applied to the user account that’s enrolled into MDM.
        /// </summary>
        [JsonPropertyName("networkProxyApplySettingsDeviceWide")]
        public bool? NetworkProxyApplySettingsDeviceWide { get; set; }
    
        /// <summary>
        /// Gets or sets network proxy automatic configuration url.
        /// Address to the proxy auto-config (PAC) script you want to use.
        /// </summary>
        [JsonPropertyName("networkProxyAutomaticConfigurationUrl")]
        public string NetworkProxyAutomaticConfigurationUrl { get; set; }
    
        /// <summary>
        /// Gets or sets network proxy disable auto detect.
        /// Disable automatic detection of settings. If enabled, the system will try to find the path to a proxy auto-config (PAC) script.
        /// </summary>
        [JsonPropertyName("networkProxyDisableAutoDetect")]
        public bool? NetworkProxyDisableAutoDetect { get; set; }
    
        /// <summary>
        /// Gets or sets network proxy server.
        /// Specifies manual proxy server settings.
        /// </summary>
        [JsonPropertyName("networkProxyServer")]
        public Windows10NetworkProxyServer NetworkProxyServer { get; set; }
    
        /// <summary>
        /// Gets or sets nfc blocked.
        /// Indicates whether or not to Block the user from using near field communication.
        /// </summary>
        [JsonPropertyName("nfcBlocked")]
        public bool? NfcBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets one drive disable file sync.
        /// Gets or sets a value allowing IT admins to prevent apps and features from working with files on OneDrive.
        /// </summary>
        [JsonPropertyName("oneDriveDisableFileSync")]
        public bool? OneDriveDisableFileSync { get; set; }
    
        /// <summary>
        /// Gets or sets password block simple.
        /// Specify whether PINs or passwords such as '1111' or '1234' are allowed. For Windows 10 desktops, it also controls the use of picture passwords.
        /// </summary>
        [JsonPropertyName("passwordBlockSimple")]
        public bool? PasswordBlockSimple { get; set; }
    
        /// <summary>
        /// Gets or sets password expiration days.
        /// The password expiration in days. Valid values 0 to 730
        /// </summary>
        [JsonPropertyName("passwordExpirationDays")]
        public Int32? PasswordExpirationDays { get; set; }
    
        /// <summary>
        /// Gets or sets password minimum character set count.
        /// The number of character sets required in the password.
        /// </summary>
        [JsonPropertyName("passwordMinimumCharacterSetCount")]
        public Int32? PasswordMinimumCharacterSetCount { get; set; }
    
        /// <summary>
        /// Gets or sets password minimum length.
        /// The minimum password length. Valid values 4 to 16
        /// </summary>
        [JsonPropertyName("passwordMinimumLength")]
        public Int32? PasswordMinimumLength { get; set; }
    
        /// <summary>
        /// Gets or sets password minutes of inactivity before screen timeout.
        /// The minutes of inactivity before the screen times out.
        /// </summary>
        [JsonPropertyName("passwordMinutesOfInactivityBeforeScreenTimeout")]
        public Int32? PasswordMinutesOfInactivityBeforeScreenTimeout { get; set; }
    
        /// <summary>
        /// Gets or sets password previous password block count.
        /// The number of previous passwords to prevent reuse of. Valid values 0 to 50
        /// </summary>
        [JsonPropertyName("passwordPreviousPasswordBlockCount")]
        public Int32? PasswordPreviousPasswordBlockCount { get; set; }
    
        /// <summary>
        /// Gets or sets password required.
        /// Indicates whether or not to require the user to have a password.
        /// </summary>
        [JsonPropertyName("passwordRequired")]
        public bool? PasswordRequired { get; set; }
    
        /// <summary>
        /// Gets or sets password required type.
        /// The required password type. Possible values are: deviceDefault, alphanumeric, numeric.
        /// </summary>
        [JsonPropertyName("passwordRequiredType")]
        public RequiredPasswordType? PasswordRequiredType { get; set; }
    
        /// <summary>
        /// Gets or sets password require when resume from idle state.
        /// Indicates whether or not to require a password upon resuming from an idle state.
        /// </summary>
        [JsonPropertyName("passwordRequireWhenResumeFromIdleState")]
        public bool? PasswordRequireWhenResumeFromIdleState { get; set; }
    
        /// <summary>
        /// Gets or sets password sign in failure count before factory reset.
        /// The number of sign in failures before factory reset. Valid values 0 to 999
        /// </summary>
        [JsonPropertyName("passwordSignInFailureCountBeforeFactoryReset")]
        public Int32? PasswordSignInFailureCountBeforeFactoryReset { get; set; }
    
        /// <summary>
        /// Gets or sets personalization desktop image url.
        /// A http or https Url to a jpg, jpeg or png image that needs to be downloaded and used as the Desktop Image or a file Url to a local image on the file system that needs to used as the Desktop Image.
        /// </summary>
        [JsonPropertyName("personalizationDesktopImageUrl")]
        public string PersonalizationDesktopImageUrl { get; set; }
    
        /// <summary>
        /// Gets or sets personalization lock screen image url.
        /// A http or https Url to a jpg, jpeg or png image that neeeds to be downloaded and used as the Lock Screen Image or a file Url to a local image on the file system that needs to be used as the Lock Screen Image.
        /// </summary>
        [JsonPropertyName("personalizationLockScreenImageUrl")]
        public string PersonalizationLockScreenImageUrl { get; set; }
    
        /// <summary>
        /// Gets or sets privacy advertising id.
        /// Enables or disables the use of advertising ID. Added in Windows 10, version 1607. Possible values are: notConfigured, blocked, allowed.
        /// </summary>
        [JsonPropertyName("privacyAdvertisingId")]
        public StateManagementSetting? PrivacyAdvertisingId { get; set; }
    
        /// <summary>
        /// Gets or sets privacy auto accept pairing and consent prompts.
        /// Indicates whether or not to allow the automatic acceptance of the pairing and privacy user consent dialog when launching apps.
        /// </summary>
        [JsonPropertyName("privacyAutoAcceptPairingAndConsentPrompts")]
        public bool? PrivacyAutoAcceptPairingAndConsentPrompts { get; set; }
    
        /// <summary>
        /// Gets or sets privacy block input personalization.
        /// Indicates whether or not to block the usage of cloud based speech services for Cortana, Dictation, or Store applications.
        /// </summary>
        [JsonPropertyName("privacyBlockInputPersonalization")]
        public bool? PrivacyBlockInputPersonalization { get; set; }
    
        /// <summary>
        /// Gets or sets reset protection mode blocked.
        /// Indicates whether or not to Block the user from reset protection mode.
        /// </summary>
        [JsonPropertyName("resetProtectionModeBlocked")]
        public bool? ResetProtectionModeBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets safe search filter.
        /// Specifies what filter level of safe search is required. Possible values are: userDefined, strict, moderate.
        /// </summary>
        [JsonPropertyName("safeSearchFilter")]
        public SafeSearchFilterType? SafeSearchFilter { get; set; }
    
        /// <summary>
        /// Gets or sets screen capture blocked.
        /// Indicates whether or not to Block the user from taking Screenshots.
        /// </summary>
        [JsonPropertyName("screenCaptureBlocked")]
        public bool? ScreenCaptureBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets search block diacritics.
        /// Specifies if search can use diacritics.
        /// </summary>
        [JsonPropertyName("searchBlockDiacritics")]
        public bool? SearchBlockDiacritics { get; set; }
    
        /// <summary>
        /// Gets or sets search disable auto language detection.
        /// Specifies whether to use automatic language detection when indexing content and properties.
        /// </summary>
        [JsonPropertyName("searchDisableAutoLanguageDetection")]
        public bool? SearchDisableAutoLanguageDetection { get; set; }
    
        /// <summary>
        /// Gets or sets search disable indexer backoff.
        /// Indicates whether or not to disable the search indexer backoff feature.
        /// </summary>
        [JsonPropertyName("searchDisableIndexerBackoff")]
        public bool? SearchDisableIndexerBackoff { get; set; }
    
        /// <summary>
        /// Gets or sets search disable indexing encrypted items.
        /// Indicates whether or not to block indexing of WIP-protected items to prevent them from appearing in search results for Cortana or Explorer.
        /// </summary>
        [JsonPropertyName("searchDisableIndexingEncryptedItems")]
        public bool? SearchDisableIndexingEncryptedItems { get; set; }
    
        /// <summary>
        /// Gets or sets search disable indexing removable drive.
        /// Indicates whether or not to allow users to add locations on removable drives to libraries and to be indexed.
        /// </summary>
        [JsonPropertyName("searchDisableIndexingRemovableDrive")]
        public bool? SearchDisableIndexingRemovableDrive { get; set; }
    
        /// <summary>
        /// Gets or sets search enable automatic index size manangement.
        /// Specifies minimum amount of hard drive space on the same drive as the index location before indexing stops.
        /// </summary>
        [JsonPropertyName("searchEnableAutomaticIndexSizeManangement")]
        public bool? SearchEnableAutomaticIndexSizeManangement { get; set; }
    
        /// <summary>
        /// Gets or sets search enable remote queries.
        /// Indicates whether or not to block remote queries of this computer’s index.
        /// </summary>
        [JsonPropertyName("searchEnableRemoteQueries")]
        public bool? SearchEnableRemoteQueries { get; set; }
    
        /// <summary>
        /// Gets or sets settings block accounts page.
        /// Indicates whether or not to block access to Accounts in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockAccountsPage")]
        public bool? SettingsBlockAccountsPage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block add provisioning package.
        /// Indicates whether or not to block the user from installing provisioning packages.
        /// </summary>
        [JsonPropertyName("settingsBlockAddProvisioningPackage")]
        public bool? SettingsBlockAddProvisioningPackage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block apps page.
        /// Indicates whether or not to block access to Apps in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockAppsPage")]
        public bool? SettingsBlockAppsPage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block change language.
        /// Indicates whether or not to block the user from changing the language settings.
        /// </summary>
        [JsonPropertyName("settingsBlockChangeLanguage")]
        public bool? SettingsBlockChangeLanguage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block change power sleep.
        /// Indicates whether or not to block the user from changing power and sleep settings.
        /// </summary>
        [JsonPropertyName("settingsBlockChangePowerSleep")]
        public bool? SettingsBlockChangePowerSleep { get; set; }
    
        /// <summary>
        /// Gets or sets settings block change region.
        /// Indicates whether or not to block the user from changing the region settings.
        /// </summary>
        [JsonPropertyName("settingsBlockChangeRegion")]
        public bool? SettingsBlockChangeRegion { get; set; }
    
        /// <summary>
        /// Gets or sets settings block change system time.
        /// Indicates whether or not to block the user from changing date and time settings.
        /// </summary>
        [JsonPropertyName("settingsBlockChangeSystemTime")]
        public bool? SettingsBlockChangeSystemTime { get; set; }
    
        /// <summary>
        /// Gets or sets settings block devices page.
        /// Indicates whether or not to block access to Devices in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockDevicesPage")]
        public bool? SettingsBlockDevicesPage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block ease of access page.
        /// Indicates whether or not to block access to Ease of Access in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockEaseOfAccessPage")]
        public bool? SettingsBlockEaseOfAccessPage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block edit device name.
        /// Indicates whether or not to block the user from editing the device name.
        /// </summary>
        [JsonPropertyName("settingsBlockEditDeviceName")]
        public bool? SettingsBlockEditDeviceName { get; set; }
    
        /// <summary>
        /// Gets or sets settings block gaming page.
        /// Indicates whether or not to block access to Gaming in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockGamingPage")]
        public bool? SettingsBlockGamingPage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block network internet page.
        /// Indicates whether or not to block access to Network &amp; Internet in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockNetworkInternetPage")]
        public bool? SettingsBlockNetworkInternetPage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block personalization page.
        /// Indicates whether or not to block access to Personalization in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockPersonalizationPage")]
        public bool? SettingsBlockPersonalizationPage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block privacy page.
        /// Indicates whether or not to block access to Privacy in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockPrivacyPage")]
        public bool? SettingsBlockPrivacyPage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block remove provisioning package.
        /// Indicates whether or not to block the runtime configuration agent from removing provisioning packages.
        /// </summary>
        [JsonPropertyName("settingsBlockRemoveProvisioningPackage")]
        public bool? SettingsBlockRemoveProvisioningPackage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block settings app.
        /// Indicates whether or not to block access to Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockSettingsApp")]
        public bool? SettingsBlockSettingsApp { get; set; }
    
        /// <summary>
        /// Gets or sets settings block system page.
        /// Indicates whether or not to block access to System in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockSystemPage")]
        public bool? SettingsBlockSystemPage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block time language page.
        /// Indicates whether or not to block access to Time &amp; Language in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockTimeLanguagePage")]
        public bool? SettingsBlockTimeLanguagePage { get; set; }
    
        /// <summary>
        /// Gets or sets settings block update security page.
        /// Indicates whether or not to block access to Update &amp; Security in Settings app.
        /// </summary>
        [JsonPropertyName("settingsBlockUpdateSecurityPage")]
        public bool? SettingsBlockUpdateSecurityPage { get; set; }
    
        /// <summary>
        /// Gets or sets shared user app data allowed.
        /// Indicates whether or not to block multiple users of the same app to share data.
        /// </summary>
        [JsonPropertyName("sharedUserAppDataAllowed")]
        public bool? SharedUserAppDataAllowed { get; set; }
    
        /// <summary>
        /// Gets or sets smart screen block prompt override.
        /// Indicates whether or not users can override SmartScreen Filter warnings about potentially malicious websites.
        /// </summary>
        [JsonPropertyName("smartScreenBlockPromptOverride")]
        public bool? SmartScreenBlockPromptOverride { get; set; }
    
        /// <summary>
        /// Gets or sets smart screen block prompt override for files.
        /// Indicates whether or not users can override the SmartScreen Filter warnings about downloading unverified files
        /// </summary>
        [JsonPropertyName("smartScreenBlockPromptOverrideForFiles")]
        public bool? SmartScreenBlockPromptOverrideForFiles { get; set; }
    
        /// <summary>
        /// Gets or sets smart screen enable app install control.
        /// This property will be deprecated in July 2019 and will be replaced by property SmartScreenAppInstallControl. Allows IT Admins to control whether users are allowed to install apps from places other than the Store.
        /// </summary>
        [JsonPropertyName("smartScreenEnableAppInstallControl")]
        public bool? SmartScreenEnableAppInstallControl { get; set; }
    
        /// <summary>
        /// Gets or sets start block unpinning apps from taskbar.
        /// Indicates whether or not to block the user from unpinning apps from taskbar.
        /// </summary>
        [JsonPropertyName("startBlockUnpinningAppsFromTaskbar")]
        public bool? StartBlockUnpinningAppsFromTaskbar { get; set; }
    
        /// <summary>
        /// Gets or sets start menu app list visibility.
        /// Setting the value of this collapses the app list, removes the app list entirely, or disables the corresponding toggle in the Settings app. Possible values are: userDefined, collapse, remove, disableSettingsApp.
        /// </summary>
        [JsonPropertyName("startMenuAppListVisibility")]
        public WindowsStartMenuAppListVisibilityType? StartMenuAppListVisibility { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide change account settings.
        /// Enabling this policy hides the change account setting from appearing in the user tile in the start menu.
        /// </summary>
        [JsonPropertyName("startMenuHideChangeAccountSettings")]
        public bool? StartMenuHideChangeAccountSettings { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide frequently used apps.
        /// Enabling this policy hides the most used apps from appearing on the start menu and disables the corresponding toggle in the Settings app.
        /// </summary>
        [JsonPropertyName("startMenuHideFrequentlyUsedApps")]
        public bool? StartMenuHideFrequentlyUsedApps { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide hibernate.
        /// Enabling this policy hides hibernate from appearing in the power button in the start menu.
        /// </summary>
        [JsonPropertyName("startMenuHideHibernate")]
        public bool? StartMenuHideHibernate { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide lock.
        /// Enabling this policy hides lock from appearing in the user tile in the start menu.
        /// </summary>
        [JsonPropertyName("startMenuHideLock")]
        public bool? StartMenuHideLock { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide power button.
        /// Enabling this policy hides the power button from appearing in the start menu.
        /// </summary>
        [JsonPropertyName("startMenuHidePowerButton")]
        public bool? StartMenuHidePowerButton { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide recent jump lists.
        /// Enabling this policy hides recent jump lists from appearing on the start menu/taskbar and disables the corresponding toggle in the Settings app.
        /// </summary>
        [JsonPropertyName("startMenuHideRecentJumpLists")]
        public bool? StartMenuHideRecentJumpLists { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide recently added apps.
        /// Enabling this policy hides recently added apps from appearing on the start menu and disables the corresponding toggle in the Settings app.
        /// </summary>
        [JsonPropertyName("startMenuHideRecentlyAddedApps")]
        public bool? StartMenuHideRecentlyAddedApps { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide restart options.
        /// Enabling this policy hides 'Restart/Update and Restart' from appearing in the power button in the start menu.
        /// </summary>
        [JsonPropertyName("startMenuHideRestartOptions")]
        public bool? StartMenuHideRestartOptions { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide shut down.
        /// Enabling this policy hides shut down/update and shut down from appearing in the power button in the start menu.
        /// </summary>
        [JsonPropertyName("startMenuHideShutDown")]
        public bool? StartMenuHideShutDown { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide sign out.
        /// Enabling this policy hides sign out from appearing in the user tile in the start menu.
        /// </summary>
        [JsonPropertyName("startMenuHideSignOut")]
        public bool? StartMenuHideSignOut { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide sleep.
        /// Enabling this policy hides sleep from appearing in the power button in the start menu.
        /// </summary>
        [JsonPropertyName("startMenuHideSleep")]
        public bool? StartMenuHideSleep { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide switch account.
        /// Enabling this policy hides switch account from appearing in the user tile in the start menu.
        /// </summary>
        [JsonPropertyName("startMenuHideSwitchAccount")]
        public bool? StartMenuHideSwitchAccount { get; set; }
    
        /// <summary>
        /// Gets or sets start menu hide user tile.
        /// Enabling this policy hides the user tile from appearing in the start menu.
        /// </summary>
        [JsonPropertyName("startMenuHideUserTile")]
        public bool? StartMenuHideUserTile { get; set; }
    
        /// <summary>
        /// Gets or sets start menu layout edge assets xml.
        /// This policy setting allows you to import Edge assets to be used with startMenuLayoutXml policy. Start layout can contain secondary tile from Edge app which looks for Edge local asset file. Edge local asset would not exist and cause Edge secondary tile to appear empty in this case. This policy only gets applied when startMenuLayoutXml policy is modified. The value should be a UTF-8 Base64 encoded byte array.
        /// </summary>
        [JsonPropertyName("startMenuLayoutEdgeAssetsXml")]
        public byte[] StartMenuLayoutEdgeAssetsXml { get; set; }
    
        /// <summary>
        /// Gets or sets start menu layout xml.
        /// Allows admins to override the default Start menu layout and prevents the user from changing it. The layout is modified by specifying an XML file based on a layout modification schema. XML needs to be in a UTF8 encoded byte array format.
        /// </summary>
        [JsonPropertyName("startMenuLayoutXml")]
        public byte[] StartMenuLayoutXml { get; set; }
    
        /// <summary>
        /// Gets or sets start menu mode.
        /// Allows admins to decide how the Start menu is displayed. Possible values are: userDefined, fullScreen, nonFullScreen.
        /// </summary>
        [JsonPropertyName("startMenuMode")]
        public WindowsStartMenuModeType? StartMenuMode { get; set; }
    
        /// <summary>
        /// Gets or sets start menu pinned folder documents.
        /// Enforces the visibility (Show/Hide) of the Documents folder shortcut on the Start menu. Possible values are: notConfigured, hide, show.
        /// </summary>
        [JsonPropertyName("startMenuPinnedFolderDocuments")]
        public VisibilitySetting? StartMenuPinnedFolderDocuments { get; set; }
    
        /// <summary>
        /// Gets or sets start menu pinned folder downloads.
        /// Enforces the visibility (Show/Hide) of the Downloads folder shortcut on the Start menu. Possible values are: notConfigured, hide, show.
        /// </summary>
        [JsonPropertyName("startMenuPinnedFolderDownloads")]
        public VisibilitySetting? StartMenuPinnedFolderDownloads { get; set; }
    
        /// <summary>
        /// Gets or sets start menu pinned folder file explorer.
        /// Enforces the visibility (Show/Hide) of the FileExplorer shortcut on the Start menu. Possible values are: notConfigured, hide, show.
        /// </summary>
        [JsonPropertyName("startMenuPinnedFolderFileExplorer")]
        public VisibilitySetting? StartMenuPinnedFolderFileExplorer { get; set; }
    
        /// <summary>
        /// Gets or sets start menu pinned folder home group.
        /// Enforces the visibility (Show/Hide) of the HomeGroup folder shortcut on the Start menu. Possible values are: notConfigured, hide, show.
        /// </summary>
        [JsonPropertyName("startMenuPinnedFolderHomeGroup")]
        public VisibilitySetting? StartMenuPinnedFolderHomeGroup { get; set; }
    
        /// <summary>
        /// Gets or sets start menu pinned folder music.
        /// Enforces the visibility (Show/Hide) of the Music folder shortcut on the Start menu. Possible values are: notConfigured, hide, show.
        /// </summary>
        [JsonPropertyName("startMenuPinnedFolderMusic")]
        public VisibilitySetting? StartMenuPinnedFolderMusic { get; set; }
    
        /// <summary>
        /// Gets or sets start menu pinned folder network.
        /// Enforces the visibility (Show/Hide) of the Network folder shortcut on the Start menu. Possible values are: notConfigured, hide, show.
        /// </summary>
        [JsonPropertyName("startMenuPinnedFolderNetwork")]
        public VisibilitySetting? StartMenuPinnedFolderNetwork { get; set; }
    
        /// <summary>
        /// Gets or sets start menu pinned folder personal folder.
        /// Enforces the visibility (Show/Hide) of the PersonalFolder shortcut on the Start menu. Possible values are: notConfigured, hide, show.
        /// </summary>
        [JsonPropertyName("startMenuPinnedFolderPersonalFolder")]
        public VisibilitySetting? StartMenuPinnedFolderPersonalFolder { get; set; }
    
        /// <summary>
        /// Gets or sets start menu pinned folder pictures.
        /// Enforces the visibility (Show/Hide) of the Pictures folder shortcut on the Start menu. Possible values are: notConfigured, hide, show.
        /// </summary>
        [JsonPropertyName("startMenuPinnedFolderPictures")]
        public VisibilitySetting? StartMenuPinnedFolderPictures { get; set; }
    
        /// <summary>
        /// Gets or sets start menu pinned folder settings.
        /// Enforces the visibility (Show/Hide) of the Settings folder shortcut on the Start menu. Possible values are: notConfigured, hide, show.
        /// </summary>
        [JsonPropertyName("startMenuPinnedFolderSettings")]
        public VisibilitySetting? StartMenuPinnedFolderSettings { get; set; }
    
        /// <summary>
        /// Gets or sets start menu pinned folder videos.
        /// Enforces the visibility (Show/Hide) of the Videos folder shortcut on the Start menu. Possible values are: notConfigured, hide, show.
        /// </summary>
        [JsonPropertyName("startMenuPinnedFolderVideos")]
        public VisibilitySetting? StartMenuPinnedFolderVideos { get; set; }
    
        /// <summary>
        /// Gets or sets storage block removable storage.
        /// Indicates whether or not to Block the user from using removable storage.
        /// </summary>
        [JsonPropertyName("storageBlockRemovableStorage")]
        public bool? StorageBlockRemovableStorage { get; set; }
    
        /// <summary>
        /// Gets or sets storage require mobile device encryption.
        /// Indicating whether or not to require encryption on a mobile device.
        /// </summary>
        [JsonPropertyName("storageRequireMobileDeviceEncryption")]
        public bool? StorageRequireMobileDeviceEncryption { get; set; }
    
        /// <summary>
        /// Gets or sets storage restrict app data to system volume.
        /// Indicates whether application data is restricted to the system drive.
        /// </summary>
        [JsonPropertyName("storageRestrictAppDataToSystemVolume")]
        public bool? StorageRestrictAppDataToSystemVolume { get; set; }
    
        /// <summary>
        /// Gets or sets storage restrict app install to system volume.
        /// Indicates whether the installation of applications is restricted to the system drive.
        /// </summary>
        [JsonPropertyName("storageRestrictAppInstallToSystemVolume")]
        public bool? StorageRestrictAppInstallToSystemVolume { get; set; }
    
        /// <summary>
        /// Gets or sets tenant lockdown require network during out of box experience.
        /// Whether the device is required to connect to the network.
        /// </summary>
        [JsonPropertyName("tenantLockdownRequireNetworkDuringOutOfBoxExperience")]
        public bool? TenantLockdownRequireNetworkDuringOutOfBoxExperience { get; set; }
    
        /// <summary>
        /// Gets or sets usb blocked.
        /// Indicates whether or not to Block the user from USB connection.
        /// </summary>
        [JsonPropertyName("usbBlocked")]
        public bool? UsbBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets voice recording blocked.
        /// Indicates whether or not to Block the user from voice recording.
        /// </summary>
        [JsonPropertyName("voiceRecordingBlocked")]
        public bool? VoiceRecordingBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets web rtc block localhost ip address.
        /// Indicates whether or not user's localhost IP address is displayed while making phone calls using the WebRTC
        /// </summary>
        [JsonPropertyName("webRtcBlockLocalhostIpAddress")]
        public bool? WebRtcBlockLocalhostIpAddress { get; set; }
    
        /// <summary>
        /// Gets or sets wi fi block automatic connect hotspots.
        /// Indicating whether or not to block automatically connecting to Wi-Fi hotspots. Has no impact if Wi-Fi is blocked.
        /// </summary>
        [JsonPropertyName("wiFiBlockAutomaticConnectHotspots")]
        public bool? WiFiBlockAutomaticConnectHotspots { get; set; }
    
        /// <summary>
        /// Gets or sets wi fi blocked.
        /// Indicates whether or not to Block the user from using Wi-Fi.
        /// </summary>
        [JsonPropertyName("wiFiBlocked")]
        public bool? WiFiBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets wi fi block manual configuration.
        /// Indicates whether or not to Block the user from using Wi-Fi manual configuration.
        /// </summary>
        [JsonPropertyName("wiFiBlockManualConfiguration")]
        public bool? WiFiBlockManualConfiguration { get; set; }
    
        /// <summary>
        /// Gets or sets wi fi scan interval.
        /// Specify how often devices scan for Wi-Fi networks. Supported values are 1-500, where 100 = default, and 500 = low frequency. Valid values 1 to 500
        /// </summary>
        [JsonPropertyName("wiFiScanInterval")]
        public Int32? WiFiScanInterval { get; set; }
    
        /// <summary>
        /// Gets or sets windows spotlight block consumer specific features.
        /// Allows IT admins to block experiences that are typically for consumers only, such as Start suggestions, Membership notifications, Post-OOBE app install and redirect tiles.
        /// </summary>
        [JsonPropertyName("windowsSpotlightBlockConsumerSpecificFeatures")]
        public bool? WindowsSpotlightBlockConsumerSpecificFeatures { get; set; }
    
        /// <summary>
        /// Gets or sets windows spotlight blocked.
        /// Allows IT admins to turn off all Windows Spotlight features
        /// </summary>
        [JsonPropertyName("windowsSpotlightBlocked")]
        public bool? WindowsSpotlightBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets windows spotlight block on action center.
        /// Block suggestions from Microsoft that show after each OS clean install, upgrade or in an on-going basis to introduce users to what is new or changed
        /// </summary>
        [JsonPropertyName("windowsSpotlightBlockOnActionCenter")]
        public bool? WindowsSpotlightBlockOnActionCenter { get; set; }
    
        /// <summary>
        /// Gets or sets windows spotlight block tailored experiences.
        /// Block personalized content in Windows spotlight based on user’s device usage.
        /// </summary>
        [JsonPropertyName("windowsSpotlightBlockTailoredExperiences")]
        public bool? WindowsSpotlightBlockTailoredExperiences { get; set; }
    
        /// <summary>
        /// Gets or sets windows spotlight block third party notifications.
        /// Block third party content delivered via Windows Spotlight
        /// </summary>
        [JsonPropertyName("windowsSpotlightBlockThirdPartyNotifications")]
        public bool? WindowsSpotlightBlockThirdPartyNotifications { get; set; }
    
        /// <summary>
        /// Gets or sets windows spotlight block welcome experience.
        /// Block Windows Spotlight Windows welcome experience
        /// </summary>
        [JsonPropertyName("windowsSpotlightBlockWelcomeExperience")]
        public bool? WindowsSpotlightBlockWelcomeExperience { get; set; }
    
        /// <summary>
        /// Gets or sets windows spotlight block windows tips.
        /// Allows IT admins to turn off the popup of Windows Tips.
        /// </summary>
        [JsonPropertyName("windowsSpotlightBlockWindowsTips")]
        public bool? WindowsSpotlightBlockWindowsTips { get; set; }
    
        /// <summary>
        /// Gets or sets windows spotlight configure on lock screen.
        /// Specifies the type of Spotlight. Possible values are: notConfigured, disabled, enabled.
        /// </summary>
        [JsonPropertyName("windowsSpotlightConfigureOnLockScreen")]
        public WindowsSpotlightEnablementSettings? WindowsSpotlightConfigureOnLockScreen { get; set; }
    
        /// <summary>
        /// Gets or sets windows store block auto update.
        /// Indicates whether or not to block automatic update of apps from Windows Store.
        /// </summary>
        [JsonPropertyName("windowsStoreBlockAutoUpdate")]
        public bool? WindowsStoreBlockAutoUpdate { get; set; }
    
        /// <summary>
        /// Gets or sets windows store blocked.
        /// Indicates whether or not to Block the user from using the Windows store.
        /// </summary>
        [JsonPropertyName("windowsStoreBlocked")]
        public bool? WindowsStoreBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets windows store enable private store only.
        /// Indicates whether or not to enable Private Store Only.
        /// </summary>
        [JsonPropertyName("windowsStoreEnablePrivateStoreOnly")]
        public bool? WindowsStoreEnablePrivateStoreOnly { get; set; }
    
        /// <summary>
        /// Gets or sets wireless display block projection to this device.
        /// Indicates whether or not to allow other devices from discovering this PC for projection.
        /// </summary>
        [JsonPropertyName("wirelessDisplayBlockProjectionToThisDevice")]
        public bool? WirelessDisplayBlockProjectionToThisDevice { get; set; }
    
        /// <summary>
        /// Gets or sets wireless display block user input from receiver.
        /// Indicates whether or not to allow user input from wireless display receiver.
        /// </summary>
        [JsonPropertyName("wirelessDisplayBlockUserInputFromReceiver")]
        public bool? WirelessDisplayBlockUserInputFromReceiver { get; set; }
    
        /// <summary>
        /// Gets or sets wireless display require pin for pairing.
        /// Indicates whether or not to require a PIN for new devices to initiate pairing.
        /// </summary>
        [JsonPropertyName("wirelessDisplayRequirePinForPairing")]
        public bool? WirelessDisplayRequirePinForPairing { get; set; }
    
    }
}

