// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Windows Phone81General Configuration.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<WindowsPhone81GeneralConfiguration>))]
    public partial class WindowsPhone81GeneralConfiguration : DeviceConfiguration
    {
    
        ///<summary>
        /// The WindowsPhone81GeneralConfiguration constructor
        ///</summary>
        public WindowsPhone81GeneralConfiguration()
        {
            this.ODataType = "microsoft.graph.windowsPhone81GeneralConfiguration";
        }

        /// <summary>
        /// Gets or sets apply only to windows phone81.
        /// Value indicating whether this policy only applies to Windows Phone 8.1. This property is read-only.
        /// </summary>
        [JsonPropertyName("applyOnlyToWindowsPhone81")]
        public bool? ApplyOnlyToWindowsPhone81 { get; set; }
    
        /// <summary>
        /// Gets or sets apps block copy paste.
        /// Indicates whether or not to block copy paste.
        /// </summary>
        [JsonPropertyName("appsBlockCopyPaste")]
        public bool? AppsBlockCopyPaste { get; set; }
    
        /// <summary>
        /// Gets or sets bluetooth blocked.
        /// Indicates whether or not to block bluetooth.
        /// </summary>
        [JsonPropertyName("bluetoothBlocked")]
        public bool? BluetoothBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets camera blocked.
        /// Indicates whether or not to block camera.
        /// </summary>
        [JsonPropertyName("cameraBlocked")]
        public bool? CameraBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets cellular block wifi tethering.
        /// Indicates whether or not to block Wi-Fi tethering. Has no impact if Wi-Fi is blocked.
        /// </summary>
        [JsonPropertyName("cellularBlockWifiTethering")]
        public bool? CellularBlockWifiTethering { get; set; }
    
        /// <summary>
        /// Gets or sets compliant app list type.
        /// List that is in the AppComplianceList. Possible values are: none, appsInListCompliant, appsNotInListCompliant.
        /// </summary>
        [JsonPropertyName("compliantAppListType")]
        public AppListType? CompliantAppListType { get; set; }
    
        /// <summary>
        /// Gets or sets compliant apps list.
        /// List of apps in the compliance (either allow list or block list, controlled by CompliantAppListType). This collection can contain a maximum of 10000 elements.
        /// </summary>
        [JsonPropertyName("compliantAppsList")]
        public IEnumerable<AppListItem> CompliantAppsList { get; set; }
    
        /// <summary>
        /// Gets or sets diagnostic data block submission.
        /// Indicates whether or not to block diagnostic data submission.
        /// </summary>
        [JsonPropertyName("diagnosticDataBlockSubmission")]
        public bool? DiagnosticDataBlockSubmission { get; set; }
    
        /// <summary>
        /// Gets or sets email block adding accounts.
        /// Indicates whether or not to block custom email accounts.
        /// </summary>
        [JsonPropertyName("emailBlockAddingAccounts")]
        public bool? EmailBlockAddingAccounts { get; set; }
    
        /// <summary>
        /// Gets or sets location services blocked.
        /// Indicates whether or not to block location services.
        /// </summary>
        [JsonPropertyName("locationServicesBlocked")]
        public bool? LocationServicesBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets microsoft account blocked.
        /// Indicates whether or not to block using a Microsoft Account.
        /// </summary>
        [JsonPropertyName("microsoftAccountBlocked")]
        public bool? MicrosoftAccountBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets nfc blocked.
        /// Indicates whether or not to block Near-Field Communication.
        /// </summary>
        [JsonPropertyName("nfcBlocked")]
        public bool? NfcBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets password block simple.
        /// Indicates whether or not to block syncing the calendar.
        /// </summary>
        [JsonPropertyName("passwordBlockSimple")]
        public bool? PasswordBlockSimple { get; set; }
    
        /// <summary>
        /// Gets or sets password expiration days.
        /// Number of days before the password expires.
        /// </summary>
        [JsonPropertyName("passwordExpirationDays")]
        public Int32? PasswordExpirationDays { get; set; }
    
        /// <summary>
        /// Gets or sets password minimum character set count.
        /// Number of character sets a password must contain.
        /// </summary>
        [JsonPropertyName("passwordMinimumCharacterSetCount")]
        public Int32? PasswordMinimumCharacterSetCount { get; set; }
    
        /// <summary>
        /// Gets or sets password minimum length.
        /// Minimum length of passwords.
        /// </summary>
        [JsonPropertyName("passwordMinimumLength")]
        public Int32? PasswordMinimumLength { get; set; }
    
        /// <summary>
        /// Gets or sets password minutes of inactivity before screen timeout.
        /// Minutes of inactivity before screen timeout.
        /// </summary>
        [JsonPropertyName("passwordMinutesOfInactivityBeforeScreenTimeout")]
        public Int32? PasswordMinutesOfInactivityBeforeScreenTimeout { get; set; }
    
        /// <summary>
        /// Gets or sets password previous password block count.
        /// Number of previous passwords to block. Valid values 0 to 24
        /// </summary>
        [JsonPropertyName("passwordPreviousPasswordBlockCount")]
        public Int32? PasswordPreviousPasswordBlockCount { get; set; }
    
        /// <summary>
        /// Gets or sets password required.
        /// Indicates whether or not to require a password.
        /// </summary>
        [JsonPropertyName("passwordRequired")]
        public bool? PasswordRequired { get; set; }
    
        /// <summary>
        /// Gets or sets password required type.
        /// Password type that is required. Possible values are: deviceDefault, alphanumeric, numeric.
        /// </summary>
        [JsonPropertyName("passwordRequiredType")]
        public RequiredPasswordType? PasswordRequiredType { get; set; }
    
        /// <summary>
        /// Gets or sets password sign in failure count before factory reset.
        /// Number of sign in failures allowed before factory reset.
        /// </summary>
        [JsonPropertyName("passwordSignInFailureCountBeforeFactoryReset")]
        public Int32? PasswordSignInFailureCountBeforeFactoryReset { get; set; }
    
        /// <summary>
        /// Gets or sets screen capture blocked.
        /// Indicates whether or not to block screenshots.
        /// </summary>
        [JsonPropertyName("screenCaptureBlocked")]
        public bool? ScreenCaptureBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets storage block removable storage.
        /// Indicates whether or not to block removable storage.
        /// </summary>
        [JsonPropertyName("storageBlockRemovableStorage")]
        public bool? StorageBlockRemovableStorage { get; set; }
    
        /// <summary>
        /// Gets or sets storage require encryption.
        /// Indicates whether or not to require encryption.
        /// </summary>
        [JsonPropertyName("storageRequireEncryption")]
        public bool? StorageRequireEncryption { get; set; }
    
        /// <summary>
        /// Gets or sets web browser blocked.
        /// Indicates whether or not to block the web browser.
        /// </summary>
        [JsonPropertyName("webBrowserBlocked")]
        public bool? WebBrowserBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets wifi block automatic connect hotspots.
        /// Indicates whether or not to block automatically connecting to Wi-Fi hotspots. Has no impact if Wi-Fi is blocked.
        /// </summary>
        [JsonPropertyName("wifiBlockAutomaticConnectHotspots")]
        public bool? WifiBlockAutomaticConnectHotspots { get; set; }
    
        /// <summary>
        /// Gets or sets wifi blocked.
        /// Indicates whether or not to block Wi-Fi.
        /// </summary>
        [JsonPropertyName("wifiBlocked")]
        public bool? WifiBlocked { get; set; }
    
        /// <summary>
        /// Gets or sets wifi block hotspot reporting.
        /// Indicates whether or not to block Wi-Fi hotspot reporting. Has no impact if Wi-Fi is blocked.
        /// </summary>
        [JsonPropertyName("wifiBlockHotspotReporting")]
        public bool? WifiBlockHotspotReporting { get; set; }
    
        /// <summary>
        /// Gets or sets windows store blocked.
        /// Indicates whether or not to block the Windows Store.
        /// </summary>
        [JsonPropertyName("windowsStoreBlocked")]
        public bool? WindowsStoreBlocked { get; set; }
    
    }
}

