// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Workbook Chart Axis.
    /// </summary>
    public partial class WorkbookChartAxis : Entity
    {
    
        /// <summary>
        /// Gets or sets major unit.
        /// Represents the interval between two major tick marks. Can be set to a numeric value or an empty string.  The returned value is always a number.
        /// </summary>
        [JsonPropertyName("majorUnit")]
        public System.Text.Json.JsonDocument MajorUnit { get; set; }
    
        /// <summary>
        /// Gets or sets maximum.
        /// Represents the maximum value on the value axis.  Can be set to a numeric value or an empty string (for automatic axis values).  The returned value is always a number.
        /// </summary>
        [JsonPropertyName("maximum")]
        public System.Text.Json.JsonDocument Maximum { get; set; }
    
        /// <summary>
        /// Gets or sets minimum.
        /// Represents the minimum value on the value axis. Can be set to a numeric value or an empty string (for automatic axis values).  The returned value is always a number.
        /// </summary>
        [JsonPropertyName("minimum")]
        public System.Text.Json.JsonDocument Minimum { get; set; }
    
        /// <summary>
        /// Gets or sets minor unit.
        /// Represents the interval between two minor tick marks. 'Can be set to a numeric value or an empty string (for automatic axis values). The returned value is always a number.
        /// </summary>
        [JsonPropertyName("minorUnit")]
        public System.Text.Json.JsonDocument MinorUnit { get; set; }
    
        /// <summary>
        /// Gets or sets format.
        /// Represents the formatting of a chart object, which includes line and font formatting. Read-only.
        /// </summary>
        [JsonPropertyName("format")]
        public WorkbookChartAxisFormat Format { get; set; }
    
        /// <summary>
        /// Gets or sets major gridlines.
        /// Returns a gridlines object that represents the major gridlines for the specified axis. Read-only.
        /// </summary>
        [JsonPropertyName("majorGridlines")]
        public WorkbookChartGridlines MajorGridlines { get; set; }
    
        /// <summary>
        /// Gets or sets minor gridlines.
        /// Returns a Gridlines object that represents the minor gridlines for the specified axis. Read-only.
        /// </summary>
        [JsonPropertyName("minorGridlines")]
        public WorkbookChartGridlines MinorGridlines { get; set; }
    
        /// <summary>
        /// Gets or sets title.
        /// Represents the axis title. Read-only.
        /// </summary>
        [JsonPropertyName("title")]
        public WorkbookChartAxisTitle Title { get; set; }
    
    }
}

