// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Workbook Table Column.
    /// </summary>
    public partial class WorkbookTableColumn : Entity
    {
    
        /// <summary>
        /// Gets or sets index.
        /// Returns the index number of the column within the columns collection of the table. Zero-indexed. Read-only.
        /// </summary>
        [JsonPropertyName("index")]
        public Int32? Index { get; set; }
    
        /// <summary>
        /// Gets or sets name.
        /// Returns the name of the table column.
        /// </summary>
        [JsonPropertyName("name")]
        public string Name { get; set; }
    
        /// <summary>
        /// Gets or sets values.
        /// Represents the raw values of the specified range. The data returned could be of type string, number, or a boolean. Cell that contain an error will return the error string.
        /// </summary>
        [JsonPropertyName("values")]
        public System.Text.Json.JsonDocument Values { get; set; }
    
        /// <summary>
        /// Gets or sets filter.
        /// Retrieve the filter applied to the column. Read-only.
        /// </summary>
        [JsonPropertyName("filter")]
        public WorkbookFilter Filter { get; set; }
    
    }
}

