// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type AccessPackageAssignmentRequestRequestBuilder.
    /// </summary>
    public partial class AccessPackageAssignmentRequestRequestBuilder : EntityRequestBuilder, IAccessPackageAssignmentRequestRequestBuilder
    {

        /// <summary>
        /// Constructs a new AccessPackageAssignmentRequestRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public AccessPackageAssignmentRequestRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IAccessPackageAssignmentRequestRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IAccessPackageAssignmentRequestRequest Request(IEnumerable<Option> options)
        {
            return new AccessPackageAssignmentRequestRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for AccessPackage.
        /// </summary>
        /// <returns>The <see cref="IAccessPackageWithReferenceRequestBuilder"/>.</returns>
        public IAccessPackageWithReferenceRequestBuilder AccessPackage
        {
            get
            {
                return new AccessPackageWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("accessPackage"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Assignment.
        /// </summary>
        /// <returns>The <see cref="IAccessPackageAssignmentWithReferenceRequestBuilder"/>.</returns>
        public IAccessPackageAssignmentWithReferenceRequestBuilder Assignment
        {
            get
            {
                return new AccessPackageAssignmentWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("assignment"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Requestor.
        /// </summary>
        /// <returns>The <see cref="IAccessPackageSubjectWithReferenceRequestBuilder"/>.</returns>
        public IAccessPackageSubjectWithReferenceRequestBuilder Requestor
        {
            get
            {
                return new AccessPackageSubjectWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("requestor"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for AccessPackageAssignmentRequestCancel.
        /// </summary>
        /// <returns>The <see cref="IAccessPackageAssignmentRequestCancelRequestBuilder"/>.</returns>
        public IAccessPackageAssignmentRequestCancelRequestBuilder Cancel()
        {
            return new AccessPackageAssignmentRequestCancelRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.cancel"),
                this.Client);
        }
    
    }
}
