// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type AccessReviewScheduleDefinitionInstancesCollectionRequestBuilder.
    /// </summary>
    public partial class AccessReviewScheduleDefinitionInstancesCollectionRequestBuilder : BaseRequestBuilder, IAccessReviewScheduleDefinitionInstancesCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new AccessReviewScheduleDefinitionInstancesCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public AccessReviewScheduleDefinitionInstancesCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IAccessReviewScheduleDefinitionInstancesCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IAccessReviewScheduleDefinitionInstancesCollectionRequest Request(IEnumerable<Option> options)
        {
            return new AccessReviewScheduleDefinitionInstancesCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IAccessReviewInstanceRequestBuilder"/> for the specified AccessReviewScheduleDefinitionAccessReviewInstance.
        /// </summary>
        /// <param name="id">The ID for the AccessReviewScheduleDefinitionAccessReviewInstance.</param>
        /// <returns>The <see cref="IAccessReviewInstanceRequestBuilder"/>.</returns>
        public IAccessReviewInstanceRequestBuilder this[string id]
        {
            get
            {
                return new AccessReviewInstanceRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AccessReviewInstanceFilterByCurrentUser.
        /// </summary>
        /// <returns>The <see cref="IAccessReviewInstanceFilterByCurrentUserRequestBuilder"/>.</returns>
        public IAccessReviewInstanceFilterByCurrentUserRequestBuilder FilterByCurrentUser(
            AccessReviewInstanceFilterByCurrentUserOptions on)
        {
            return new AccessReviewInstanceFilterByCurrentUserRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.filterByCurrentUser"),
                this.Client,
                on);
        }
    }
}
