// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ApplicationAddKeyRequestBuilder.
    /// </summary>
    public partial class ApplicationAddKeyRequestBuilder : BaseActionMethodRequestBuilder<IApplicationAddKeyRequest>, IApplicationAddKeyRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="ApplicationAddKeyRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="keyCredential">A keyCredential parameter for the OData method call.</param>
        /// <param name="proof">A proof parameter for the OData method call.</param>
        /// <param name="passwordCredential">A passwordCredential parameter for the OData method call.</param>
        public ApplicationAddKeyRequestBuilder(
            string requestUrl,
            IBaseClient client,
            KeyCredential keyCredential,
            string proof,
            PasswordCredential passwordCredential)
            : base(requestUrl, client)
        {
            this.SetParameter("keyCredential", keyCredential, false);
            this.SetParameter("proof", proof, false);
            this.SetParameter("passwordCredential", passwordCredential, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IApplicationAddKeyRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new ApplicationAddKeyRequest(functionUrl, this.Client, options);

            if (this.HasParameter("keyCredential"))
            {
                request.RequestBody.KeyCredential = this.GetParameter<KeyCredential>("keyCredential");
            }

            if (this.HasParameter("proof"))
            {
                request.RequestBody.Proof = this.GetParameter<string>("proof");
            }

            if (this.HasParameter("passwordCredential"))
            {
                request.RequestBody.PasswordCredential = this.GetParameter<PasswordCredential>("passwordCredential");
            }

            return request;
        }
    }
}
