// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ApplicationExtensionPropertiesCollectionRequestBuilder.
    /// </summary>
    public partial class ApplicationExtensionPropertiesCollectionRequestBuilder : BaseRequestBuilder, IApplicationExtensionPropertiesCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ApplicationExtensionPropertiesCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ApplicationExtensionPropertiesCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IApplicationExtensionPropertiesCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IApplicationExtensionPropertiesCollectionRequest Request(IEnumerable<Option> options)
        {
            return new ApplicationExtensionPropertiesCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IExtensionPropertyRequestBuilder"/> for the specified ApplicationExtensionProperty.
        /// </summary>
        /// <param name="id">The ID for the ApplicationExtensionProperty.</param>
        /// <returns>The <see cref="IExtensionPropertyRequestBuilder"/>.</returns>
        public IExtensionPropertyRequestBuilder this[string id]
        {
            get
            {
                return new ExtensionPropertyRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
