// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ApprovalStagesCollectionRequestBuilder.
    /// </summary>
    public partial class ApprovalStagesCollectionRequestBuilder : BaseRequestBuilder, IApprovalStagesCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ApprovalStagesCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ApprovalStagesCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IApprovalStagesCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IApprovalStagesCollectionRequest Request(IEnumerable<Option> options)
        {
            return new ApprovalStagesCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IApprovalStageRequestBuilder"/> for the specified ApprovalApprovalStage.
        /// </summary>
        /// <param name="id">The ID for the ApprovalApprovalStage.</param>
        /// <returns>The <see cref="IApprovalStageRequestBuilder"/>.</returns>
        public IApprovalStageRequestBuilder this[string id]
        {
            get
            {
                return new ApprovalStageRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
