// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type BitlockerRecoveryKeysCollectionRequestBuilder.
    /// </summary>
    public partial class BitlockerRecoveryKeysCollectionRequestBuilder : BaseRequestBuilder, IBitlockerRecoveryKeysCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new BitlockerRecoveryKeysCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public BitlockerRecoveryKeysCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IBitlockerRecoveryKeysCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IBitlockerRecoveryKeysCollectionRequest Request(IEnumerable<Option> options)
        {
            return new BitlockerRecoveryKeysCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IBitlockerRecoveryKeyRequestBuilder"/> for the specified BitlockerBitlockerRecoveryKey.
        /// </summary>
        /// <param name="id">The ID for the BitlockerBitlockerRecoveryKey.</param>
        /// <returns>The <see cref="IBitlockerRecoveryKeyRequestBuilder"/>.</returns>
        public IBitlockerRecoveryKeyRequestBuilder this[string id]
        {
            get
            {
                return new BitlockerRecoveryKeyRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
