// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type CalendarGetScheduleRequestBuilder.
    /// </summary>
    public partial class CalendarGetScheduleRequestBuilder : BaseActionMethodRequestBuilder<ICalendarGetScheduleRequest>, ICalendarGetScheduleRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="CalendarGetScheduleRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="Schedules">A Schedules parameter for the OData method call.</param>
        /// <param name="EndTime">A EndTime parameter for the OData method call.</param>
        /// <param name="StartTime">A StartTime parameter for the OData method call.</param>
        /// <param name="AvailabilityViewInterval">A AvailabilityViewInterval parameter for the OData method call.</param>
        public CalendarGetScheduleRequestBuilder(
            string requestUrl,
            IBaseClient client,
            IEnumerable<string> Schedules,
            DateTimeTimeZone EndTime,
            DateTimeTimeZone StartTime,
            Int32? AvailabilityViewInterval)
            : base(requestUrl, client)
        {
            this.SetParameter("schedules", Schedules, true);
            this.SetParameter("endTime", EndTime, true);
            this.SetParameter("startTime", StartTime, true);
            this.SetParameter("availabilityViewInterval", AvailabilityViewInterval, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override ICalendarGetScheduleRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new CalendarGetScheduleRequest(functionUrl, this.Client, options);

            if (this.HasParameter("schedules"))
            {
                request.RequestBody.Schedules = this.GetParameter<IEnumerable<string>>("schedules");
            }

            if (this.HasParameter("endTime"))
            {
                request.RequestBody.EndTime = this.GetParameter<DateTimeTimeZone>("endTime");
            }

            if (this.HasParameter("startTime"))
            {
                request.RequestBody.StartTime = this.GetParameter<DateTimeTimeZone>("startTime");
            }

            if (this.HasParameter("availabilityViewInterval"))
            {
                request.RequestBody.AvailabilityViewInterval = this.GetParameter<Int32?>("availabilityViewInterval");
            }

            return request;
        }
    }
}
