// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type CalendarRequestBuilder.
    /// </summary>
    public partial class CalendarRequestBuilder : EntityRequestBuilder, ICalendarRequestBuilder
    {

        /// <summary>
        /// Constructs a new CalendarRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public CalendarRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ICalendarRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ICalendarRequest Request(IEnumerable<Option> options)
        {
            return new CalendarRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for CalendarPermissions.
        /// </summary>
        /// <returns>The <see cref="ICalendarCalendarPermissionsCollectionRequestBuilder"/>.</returns>
        public ICalendarCalendarPermissionsCollectionRequestBuilder CalendarPermissions
        {
            get
            {
                return new CalendarCalendarPermissionsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("calendarPermissions"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for CalendarView.
        /// </summary>
        /// <returns>The <see cref="ICalendarCalendarViewCollectionRequestBuilder"/>.</returns>
        public ICalendarCalendarViewCollectionRequestBuilder CalendarView
        {
            get
            {
                return new CalendarCalendarViewCollectionRequestBuilder(this.AppendSegmentToRequestUrl("calendarView"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Events.
        /// </summary>
        /// <returns>The <see cref="ICalendarEventsCollectionRequestBuilder"/>.</returns>
        public ICalendarEventsCollectionRequestBuilder Events
        {
            get
            {
                return new CalendarEventsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("events"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for MultiValueExtendedProperties.
        /// </summary>
        /// <returns>The <see cref="ICalendarMultiValueExtendedPropertiesCollectionRequestBuilder"/>.</returns>
        public ICalendarMultiValueExtendedPropertiesCollectionRequestBuilder MultiValueExtendedProperties
        {
            get
            {
                return new CalendarMultiValueExtendedPropertiesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("multiValueExtendedProperties"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for SingleValueExtendedProperties.
        /// </summary>
        /// <returns>The <see cref="ICalendarSingleValueExtendedPropertiesCollectionRequestBuilder"/>.</returns>
        public ICalendarSingleValueExtendedPropertiesCollectionRequestBuilder SingleValueExtendedProperties
        {
            get
            {
                return new CalendarSingleValueExtendedPropertiesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("singleValueExtendedProperties"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for CalendarGetSchedule.
        /// </summary>
        /// <returns>The <see cref="ICalendarGetScheduleRequestBuilder"/>.</returns>
        public ICalendarGetScheduleRequestBuilder GetSchedule(
            IEnumerable<string> Schedules = null,
            DateTimeTimeZone EndTime = null,
            DateTimeTimeZone StartTime = null,
            Int32? AvailabilityViewInterval = null)
        {
            return new CalendarGetScheduleRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.getSchedule"),
                this.Client,
                Schedules,
                EndTime,
                StartTime,
                AvailabilityViewInterval);
        }

        /// <summary>
        /// Gets the request builder for CalendarAllowedCalendarSharingRoles.
        /// </summary>
        /// <returns>The <see cref="ICalendarAllowedCalendarSharingRolesRequestBuilder"/>.</returns>
        public ICalendarAllowedCalendarSharingRolesRequestBuilder AllowedCalendarSharingRoles(
            string User)
        {
            return new CalendarAllowedCalendarSharingRolesRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.allowedCalendarSharingRoles"),
                this.Client,
                User);
        }
    
    }
}
