// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ConnectedOrganizationRequestBuilder.
    /// </summary>
    public partial class ConnectedOrganizationRequestBuilder : EntityRequestBuilder, IConnectedOrganizationRequestBuilder
    {

        /// <summary>
        /// Constructs a new ConnectedOrganizationRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ConnectedOrganizationRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IConnectedOrganizationRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IConnectedOrganizationRequest Request(IEnumerable<Option> options)
        {
            return new ConnectedOrganizationRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for ExternalSponsors.
        /// </summary>
        /// <returns>The <see cref="IConnectedOrganizationExternalSponsorsCollectionRequestBuilder"/>.</returns>
        public IConnectedOrganizationExternalSponsorsCollectionRequestBuilder ExternalSponsors
        {
            get
            {
                return new ConnectedOrganizationExternalSponsorsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("externalSponsors"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for InternalSponsors.
        /// </summary>
        /// <returns>The <see cref="IConnectedOrganizationInternalSponsorsCollectionRequestBuilder"/>.</returns>
        public IConnectedOrganizationInternalSponsorsCollectionRequestBuilder InternalSponsors
        {
            get
            {
                return new ConnectedOrganizationInternalSponsorsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("internalSponsors"), this.Client);
            }
        }
    
    }
}
