// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ContactFolderChildFoldersCollectionRequestBuilder.
    /// </summary>
    public partial class ContactFolderChildFoldersCollectionRequestBuilder : BaseRequestBuilder, IContactFolderChildFoldersCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ContactFolderChildFoldersCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ContactFolderChildFoldersCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IContactFolderChildFoldersCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IContactFolderChildFoldersCollectionRequest Request(IEnumerable<Option> options)
        {
            return new ContactFolderChildFoldersCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IContactFolderRequestBuilder"/> for the specified ContactFolderContactFolder.
        /// </summary>
        /// <param name="id">The ID for the ContactFolderContactFolder.</param>
        /// <returns>The <see cref="IContactFolderRequestBuilder"/>.</returns>
        public IContactFolderRequestBuilder this[string id]
        {
            get
            {
                return new ContactFolderRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ContactFolderDelta.
        /// </summary>
        /// <returns>The <see cref="IContactFolderDeltaRequestBuilder"/>.</returns>
        public IContactFolderDeltaRequestBuilder Delta()
        {
            return new ContactFolderDeltaRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.delta"),
                this.Client);
        }
    }
}
