// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type DeviceAppManagementManagedAppRegistrationsCollectionRequestBuilder.
    /// </summary>
    public partial class DeviceAppManagementManagedAppRegistrationsCollectionRequestBuilder : BaseRequestBuilder, IDeviceAppManagementManagedAppRegistrationsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new DeviceAppManagementManagedAppRegistrationsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public DeviceAppManagementManagedAppRegistrationsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IDeviceAppManagementManagedAppRegistrationsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IDeviceAppManagementManagedAppRegistrationsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new DeviceAppManagementManagedAppRegistrationsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IManagedAppRegistrationRequestBuilder"/> for the specified DeviceAppManagementManagedAppRegistration.
        /// </summary>
        /// <param name="id">The ID for the DeviceAppManagementManagedAppRegistration.</param>
        /// <returns>The <see cref="IManagedAppRegistrationRequestBuilder"/>.</returns>
        public IManagedAppRegistrationRequestBuilder this[string id]
        {
            get
            {
                return new ManagedAppRegistrationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ManagedAppRegistrationGetUserIdsWithFlaggedAppRegistration.
        /// </summary>
        /// <returns>The <see cref="IManagedAppRegistrationGetUserIdsWithFlaggedAppRegistrationRequestBuilder"/>.</returns>
        public IManagedAppRegistrationGetUserIdsWithFlaggedAppRegistrationRequestBuilder GetUserIdsWithFlaggedAppRegistration()
        {
            return new ManagedAppRegistrationGetUserIdsWithFlaggedAppRegistrationRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.getUserIdsWithFlaggedAppRegistration"),
                this.Client);
        }
    }
}
