// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type DirectoryRequestBuilder.
    /// </summary>
    public partial class DirectoryRequestBuilder : EntityRequestBuilder, IDirectoryRequestBuilder
    {

        /// <summary>
        /// Constructs a new DirectoryRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public DirectoryRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IDirectoryRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IDirectoryRequest Request(IEnumerable<Option> options)
        {
            return new DirectoryRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for AdministrativeUnits.
        /// </summary>
        /// <returns>The <see cref="IDirectoryAdministrativeUnitsCollectionRequestBuilder"/>.</returns>
        public IDirectoryAdministrativeUnitsCollectionRequestBuilder AdministrativeUnits
        {
            get
            {
                return new DirectoryAdministrativeUnitsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("administrativeUnits"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for DeletedItems.
        /// </summary>
        /// <returns>The <see cref="IDirectoryDeletedItemsCollectionRequestBuilder"/>.</returns>
        public IDirectoryDeletedItemsCollectionRequestBuilder DeletedItems
        {
            get
            {
                return new DirectoryDeletedItemsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("deletedItems"), this.Client);
            }
        }
    
    }
}
