// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type DriveItemCreateLinkRequestBuilder.
    /// </summary>
    public partial class DriveItemCreateLinkRequestBuilder : BaseActionMethodRequestBuilder<IDriveItemCreateLinkRequest>, IDriveItemCreateLinkRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="DriveItemCreateLinkRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="type">A type parameter for the OData method call.</param>
        /// <param name="scope">A scope parameter for the OData method call.</param>
        /// <param name="expirationDateTime">A expirationDateTime parameter for the OData method call.</param>
        /// <param name="password">A password parameter for the OData method call.</param>
        /// <param name="message">A message parameter for the OData method call.</param>
        public DriveItemCreateLinkRequestBuilder(
            string requestUrl,
            IBaseClient client,
            string type,
            string scope,
            DateTimeOffset? expirationDateTime,
            string password,
            string message)
            : base(requestUrl, client)
        {
            this.SetParameter("type", type, false);
            this.SetParameter("scope", scope, true);
            this.SetParameter("expirationDateTime", expirationDateTime, true);
            this.SetParameter("password", password, true);
            this.SetParameter("message", message, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IDriveItemCreateLinkRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new DriveItemCreateLinkRequest(functionUrl, this.Client, options);

            if (this.HasParameter("type"))
            {
                request.RequestBody.Type = this.GetParameter<string>("type");
            }

            if (this.HasParameter("scope"))
            {
                request.RequestBody.Scope = this.GetParameter<string>("scope");
            }

            if (this.HasParameter("expirationDateTime"))
            {
                request.RequestBody.ExpirationDateTime = this.GetParameter<DateTimeOffset?>("expirationDateTime");
            }

            if (this.HasParameter("password"))
            {
                request.RequestBody.Password = this.GetParameter<string>("password");
            }

            if (this.HasParameter("message"))
            {
                request.RequestBody.Message = this.GetParameter<string>("message");
            }

            return request;
        }
    }
}
