// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type DriveItemInviteRequestBuilder.
    /// </summary>
    public partial class DriveItemInviteRequestBuilder : BaseActionMethodRequestBuilder<IDriveItemInviteRequest>, IDriveItemInviteRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="DriveItemInviteRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="recipients">A recipients parameter for the OData method call.</param>
        /// <param name="requireSignIn">A requireSignIn parameter for the OData method call.</param>
        /// <param name="roles">A roles parameter for the OData method call.</param>
        /// <param name="sendInvitation">A sendInvitation parameter for the OData method call.</param>
        /// <param name="message">A message parameter for the OData method call.</param>
        /// <param name="expirationDateTime">A expirationDateTime parameter for the OData method call.</param>
        /// <param name="password">A password parameter for the OData method call.</param>
        public DriveItemInviteRequestBuilder(
            string requestUrl,
            IBaseClient client,
            IEnumerable<DriveRecipient> recipients,
            bool? requireSignIn,
            IEnumerable<string> roles,
            bool? sendInvitation,
            string message,
            string expirationDateTime,
            string password)
            : base(requestUrl, client)
        {
            this.SetParameter("recipients", recipients, false);
            this.SetParameter("requireSignIn", requireSignIn, true);
            this.SetParameter("roles", roles, true);
            this.SetParameter("sendInvitation", sendInvitation, true);
            this.SetParameter("message", message, true);
            this.SetParameter("expirationDateTime", expirationDateTime, true);
            this.SetParameter("password", password, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IDriveItemInviteRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new DriveItemInviteRequest(functionUrl, this.Client, options);

            if (this.HasParameter("recipients"))
            {
                request.RequestBody.Recipients = this.GetParameter<IEnumerable<DriveRecipient>>("recipients");
            }

            if (this.HasParameter("requireSignIn"))
            {
                request.RequestBody.RequireSignIn = this.GetParameter<bool?>("requireSignIn");
            }

            if (this.HasParameter("roles"))
            {
                request.RequestBody.Roles = this.GetParameter<IEnumerable<string>>("roles");
            }

            if (this.HasParameter("sendInvitation"))
            {
                request.RequestBody.SendInvitation = this.GetParameter<bool?>("sendInvitation");
            }

            if (this.HasParameter("message"))
            {
                request.RequestBody.Message = this.GetParameter<string>("message");
            }

            if (this.HasParameter("expirationDateTime"))
            {
                request.RequestBody.ExpirationDateTime = this.GetParameter<string>("expirationDateTime");
            }

            if (this.HasParameter("password"))
            {
                request.RequestBody.Password = this.GetParameter<string>("password");
            }

            return request;
        }
    }
}
