// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type DriveItemVersionRequestBuilder.
    /// </summary>
    public partial class DriveItemVersionRequestBuilder : BaseItemVersionRequestBuilder, IDriveItemVersionRequestBuilder
    {

        /// <summary>
        /// Constructs a new DriveItemVersionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public DriveItemVersionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IDriveItemVersionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IDriveItemVersionRequest Request(IEnumerable<Option> options)
        {
            return new DriveItemVersionRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Content.
        /// </summary>
        /// <returns>The <see cref="IDriveItemVersionContentRequestBuilder"/>.</returns>
        public IDriveItemVersionContentRequestBuilder Content
        {
            get
            {
                return new DriveItemVersionContentRequestBuilder(this.AppendSegmentToRequestUrl("content"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for DriveItemVersionRestoreVersion.
        /// </summary>
        /// <returns>The <see cref="IDriveItemVersionRestoreVersionRequestBuilder"/>.</returns>
        public IDriveItemVersionRestoreVersionRequestBuilder RestoreVersion()
        {
            return new DriveItemVersionRestoreVersionRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.restoreVersion"),
                this.Client);
        }
    
    }
}
