// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type EducationClassRequestBuilder.
    /// </summary>
    public partial class EducationClassRequestBuilder : EntityRequestBuilder, IEducationClassRequestBuilder
    {

        /// <summary>
        /// Constructs a new EducationClassRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public EducationClassRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IEducationClassRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IEducationClassRequest Request(IEnumerable<Option> options)
        {
            return new EducationClassRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for AssignmentCategories.
        /// </summary>
        /// <returns>The <see cref="IEducationClassAssignmentCategoriesCollectionRequestBuilder"/>.</returns>
        public IEducationClassAssignmentCategoriesCollectionRequestBuilder AssignmentCategories
        {
            get
            {
                return new EducationClassAssignmentCategoriesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("assignmentCategories"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AssignmentDefaults.
        /// </summary>
        /// <returns>The <see cref="IEducationAssignmentDefaultsRequestBuilder"/>.</returns>
        public IEducationAssignmentDefaultsRequestBuilder AssignmentDefaults
        {
            get
            {
                return new EducationAssignmentDefaultsRequestBuilder(this.AppendSegmentToRequestUrl("assignmentDefaults"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Assignments.
        /// </summary>
        /// <returns>The <see cref="IEducationClassAssignmentsCollectionRequestBuilder"/>.</returns>
        public IEducationClassAssignmentsCollectionRequestBuilder Assignments
        {
            get
            {
                return new EducationClassAssignmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("assignments"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AssignmentSettings.
        /// </summary>
        /// <returns>The <see cref="IEducationAssignmentSettingsRequestBuilder"/>.</returns>
        public IEducationAssignmentSettingsRequestBuilder AssignmentSettings
        {
            get
            {
                return new EducationAssignmentSettingsRequestBuilder(this.AppendSegmentToRequestUrl("assignmentSettings"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Group.
        /// </summary>
        /// <returns>The <see cref="IGroupWithReferenceRequestBuilder"/>.</returns>
        public IGroupWithReferenceRequestBuilder Group
        {
            get
            {
                return new GroupWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("group"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Members.
        /// </summary>
        /// <returns>The <see cref="IEducationClassMembersCollectionWithReferencesRequestBuilder"/>.</returns>
        public IEducationClassMembersCollectionWithReferencesRequestBuilder Members
        {
            get
            {
                return new EducationClassMembersCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("members"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Schools.
        /// </summary>
        /// <returns>The <see cref="IEducationClassSchoolsCollectionWithReferencesRequestBuilder"/>.</returns>
        public IEducationClassSchoolsCollectionWithReferencesRequestBuilder Schools
        {
            get
            {
                return new EducationClassSchoolsCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("schools"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Teachers.
        /// </summary>
        /// <returns>The <see cref="IEducationClassTeachersCollectionWithReferencesRequestBuilder"/>.</returns>
        public IEducationClassTeachersCollectionWithReferencesRequestBuilder Teachers
        {
            get
            {
                return new EducationClassTeachersCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("teachers"), this.Client);
            }
        }
    
        
    
    }
}
