// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type EducationRootUsersCollectionRequestBuilder.
    /// </summary>
    public partial class EducationRootUsersCollectionRequestBuilder : BaseRequestBuilder, IEducationRootUsersCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new EducationRootUsersCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public EducationRootUsersCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IEducationRootUsersCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IEducationRootUsersCollectionRequest Request(IEnumerable<Option> options)
        {
            return new EducationRootUsersCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IEducationUserRequestBuilder"/> for the specified EducationRootEducationUser.
        /// </summary>
        /// <param name="id">The ID for the EducationRootEducationUser.</param>
        /// <returns>The <see cref="IEducationUserRequestBuilder"/>.</returns>
        public IEducationUserRequestBuilder this[string id]
        {
            get
            {
                return new EducationUserRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for EducationUserDelta.
        /// </summary>
        /// <returns>The <see cref="IEducationUserDeltaRequestBuilder"/>.</returns>
        public IEducationUserDeltaRequestBuilder Delta()
        {
            return new EducationUserDeltaRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.delta"),
                this.Client);
        }
    }
}
