// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The type EducationSubmissionRequest.
    /// </summary>
    public partial class EducationSubmissionRequest : BaseRequest, IEducationSubmissionRequest
    {
        /// <summary>
        /// Constructs a new EducationSubmissionRequest.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="options">Query and header option name value pairs for the request.</param>
        public EducationSubmissionRequest(
            string requestUrl,
            IBaseClient client,
            IEnumerable<Option> options)
            : base(requestUrl, client, options)
        {
        }

        /// <summary>
        /// Creates the specified EducationSubmission using POST.
        /// </summary>
        /// <param name="educationSubmissionToCreate">The EducationSubmission to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created EducationSubmission.</returns>
        public async System.Threading.Tasks.Task<EducationSubmission> CreateAsync(EducationSubmission educationSubmissionToCreate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.POST;
            var newEntity = await this.SendAsync<EducationSubmission>(educationSubmissionToCreate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(newEntity);
            return newEntity;
        }

        /// <summary>
        /// Creates the specified EducationSubmission using POST and returns a <see cref="GraphResponse{EducationSubmission}"/> object.
        /// </summary>
        /// <param name="educationSubmissionToCreate">The EducationSubmission to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EducationSubmission}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<EducationSubmission>> CreateResponseAsync(EducationSubmission educationSubmissionToCreate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.POST;
            return this.SendAsyncWithGraphResponse<EducationSubmission>(educationSubmissionToCreate, cancellationToken);
        }

        /// <summary>
        /// Deletes the specified EducationSubmission.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        public async System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.DELETE;
            await this.SendAsync<EducationSubmission>(null, cancellationToken).ConfigureAwait(false);
        }

        /// <summary>
        /// Deletes the specified EducationSubmission and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        public System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.DELETE;
            return this.SendAsyncWithGraphResponse(null, cancellationToken);
        }

        /// <summary>
        /// Gets the specified EducationSubmission.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The EducationSubmission.</returns>
        public async System.Threading.Tasks.Task<EducationSubmission> GetAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.GET;
            var retrievedEntity = await this.SendAsync<EducationSubmission>(null, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(retrievedEntity);
            return retrievedEntity;
        }

        /// <summary>
        /// Gets the specified EducationSubmission and returns a <see cref="GraphResponse{EducationSubmission}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EducationSubmission}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<EducationSubmission>> GetResponseAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.GET;
            return this.SendAsyncWithGraphResponse<EducationSubmission>(null, cancellationToken);
        }

        /// <summary>
        /// Updates the specified EducationSubmission using PATCH.
        /// </summary>
        /// <param name="educationSubmissionToUpdate">The EducationSubmission to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated EducationSubmission.</returns>
        public async System.Threading.Tasks.Task<EducationSubmission> UpdateAsync(EducationSubmission educationSubmissionToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PATCH;
            var updatedEntity = await this.SendAsync<EducationSubmission>(educationSubmissionToUpdate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(updatedEntity);
            return updatedEntity;
        }

        /// <summary>
        /// Updates the specified EducationSubmission using PATCH and returns a <see cref="GraphResponse{EducationSubmission}"/> object.
        /// </summary>
        /// <param name="educationSubmissionToUpdate">The EducationSubmission to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{EducationSubmission}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<EducationSubmission>> UpdateResponseAsync(EducationSubmission educationSubmissionToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PATCH;
            return this.SendAsyncWithGraphResponse<EducationSubmission>(educationSubmissionToUpdate, cancellationToken);
        }

        /// <summary>
        /// Updates the specified EducationSubmission using PUT.
        /// </summary>
        /// <param name="educationSubmissionToUpdate">The EducationSubmission object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        public async System.Threading.Tasks.Task<EducationSubmission> PutAsync(EducationSubmission educationSubmissionToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PUT;
            var updatedEntity = await this.SendAsync<EducationSubmission>(educationSubmissionToUpdate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(updatedEntity);
            return updatedEntity;
        }

        /// <summary>
        /// Updates the specified EducationSubmission using PUT and returns a <see cref="GraphResponse{EducationSubmission}"/> object.
        /// </summary>
        /// <param name="educationSubmissionToUpdate">The EducationSubmission object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await of <see cref="GraphResponse{EducationSubmission}"/>.</returns>
        public System.Threading.Tasks.Task<GraphResponse<EducationSubmission>> PutResponseAsync(EducationSubmission educationSubmissionToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PUT;
            return this.SendAsyncWithGraphResponse<EducationSubmission>(educationSubmissionToUpdate, cancellationToken);
        }

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        public IEducationSubmissionRequest Expand(string value)
        {
            this.QueryOptions.Add(new QueryOption("$expand", value));
            return this;
        }

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        public IEducationSubmissionRequest Expand(Expression<Func<EducationSubmission, object>> expandExpression)
        {
		    if (expandExpression == null)
            {
                throw new ArgumentNullException(nameof(expandExpression));
            }
            string error;
            string value = ExpressionExtractHelper.ExtractMembers(expandExpression, out error);
            if (value == null)
            {
                throw new ArgumentException(error, nameof(expandExpression));
            }
            else
            {
                this.QueryOptions.Add(new QueryOption("$expand", value));
            }
            return this;
        }

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        public IEducationSubmissionRequest Select(string value)
        {
            this.QueryOptions.Add(new QueryOption("$select", value));
            return this;
        }

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        public IEducationSubmissionRequest Select(Expression<Func<EducationSubmission, object>> selectExpression)
        {
            if (selectExpression == null)
            {
                throw new ArgumentNullException(nameof(selectExpression));
            }
            string error;
            string value = ExpressionExtractHelper.ExtractMembers(selectExpression, out error);
            if (value == null)
            {
                throw new ArgumentException(error, nameof(selectExpression));
            }
            else
            {
                this.QueryOptions.Add(new QueryOption("$select", value));
            }
            return this;
        }

        /// <summary>
        /// Initializes any collection properties after deserialization, like next requests for paging.
        /// </summary>
        /// <param name="educationSubmissionToInitialize">The <see cref="EducationSubmission"/> with the collection properties to initialize.</param>
        private void InitializeCollectionProperties(EducationSubmission educationSubmissionToInitialize)
        {

            if (educationSubmissionToInitialize != null)
            {
                if (educationSubmissionToInitialize.Outcomes != null && educationSubmissionToInitialize.Outcomes.CurrentPage != null)
                {
                    educationSubmissionToInitialize.Outcomes.InitializeNextPageRequest(this.Client, educationSubmissionToInitialize.OutcomesNextLink);
                    // Copy the additional data collection to the page itself so that information is not lost
                    educationSubmissionToInitialize.Outcomes.AdditionalData = educationSubmissionToInitialize.AdditionalData;
                }
                if (educationSubmissionToInitialize.Resources != null && educationSubmissionToInitialize.Resources.CurrentPage != null)
                {
                    educationSubmissionToInitialize.Resources.InitializeNextPageRequest(this.Client, educationSubmissionToInitialize.ResourcesNextLink);
                    // Copy the additional data collection to the page itself so that information is not lost
                    educationSubmissionToInitialize.Resources.AdditionalData = educationSubmissionToInitialize.AdditionalData;
                }
                if (educationSubmissionToInitialize.SubmittedResources != null && educationSubmissionToInitialize.SubmittedResources.CurrentPage != null)
                {
                    educationSubmissionToInitialize.SubmittedResources.InitializeNextPageRequest(this.Client, educationSubmissionToInitialize.SubmittedResourcesNextLink);
                    // Copy the additional data collection to the page itself so that information is not lost
                    educationSubmissionToInitialize.SubmittedResources.AdditionalData = educationSubmissionToInitialize.AdditionalData;
                }

            }


        }
    }
}
