// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type EntitlementManagementAccessPackagesCollectionRequestBuilder.
    /// </summary>
    public partial class EntitlementManagementAccessPackagesCollectionRequestBuilder : BaseRequestBuilder, IEntitlementManagementAccessPackagesCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new EntitlementManagementAccessPackagesCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public EntitlementManagementAccessPackagesCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IEntitlementManagementAccessPackagesCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IEntitlementManagementAccessPackagesCollectionRequest Request(IEnumerable<Option> options)
        {
            return new EntitlementManagementAccessPackagesCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IAccessPackageRequestBuilder"/> for the specified EntitlementManagementAccessPackage.
        /// </summary>
        /// <param name="id">The ID for the EntitlementManagementAccessPackage.</param>
        /// <returns>The <see cref="IAccessPackageRequestBuilder"/>.</returns>
        public IAccessPackageRequestBuilder this[string id]
        {
            get
            {
                return new AccessPackageRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AccessPackageFilterByCurrentUser.
        /// </summary>
        /// <returns>The <see cref="IAccessPackageFilterByCurrentUserRequestBuilder"/>.</returns>
        public IAccessPackageFilterByCurrentUserRequestBuilder FilterByCurrentUser(
            AccessPackageFilterByCurrentUserOptions on)
        {
            return new AccessPackageFilterByCurrentUserRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.filterByCurrentUser"),
                this.Client,
                on);
        }
    }
}
