// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type EntitlementManagementAssignmentsCollectionRequestBuilder.
    /// </summary>
    public partial class EntitlementManagementAssignmentsCollectionRequestBuilder : BaseRequestBuilder, IEntitlementManagementAssignmentsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new EntitlementManagementAssignmentsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public EntitlementManagementAssignmentsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IEntitlementManagementAssignmentsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IEntitlementManagementAssignmentsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new EntitlementManagementAssignmentsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IAccessPackageAssignmentRequestBuilder"/> for the specified EntitlementManagementAccessPackageAssignment.
        /// </summary>
        /// <param name="id">The ID for the EntitlementManagementAccessPackageAssignment.</param>
        /// <returns>The <see cref="IAccessPackageAssignmentRequestBuilder"/>.</returns>
        public IAccessPackageAssignmentRequestBuilder this[string id]
        {
            get
            {
                return new AccessPackageAssignmentRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AccessPackageAssignmentFilterByCurrentUser.
        /// </summary>
        /// <returns>The <see cref="IAccessPackageAssignmentFilterByCurrentUserRequestBuilder"/>.</returns>
        public IAccessPackageAssignmentFilterByCurrentUserRequestBuilder FilterByCurrentUser(
            AccessPackageAssignmentFilterByCurrentUserOptions on)
        {
            return new AccessPackageAssignmentFilterByCurrentUserRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.filterByCurrentUser"),
                this.Client,
                on);
        }
    }
}
