// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type GraphServiceApplicationsCollectionRequestBuilder.
    /// </summary>
    public partial class GraphServiceApplicationsCollectionRequestBuilder : BaseRequestBuilder, IGraphServiceApplicationsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new GraphServiceApplicationsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public GraphServiceApplicationsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IGraphServiceApplicationsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IGraphServiceApplicationsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new GraphServiceApplicationsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IApplicationRequestBuilder"/> for the specified GraphServiceApplication.
        /// </summary>
        /// <param name="id">The ID for the GraphServiceApplication.</param>
        /// <returns>The <see cref="IApplicationRequestBuilder"/>.</returns>
        public IApplicationRequestBuilder this[string id]
        {
            get
            {
                return new ApplicationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ApplicationDelta.
        /// </summary>
        /// <returns>The <see cref="IApplicationDeltaRequestBuilder"/>.</returns>
        public IApplicationDeltaRequestBuilder Delta()
        {
            return new ApplicationDeltaRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.delta"),
                this.Client);
        }
    }
}
