// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type GraphServiceAuthenticationMethodConfigurationsCollectionRequestBuilder.
    /// </summary>
    public partial class GraphServiceAuthenticationMethodConfigurationsCollectionRequestBuilder : BaseRequestBuilder, IGraphServiceAuthenticationMethodConfigurationsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new GraphServiceAuthenticationMethodConfigurationsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public GraphServiceAuthenticationMethodConfigurationsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IGraphServiceAuthenticationMethodConfigurationsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IGraphServiceAuthenticationMethodConfigurationsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new GraphServiceAuthenticationMethodConfigurationsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IAuthenticationMethodConfigurationRequestBuilder"/> for the specified GraphServiceAuthenticationMethodConfiguration.
        /// </summary>
        /// <param name="id">The ID for the GraphServiceAuthenticationMethodConfiguration.</param>
        /// <returns>The <see cref="IAuthenticationMethodConfigurationRequestBuilder"/>.</returns>
        public IAuthenticationMethodConfigurationRequestBuilder this[string id]
        {
            get
            {
                return new AuthenticationMethodConfigurationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
