// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type GraphServiceDataPolicyOperationsCollectionRequestBuilder.
    /// </summary>
    public partial class GraphServiceDataPolicyOperationsCollectionRequestBuilder : BaseRequestBuilder, IGraphServiceDataPolicyOperationsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new GraphServiceDataPolicyOperationsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public GraphServiceDataPolicyOperationsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IGraphServiceDataPolicyOperationsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IGraphServiceDataPolicyOperationsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new GraphServiceDataPolicyOperationsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IDataPolicyOperationRequestBuilder"/> for the specified GraphServiceDataPolicyOperation.
        /// </summary>
        /// <param name="id">The ID for the GraphServiceDataPolicyOperation.</param>
        /// <returns>The <see cref="IDataPolicyOperationRequestBuilder"/>.</returns>
        public IDataPolicyOperationRequestBuilder this[string id]
        {
            get
            {
                return new DataPolicyOperationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
