// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type GraphServiceOauth2PermissionGrantsCollectionRequestBuilder.
    /// </summary>
    public partial class GraphServiceOauth2PermissionGrantsCollectionRequestBuilder : BaseRequestBuilder, IGraphServiceOauth2PermissionGrantsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new GraphServiceOauth2PermissionGrantsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public GraphServiceOauth2PermissionGrantsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IGraphServiceOauth2PermissionGrantsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IGraphServiceOauth2PermissionGrantsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new GraphServiceOauth2PermissionGrantsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IOAuth2PermissionGrantRequestBuilder"/> for the specified GraphServiceOAuth2PermissionGrant.
        /// </summary>
        /// <param name="id">The ID for the GraphServiceOAuth2PermissionGrant.</param>
        /// <returns>The <see cref="IOAuth2PermissionGrantRequestBuilder"/>.</returns>
        public IOAuth2PermissionGrantRequestBuilder this[string id]
        {
            get
            {
                return new OAuth2PermissionGrantRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for OAuth2PermissionGrantDelta.
        /// </summary>
        /// <returns>The <see cref="IOAuth2PermissionGrantDeltaRequestBuilder"/>.</returns>
        public IOAuth2PermissionGrantDeltaRequestBuilder Delta()
        {
            return new OAuth2PermissionGrantDeltaRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.delta"),
                this.Client);
        }
    }
}
