// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type GraphServiceUsersCollectionRequestBuilder.
    /// </summary>
    public partial class GraphServiceUsersCollectionRequestBuilder : BaseRequestBuilder, IGraphServiceUsersCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new GraphServiceUsersCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public GraphServiceUsersCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IGraphServiceUsersCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IGraphServiceUsersCollectionRequest Request(IEnumerable<Option> options)
        {
            return new GraphServiceUsersCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IUserRequestBuilder"/> for the specified GraphServiceUser.
        /// </summary>
        /// <param name="id">The ID for the GraphServiceUser.</param>
        /// <returns>The <see cref="IUserRequestBuilder"/>.</returns>
        public IUserRequestBuilder this[string id]
        {
            get
            {
                return new UserRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for UserDelta.
        /// </summary>
        /// <returns>The <see cref="IUserDeltaRequestBuilder"/>.</returns>
        public IUserDeltaRequestBuilder Delta()
        {
            return new UserDeltaRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.delta"),
                this.Client);
        }
    }
}
