// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type GroupSitesCollectionRequestBuilder.
    /// </summary>
    public partial class GroupSitesCollectionRequestBuilder : BaseRequestBuilder, IGroupSitesCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new GroupSitesCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public GroupSitesCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IGroupSitesCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IGroupSitesCollectionRequest Request(IEnumerable<Option> options)
        {
            return new GroupSitesCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ISiteRequestBuilder"/> for the specified GroupSite.
        /// </summary>
        /// <param name="id">The ID for the GroupSite.</param>
        /// <returns>The <see cref="ISiteRequestBuilder"/>.</returns>
        public ISiteRequestBuilder this[string id]
        {
            get
            {
                return new SiteRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for SiteAdd.
        /// </summary>
        /// <returns>The <see cref="ISiteAddRequestBuilder"/>.</returns>
        public ISiteAddRequestBuilder Add(
            IEnumerable<Site> value = null)
        {
            return new SiteAddRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.add"),
                this.Client,
                value);
        }

        /// <summary>
        /// Gets the request builder for SiteRemove.
        /// </summary>
        /// <returns>The <see cref="ISiteRemoveRequestBuilder"/>.</returns>
        public ISiteRemoveRequestBuilder Remove(
            IEnumerable<Site> value = null)
        {
            return new SiteRemoveRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.remove"),
                this.Client,
                value);
        }
    }
}
