// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAccessPackageAssignmentRequestRequest.
    /// </summary>
    public partial interface IAccessPackageAssignmentRequestRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified AccessPackageAssignmentRequestObject using POST.
        /// </summary>
        /// <param name="accessPackageAssignmentRequestObjectToCreate">The AccessPackageAssignmentRequestObject to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AccessPackageAssignmentRequestObject.</returns>
        System.Threading.Tasks.Task<AccessPackageAssignmentRequestObject> CreateAsync(AccessPackageAssignmentRequestObject accessPackageAssignmentRequestObjectToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified AccessPackageAssignmentRequestObject using POST and returns a <see cref="GraphResponse{AccessPackageAssignmentRequestObject}"/> object.
        /// </summary>
        /// <param name="accessPackageAssignmentRequestObjectToCreate">The AccessPackageAssignmentRequestObject to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AccessPackageAssignmentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessPackageAssignmentRequestObject>> CreateResponseAsync(AccessPackageAssignmentRequestObject accessPackageAssignmentRequestObjectToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AccessPackageAssignmentRequestObject.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AccessPackageAssignmentRequestObject and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AccessPackageAssignmentRequestObject.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AccessPackageAssignmentRequestObject.</returns>
        System.Threading.Tasks.Task<AccessPackageAssignmentRequestObject> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AccessPackageAssignmentRequestObject and returns a <see cref="GraphResponse{AccessPackageAssignmentRequestObject}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AccessPackageAssignmentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessPackageAssignmentRequestObject>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AccessPackageAssignmentRequestObject using PATCH.
        /// </summary>
        /// <param name="accessPackageAssignmentRequestObjectToUpdate">The AccessPackageAssignmentRequestObject to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AccessPackageAssignmentRequestObject.</returns>
        System.Threading.Tasks.Task<AccessPackageAssignmentRequestObject> UpdateAsync(AccessPackageAssignmentRequestObject accessPackageAssignmentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AccessPackageAssignmentRequestObject using PATCH and returns a <see cref="GraphResponse{AccessPackageAssignmentRequestObject}"/> object.
        /// </summary>
        /// <param name="accessPackageAssignmentRequestObjectToUpdate">The AccessPackageAssignmentRequestObject to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AccessPackageAssignmentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessPackageAssignmentRequestObject>> UpdateResponseAsync(AccessPackageAssignmentRequestObject accessPackageAssignmentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AccessPackageAssignmentRequestObject using PUT.
        /// </summary>
        /// <param name="accessPackageAssignmentRequestObjectToUpdate">The AccessPackageAssignmentRequestObject object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<AccessPackageAssignmentRequestObject> PutAsync(AccessPackageAssignmentRequestObject accessPackageAssignmentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AccessPackageAssignmentRequestObject using PUT and returns a <see cref="GraphResponse{AccessPackageAssignmentRequestObject}"/> object.
        /// </summary>
        /// <param name="accessPackageAssignmentRequestObjectToUpdate">The AccessPackageAssignmentRequestObject object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{AccessPackageAssignmentRequestObject}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessPackageAssignmentRequestObject>> PutResponseAsync(AccessPackageAssignmentRequestObject accessPackageAssignmentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAccessPackageAssignmentRequestRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAccessPackageAssignmentRequestRequest Expand(Expression<Func<AccessPackageAssignmentRequestObject, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAccessPackageAssignmentRequestRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAccessPackageAssignmentRequestRequest Select(Expression<Func<AccessPackageAssignmentRequestObject, object>> selectExpression);

    }
}
