// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityWithReferenceRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAccessPackageCatalogWithReferenceRequest.
    /// </summary>
    public partial interface IAccessPackageCatalogWithReferenceRequest : IBaseRequest
    {
        /// <summary>
        /// Gets the specified AccessPackageCatalog.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AccessPackageCatalog.</returns>
        System.Threading.Tasks.Task<AccessPackageCatalog> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AccessPackageCatalog and returns a <see cref="GraphResponse{AccessPackageCatalog}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AccessPackageCatalog}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessPackageCatalog>> GetResponseAsync(CancellationToken cancellationToken = default);

		/// <summary>
        /// Creates the specified AccessPackageCatalog using POST.
        /// </summary>
        /// <param name="accessPackageCatalogToCreate">The AccessPackageCatalog to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AccessPackageCatalog.</returns>
        System.Threading.Tasks.Task<AccessPackageCatalog> CreateAsync(AccessPackageCatalog accessPackageCatalogToCreate, CancellationToken cancellationToken = default);

		/// <summary>
        /// Creates the specified AccessPackageCatalog using POST and returns a <see cref="GraphResponse{AccessPackageCatalog}"/> object.
        /// </summary>
        /// <param name="accessPackageCatalogToCreate">The AccessPackageCatalog to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AccessPackageCatalog}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessPackageCatalog>> CreateResponseAsync(AccessPackageCatalog accessPackageCatalogToCreate, CancellationToken cancellationToken = default);

		/// <summary>
        /// Updates the specified AccessPackageCatalog using PATCH.
        /// </summary>
        /// <param name="accessPackageCatalogToUpdate">The AccessPackageCatalog to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AccessPackageCatalog.</returns>
        System.Threading.Tasks.Task<AccessPackageCatalog> UpdateAsync(AccessPackageCatalog accessPackageCatalogToUpdate, CancellationToken cancellationToken = default);

		/// <summary>
        /// Updates the specified AccessPackageCatalog using PATCH and returns a <see cref="GraphResponse{AccessPackageCatalog}"/> object.
        /// </summary>
        /// <param name="accessPackageCatalogToUpdate">The AccessPackageCatalog to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AccessPackageCatalog}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessPackageCatalog>> UpdateResponseAsync(AccessPackageCatalog accessPackageCatalogToUpdate, CancellationToken cancellationToken = default);

		/// <summary>
        /// Deletes the specified AccessPackageCatalog.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

		/// <summary>
        /// Deletes the specified AccessPackageCatalog and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAccessPackageCatalogWithReferenceRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAccessPackageCatalogWithReferenceRequest Expand(Expression<Func<AccessPackageCatalog, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAccessPackageCatalogWithReferenceRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAccessPackageCatalogWithReferenceRequest Select(Expression<Func<AccessPackageCatalog, object>> selectExpression);

    }
}
