// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAccessReviewReviewerRequest.
    /// </summary>
    public partial interface IAccessReviewReviewerRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified AccessReviewReviewer using POST.
        /// </summary>
        /// <param name="accessReviewReviewerToCreate">The AccessReviewReviewer to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AccessReviewReviewer.</returns>
        System.Threading.Tasks.Task<AccessReviewReviewer> CreateAsync(AccessReviewReviewer accessReviewReviewerToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified AccessReviewReviewer using POST and returns a <see cref="GraphResponse{AccessReviewReviewer}"/> object.
        /// </summary>
        /// <param name="accessReviewReviewerToCreate">The AccessReviewReviewer to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AccessReviewReviewer}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessReviewReviewer>> CreateResponseAsync(AccessReviewReviewer accessReviewReviewerToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AccessReviewReviewer.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AccessReviewReviewer and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AccessReviewReviewer.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AccessReviewReviewer.</returns>
        System.Threading.Tasks.Task<AccessReviewReviewer> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AccessReviewReviewer and returns a <see cref="GraphResponse{AccessReviewReviewer}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AccessReviewReviewer}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessReviewReviewer>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AccessReviewReviewer using PATCH.
        /// </summary>
        /// <param name="accessReviewReviewerToUpdate">The AccessReviewReviewer to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AccessReviewReviewer.</returns>
        System.Threading.Tasks.Task<AccessReviewReviewer> UpdateAsync(AccessReviewReviewer accessReviewReviewerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AccessReviewReviewer using PATCH and returns a <see cref="GraphResponse{AccessReviewReviewer}"/> object.
        /// </summary>
        /// <param name="accessReviewReviewerToUpdate">The AccessReviewReviewer to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AccessReviewReviewer}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessReviewReviewer>> UpdateResponseAsync(AccessReviewReviewer accessReviewReviewerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AccessReviewReviewer using PUT.
        /// </summary>
        /// <param name="accessReviewReviewerToUpdate">The AccessReviewReviewer object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<AccessReviewReviewer> PutAsync(AccessReviewReviewer accessReviewReviewerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AccessReviewReviewer using PUT and returns a <see cref="GraphResponse{AccessReviewReviewer}"/> object.
        /// </summary>
        /// <param name="accessReviewReviewerToUpdate">The AccessReviewReviewer object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{AccessReviewReviewer}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<AccessReviewReviewer>> PutResponseAsync(AccessReviewReviewer accessReviewReviewerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAccessReviewReviewerRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAccessReviewReviewerRequest Expand(Expression<Func<AccessReviewReviewer, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAccessReviewReviewerRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAccessReviewReviewerRequest Select(Expression<Func<AccessReviewReviewer, object>> selectExpression);

    }
}
