// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAgreementFileLocalizationRequest.
    /// </summary>
    public partial interface IAgreementFileLocalizationRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified AgreementFileLocalization using POST.
        /// </summary>
        /// <param name="agreementFileLocalizationToCreate">The AgreementFileLocalization to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AgreementFileLocalization.</returns>
        System.Threading.Tasks.Task<AgreementFileLocalization> CreateAsync(AgreementFileLocalization agreementFileLocalizationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified AgreementFileLocalization using POST and returns a <see cref="GraphResponse{AgreementFileLocalization}"/> object.
        /// </summary>
        /// <param name="agreementFileLocalizationToCreate">The AgreementFileLocalization to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AgreementFileLocalization}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AgreementFileLocalization>> CreateResponseAsync(AgreementFileLocalization agreementFileLocalizationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AgreementFileLocalization.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AgreementFileLocalization and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AgreementFileLocalization.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AgreementFileLocalization.</returns>
        System.Threading.Tasks.Task<AgreementFileLocalization> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AgreementFileLocalization and returns a <see cref="GraphResponse{AgreementFileLocalization}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AgreementFileLocalization}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AgreementFileLocalization>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AgreementFileLocalization using PATCH.
        /// </summary>
        /// <param name="agreementFileLocalizationToUpdate">The AgreementFileLocalization to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AgreementFileLocalization.</returns>
        System.Threading.Tasks.Task<AgreementFileLocalization> UpdateAsync(AgreementFileLocalization agreementFileLocalizationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AgreementFileLocalization using PATCH and returns a <see cref="GraphResponse{AgreementFileLocalization}"/> object.
        /// </summary>
        /// <param name="agreementFileLocalizationToUpdate">The AgreementFileLocalization to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AgreementFileLocalization}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AgreementFileLocalization>> UpdateResponseAsync(AgreementFileLocalization agreementFileLocalizationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AgreementFileLocalization using PUT.
        /// </summary>
        /// <param name="agreementFileLocalizationToUpdate">The AgreementFileLocalization object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<AgreementFileLocalization> PutAsync(AgreementFileLocalization agreementFileLocalizationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AgreementFileLocalization using PUT and returns a <see cref="GraphResponse{AgreementFileLocalization}"/> object.
        /// </summary>
        /// <param name="agreementFileLocalizationToUpdate">The AgreementFileLocalization object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{AgreementFileLocalization}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<AgreementFileLocalization>> PutResponseAsync(AgreementFileLocalization agreementFileLocalizationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAgreementFileLocalizationRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAgreementFileLocalizationRequest Expand(Expression<Func<AgreementFileLocalization, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAgreementFileLocalizationRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAgreementFileLocalizationRequest Select(Expression<Func<AgreementFileLocalization, object>> selectExpression);

    }
}
