// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAppConsentApprovalRouteRequest.
    /// </summary>
    public partial interface IAppConsentApprovalRouteRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified AppConsentApprovalRoute using POST.
        /// </summary>
        /// <param name="appConsentApprovalRouteToCreate">The AppConsentApprovalRoute to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AppConsentApprovalRoute.</returns>
        System.Threading.Tasks.Task<AppConsentApprovalRoute> CreateAsync(AppConsentApprovalRoute appConsentApprovalRouteToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified AppConsentApprovalRoute using POST and returns a <see cref="GraphResponse{AppConsentApprovalRoute}"/> object.
        /// </summary>
        /// <param name="appConsentApprovalRouteToCreate">The AppConsentApprovalRoute to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AppConsentApprovalRoute}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AppConsentApprovalRoute>> CreateResponseAsync(AppConsentApprovalRoute appConsentApprovalRouteToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AppConsentApprovalRoute.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AppConsentApprovalRoute and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AppConsentApprovalRoute.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AppConsentApprovalRoute.</returns>
        System.Threading.Tasks.Task<AppConsentApprovalRoute> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AppConsentApprovalRoute and returns a <see cref="GraphResponse{AppConsentApprovalRoute}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AppConsentApprovalRoute}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AppConsentApprovalRoute>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AppConsentApprovalRoute using PATCH.
        /// </summary>
        /// <param name="appConsentApprovalRouteToUpdate">The AppConsentApprovalRoute to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AppConsentApprovalRoute.</returns>
        System.Threading.Tasks.Task<AppConsentApprovalRoute> UpdateAsync(AppConsentApprovalRoute appConsentApprovalRouteToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AppConsentApprovalRoute using PATCH and returns a <see cref="GraphResponse{AppConsentApprovalRoute}"/> object.
        /// </summary>
        /// <param name="appConsentApprovalRouteToUpdate">The AppConsentApprovalRoute to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AppConsentApprovalRoute}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AppConsentApprovalRoute>> UpdateResponseAsync(AppConsentApprovalRoute appConsentApprovalRouteToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AppConsentApprovalRoute using PUT.
        /// </summary>
        /// <param name="appConsentApprovalRouteToUpdate">The AppConsentApprovalRoute object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<AppConsentApprovalRoute> PutAsync(AppConsentApprovalRoute appConsentApprovalRouteToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AppConsentApprovalRoute using PUT and returns a <see cref="GraphResponse{AppConsentApprovalRoute}"/> object.
        /// </summary>
        /// <param name="appConsentApprovalRouteToUpdate">The AppConsentApprovalRoute object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{AppConsentApprovalRoute}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<AppConsentApprovalRoute>> PutResponseAsync(AppConsentApprovalRoute appConsentApprovalRouteToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAppConsentApprovalRouteRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAppConsentApprovalRouteRequest Expand(Expression<Func<AppConsentApprovalRoute, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAppConsentApprovalRouteRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAppConsentApprovalRouteRequest Select(Expression<Func<AppConsentApprovalRoute, object>> selectExpression);

    }
}
