// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAppConsentRequestRequest.
    /// </summary>
    public partial interface IAppConsentRequestRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified AppConsentRequestObject using POST.
        /// </summary>
        /// <param name="appConsentRequestObjectToCreate">The AppConsentRequestObject to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AppConsentRequestObject.</returns>
        System.Threading.Tasks.Task<AppConsentRequestObject> CreateAsync(AppConsentRequestObject appConsentRequestObjectToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified AppConsentRequestObject using POST and returns a <see cref="GraphResponse{AppConsentRequestObject}"/> object.
        /// </summary>
        /// <param name="appConsentRequestObjectToCreate">The AppConsentRequestObject to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AppConsentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AppConsentRequestObject>> CreateResponseAsync(AppConsentRequestObject appConsentRequestObjectToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AppConsentRequestObject.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AppConsentRequestObject and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AppConsentRequestObject.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AppConsentRequestObject.</returns>
        System.Threading.Tasks.Task<AppConsentRequestObject> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AppConsentRequestObject and returns a <see cref="GraphResponse{AppConsentRequestObject}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AppConsentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AppConsentRequestObject>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AppConsentRequestObject using PATCH.
        /// </summary>
        /// <param name="appConsentRequestObjectToUpdate">The AppConsentRequestObject to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AppConsentRequestObject.</returns>
        System.Threading.Tasks.Task<AppConsentRequestObject> UpdateAsync(AppConsentRequestObject appConsentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AppConsentRequestObject using PATCH and returns a <see cref="GraphResponse{AppConsentRequestObject}"/> object.
        /// </summary>
        /// <param name="appConsentRequestObjectToUpdate">The AppConsentRequestObject to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AppConsentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AppConsentRequestObject>> UpdateResponseAsync(AppConsentRequestObject appConsentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AppConsentRequestObject using PUT.
        /// </summary>
        /// <param name="appConsentRequestObjectToUpdate">The AppConsentRequestObject object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<AppConsentRequestObject> PutAsync(AppConsentRequestObject appConsentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AppConsentRequestObject using PUT and returns a <see cref="GraphResponse{AppConsentRequestObject}"/> object.
        /// </summary>
        /// <param name="appConsentRequestObjectToUpdate">The AppConsentRequestObject object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{AppConsentRequestObject}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<AppConsentRequestObject>> PutResponseAsync(AppConsentRequestObject appConsentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAppConsentRequestRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAppConsentRequestRequest Expand(Expression<Func<AppConsentRequestObject, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAppConsentRequestRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAppConsentRequestRequest Select(Expression<Func<AppConsentRequestObject, object>> selectExpression);

    }
}
