// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IApplicationTemplateRequest.
    /// </summary>
    public partial interface IApplicationTemplateRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ApplicationTemplate using POST.
        /// </summary>
        /// <param name="applicationTemplateToCreate">The ApplicationTemplate to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ApplicationTemplate.</returns>
        System.Threading.Tasks.Task<ApplicationTemplate> CreateAsync(ApplicationTemplate applicationTemplateToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ApplicationTemplate using POST and returns a <see cref="GraphResponse{ApplicationTemplate}"/> object.
        /// </summary>
        /// <param name="applicationTemplateToCreate">The ApplicationTemplate to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ApplicationTemplate}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ApplicationTemplate>> CreateResponseAsync(ApplicationTemplate applicationTemplateToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ApplicationTemplate.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ApplicationTemplate and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ApplicationTemplate.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ApplicationTemplate.</returns>
        System.Threading.Tasks.Task<ApplicationTemplate> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ApplicationTemplate and returns a <see cref="GraphResponse{ApplicationTemplate}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ApplicationTemplate}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ApplicationTemplate>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ApplicationTemplate using PATCH.
        /// </summary>
        /// <param name="applicationTemplateToUpdate">The ApplicationTemplate to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ApplicationTemplate.</returns>
        System.Threading.Tasks.Task<ApplicationTemplate> UpdateAsync(ApplicationTemplate applicationTemplateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ApplicationTemplate using PATCH and returns a <see cref="GraphResponse{ApplicationTemplate}"/> object.
        /// </summary>
        /// <param name="applicationTemplateToUpdate">The ApplicationTemplate to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ApplicationTemplate}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ApplicationTemplate>> UpdateResponseAsync(ApplicationTemplate applicationTemplateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ApplicationTemplate using PUT.
        /// </summary>
        /// <param name="applicationTemplateToUpdate">The ApplicationTemplate object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ApplicationTemplate> PutAsync(ApplicationTemplate applicationTemplateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ApplicationTemplate using PUT and returns a <see cref="GraphResponse{ApplicationTemplate}"/> object.
        /// </summary>
        /// <param name="applicationTemplateToUpdate">The ApplicationTemplate object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ApplicationTemplate}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ApplicationTemplate>> PutResponseAsync(ApplicationTemplate applicationTemplateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IApplicationTemplateRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IApplicationTemplateRequest Expand(Expression<Func<ApplicationTemplate, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IApplicationTemplateRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IApplicationTemplateRequest Select(Expression<Func<ApplicationTemplate, object>> selectExpression);

    }
}
