// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IApprovalRequest.
    /// </summary>
    public partial interface IApprovalRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified Approval using POST.
        /// </summary>
        /// <param name="approvalToCreate">The Approval to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Approval.</returns>
        System.Threading.Tasks.Task<Approval> CreateAsync(Approval approvalToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Approval using POST and returns a <see cref="GraphResponse{Approval}"/> object.
        /// </summary>
        /// <param name="approvalToCreate">The Approval to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Approval}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Approval>> CreateResponseAsync(Approval approvalToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Approval.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Approval and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Approval.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Approval.</returns>
        System.Threading.Tasks.Task<Approval> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Approval and returns a <see cref="GraphResponse{Approval}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Approval}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Approval>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Approval using PATCH.
        /// </summary>
        /// <param name="approvalToUpdate">The Approval to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Approval.</returns>
        System.Threading.Tasks.Task<Approval> UpdateAsync(Approval approvalToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Approval using PATCH and returns a <see cref="GraphResponse{Approval}"/> object.
        /// </summary>
        /// <param name="approvalToUpdate">The Approval to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Approval}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Approval>> UpdateResponseAsync(Approval approvalToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Approval using PUT.
        /// </summary>
        /// <param name="approvalToUpdate">The Approval object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Approval> PutAsync(Approval approvalToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Approval using PUT and returns a <see cref="GraphResponse{Approval}"/> object.
        /// </summary>
        /// <param name="approvalToUpdate">The Approval object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Approval}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Approval>> PutResponseAsync(Approval approvalToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IApprovalRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IApprovalRequest Expand(Expression<Func<Approval, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IApprovalRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IApprovalRequest Select(Expression<Func<Approval, object>> selectExpression);

    }
}
