// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IApprovalStageRequest.
    /// </summary>
    public partial interface IApprovalStageRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ApprovalStage using POST.
        /// </summary>
        /// <param name="approvalStageToCreate">The ApprovalStage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ApprovalStage.</returns>
        System.Threading.Tasks.Task<ApprovalStage> CreateAsync(ApprovalStage approvalStageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ApprovalStage using POST and returns a <see cref="GraphResponse{ApprovalStage}"/> object.
        /// </summary>
        /// <param name="approvalStageToCreate">The ApprovalStage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ApprovalStage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ApprovalStage>> CreateResponseAsync(ApprovalStage approvalStageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ApprovalStage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ApprovalStage and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ApprovalStage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ApprovalStage.</returns>
        System.Threading.Tasks.Task<ApprovalStage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ApprovalStage and returns a <see cref="GraphResponse{ApprovalStage}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ApprovalStage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ApprovalStage>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ApprovalStage using PATCH.
        /// </summary>
        /// <param name="approvalStageToUpdate">The ApprovalStage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ApprovalStage.</returns>
        System.Threading.Tasks.Task<ApprovalStage> UpdateAsync(ApprovalStage approvalStageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ApprovalStage using PATCH and returns a <see cref="GraphResponse{ApprovalStage}"/> object.
        /// </summary>
        /// <param name="approvalStageToUpdate">The ApprovalStage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ApprovalStage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ApprovalStage>> UpdateResponseAsync(ApprovalStage approvalStageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ApprovalStage using PUT.
        /// </summary>
        /// <param name="approvalStageToUpdate">The ApprovalStage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ApprovalStage> PutAsync(ApprovalStage approvalStageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ApprovalStage using PUT and returns a <see cref="GraphResponse{ApprovalStage}"/> object.
        /// </summary>
        /// <param name="approvalStageToUpdate">The ApprovalStage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ApprovalStage}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ApprovalStage>> PutResponseAsync(ApprovalStage approvalStageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IApprovalStageRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IApprovalStageRequest Expand(Expression<Func<ApprovalStage, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IApprovalStageRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IApprovalStageRequest Select(Expression<Func<ApprovalStage, object>> selectExpression);

    }
}
