// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAuthenticationMethodsPolicyRequest.
    /// </summary>
    public partial interface IAuthenticationMethodsPolicyRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified AuthenticationMethodsPolicy using POST.
        /// </summary>
        /// <param name="authenticationMethodsPolicyToCreate">The AuthenticationMethodsPolicy to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AuthenticationMethodsPolicy.</returns>
        System.Threading.Tasks.Task<AuthenticationMethodsPolicy> CreateAsync(AuthenticationMethodsPolicy authenticationMethodsPolicyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified AuthenticationMethodsPolicy using POST and returns a <see cref="GraphResponse{AuthenticationMethodsPolicy}"/> object.
        /// </summary>
        /// <param name="authenticationMethodsPolicyToCreate">The AuthenticationMethodsPolicy to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AuthenticationMethodsPolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AuthenticationMethodsPolicy>> CreateResponseAsync(AuthenticationMethodsPolicy authenticationMethodsPolicyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AuthenticationMethodsPolicy.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AuthenticationMethodsPolicy and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AuthenticationMethodsPolicy.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AuthenticationMethodsPolicy.</returns>
        System.Threading.Tasks.Task<AuthenticationMethodsPolicy> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AuthenticationMethodsPolicy and returns a <see cref="GraphResponse{AuthenticationMethodsPolicy}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AuthenticationMethodsPolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AuthenticationMethodsPolicy>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AuthenticationMethodsPolicy using PATCH.
        /// </summary>
        /// <param name="authenticationMethodsPolicyToUpdate">The AuthenticationMethodsPolicy to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AuthenticationMethodsPolicy.</returns>
        System.Threading.Tasks.Task<AuthenticationMethodsPolicy> UpdateAsync(AuthenticationMethodsPolicy authenticationMethodsPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AuthenticationMethodsPolicy using PATCH and returns a <see cref="GraphResponse{AuthenticationMethodsPolicy}"/> object.
        /// </summary>
        /// <param name="authenticationMethodsPolicyToUpdate">The AuthenticationMethodsPolicy to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AuthenticationMethodsPolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AuthenticationMethodsPolicy>> UpdateResponseAsync(AuthenticationMethodsPolicy authenticationMethodsPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AuthenticationMethodsPolicy using PUT.
        /// </summary>
        /// <param name="authenticationMethodsPolicyToUpdate">The AuthenticationMethodsPolicy object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<AuthenticationMethodsPolicy> PutAsync(AuthenticationMethodsPolicy authenticationMethodsPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AuthenticationMethodsPolicy using PUT and returns a <see cref="GraphResponse{AuthenticationMethodsPolicy}"/> object.
        /// </summary>
        /// <param name="authenticationMethodsPolicyToUpdate">The AuthenticationMethodsPolicy object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{AuthenticationMethodsPolicy}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<AuthenticationMethodsPolicy>> PutResponseAsync(AuthenticationMethodsPolicy authenticationMethodsPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAuthenticationMethodsPolicyRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAuthenticationMethodsPolicyRequest Expand(Expression<Func<AuthenticationMethodsPolicy, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAuthenticationMethodsPolicyRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAuthenticationMethodsPolicyRequest Select(Expression<Func<AuthenticationMethodsPolicy, object>> selectExpression);

    }
}
