// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IAuthenticationRequestBuilder.
    /// </summary>
    public partial interface IAuthenticationRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IAuthenticationRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IAuthenticationRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for Fido2Methods.
        /// </summary>
        /// <returns>The <see cref="IAuthenticationFido2MethodsCollectionRequestBuilder"/>.</returns>
        IAuthenticationFido2MethodsCollectionRequestBuilder Fido2Methods { get; }

        /// <summary>
        /// Gets the request builder for Methods.
        /// </summary>
        /// <returns>The <see cref="IAuthenticationMethodsCollectionRequestBuilder"/>.</returns>
        IAuthenticationMethodsCollectionRequestBuilder Methods { get; }

        /// <summary>
        /// Gets the request builder for MicrosoftAuthenticatorMethods.
        /// </summary>
        /// <returns>The <see cref="IAuthenticationMicrosoftAuthenticatorMethodsCollectionRequestBuilder"/>.</returns>
        IAuthenticationMicrosoftAuthenticatorMethodsCollectionRequestBuilder MicrosoftAuthenticatorMethods { get; }

        /// <summary>
        /// Gets the request builder for WindowsHelloForBusinessMethods.
        /// </summary>
        /// <returns>The <see cref="IAuthenticationWindowsHelloForBusinessMethodsCollectionRequestBuilder"/>.</returns>
        IAuthenticationWindowsHelloForBusinessMethodsCollectionRequestBuilder WindowsHelloForBusinessMethods { get; }
    
    }
}
