// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IB2xIdentityUserFlowRequest.
    /// </summary>
    public partial interface IB2xIdentityUserFlowRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified B2xIdentityUserFlow using POST.
        /// </summary>
        /// <param name="b2xIdentityUserFlowToCreate">The B2xIdentityUserFlow to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created B2xIdentityUserFlow.</returns>
        System.Threading.Tasks.Task<B2xIdentityUserFlow> CreateAsync(B2xIdentityUserFlow b2xIdentityUserFlowToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified B2xIdentityUserFlow using POST and returns a <see cref="GraphResponse{B2xIdentityUserFlow}"/> object.
        /// </summary>
        /// <param name="b2xIdentityUserFlowToCreate">The B2xIdentityUserFlow to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{B2xIdentityUserFlow}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<B2xIdentityUserFlow>> CreateResponseAsync(B2xIdentityUserFlow b2xIdentityUserFlowToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified B2xIdentityUserFlow.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified B2xIdentityUserFlow and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified B2xIdentityUserFlow.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The B2xIdentityUserFlow.</returns>
        System.Threading.Tasks.Task<B2xIdentityUserFlow> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified B2xIdentityUserFlow and returns a <see cref="GraphResponse{B2xIdentityUserFlow}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{B2xIdentityUserFlow}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<B2xIdentityUserFlow>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified B2xIdentityUserFlow using PATCH.
        /// </summary>
        /// <param name="b2xIdentityUserFlowToUpdate">The B2xIdentityUserFlow to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated B2xIdentityUserFlow.</returns>
        System.Threading.Tasks.Task<B2xIdentityUserFlow> UpdateAsync(B2xIdentityUserFlow b2xIdentityUserFlowToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified B2xIdentityUserFlow using PATCH and returns a <see cref="GraphResponse{B2xIdentityUserFlow}"/> object.
        /// </summary>
        /// <param name="b2xIdentityUserFlowToUpdate">The B2xIdentityUserFlow to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{B2xIdentityUserFlow}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<B2xIdentityUserFlow>> UpdateResponseAsync(B2xIdentityUserFlow b2xIdentityUserFlowToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified B2xIdentityUserFlow using PUT.
        /// </summary>
        /// <param name="b2xIdentityUserFlowToUpdate">The B2xIdentityUserFlow object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<B2xIdentityUserFlow> PutAsync(B2xIdentityUserFlow b2xIdentityUserFlowToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified B2xIdentityUserFlow using PUT and returns a <see cref="GraphResponse{B2xIdentityUserFlow}"/> object.
        /// </summary>
        /// <param name="b2xIdentityUserFlowToUpdate">The B2xIdentityUserFlow object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{B2xIdentityUserFlow}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<B2xIdentityUserFlow>> PutResponseAsync(B2xIdentityUserFlow b2xIdentityUserFlowToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IB2xIdentityUserFlowRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IB2xIdentityUserFlowRequest Expand(Expression<Func<B2xIdentityUserFlow, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IB2xIdentityUserFlowRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IB2xIdentityUserFlowRequest Select(Expression<Func<B2xIdentityUserFlow, object>> selectExpression);

    }
}
