// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IBookingCustomerRequest.
    /// </summary>
    public partial interface IBookingCustomerRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified BookingCustomer using POST.
        /// </summary>
        /// <param name="bookingCustomerToCreate">The BookingCustomer to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created BookingCustomer.</returns>
        System.Threading.Tasks.Task<BookingCustomer> CreateAsync(BookingCustomer bookingCustomerToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified BookingCustomer using POST and returns a <see cref="GraphResponse{BookingCustomer}"/> object.
        /// </summary>
        /// <param name="bookingCustomerToCreate">The BookingCustomer to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{BookingCustomer}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<BookingCustomer>> CreateResponseAsync(BookingCustomer bookingCustomerToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified BookingCustomer.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified BookingCustomer and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified BookingCustomer.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The BookingCustomer.</returns>
        System.Threading.Tasks.Task<BookingCustomer> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified BookingCustomer and returns a <see cref="GraphResponse{BookingCustomer}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{BookingCustomer}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<BookingCustomer>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BookingCustomer using PATCH.
        /// </summary>
        /// <param name="bookingCustomerToUpdate">The BookingCustomer to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated BookingCustomer.</returns>
        System.Threading.Tasks.Task<BookingCustomer> UpdateAsync(BookingCustomer bookingCustomerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BookingCustomer using PATCH and returns a <see cref="GraphResponse{BookingCustomer}"/> object.
        /// </summary>
        /// <param name="bookingCustomerToUpdate">The BookingCustomer to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{BookingCustomer}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<BookingCustomer>> UpdateResponseAsync(BookingCustomer bookingCustomerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BookingCustomer using PUT.
        /// </summary>
        /// <param name="bookingCustomerToUpdate">The BookingCustomer object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<BookingCustomer> PutAsync(BookingCustomer bookingCustomerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BookingCustomer using PUT and returns a <see cref="GraphResponse{BookingCustomer}"/> object.
        /// </summary>
        /// <param name="bookingCustomerToUpdate">The BookingCustomer object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{BookingCustomer}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<BookingCustomer>> PutResponseAsync(BookingCustomer bookingCustomerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IBookingCustomerRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IBookingCustomerRequest Expand(Expression<Func<BookingCustomer, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IBookingCustomerRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IBookingCustomerRequest Select(Expression<Func<BookingCustomer, object>> selectExpression);

    }
}
