// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IBuiltInIdentityProviderRequest.
    /// </summary>
    public partial interface IBuiltInIdentityProviderRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified BuiltInIdentityProvider using POST.
        /// </summary>
        /// <param name="builtInIdentityProviderToCreate">The BuiltInIdentityProvider to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created BuiltInIdentityProvider.</returns>
        System.Threading.Tasks.Task<BuiltInIdentityProvider> CreateAsync(BuiltInIdentityProvider builtInIdentityProviderToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified BuiltInIdentityProvider using POST and returns a <see cref="GraphResponse{BuiltInIdentityProvider}"/> object.
        /// </summary>
        /// <param name="builtInIdentityProviderToCreate">The BuiltInIdentityProvider to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{BuiltInIdentityProvider}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<BuiltInIdentityProvider>> CreateResponseAsync(BuiltInIdentityProvider builtInIdentityProviderToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified BuiltInIdentityProvider.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified BuiltInIdentityProvider and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified BuiltInIdentityProvider.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The BuiltInIdentityProvider.</returns>
        System.Threading.Tasks.Task<BuiltInIdentityProvider> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified BuiltInIdentityProvider and returns a <see cref="GraphResponse{BuiltInIdentityProvider}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{BuiltInIdentityProvider}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<BuiltInIdentityProvider>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BuiltInIdentityProvider using PATCH.
        /// </summary>
        /// <param name="builtInIdentityProviderToUpdate">The BuiltInIdentityProvider to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated BuiltInIdentityProvider.</returns>
        System.Threading.Tasks.Task<BuiltInIdentityProvider> UpdateAsync(BuiltInIdentityProvider builtInIdentityProviderToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BuiltInIdentityProvider using PATCH and returns a <see cref="GraphResponse{BuiltInIdentityProvider}"/> object.
        /// </summary>
        /// <param name="builtInIdentityProviderToUpdate">The BuiltInIdentityProvider to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{BuiltInIdentityProvider}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<BuiltInIdentityProvider>> UpdateResponseAsync(BuiltInIdentityProvider builtInIdentityProviderToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BuiltInIdentityProvider using PUT.
        /// </summary>
        /// <param name="builtInIdentityProviderToUpdate">The BuiltInIdentityProvider object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<BuiltInIdentityProvider> PutAsync(BuiltInIdentityProvider builtInIdentityProviderToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BuiltInIdentityProvider using PUT and returns a <see cref="GraphResponse{BuiltInIdentityProvider}"/> object.
        /// </summary>
        /// <param name="builtInIdentityProviderToUpdate">The BuiltInIdentityProvider object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{BuiltInIdentityProvider}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<BuiltInIdentityProvider>> PutResponseAsync(BuiltInIdentityProvider builtInIdentityProviderToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IBuiltInIdentityProviderRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IBuiltInIdentityProviderRequest Expand(Expression<Func<BuiltInIdentityProvider, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IBuiltInIdentityProviderRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IBuiltInIdentityProviderRequest Select(Expression<Func<BuiltInIdentityProvider, object>> selectExpression);

    }
}
