// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IChatMessageRequest.
    /// </summary>
    public partial interface IChatMessageRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ChatMessage using POST.
        /// </summary>
        /// <param name="chatMessageToCreate">The ChatMessage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ChatMessage.</returns>
        System.Threading.Tasks.Task<ChatMessage> CreateAsync(ChatMessage chatMessageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ChatMessage using POST and returns a <see cref="GraphResponse{ChatMessage}"/> object.
        /// </summary>
        /// <param name="chatMessageToCreate">The ChatMessage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ChatMessage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ChatMessage>> CreateResponseAsync(ChatMessage chatMessageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ChatMessage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ChatMessage and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ChatMessage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ChatMessage.</returns>
        System.Threading.Tasks.Task<ChatMessage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ChatMessage and returns a <see cref="GraphResponse{ChatMessage}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ChatMessage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ChatMessage>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ChatMessage using PATCH.
        /// </summary>
        /// <param name="chatMessageToUpdate">The ChatMessage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ChatMessage.</returns>
        System.Threading.Tasks.Task<ChatMessage> UpdateAsync(ChatMessage chatMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ChatMessage using PATCH and returns a <see cref="GraphResponse{ChatMessage}"/> object.
        /// </summary>
        /// <param name="chatMessageToUpdate">The ChatMessage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ChatMessage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ChatMessage>> UpdateResponseAsync(ChatMessage chatMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ChatMessage using PUT.
        /// </summary>
        /// <param name="chatMessageToUpdate">The ChatMessage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ChatMessage> PutAsync(ChatMessage chatMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ChatMessage using PUT and returns a <see cref="GraphResponse{ChatMessage}"/> object.
        /// </summary>
        /// <param name="chatMessageToUpdate">The ChatMessage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ChatMessage}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ChatMessage>> PutResponseAsync(ChatMessage chatMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IChatMessageRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IChatMessageRequest Expand(Expression<Func<ChatMessage, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IChatMessageRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IChatMessageRequest Select(Expression<Func<ChatMessage, object>> selectExpression);

    }
}
