// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IColumnLinkRequest.
    /// </summary>
    public partial interface IColumnLinkRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ColumnLink using POST.
        /// </summary>
        /// <param name="columnLinkToCreate">The ColumnLink to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ColumnLink.</returns>
        System.Threading.Tasks.Task<ColumnLink> CreateAsync(ColumnLink columnLinkToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ColumnLink using POST and returns a <see cref="GraphResponse{ColumnLink}"/> object.
        /// </summary>
        /// <param name="columnLinkToCreate">The ColumnLink to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ColumnLink}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ColumnLink>> CreateResponseAsync(ColumnLink columnLinkToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ColumnLink.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ColumnLink and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ColumnLink.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ColumnLink.</returns>
        System.Threading.Tasks.Task<ColumnLink> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ColumnLink and returns a <see cref="GraphResponse{ColumnLink}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ColumnLink}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ColumnLink>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ColumnLink using PATCH.
        /// </summary>
        /// <param name="columnLinkToUpdate">The ColumnLink to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ColumnLink.</returns>
        System.Threading.Tasks.Task<ColumnLink> UpdateAsync(ColumnLink columnLinkToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ColumnLink using PATCH and returns a <see cref="GraphResponse{ColumnLink}"/> object.
        /// </summary>
        /// <param name="columnLinkToUpdate">The ColumnLink to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ColumnLink}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ColumnLink>> UpdateResponseAsync(ColumnLink columnLinkToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ColumnLink using PUT.
        /// </summary>
        /// <param name="columnLinkToUpdate">The ColumnLink object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ColumnLink> PutAsync(ColumnLink columnLinkToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ColumnLink using PUT and returns a <see cref="GraphResponse{ColumnLink}"/> object.
        /// </summary>
        /// <param name="columnLinkToUpdate">The ColumnLink object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ColumnLink}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ColumnLink>> PutResponseAsync(ColumnLink columnLinkToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IColumnLinkRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IColumnLinkRequest Expand(Expression<Func<ColumnLink, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IColumnLinkRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IColumnLinkRequest Select(Expression<Func<ColumnLink, object>> selectExpression);

    }
}
