// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IDeviceComplianceDeviceStatusRequest.
    /// </summary>
    public partial interface IDeviceComplianceDeviceStatusRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified DeviceComplianceDeviceStatus using POST.
        /// </summary>
        /// <param name="deviceComplianceDeviceStatusToCreate">The DeviceComplianceDeviceStatus to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created DeviceComplianceDeviceStatus.</returns>
        System.Threading.Tasks.Task<DeviceComplianceDeviceStatus> CreateAsync(DeviceComplianceDeviceStatus deviceComplianceDeviceStatusToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified DeviceComplianceDeviceStatus using POST and returns a <see cref="GraphResponse{DeviceComplianceDeviceStatus}"/> object.
        /// </summary>
        /// <param name="deviceComplianceDeviceStatusToCreate">The DeviceComplianceDeviceStatus to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DeviceComplianceDeviceStatus}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceComplianceDeviceStatus>> CreateResponseAsync(DeviceComplianceDeviceStatus deviceComplianceDeviceStatusToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified DeviceComplianceDeviceStatus.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified DeviceComplianceDeviceStatus and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified DeviceComplianceDeviceStatus.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The DeviceComplianceDeviceStatus.</returns>
        System.Threading.Tasks.Task<DeviceComplianceDeviceStatus> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified DeviceComplianceDeviceStatus and returns a <see cref="GraphResponse{DeviceComplianceDeviceStatus}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DeviceComplianceDeviceStatus}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceComplianceDeviceStatus>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceComplianceDeviceStatus using PATCH.
        /// </summary>
        /// <param name="deviceComplianceDeviceStatusToUpdate">The DeviceComplianceDeviceStatus to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated DeviceComplianceDeviceStatus.</returns>
        System.Threading.Tasks.Task<DeviceComplianceDeviceStatus> UpdateAsync(DeviceComplianceDeviceStatus deviceComplianceDeviceStatusToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceComplianceDeviceStatus using PATCH and returns a <see cref="GraphResponse{DeviceComplianceDeviceStatus}"/> object.
        /// </summary>
        /// <param name="deviceComplianceDeviceStatusToUpdate">The DeviceComplianceDeviceStatus to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{DeviceComplianceDeviceStatus}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceComplianceDeviceStatus>> UpdateResponseAsync(DeviceComplianceDeviceStatus deviceComplianceDeviceStatusToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceComplianceDeviceStatus using PUT.
        /// </summary>
        /// <param name="deviceComplianceDeviceStatusToUpdate">The DeviceComplianceDeviceStatus object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<DeviceComplianceDeviceStatus> PutAsync(DeviceComplianceDeviceStatus deviceComplianceDeviceStatusToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceComplianceDeviceStatus using PUT and returns a <see cref="GraphResponse{DeviceComplianceDeviceStatus}"/> object.
        /// </summary>
        /// <param name="deviceComplianceDeviceStatusToUpdate">The DeviceComplianceDeviceStatus object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{DeviceComplianceDeviceStatus}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceComplianceDeviceStatus>> PutResponseAsync(DeviceComplianceDeviceStatus deviceComplianceDeviceStatusToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceComplianceDeviceStatusRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceComplianceDeviceStatusRequest Expand(Expression<Func<DeviceComplianceDeviceStatus, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceComplianceDeviceStatusRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceComplianceDeviceStatusRequest Select(Expression<Func<DeviceComplianceDeviceStatus, object>> selectExpression);

    }
}
