// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IDirectoryAuditRequest.
    /// </summary>
    public partial interface IDirectoryAuditRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified DirectoryAudit using POST.
        /// </summary>
        /// <param name="directoryAuditToCreate">The DirectoryAudit to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created DirectoryAudit.</returns>
        System.Threading.Tasks.Task<DirectoryAudit> CreateAsync(DirectoryAudit directoryAuditToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified DirectoryAudit using POST and returns a <see cref="GraphResponse{DirectoryAudit}"/> object.
        /// </summary>
        /// <param name="directoryAuditToCreate">The DirectoryAudit to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DirectoryAudit}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DirectoryAudit>> CreateResponseAsync(DirectoryAudit directoryAuditToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified DirectoryAudit.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified DirectoryAudit and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified DirectoryAudit.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The DirectoryAudit.</returns>
        System.Threading.Tasks.Task<DirectoryAudit> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified DirectoryAudit and returns a <see cref="GraphResponse{DirectoryAudit}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DirectoryAudit}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DirectoryAudit>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DirectoryAudit using PATCH.
        /// </summary>
        /// <param name="directoryAuditToUpdate">The DirectoryAudit to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated DirectoryAudit.</returns>
        System.Threading.Tasks.Task<DirectoryAudit> UpdateAsync(DirectoryAudit directoryAuditToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DirectoryAudit using PATCH and returns a <see cref="GraphResponse{DirectoryAudit}"/> object.
        /// </summary>
        /// <param name="directoryAuditToUpdate">The DirectoryAudit to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{DirectoryAudit}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DirectoryAudit>> UpdateResponseAsync(DirectoryAudit directoryAuditToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DirectoryAudit using PUT.
        /// </summary>
        /// <param name="directoryAuditToUpdate">The DirectoryAudit object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<DirectoryAudit> PutAsync(DirectoryAudit directoryAuditToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DirectoryAudit using PUT and returns a <see cref="GraphResponse{DirectoryAudit}"/> object.
        /// </summary>
        /// <param name="directoryAuditToUpdate">The DirectoryAudit object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{DirectoryAudit}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<DirectoryAudit>> PutResponseAsync(DirectoryAudit directoryAuditToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IDirectoryAuditRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IDirectoryAuditRequest Expand(Expression<Func<DirectoryAudit, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IDirectoryAuditRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IDirectoryAuditRequest Select(Expression<Func<DirectoryAudit, object>> selectExpression);

    }
}
