// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IDomainRequest.
    /// </summary>
    public partial interface IDomainRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified Domain using POST.
        /// </summary>
        /// <param name="domainToCreate">The Domain to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Domain.</returns>
        System.Threading.Tasks.Task<Domain> CreateAsync(Domain domainToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Domain using POST and returns a <see cref="GraphResponse{Domain}"/> object.
        /// </summary>
        /// <param name="domainToCreate">The Domain to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Domain}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Domain>> CreateResponseAsync(Domain domainToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Domain.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Domain and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Domain.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Domain.</returns>
        System.Threading.Tasks.Task<Domain> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Domain and returns a <see cref="GraphResponse{Domain}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Domain}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Domain>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Domain using PATCH.
        /// </summary>
        /// <param name="domainToUpdate">The Domain to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Domain.</returns>
        System.Threading.Tasks.Task<Domain> UpdateAsync(Domain domainToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Domain using PATCH and returns a <see cref="GraphResponse{Domain}"/> object.
        /// </summary>
        /// <param name="domainToUpdate">The Domain to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Domain}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Domain>> UpdateResponseAsync(Domain domainToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Domain using PUT.
        /// </summary>
        /// <param name="domainToUpdate">The Domain object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Domain> PutAsync(Domain domainToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Domain using PUT and returns a <see cref="GraphResponse{Domain}"/> object.
        /// </summary>
        /// <param name="domainToUpdate">The Domain object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Domain}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Domain>> PutResponseAsync(Domain domainToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IDomainRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IDomainRequest Expand(Expression<Func<Domain, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IDomainRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IDomainRequest Select(Expression<Func<Domain, object>> selectExpression);

    }
}
