// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IEducationRubricRequest.
    /// </summary>
    public partial interface IEducationRubricRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified EducationRubric using POST.
        /// </summary>
        /// <param name="educationRubricToCreate">The EducationRubric to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created EducationRubric.</returns>
        System.Threading.Tasks.Task<EducationRubric> CreateAsync(EducationRubric educationRubricToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified EducationRubric using POST and returns a <see cref="GraphResponse{EducationRubric}"/> object.
        /// </summary>
        /// <param name="educationRubricToCreate">The EducationRubric to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EducationRubric}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationRubric>> CreateResponseAsync(EducationRubric educationRubricToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EducationRubric.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EducationRubric and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EducationRubric.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The EducationRubric.</returns>
        System.Threading.Tasks.Task<EducationRubric> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EducationRubric and returns a <see cref="GraphResponse{EducationRubric}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EducationRubric}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationRubric>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationRubric using PATCH.
        /// </summary>
        /// <param name="educationRubricToUpdate">The EducationRubric to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated EducationRubric.</returns>
        System.Threading.Tasks.Task<EducationRubric> UpdateAsync(EducationRubric educationRubricToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationRubric using PATCH and returns a <see cref="GraphResponse{EducationRubric}"/> object.
        /// </summary>
        /// <param name="educationRubricToUpdate">The EducationRubric to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{EducationRubric}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationRubric>> UpdateResponseAsync(EducationRubric educationRubricToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationRubric using PUT.
        /// </summary>
        /// <param name="educationRubricToUpdate">The EducationRubric object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<EducationRubric> PutAsync(EducationRubric educationRubricToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationRubric using PUT and returns a <see cref="GraphResponse{EducationRubric}"/> object.
        /// </summary>
        /// <param name="educationRubricToUpdate">The EducationRubric object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{EducationRubric}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationRubric>> PutResponseAsync(EducationRubric educationRubricToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IEducationRubricRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IEducationRubricRequest Expand(Expression<Func<EducationRubric, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IEducationRubricRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IEducationRubricRequest Select(Expression<Func<EducationRubric, object>> selectExpression);

    }
}
