// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IEducationSubmissionRequest.
    /// </summary>
    public partial interface IEducationSubmissionRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified EducationSubmission using POST.
        /// </summary>
        /// <param name="educationSubmissionToCreate">The EducationSubmission to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created EducationSubmission.</returns>
        System.Threading.Tasks.Task<EducationSubmission> CreateAsync(EducationSubmission educationSubmissionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified EducationSubmission using POST and returns a <see cref="GraphResponse{EducationSubmission}"/> object.
        /// </summary>
        /// <param name="educationSubmissionToCreate">The EducationSubmission to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EducationSubmission}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationSubmission>> CreateResponseAsync(EducationSubmission educationSubmissionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EducationSubmission.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EducationSubmission and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EducationSubmission.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The EducationSubmission.</returns>
        System.Threading.Tasks.Task<EducationSubmission> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EducationSubmission and returns a <see cref="GraphResponse{EducationSubmission}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EducationSubmission}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationSubmission>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationSubmission using PATCH.
        /// </summary>
        /// <param name="educationSubmissionToUpdate">The EducationSubmission to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated EducationSubmission.</returns>
        System.Threading.Tasks.Task<EducationSubmission> UpdateAsync(EducationSubmission educationSubmissionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationSubmission using PATCH and returns a <see cref="GraphResponse{EducationSubmission}"/> object.
        /// </summary>
        /// <param name="educationSubmissionToUpdate">The EducationSubmission to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{EducationSubmission}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationSubmission>> UpdateResponseAsync(EducationSubmission educationSubmissionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationSubmission using PUT.
        /// </summary>
        /// <param name="educationSubmissionToUpdate">The EducationSubmission object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<EducationSubmission> PutAsync(EducationSubmission educationSubmissionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationSubmission using PUT and returns a <see cref="GraphResponse{EducationSubmission}"/> object.
        /// </summary>
        /// <param name="educationSubmissionToUpdate">The EducationSubmission object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{EducationSubmission}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationSubmission>> PutResponseAsync(EducationSubmission educationSubmissionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IEducationSubmissionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IEducationSubmissionRequest Expand(Expression<Func<EducationSubmission, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IEducationSubmissionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IEducationSubmissionRequest Select(Expression<Func<EducationSubmission, object>> selectExpression);

    }
}
