// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IEmailAuthenticationMethodConfigurationRequest.
    /// </summary>
    public partial interface IEmailAuthenticationMethodConfigurationRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified EmailAuthenticationMethodConfiguration using POST.
        /// </summary>
        /// <param name="emailAuthenticationMethodConfigurationToCreate">The EmailAuthenticationMethodConfiguration to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created EmailAuthenticationMethodConfiguration.</returns>
        System.Threading.Tasks.Task<EmailAuthenticationMethodConfiguration> CreateAsync(EmailAuthenticationMethodConfiguration emailAuthenticationMethodConfigurationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified EmailAuthenticationMethodConfiguration using POST and returns a <see cref="GraphResponse{EmailAuthenticationMethodConfiguration}"/> object.
        /// </summary>
        /// <param name="emailAuthenticationMethodConfigurationToCreate">The EmailAuthenticationMethodConfiguration to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EmailAuthenticationMethodConfiguration}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EmailAuthenticationMethodConfiguration>> CreateResponseAsync(EmailAuthenticationMethodConfiguration emailAuthenticationMethodConfigurationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EmailAuthenticationMethodConfiguration.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EmailAuthenticationMethodConfiguration and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EmailAuthenticationMethodConfiguration.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The EmailAuthenticationMethodConfiguration.</returns>
        System.Threading.Tasks.Task<EmailAuthenticationMethodConfiguration> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EmailAuthenticationMethodConfiguration and returns a <see cref="GraphResponse{EmailAuthenticationMethodConfiguration}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EmailAuthenticationMethodConfiguration}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EmailAuthenticationMethodConfiguration>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EmailAuthenticationMethodConfiguration using PATCH.
        /// </summary>
        /// <param name="emailAuthenticationMethodConfigurationToUpdate">The EmailAuthenticationMethodConfiguration to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated EmailAuthenticationMethodConfiguration.</returns>
        System.Threading.Tasks.Task<EmailAuthenticationMethodConfiguration> UpdateAsync(EmailAuthenticationMethodConfiguration emailAuthenticationMethodConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EmailAuthenticationMethodConfiguration using PATCH and returns a <see cref="GraphResponse{EmailAuthenticationMethodConfiguration}"/> object.
        /// </summary>
        /// <param name="emailAuthenticationMethodConfigurationToUpdate">The EmailAuthenticationMethodConfiguration to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{EmailAuthenticationMethodConfiguration}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EmailAuthenticationMethodConfiguration>> UpdateResponseAsync(EmailAuthenticationMethodConfiguration emailAuthenticationMethodConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EmailAuthenticationMethodConfiguration using PUT.
        /// </summary>
        /// <param name="emailAuthenticationMethodConfigurationToUpdate">The EmailAuthenticationMethodConfiguration object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<EmailAuthenticationMethodConfiguration> PutAsync(EmailAuthenticationMethodConfiguration emailAuthenticationMethodConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EmailAuthenticationMethodConfiguration using PUT and returns a <see cref="GraphResponse{EmailAuthenticationMethodConfiguration}"/> object.
        /// </summary>
        /// <param name="emailAuthenticationMethodConfigurationToUpdate">The EmailAuthenticationMethodConfiguration object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{EmailAuthenticationMethodConfiguration}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<EmailAuthenticationMethodConfiguration>> PutResponseAsync(EmailAuthenticationMethodConfiguration emailAuthenticationMethodConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IEmailAuthenticationMethodConfigurationRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IEmailAuthenticationMethodConfigurationRequest Expand(Expression<Func<EmailAuthenticationMethodConfiguration, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IEmailAuthenticationMethodConfigurationRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IEmailAuthenticationMethodConfigurationRequest Select(Expression<Func<EmailAuthenticationMethodConfiguration, object>> selectExpression);

    }
}
