// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IFieldValueSetRequest.
    /// </summary>
    public partial interface IFieldValueSetRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified FieldValueSet using POST.
        /// </summary>
        /// <param name="fieldValueSetToCreate">The FieldValueSet to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created FieldValueSet.</returns>
        System.Threading.Tasks.Task<FieldValueSet> CreateAsync(FieldValueSet fieldValueSetToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified FieldValueSet using POST and returns a <see cref="GraphResponse{FieldValueSet}"/> object.
        /// </summary>
        /// <param name="fieldValueSetToCreate">The FieldValueSet to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{FieldValueSet}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<FieldValueSet>> CreateResponseAsync(FieldValueSet fieldValueSetToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified FieldValueSet.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified FieldValueSet and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified FieldValueSet.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The FieldValueSet.</returns>
        System.Threading.Tasks.Task<FieldValueSet> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified FieldValueSet and returns a <see cref="GraphResponse{FieldValueSet}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{FieldValueSet}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<FieldValueSet>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified FieldValueSet using PATCH.
        /// </summary>
        /// <param name="fieldValueSetToUpdate">The FieldValueSet to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated FieldValueSet.</returns>
        System.Threading.Tasks.Task<FieldValueSet> UpdateAsync(FieldValueSet fieldValueSetToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified FieldValueSet using PATCH and returns a <see cref="GraphResponse{FieldValueSet}"/> object.
        /// </summary>
        /// <param name="fieldValueSetToUpdate">The FieldValueSet to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{FieldValueSet}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<FieldValueSet>> UpdateResponseAsync(FieldValueSet fieldValueSetToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified FieldValueSet using PUT.
        /// </summary>
        /// <param name="fieldValueSetToUpdate">The FieldValueSet object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<FieldValueSet> PutAsync(FieldValueSet fieldValueSetToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified FieldValueSet using PUT and returns a <see cref="GraphResponse{FieldValueSet}"/> object.
        /// </summary>
        /// <param name="fieldValueSetToUpdate">The FieldValueSet object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{FieldValueSet}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<FieldValueSet>> PutResponseAsync(FieldValueSet fieldValueSetToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IFieldValueSetRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IFieldValueSetRequest Expand(Expression<Func<FieldValueSet, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IFieldValueSetRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IFieldValueSetRequest Select(Expression<Func<FieldValueSet, object>> selectExpression);

    }
}
