// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IIdentityBuiltInUserFlowAttributeRequest.
    /// </summary>
    public partial interface IIdentityBuiltInUserFlowAttributeRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified IdentityBuiltInUserFlowAttribute using POST.
        /// </summary>
        /// <param name="identityBuiltInUserFlowAttributeToCreate">The IdentityBuiltInUserFlowAttribute to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created IdentityBuiltInUserFlowAttribute.</returns>
        System.Threading.Tasks.Task<IdentityBuiltInUserFlowAttribute> CreateAsync(IdentityBuiltInUserFlowAttribute identityBuiltInUserFlowAttributeToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified IdentityBuiltInUserFlowAttribute using POST and returns a <see cref="GraphResponse{IdentityBuiltInUserFlowAttribute}"/> object.
        /// </summary>
        /// <param name="identityBuiltInUserFlowAttributeToCreate">The IdentityBuiltInUserFlowAttribute to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IdentityBuiltInUserFlowAttribute}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IdentityBuiltInUserFlowAttribute>> CreateResponseAsync(IdentityBuiltInUserFlowAttribute identityBuiltInUserFlowAttributeToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified IdentityBuiltInUserFlowAttribute.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified IdentityBuiltInUserFlowAttribute and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified IdentityBuiltInUserFlowAttribute.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The IdentityBuiltInUserFlowAttribute.</returns>
        System.Threading.Tasks.Task<IdentityBuiltInUserFlowAttribute> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified IdentityBuiltInUserFlowAttribute and returns a <see cref="GraphResponse{IdentityBuiltInUserFlowAttribute}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IdentityBuiltInUserFlowAttribute}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IdentityBuiltInUserFlowAttribute>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IdentityBuiltInUserFlowAttribute using PATCH.
        /// </summary>
        /// <param name="identityBuiltInUserFlowAttributeToUpdate">The IdentityBuiltInUserFlowAttribute to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated IdentityBuiltInUserFlowAttribute.</returns>
        System.Threading.Tasks.Task<IdentityBuiltInUserFlowAttribute> UpdateAsync(IdentityBuiltInUserFlowAttribute identityBuiltInUserFlowAttributeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IdentityBuiltInUserFlowAttribute using PATCH and returns a <see cref="GraphResponse{IdentityBuiltInUserFlowAttribute}"/> object.
        /// </summary>
        /// <param name="identityBuiltInUserFlowAttributeToUpdate">The IdentityBuiltInUserFlowAttribute to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{IdentityBuiltInUserFlowAttribute}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IdentityBuiltInUserFlowAttribute>> UpdateResponseAsync(IdentityBuiltInUserFlowAttribute identityBuiltInUserFlowAttributeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IdentityBuiltInUserFlowAttribute using PUT.
        /// </summary>
        /// <param name="identityBuiltInUserFlowAttributeToUpdate">The IdentityBuiltInUserFlowAttribute object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<IdentityBuiltInUserFlowAttribute> PutAsync(IdentityBuiltInUserFlowAttribute identityBuiltInUserFlowAttributeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IdentityBuiltInUserFlowAttribute using PUT and returns a <see cref="GraphResponse{IdentityBuiltInUserFlowAttribute}"/> object.
        /// </summary>
        /// <param name="identityBuiltInUserFlowAttributeToUpdate">The IdentityBuiltInUserFlowAttribute object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{IdentityBuiltInUserFlowAttribute}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<IdentityBuiltInUserFlowAttribute>> PutResponseAsync(IdentityBuiltInUserFlowAttribute identityBuiltInUserFlowAttributeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityBuiltInUserFlowAttributeRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityBuiltInUserFlowAttributeRequest Expand(Expression<Func<IdentityBuiltInUserFlowAttribute, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityBuiltInUserFlowAttributeRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityBuiltInUserFlowAttributeRequest Select(Expression<Func<IdentityBuiltInUserFlowAttribute, object>> selectExpression);

    }
}
