// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IInferenceClassificationOverrideRequest.
    /// </summary>
    public partial interface IInferenceClassificationOverrideRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified InferenceClassificationOverride using POST.
        /// </summary>
        /// <param name="inferenceClassificationOverrideToCreate">The InferenceClassificationOverride to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created InferenceClassificationOverride.</returns>
        System.Threading.Tasks.Task<InferenceClassificationOverride> CreateAsync(InferenceClassificationOverride inferenceClassificationOverrideToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified InferenceClassificationOverride using POST and returns a <see cref="GraphResponse{InferenceClassificationOverride}"/> object.
        /// </summary>
        /// <param name="inferenceClassificationOverrideToCreate">The InferenceClassificationOverride to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{InferenceClassificationOverride}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<InferenceClassificationOverride>> CreateResponseAsync(InferenceClassificationOverride inferenceClassificationOverrideToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified InferenceClassificationOverride.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified InferenceClassificationOverride and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified InferenceClassificationOverride.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The InferenceClassificationOverride.</returns>
        System.Threading.Tasks.Task<InferenceClassificationOverride> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified InferenceClassificationOverride and returns a <see cref="GraphResponse{InferenceClassificationOverride}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{InferenceClassificationOverride}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<InferenceClassificationOverride>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified InferenceClassificationOverride using PATCH.
        /// </summary>
        /// <param name="inferenceClassificationOverrideToUpdate">The InferenceClassificationOverride to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated InferenceClassificationOverride.</returns>
        System.Threading.Tasks.Task<InferenceClassificationOverride> UpdateAsync(InferenceClassificationOverride inferenceClassificationOverrideToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified InferenceClassificationOverride using PATCH and returns a <see cref="GraphResponse{InferenceClassificationOverride}"/> object.
        /// </summary>
        /// <param name="inferenceClassificationOverrideToUpdate">The InferenceClassificationOverride to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{InferenceClassificationOverride}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<InferenceClassificationOverride>> UpdateResponseAsync(InferenceClassificationOverride inferenceClassificationOverrideToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified InferenceClassificationOverride using PUT.
        /// </summary>
        /// <param name="inferenceClassificationOverrideToUpdate">The InferenceClassificationOverride object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<InferenceClassificationOverride> PutAsync(InferenceClassificationOverride inferenceClassificationOverrideToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified InferenceClassificationOverride using PUT and returns a <see cref="GraphResponse{InferenceClassificationOverride}"/> object.
        /// </summary>
        /// <param name="inferenceClassificationOverrideToUpdate">The InferenceClassificationOverride object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{InferenceClassificationOverride}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<InferenceClassificationOverride>> PutResponseAsync(InferenceClassificationOverride inferenceClassificationOverrideToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IInferenceClassificationOverrideRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IInferenceClassificationOverrideRequest Expand(Expression<Func<InferenceClassificationOverride, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IInferenceClassificationOverrideRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IInferenceClassificationOverrideRequest Select(Expression<Func<InferenceClassificationOverride, object>> selectExpression);

    }
}
