// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IInformationProtectionRequest.
    /// </summary>
    public partial interface IInformationProtectionRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified InformationProtection using POST.
        /// </summary>
        /// <param name="informationProtectionToCreate">The InformationProtection to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created InformationProtection.</returns>
        System.Threading.Tasks.Task<InformationProtection> CreateAsync(InformationProtection informationProtectionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified InformationProtection using POST and returns a <see cref="GraphResponse{InformationProtection}"/> object.
        /// </summary>
        /// <param name="informationProtectionToCreate">The InformationProtection to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{InformationProtection}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<InformationProtection>> CreateResponseAsync(InformationProtection informationProtectionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified InformationProtection.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified InformationProtection and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified InformationProtection.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The InformationProtection.</returns>
        System.Threading.Tasks.Task<InformationProtection> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified InformationProtection and returns a <see cref="GraphResponse{InformationProtection}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{InformationProtection}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<InformationProtection>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified InformationProtection using PATCH.
        /// </summary>
        /// <param name="informationProtectionToUpdate">The InformationProtection to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated InformationProtection.</returns>
        System.Threading.Tasks.Task<InformationProtection> UpdateAsync(InformationProtection informationProtectionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified InformationProtection using PATCH and returns a <see cref="GraphResponse{InformationProtection}"/> object.
        /// </summary>
        /// <param name="informationProtectionToUpdate">The InformationProtection to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{InformationProtection}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<InformationProtection>> UpdateResponseAsync(InformationProtection informationProtectionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified InformationProtection using PUT.
        /// </summary>
        /// <param name="informationProtectionToUpdate">The InformationProtection object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<InformationProtection> PutAsync(InformationProtection informationProtectionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified InformationProtection using PUT and returns a <see cref="GraphResponse{InformationProtection}"/> object.
        /// </summary>
        /// <param name="informationProtectionToUpdate">The InformationProtection object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{InformationProtection}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<InformationProtection>> PutResponseAsync(InformationProtection informationProtectionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IInformationProtectionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IInformationProtectionRequest Expand(Expression<Func<InformationProtection, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IInformationProtectionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IInformationProtectionRequest Select(Expression<Func<InformationProtection, object>> selectExpression);

    }
}
