// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IIosStoreAppRequest.
    /// </summary>
    public partial interface IIosStoreAppRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified IosStoreApp using POST.
        /// </summary>
        /// <param name="iosStoreAppToCreate">The IosStoreApp to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created IosStoreApp.</returns>
        System.Threading.Tasks.Task<IosStoreApp> CreateAsync(IosStoreApp iosStoreAppToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified IosStoreApp using POST and returns a <see cref="GraphResponse{IosStoreApp}"/> object.
        /// </summary>
        /// <param name="iosStoreAppToCreate">The IosStoreApp to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IosStoreApp}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IosStoreApp>> CreateResponseAsync(IosStoreApp iosStoreAppToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified IosStoreApp.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified IosStoreApp and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified IosStoreApp.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The IosStoreApp.</returns>
        System.Threading.Tasks.Task<IosStoreApp> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified IosStoreApp and returns a <see cref="GraphResponse{IosStoreApp}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IosStoreApp}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IosStoreApp>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IosStoreApp using PATCH.
        /// </summary>
        /// <param name="iosStoreAppToUpdate">The IosStoreApp to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated IosStoreApp.</returns>
        System.Threading.Tasks.Task<IosStoreApp> UpdateAsync(IosStoreApp iosStoreAppToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IosStoreApp using PATCH and returns a <see cref="GraphResponse{IosStoreApp}"/> object.
        /// </summary>
        /// <param name="iosStoreAppToUpdate">The IosStoreApp to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{IosStoreApp}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IosStoreApp>> UpdateResponseAsync(IosStoreApp iosStoreAppToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IosStoreApp using PUT.
        /// </summary>
        /// <param name="iosStoreAppToUpdate">The IosStoreApp object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<IosStoreApp> PutAsync(IosStoreApp iosStoreAppToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IosStoreApp using PUT and returns a <see cref="GraphResponse{IosStoreApp}"/> object.
        /// </summary>
        /// <param name="iosStoreAppToUpdate">The IosStoreApp object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{IosStoreApp}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<IosStoreApp>> PutResponseAsync(IosStoreApp iosStoreAppToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IIosStoreAppRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IIosStoreAppRequest Expand(Expression<Func<IosStoreApp, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IIosStoreAppRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IIosStoreAppRequest Select(Expression<Func<IosStoreApp, object>> selectExpression);

    }
}
