// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IIpNamedLocationRequest.
    /// </summary>
    public partial interface IIpNamedLocationRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified IpNamedLocation using POST.
        /// </summary>
        /// <param name="ipNamedLocationToCreate">The IpNamedLocation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created IpNamedLocation.</returns>
        System.Threading.Tasks.Task<IpNamedLocation> CreateAsync(IpNamedLocation ipNamedLocationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified IpNamedLocation using POST and returns a <see cref="GraphResponse{IpNamedLocation}"/> object.
        /// </summary>
        /// <param name="ipNamedLocationToCreate">The IpNamedLocation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IpNamedLocation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IpNamedLocation>> CreateResponseAsync(IpNamedLocation ipNamedLocationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified IpNamedLocation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified IpNamedLocation and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified IpNamedLocation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The IpNamedLocation.</returns>
        System.Threading.Tasks.Task<IpNamedLocation> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified IpNamedLocation and returns a <see cref="GraphResponse{IpNamedLocation}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IpNamedLocation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IpNamedLocation>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IpNamedLocation using PATCH.
        /// </summary>
        /// <param name="ipNamedLocationToUpdate">The IpNamedLocation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated IpNamedLocation.</returns>
        System.Threading.Tasks.Task<IpNamedLocation> UpdateAsync(IpNamedLocation ipNamedLocationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IpNamedLocation using PATCH and returns a <see cref="GraphResponse{IpNamedLocation}"/> object.
        /// </summary>
        /// <param name="ipNamedLocationToUpdate">The IpNamedLocation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{IpNamedLocation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IpNamedLocation>> UpdateResponseAsync(IpNamedLocation ipNamedLocationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IpNamedLocation using PUT.
        /// </summary>
        /// <param name="ipNamedLocationToUpdate">The IpNamedLocation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<IpNamedLocation> PutAsync(IpNamedLocation ipNamedLocationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IpNamedLocation using PUT and returns a <see cref="GraphResponse{IpNamedLocation}"/> object.
        /// </summary>
        /// <param name="ipNamedLocationToUpdate">The IpNamedLocation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{IpNamedLocation}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<IpNamedLocation>> PutResponseAsync(IpNamedLocation ipNamedLocationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IIpNamedLocationRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IIpNamedLocationRequest Expand(Expression<Func<IpNamedLocation, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IIpNamedLocationRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IIpNamedLocationRequest Select(Expression<Func<IpNamedLocation, object>> selectExpression);

    }
}
