// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IItemAttachmentRequest.
    /// </summary>
    public partial interface IItemAttachmentRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ItemAttachment using POST.
        /// </summary>
        /// <param name="itemAttachmentToCreate">The ItemAttachment to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ItemAttachment.</returns>
        System.Threading.Tasks.Task<ItemAttachment> CreateAsync(ItemAttachment itemAttachmentToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ItemAttachment using POST and returns a <see cref="GraphResponse{ItemAttachment}"/> object.
        /// </summary>
        /// <param name="itemAttachmentToCreate">The ItemAttachment to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ItemAttachment}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ItemAttachment>> CreateResponseAsync(ItemAttachment itemAttachmentToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ItemAttachment.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ItemAttachment and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ItemAttachment.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ItemAttachment.</returns>
        System.Threading.Tasks.Task<ItemAttachment> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ItemAttachment and returns a <see cref="GraphResponse{ItemAttachment}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ItemAttachment}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ItemAttachment>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ItemAttachment using PATCH.
        /// </summary>
        /// <param name="itemAttachmentToUpdate">The ItemAttachment to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ItemAttachment.</returns>
        System.Threading.Tasks.Task<ItemAttachment> UpdateAsync(ItemAttachment itemAttachmentToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ItemAttachment using PATCH and returns a <see cref="GraphResponse{ItemAttachment}"/> object.
        /// </summary>
        /// <param name="itemAttachmentToUpdate">The ItemAttachment to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ItemAttachment}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ItemAttachment>> UpdateResponseAsync(ItemAttachment itemAttachmentToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ItemAttachment using PUT.
        /// </summary>
        /// <param name="itemAttachmentToUpdate">The ItemAttachment object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ItemAttachment> PutAsync(ItemAttachment itemAttachmentToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ItemAttachment using PUT and returns a <see cref="GraphResponse{ItemAttachment}"/> object.
        /// </summary>
        /// <param name="itemAttachmentToUpdate">The ItemAttachment object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ItemAttachment}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ItemAttachment>> PutResponseAsync(ItemAttachment itemAttachmentToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IItemAttachmentRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IItemAttachmentRequest Expand(Expression<Func<ItemAttachment, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IItemAttachmentRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IItemAttachmentRequest Select(Expression<Func<ItemAttachment, object>> selectExpression);

    }
}
