// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface ILocalizedNotificationMessageRequest.
    /// </summary>
    public partial interface ILocalizedNotificationMessageRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified LocalizedNotificationMessage using POST.
        /// </summary>
        /// <param name="localizedNotificationMessageToCreate">The LocalizedNotificationMessage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created LocalizedNotificationMessage.</returns>
        System.Threading.Tasks.Task<LocalizedNotificationMessage> CreateAsync(LocalizedNotificationMessage localizedNotificationMessageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified LocalizedNotificationMessage using POST and returns a <see cref="GraphResponse{LocalizedNotificationMessage}"/> object.
        /// </summary>
        /// <param name="localizedNotificationMessageToCreate">The LocalizedNotificationMessage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{LocalizedNotificationMessage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<LocalizedNotificationMessage>> CreateResponseAsync(LocalizedNotificationMessage localizedNotificationMessageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified LocalizedNotificationMessage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified LocalizedNotificationMessage and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified LocalizedNotificationMessage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The LocalizedNotificationMessage.</returns>
        System.Threading.Tasks.Task<LocalizedNotificationMessage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified LocalizedNotificationMessage and returns a <see cref="GraphResponse{LocalizedNotificationMessage}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{LocalizedNotificationMessage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<LocalizedNotificationMessage>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified LocalizedNotificationMessage using PATCH.
        /// </summary>
        /// <param name="localizedNotificationMessageToUpdate">The LocalizedNotificationMessage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated LocalizedNotificationMessage.</returns>
        System.Threading.Tasks.Task<LocalizedNotificationMessage> UpdateAsync(LocalizedNotificationMessage localizedNotificationMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified LocalizedNotificationMessage using PATCH and returns a <see cref="GraphResponse{LocalizedNotificationMessage}"/> object.
        /// </summary>
        /// <param name="localizedNotificationMessageToUpdate">The LocalizedNotificationMessage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{LocalizedNotificationMessage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<LocalizedNotificationMessage>> UpdateResponseAsync(LocalizedNotificationMessage localizedNotificationMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified LocalizedNotificationMessage using PUT.
        /// </summary>
        /// <param name="localizedNotificationMessageToUpdate">The LocalizedNotificationMessage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<LocalizedNotificationMessage> PutAsync(LocalizedNotificationMessage localizedNotificationMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified LocalizedNotificationMessage using PUT and returns a <see cref="GraphResponse{LocalizedNotificationMessage}"/> object.
        /// </summary>
        /// <param name="localizedNotificationMessageToUpdate">The LocalizedNotificationMessage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{LocalizedNotificationMessage}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<LocalizedNotificationMessage>> PutResponseAsync(LocalizedNotificationMessage localizedNotificationMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        ILocalizedNotificationMessageRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        ILocalizedNotificationMessageRequest Expand(Expression<Func<LocalizedNotificationMessage, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        ILocalizedNotificationMessageRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        ILocalizedNotificationMessageRequest Select(Expression<Func<LocalizedNotificationMessage, object>> selectExpression);

    }
}
