// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IManagedDeviceMobileAppConfigurationUserSummaryRequest.
    /// </summary>
    public partial interface IManagedDeviceMobileAppConfigurationUserSummaryRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ManagedDeviceMobileAppConfigurationUserSummary using POST.
        /// </summary>
        /// <param name="managedDeviceMobileAppConfigurationUserSummaryToCreate">The ManagedDeviceMobileAppConfigurationUserSummary to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ManagedDeviceMobileAppConfigurationUserSummary.</returns>
        System.Threading.Tasks.Task<ManagedDeviceMobileAppConfigurationUserSummary> CreateAsync(ManagedDeviceMobileAppConfigurationUserSummary managedDeviceMobileAppConfigurationUserSummaryToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ManagedDeviceMobileAppConfigurationUserSummary using POST and returns a <see cref="GraphResponse{ManagedDeviceMobileAppConfigurationUserSummary}"/> object.
        /// </summary>
        /// <param name="managedDeviceMobileAppConfigurationUserSummaryToCreate">The ManagedDeviceMobileAppConfigurationUserSummary to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ManagedDeviceMobileAppConfigurationUserSummary}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ManagedDeviceMobileAppConfigurationUserSummary>> CreateResponseAsync(ManagedDeviceMobileAppConfigurationUserSummary managedDeviceMobileAppConfigurationUserSummaryToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ManagedDeviceMobileAppConfigurationUserSummary.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ManagedDeviceMobileAppConfigurationUserSummary and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ManagedDeviceMobileAppConfigurationUserSummary.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ManagedDeviceMobileAppConfigurationUserSummary.</returns>
        System.Threading.Tasks.Task<ManagedDeviceMobileAppConfigurationUserSummary> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ManagedDeviceMobileAppConfigurationUserSummary and returns a <see cref="GraphResponse{ManagedDeviceMobileAppConfigurationUserSummary}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ManagedDeviceMobileAppConfigurationUserSummary}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ManagedDeviceMobileAppConfigurationUserSummary>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ManagedDeviceMobileAppConfigurationUserSummary using PATCH.
        /// </summary>
        /// <param name="managedDeviceMobileAppConfigurationUserSummaryToUpdate">The ManagedDeviceMobileAppConfigurationUserSummary to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ManagedDeviceMobileAppConfigurationUserSummary.</returns>
        System.Threading.Tasks.Task<ManagedDeviceMobileAppConfigurationUserSummary> UpdateAsync(ManagedDeviceMobileAppConfigurationUserSummary managedDeviceMobileAppConfigurationUserSummaryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ManagedDeviceMobileAppConfigurationUserSummary using PATCH and returns a <see cref="GraphResponse{ManagedDeviceMobileAppConfigurationUserSummary}"/> object.
        /// </summary>
        /// <param name="managedDeviceMobileAppConfigurationUserSummaryToUpdate">The ManagedDeviceMobileAppConfigurationUserSummary to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ManagedDeviceMobileAppConfigurationUserSummary}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ManagedDeviceMobileAppConfigurationUserSummary>> UpdateResponseAsync(ManagedDeviceMobileAppConfigurationUserSummary managedDeviceMobileAppConfigurationUserSummaryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ManagedDeviceMobileAppConfigurationUserSummary using PUT.
        /// </summary>
        /// <param name="managedDeviceMobileAppConfigurationUserSummaryToUpdate">The ManagedDeviceMobileAppConfigurationUserSummary object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ManagedDeviceMobileAppConfigurationUserSummary> PutAsync(ManagedDeviceMobileAppConfigurationUserSummary managedDeviceMobileAppConfigurationUserSummaryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ManagedDeviceMobileAppConfigurationUserSummary using PUT and returns a <see cref="GraphResponse{ManagedDeviceMobileAppConfigurationUserSummary}"/> object.
        /// </summary>
        /// <param name="managedDeviceMobileAppConfigurationUserSummaryToUpdate">The ManagedDeviceMobileAppConfigurationUserSummary object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ManagedDeviceMobileAppConfigurationUserSummary}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ManagedDeviceMobileAppConfigurationUserSummary>> PutResponseAsync(ManagedDeviceMobileAppConfigurationUserSummary managedDeviceMobileAppConfigurationUserSummaryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IManagedDeviceMobileAppConfigurationUserSummaryRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IManagedDeviceMobileAppConfigurationUserSummaryRequest Expand(Expression<Func<ManagedDeviceMobileAppConfigurationUserSummary, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IManagedDeviceMobileAppConfigurationUserSummaryRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IManagedDeviceMobileAppConfigurationUserSummaryRequest Select(Expression<Func<ManagedDeviceMobileAppConfigurationUserSummary, object>> selectExpression);

    }
}
