// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IMeetingAttendanceReportRequest.
    /// </summary>
    public partial interface IMeetingAttendanceReportRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified MeetingAttendanceReport using POST.
        /// </summary>
        /// <param name="meetingAttendanceReportToCreate">The MeetingAttendanceReport to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created MeetingAttendanceReport.</returns>
        System.Threading.Tasks.Task<MeetingAttendanceReport> CreateAsync(MeetingAttendanceReport meetingAttendanceReportToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified MeetingAttendanceReport using POST and returns a <see cref="GraphResponse{MeetingAttendanceReport}"/> object.
        /// </summary>
        /// <param name="meetingAttendanceReportToCreate">The MeetingAttendanceReport to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{MeetingAttendanceReport}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MeetingAttendanceReport>> CreateResponseAsync(MeetingAttendanceReport meetingAttendanceReportToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified MeetingAttendanceReport.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified MeetingAttendanceReport and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified MeetingAttendanceReport.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The MeetingAttendanceReport.</returns>
        System.Threading.Tasks.Task<MeetingAttendanceReport> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified MeetingAttendanceReport and returns a <see cref="GraphResponse{MeetingAttendanceReport}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{MeetingAttendanceReport}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MeetingAttendanceReport>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MeetingAttendanceReport using PATCH.
        /// </summary>
        /// <param name="meetingAttendanceReportToUpdate">The MeetingAttendanceReport to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated MeetingAttendanceReport.</returns>
        System.Threading.Tasks.Task<MeetingAttendanceReport> UpdateAsync(MeetingAttendanceReport meetingAttendanceReportToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MeetingAttendanceReport using PATCH and returns a <see cref="GraphResponse{MeetingAttendanceReport}"/> object.
        /// </summary>
        /// <param name="meetingAttendanceReportToUpdate">The MeetingAttendanceReport to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{MeetingAttendanceReport}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MeetingAttendanceReport>> UpdateResponseAsync(MeetingAttendanceReport meetingAttendanceReportToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MeetingAttendanceReport using PUT.
        /// </summary>
        /// <param name="meetingAttendanceReportToUpdate">The MeetingAttendanceReport object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<MeetingAttendanceReport> PutAsync(MeetingAttendanceReport meetingAttendanceReportToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MeetingAttendanceReport using PUT and returns a <see cref="GraphResponse{MeetingAttendanceReport}"/> object.
        /// </summary>
        /// <param name="meetingAttendanceReportToUpdate">The MeetingAttendanceReport object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{MeetingAttendanceReport}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<MeetingAttendanceReport>> PutResponseAsync(MeetingAttendanceReport meetingAttendanceReportToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IMeetingAttendanceReportRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IMeetingAttendanceReportRequest Expand(Expression<Func<MeetingAttendanceReport, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IMeetingAttendanceReportRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IMeetingAttendanceReportRequest Select(Expression<Func<MeetingAttendanceReport, object>> selectExpression);

    }
}
