// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IMicrosoftAuthenticatorAuthenticationMethodTargetRequest.
    /// </summary>
    public partial interface IMicrosoftAuthenticatorAuthenticationMethodTargetRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified MicrosoftAuthenticatorAuthenticationMethodTarget using POST.
        /// </summary>
        /// <param name="microsoftAuthenticatorAuthenticationMethodTargetToCreate">The MicrosoftAuthenticatorAuthenticationMethodTarget to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created MicrosoftAuthenticatorAuthenticationMethodTarget.</returns>
        System.Threading.Tasks.Task<MicrosoftAuthenticatorAuthenticationMethodTarget> CreateAsync(MicrosoftAuthenticatorAuthenticationMethodTarget microsoftAuthenticatorAuthenticationMethodTargetToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified MicrosoftAuthenticatorAuthenticationMethodTarget using POST and returns a <see cref="GraphResponse{MicrosoftAuthenticatorAuthenticationMethodTarget}"/> object.
        /// </summary>
        /// <param name="microsoftAuthenticatorAuthenticationMethodTargetToCreate">The MicrosoftAuthenticatorAuthenticationMethodTarget to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{MicrosoftAuthenticatorAuthenticationMethodTarget}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MicrosoftAuthenticatorAuthenticationMethodTarget>> CreateResponseAsync(MicrosoftAuthenticatorAuthenticationMethodTarget microsoftAuthenticatorAuthenticationMethodTargetToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified MicrosoftAuthenticatorAuthenticationMethodTarget.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified MicrosoftAuthenticatorAuthenticationMethodTarget and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified MicrosoftAuthenticatorAuthenticationMethodTarget.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The MicrosoftAuthenticatorAuthenticationMethodTarget.</returns>
        System.Threading.Tasks.Task<MicrosoftAuthenticatorAuthenticationMethodTarget> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified MicrosoftAuthenticatorAuthenticationMethodTarget and returns a <see cref="GraphResponse{MicrosoftAuthenticatorAuthenticationMethodTarget}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{MicrosoftAuthenticatorAuthenticationMethodTarget}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MicrosoftAuthenticatorAuthenticationMethodTarget>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MicrosoftAuthenticatorAuthenticationMethodTarget using PATCH.
        /// </summary>
        /// <param name="microsoftAuthenticatorAuthenticationMethodTargetToUpdate">The MicrosoftAuthenticatorAuthenticationMethodTarget to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated MicrosoftAuthenticatorAuthenticationMethodTarget.</returns>
        System.Threading.Tasks.Task<MicrosoftAuthenticatorAuthenticationMethodTarget> UpdateAsync(MicrosoftAuthenticatorAuthenticationMethodTarget microsoftAuthenticatorAuthenticationMethodTargetToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MicrosoftAuthenticatorAuthenticationMethodTarget using PATCH and returns a <see cref="GraphResponse{MicrosoftAuthenticatorAuthenticationMethodTarget}"/> object.
        /// </summary>
        /// <param name="microsoftAuthenticatorAuthenticationMethodTargetToUpdate">The MicrosoftAuthenticatorAuthenticationMethodTarget to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{MicrosoftAuthenticatorAuthenticationMethodTarget}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MicrosoftAuthenticatorAuthenticationMethodTarget>> UpdateResponseAsync(MicrosoftAuthenticatorAuthenticationMethodTarget microsoftAuthenticatorAuthenticationMethodTargetToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MicrosoftAuthenticatorAuthenticationMethodTarget using PUT.
        /// </summary>
        /// <param name="microsoftAuthenticatorAuthenticationMethodTargetToUpdate">The MicrosoftAuthenticatorAuthenticationMethodTarget object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<MicrosoftAuthenticatorAuthenticationMethodTarget> PutAsync(MicrosoftAuthenticatorAuthenticationMethodTarget microsoftAuthenticatorAuthenticationMethodTargetToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MicrosoftAuthenticatorAuthenticationMethodTarget using PUT and returns a <see cref="GraphResponse{MicrosoftAuthenticatorAuthenticationMethodTarget}"/> object.
        /// </summary>
        /// <param name="microsoftAuthenticatorAuthenticationMethodTargetToUpdate">The MicrosoftAuthenticatorAuthenticationMethodTarget object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{MicrosoftAuthenticatorAuthenticationMethodTarget}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<MicrosoftAuthenticatorAuthenticationMethodTarget>> PutResponseAsync(MicrosoftAuthenticatorAuthenticationMethodTarget microsoftAuthenticatorAuthenticationMethodTargetToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IMicrosoftAuthenticatorAuthenticationMethodTargetRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IMicrosoftAuthenticatorAuthenticationMethodTargetRequest Expand(Expression<Func<MicrosoftAuthenticatorAuthenticationMethodTarget, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IMicrosoftAuthenticatorAuthenticationMethodTargetRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IMicrosoftAuthenticatorAuthenticationMethodTargetRequest Select(Expression<Func<MicrosoftAuthenticatorAuthenticationMethodTarget, object>> selectExpression);

    }
}
