// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IMobileThreatDefenseConnectorRequest.
    /// </summary>
    public partial interface IMobileThreatDefenseConnectorRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified MobileThreatDefenseConnector using POST.
        /// </summary>
        /// <param name="mobileThreatDefenseConnectorToCreate">The MobileThreatDefenseConnector to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created MobileThreatDefenseConnector.</returns>
        System.Threading.Tasks.Task<MobileThreatDefenseConnector> CreateAsync(MobileThreatDefenseConnector mobileThreatDefenseConnectorToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified MobileThreatDefenseConnector using POST and returns a <see cref="GraphResponse{MobileThreatDefenseConnector}"/> object.
        /// </summary>
        /// <param name="mobileThreatDefenseConnectorToCreate">The MobileThreatDefenseConnector to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{MobileThreatDefenseConnector}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MobileThreatDefenseConnector>> CreateResponseAsync(MobileThreatDefenseConnector mobileThreatDefenseConnectorToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified MobileThreatDefenseConnector.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified MobileThreatDefenseConnector and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified MobileThreatDefenseConnector.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The MobileThreatDefenseConnector.</returns>
        System.Threading.Tasks.Task<MobileThreatDefenseConnector> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified MobileThreatDefenseConnector and returns a <see cref="GraphResponse{MobileThreatDefenseConnector}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{MobileThreatDefenseConnector}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MobileThreatDefenseConnector>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MobileThreatDefenseConnector using PATCH.
        /// </summary>
        /// <param name="mobileThreatDefenseConnectorToUpdate">The MobileThreatDefenseConnector to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated MobileThreatDefenseConnector.</returns>
        System.Threading.Tasks.Task<MobileThreatDefenseConnector> UpdateAsync(MobileThreatDefenseConnector mobileThreatDefenseConnectorToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MobileThreatDefenseConnector using PATCH and returns a <see cref="GraphResponse{MobileThreatDefenseConnector}"/> object.
        /// </summary>
        /// <param name="mobileThreatDefenseConnectorToUpdate">The MobileThreatDefenseConnector to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{MobileThreatDefenseConnector}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MobileThreatDefenseConnector>> UpdateResponseAsync(MobileThreatDefenseConnector mobileThreatDefenseConnectorToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MobileThreatDefenseConnector using PUT.
        /// </summary>
        /// <param name="mobileThreatDefenseConnectorToUpdate">The MobileThreatDefenseConnector object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<MobileThreatDefenseConnector> PutAsync(MobileThreatDefenseConnector mobileThreatDefenseConnectorToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MobileThreatDefenseConnector using PUT and returns a <see cref="GraphResponse{MobileThreatDefenseConnector}"/> object.
        /// </summary>
        /// <param name="mobileThreatDefenseConnectorToUpdate">The MobileThreatDefenseConnector object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{MobileThreatDefenseConnector}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<MobileThreatDefenseConnector>> PutResponseAsync(MobileThreatDefenseConnector mobileThreatDefenseConnectorToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IMobileThreatDefenseConnectorRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IMobileThreatDefenseConnectorRequest Expand(Expression<Func<MobileThreatDefenseConnector, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IMobileThreatDefenseConnectorRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IMobileThreatDefenseConnectorRequest Select(Expression<Func<MobileThreatDefenseConnector, object>> selectExpression);

    }
}
