// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IMultiValueLegacyExtendedPropertyRequest.
    /// </summary>
    public partial interface IMultiValueLegacyExtendedPropertyRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified MultiValueLegacyExtendedProperty using POST.
        /// </summary>
        /// <param name="multiValueLegacyExtendedPropertyToCreate">The MultiValueLegacyExtendedProperty to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created MultiValueLegacyExtendedProperty.</returns>
        System.Threading.Tasks.Task<MultiValueLegacyExtendedProperty> CreateAsync(MultiValueLegacyExtendedProperty multiValueLegacyExtendedPropertyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified MultiValueLegacyExtendedProperty using POST and returns a <see cref="GraphResponse{MultiValueLegacyExtendedProperty}"/> object.
        /// </summary>
        /// <param name="multiValueLegacyExtendedPropertyToCreate">The MultiValueLegacyExtendedProperty to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{MultiValueLegacyExtendedProperty}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MultiValueLegacyExtendedProperty>> CreateResponseAsync(MultiValueLegacyExtendedProperty multiValueLegacyExtendedPropertyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified MultiValueLegacyExtendedProperty.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified MultiValueLegacyExtendedProperty and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified MultiValueLegacyExtendedProperty.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The MultiValueLegacyExtendedProperty.</returns>
        System.Threading.Tasks.Task<MultiValueLegacyExtendedProperty> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified MultiValueLegacyExtendedProperty and returns a <see cref="GraphResponse{MultiValueLegacyExtendedProperty}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{MultiValueLegacyExtendedProperty}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MultiValueLegacyExtendedProperty>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MultiValueLegacyExtendedProperty using PATCH.
        /// </summary>
        /// <param name="multiValueLegacyExtendedPropertyToUpdate">The MultiValueLegacyExtendedProperty to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated MultiValueLegacyExtendedProperty.</returns>
        System.Threading.Tasks.Task<MultiValueLegacyExtendedProperty> UpdateAsync(MultiValueLegacyExtendedProperty multiValueLegacyExtendedPropertyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MultiValueLegacyExtendedProperty using PATCH and returns a <see cref="GraphResponse{MultiValueLegacyExtendedProperty}"/> object.
        /// </summary>
        /// <param name="multiValueLegacyExtendedPropertyToUpdate">The MultiValueLegacyExtendedProperty to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{MultiValueLegacyExtendedProperty}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MultiValueLegacyExtendedProperty>> UpdateResponseAsync(MultiValueLegacyExtendedProperty multiValueLegacyExtendedPropertyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MultiValueLegacyExtendedProperty using PUT.
        /// </summary>
        /// <param name="multiValueLegacyExtendedPropertyToUpdate">The MultiValueLegacyExtendedProperty object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<MultiValueLegacyExtendedProperty> PutAsync(MultiValueLegacyExtendedProperty multiValueLegacyExtendedPropertyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MultiValueLegacyExtendedProperty using PUT and returns a <see cref="GraphResponse{MultiValueLegacyExtendedProperty}"/> object.
        /// </summary>
        /// <param name="multiValueLegacyExtendedPropertyToUpdate">The MultiValueLegacyExtendedProperty object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{MultiValueLegacyExtendedProperty}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<MultiValueLegacyExtendedProperty>> PutResponseAsync(MultiValueLegacyExtendedProperty multiValueLegacyExtendedPropertyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IMultiValueLegacyExtendedPropertyRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IMultiValueLegacyExtendedPropertyRequest Expand(Expression<Func<MultiValueLegacyExtendedProperty, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IMultiValueLegacyExtendedPropertyRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IMultiValueLegacyExtendedPropertyRequest Select(Expression<Func<MultiValueLegacyExtendedProperty, object>> selectExpression);

    }
}
