// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface INotificationMessageTemplateRequest.
    /// </summary>
    public partial interface INotificationMessageTemplateRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified NotificationMessageTemplate using POST.
        /// </summary>
        /// <param name="notificationMessageTemplateToCreate">The NotificationMessageTemplate to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created NotificationMessageTemplate.</returns>
        System.Threading.Tasks.Task<NotificationMessageTemplate> CreateAsync(NotificationMessageTemplate notificationMessageTemplateToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified NotificationMessageTemplate using POST and returns a <see cref="GraphResponse{NotificationMessageTemplate}"/> object.
        /// </summary>
        /// <param name="notificationMessageTemplateToCreate">The NotificationMessageTemplate to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{NotificationMessageTemplate}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<NotificationMessageTemplate>> CreateResponseAsync(NotificationMessageTemplate notificationMessageTemplateToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified NotificationMessageTemplate.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified NotificationMessageTemplate and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified NotificationMessageTemplate.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The NotificationMessageTemplate.</returns>
        System.Threading.Tasks.Task<NotificationMessageTemplate> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified NotificationMessageTemplate and returns a <see cref="GraphResponse{NotificationMessageTemplate}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{NotificationMessageTemplate}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<NotificationMessageTemplate>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified NotificationMessageTemplate using PATCH.
        /// </summary>
        /// <param name="notificationMessageTemplateToUpdate">The NotificationMessageTemplate to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated NotificationMessageTemplate.</returns>
        System.Threading.Tasks.Task<NotificationMessageTemplate> UpdateAsync(NotificationMessageTemplate notificationMessageTemplateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified NotificationMessageTemplate using PATCH and returns a <see cref="GraphResponse{NotificationMessageTemplate}"/> object.
        /// </summary>
        /// <param name="notificationMessageTemplateToUpdate">The NotificationMessageTemplate to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{NotificationMessageTemplate}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<NotificationMessageTemplate>> UpdateResponseAsync(NotificationMessageTemplate notificationMessageTemplateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified NotificationMessageTemplate using PUT.
        /// </summary>
        /// <param name="notificationMessageTemplateToUpdate">The NotificationMessageTemplate object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<NotificationMessageTemplate> PutAsync(NotificationMessageTemplate notificationMessageTemplateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified NotificationMessageTemplate using PUT and returns a <see cref="GraphResponse{NotificationMessageTemplate}"/> object.
        /// </summary>
        /// <param name="notificationMessageTemplateToUpdate">The NotificationMessageTemplate object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{NotificationMessageTemplate}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<NotificationMessageTemplate>> PutResponseAsync(NotificationMessageTemplate notificationMessageTemplateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        INotificationMessageTemplateRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        INotificationMessageTemplateRequest Expand(Expression<Func<NotificationMessageTemplate, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        INotificationMessageTemplateRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        INotificationMessageTemplateRequest Select(Expression<Func<NotificationMessageTemplate, object>> selectExpression);

    }
}
