// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IOutlookUserRequest.
    /// </summary>
    public partial interface IOutlookUserRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified OutlookUser using POST.
        /// </summary>
        /// <param name="outlookUserToCreate">The OutlookUser to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created OutlookUser.</returns>
        System.Threading.Tasks.Task<OutlookUser> CreateAsync(OutlookUser outlookUserToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified OutlookUser using POST and returns a <see cref="GraphResponse{OutlookUser}"/> object.
        /// </summary>
        /// <param name="outlookUserToCreate">The OutlookUser to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{OutlookUser}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<OutlookUser>> CreateResponseAsync(OutlookUser outlookUserToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified OutlookUser.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified OutlookUser and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified OutlookUser.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The OutlookUser.</returns>
        System.Threading.Tasks.Task<OutlookUser> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified OutlookUser and returns a <see cref="GraphResponse{OutlookUser}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{OutlookUser}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<OutlookUser>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified OutlookUser using PATCH.
        /// </summary>
        /// <param name="outlookUserToUpdate">The OutlookUser to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated OutlookUser.</returns>
        System.Threading.Tasks.Task<OutlookUser> UpdateAsync(OutlookUser outlookUserToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified OutlookUser using PATCH and returns a <see cref="GraphResponse{OutlookUser}"/> object.
        /// </summary>
        /// <param name="outlookUserToUpdate">The OutlookUser to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{OutlookUser}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<OutlookUser>> UpdateResponseAsync(OutlookUser outlookUserToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified OutlookUser using PUT.
        /// </summary>
        /// <param name="outlookUserToUpdate">The OutlookUser object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<OutlookUser> PutAsync(OutlookUser outlookUserToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified OutlookUser using PUT and returns a <see cref="GraphResponse{OutlookUser}"/> object.
        /// </summary>
        /// <param name="outlookUserToUpdate">The OutlookUser object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{OutlookUser}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<OutlookUser>> PutResponseAsync(OutlookUser outlookUserToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IOutlookUserRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IOutlookUserRequest Expand(Expression<Func<OutlookUser, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IOutlookUserRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IOutlookUserRequest Select(Expression<Func<OutlookUser, object>> selectExpression);

    }
}
