// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IParticipantRequestBuilder.
    /// </summary>
    public partial interface IParticipantRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IParticipantRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IParticipantRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for ParticipantMute.
        /// </summary>
        /// <returns>The <see cref="IParticipantMuteRequestBuilder"/>.</returns>
        IParticipantMuteRequestBuilder Mute(
            string clientContext = null);

        /// <summary>
        /// Gets the request builder for ParticipantStartHoldMusic.
        /// </summary>
        /// <returns>The <see cref="IParticipantStartHoldMusicRequestBuilder"/>.</returns>
        IParticipantStartHoldMusicRequestBuilder StartHoldMusic(
            Prompt customPrompt = null,
            string clientContext = null);

        /// <summary>
        /// Gets the request builder for ParticipantStopHoldMusic.
        /// </summary>
        /// <returns>The <see cref="IParticipantStopHoldMusicRequestBuilder"/>.</returns>
        IParticipantStopHoldMusicRequestBuilder StopHoldMusic(
            string clientContext = null);
    
    }
}
