// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPostRequest.
    /// </summary>
    public partial interface IPostRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified Post using POST.
        /// </summary>
        /// <param name="postToCreate">The Post to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Post.</returns>
        System.Threading.Tasks.Task<Post> CreateAsync(Post postToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Post using POST and returns a <see cref="GraphResponse{Post}"/> object.
        /// </summary>
        /// <param name="postToCreate">The Post to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Post}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Post>> CreateResponseAsync(Post postToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Post.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Post and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Post.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Post.</returns>
        System.Threading.Tasks.Task<Post> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Post and returns a <see cref="GraphResponse{Post}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Post}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Post>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Post using PATCH.
        /// </summary>
        /// <param name="postToUpdate">The Post to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Post.</returns>
        System.Threading.Tasks.Task<Post> UpdateAsync(Post postToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Post using PATCH and returns a <see cref="GraphResponse{Post}"/> object.
        /// </summary>
        /// <param name="postToUpdate">The Post to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Post}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Post>> UpdateResponseAsync(Post postToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Post using PUT.
        /// </summary>
        /// <param name="postToUpdate">The Post object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Post> PutAsync(Post postToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Post using PUT and returns a <see cref="GraphResponse{Post}"/> object.
        /// </summary>
        /// <param name="postToUpdate">The Post object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Post}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Post>> PutResponseAsync(Post postToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPostRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPostRequest Expand(Expression<Func<Post, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPostRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPostRequest Select(Expression<Func<Post, object>> selectExpression);

    }
}
