// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IPrintJobRequestBuilder.
    /// </summary>
    public partial interface IPrintJobRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IPrintJobRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IPrintJobRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for Documents.
        /// </summary>
        /// <returns>The <see cref="IPrintJobDocumentsCollectionRequestBuilder"/>.</returns>
        IPrintJobDocumentsCollectionRequestBuilder Documents { get; }

        /// <summary>
        /// Gets the request builder for Tasks.
        /// </summary>
        /// <returns>The <see cref="IPrintJobTasksCollectionRequestBuilder"/>.</returns>
        IPrintJobTasksCollectionRequestBuilder Tasks { get; }
    
        /// <summary>
        /// Gets the request builder for PrintJobCancel.
        /// </summary>
        /// <returns>The <see cref="IPrintJobCancelRequestBuilder"/>.</returns>
        IPrintJobCancelRequestBuilder Cancel();

        /// <summary>
        /// Gets the request builder for PrintJobAbort.
        /// </summary>
        /// <returns>The <see cref="IPrintJobAbortRequestBuilder"/>.</returns>
        IPrintJobAbortRequestBuilder Abort(
            string reason = null);

        /// <summary>
        /// Gets the request builder for PrintJobRedirect.
        /// </summary>
        /// <returns>The <see cref="IPrintJobRedirectRequestBuilder"/>.</returns>
        IPrintJobRedirectRequestBuilder Redirect(
            string destinationPrinterId,
            PrintJobConfiguration configuration = null);

        /// <summary>
        /// Gets the request builder for PrintJobStart.
        /// </summary>
        /// <returns>The <see cref="IPrintJobStartRequestBuilder"/>.</returns>
        IPrintJobStartRequestBuilder Start();
    
    }
}
