// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPrintRequest.
    /// </summary>
    public partial interface IPrintRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified Print using POST.
        /// </summary>
        /// <param name="printToCreate">The Print to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Print.</returns>
        System.Threading.Tasks.Task<Print> CreateAsync(Print printToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Print using POST and returns a <see cref="GraphResponse{Print}"/> object.
        /// </summary>
        /// <param name="printToCreate">The Print to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Print}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Print>> CreateResponseAsync(Print printToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Print.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Print and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Print.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Print.</returns>
        System.Threading.Tasks.Task<Print> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Print and returns a <see cref="GraphResponse{Print}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Print}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Print>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Print using PATCH.
        /// </summary>
        /// <param name="printToUpdate">The Print to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Print.</returns>
        System.Threading.Tasks.Task<Print> UpdateAsync(Print printToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Print using PATCH and returns a <see cref="GraphResponse{Print}"/> object.
        /// </summary>
        /// <param name="printToUpdate">The Print to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Print}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Print>> UpdateResponseAsync(Print printToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Print using PUT.
        /// </summary>
        /// <param name="printToUpdate">The Print object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Print> PutAsync(Print printToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Print using PUT and returns a <see cref="GraphResponse{Print}"/> object.
        /// </summary>
        /// <param name="printToUpdate">The Print object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Print}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Print>> PutResponseAsync(Print printToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrintRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrintRequest Expand(Expression<Func<Print, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPrintRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPrintRequest Select(Expression<Func<Print, object>> selectExpression);

    }
}
