// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityCollectionRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPrintTaskDefinitionsCollectionRequest.
    /// </summary>
    public partial interface IPrintTaskDefinitionsCollectionRequest : IBaseRequest
    {
        /// <summary>
        /// Adds the specified PrintTaskDefinition to the collection via POST.
        /// </summary>
        /// <param name="printTaskDefinition">The PrintTaskDefinition to add.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created PrintTaskDefinition.</returns>
        System.Threading.Tasks.Task<PrintTaskDefinition> AddAsync(PrintTaskDefinition printTaskDefinition, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified PrintTaskDefinition to the collection via POST and returns a <see cref="GraphResponse{PrintTaskDefinition}"/> object of the request.
        /// </summary>
        /// <param name="printTaskDefinition">The PrintTaskDefinition to add.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrintTaskDefinition}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintTaskDefinition>> AddResponseAsync(PrintTaskDefinition printTaskDefinition, CancellationToken cancellationToken = default);


        /// <summary>
        /// Gets the collection page.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The collection page.</returns>
        System.Threading.Tasks.Task<IPrintTaskDefinitionsCollectionPage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the collection page and returns a <see cref="GraphResponse{PrintTaskDefinitionsCollectionResponse}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrintTaskDefinitionsCollectionResponse}"/> object.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintTaskDefinitionsCollectionResponse>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskDefinitionsCollectionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskDefinitionsCollectionRequest Expand(Expression<Func<PrintTaskDefinition, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskDefinitionsCollectionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskDefinitionsCollectionRequest Select(Expression<Func<PrintTaskDefinition, object>> selectExpression);

        /// <summary>
        /// Adds the specified top value to the request.
        /// </summary>
        /// <param name="value">The top value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskDefinitionsCollectionRequest Top(int value);

        /// <summary>
        /// Adds the specified filter value to the request.
        /// </summary>
        /// <param name="value">The filter value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskDefinitionsCollectionRequest Filter(string value);

        /// <summary>
        /// Adds the specified skip value to the request.
        /// </summary>
        /// <param name="value">The skip value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskDefinitionsCollectionRequest Skip(int value);

        /// <summary>
        /// Adds the specified orderby value to the request.
        /// </summary>
        /// <param name="value">The orderby value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskDefinitionsCollectionRequest OrderBy(string value);
    }
}
