// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPrintUsageRequest.
    /// </summary>
    public partial interface IPrintUsageRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified PrintUsage using POST.
        /// </summary>
        /// <param name="printUsageToCreate">The PrintUsage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created PrintUsage.</returns>
        System.Threading.Tasks.Task<PrintUsage> CreateAsync(PrintUsage printUsageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified PrintUsage using POST and returns a <see cref="GraphResponse{PrintUsage}"/> object.
        /// </summary>
        /// <param name="printUsageToCreate">The PrintUsage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrintUsage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintUsage>> CreateResponseAsync(PrintUsage printUsageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PrintUsage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PrintUsage and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PrintUsage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The PrintUsage.</returns>
        System.Threading.Tasks.Task<PrintUsage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PrintUsage and returns a <see cref="GraphResponse{PrintUsage}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrintUsage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintUsage>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintUsage using PATCH.
        /// </summary>
        /// <param name="printUsageToUpdate">The PrintUsage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated PrintUsage.</returns>
        System.Threading.Tasks.Task<PrintUsage> UpdateAsync(PrintUsage printUsageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintUsage using PATCH and returns a <see cref="GraphResponse{PrintUsage}"/> object.
        /// </summary>
        /// <param name="printUsageToUpdate">The PrintUsage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{PrintUsage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintUsage>> UpdateResponseAsync(PrintUsage printUsageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintUsage using PUT.
        /// </summary>
        /// <param name="printUsageToUpdate">The PrintUsage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<PrintUsage> PutAsync(PrintUsage printUsageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintUsage using PUT and returns a <see cref="GraphResponse{PrintUsage}"/> object.
        /// </summary>
        /// <param name="printUsageToUpdate">The PrintUsage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{PrintUsage}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintUsage>> PutResponseAsync(PrintUsage printUsageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrintUsageRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrintUsageRequest Expand(Expression<Func<PrintUsage, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPrintUsageRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPrintUsageRequest Select(Expression<Func<PrintUsage, object>> selectExpression);

    }
}
