// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The interface IServiceAnnouncementMessagesCollectionRequestBuilder.
    /// </summary>
    public partial interface IServiceAnnouncementMessagesCollectionRequestBuilder : IBaseRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        IServiceAnnouncementMessagesCollectionRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        IServiceAnnouncementMessagesCollectionRequest Request(IEnumerable<Option> options);

        /// <summary>
        /// Gets an <see cref="IServiceUpdateMessageRequestBuilder"/> for the specified ServiceUpdateMessage.
        /// </summary>
        /// <param name="id">The ID for the ServiceUpdateMessage.</param>
        /// <returns>The <see cref="IServiceUpdateMessageRequestBuilder"/>.</returns>
        IServiceUpdateMessageRequestBuilder this[string id] { get; }

        /// <summary>
        /// Gets the request builder for ServiceUpdateMessageArchive.
        /// </summary>
        /// <returns>The <see cref="IServiceUpdateMessageArchiveRequestBuilder"/>.</returns>
        IServiceUpdateMessageArchiveRequestBuilder Archive(
            IEnumerable<string> messageIds = null);

        /// <summary>
        /// Gets the request builder for ServiceUpdateMessageFavorite.
        /// </summary>
        /// <returns>The <see cref="IServiceUpdateMessageFavoriteRequestBuilder"/>.</returns>
        IServiceUpdateMessageFavoriteRequestBuilder Favorite(
            IEnumerable<string> messageIds = null);

        /// <summary>
        /// Gets the request builder for ServiceUpdateMessageMarkRead.
        /// </summary>
        /// <returns>The <see cref="IServiceUpdateMessageMarkReadRequestBuilder"/>.</returns>
        IServiceUpdateMessageMarkReadRequestBuilder MarkRead(
            IEnumerable<string> messageIds = null);

        /// <summary>
        /// Gets the request builder for ServiceUpdateMessageMarkUnread.
        /// </summary>
        /// <returns>The <see cref="IServiceUpdateMessageMarkUnreadRequestBuilder"/>.</returns>
        IServiceUpdateMessageMarkUnreadRequestBuilder MarkUnread(
            IEnumerable<string> messageIds = null);

        /// <summary>
        /// Gets the request builder for ServiceUpdateMessageUnarchive.
        /// </summary>
        /// <returns>The <see cref="IServiceUpdateMessageUnarchiveRequestBuilder"/>.</returns>
        IServiceUpdateMessageUnarchiveRequestBuilder Unarchive(
            IEnumerable<string> messageIds = null);

        /// <summary>
        /// Gets the request builder for ServiceUpdateMessageUnfavorite.
        /// </summary>
        /// <returns>The <see cref="IServiceUpdateMessageUnfavoriteRequestBuilder"/>.</returns>
        IServiceUpdateMessageUnfavoriteRequestBuilder Unfavorite(
            IEnumerable<string> messageIds = null);
    }
}
