// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IServiceAnnouncementRequest.
    /// </summary>
    public partial interface IServiceAnnouncementRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ServiceAnnouncement using POST.
        /// </summary>
        /// <param name="serviceAnnouncementToCreate">The ServiceAnnouncement to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ServiceAnnouncement.</returns>
        System.Threading.Tasks.Task<ServiceAnnouncement> CreateAsync(ServiceAnnouncement serviceAnnouncementToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ServiceAnnouncement using POST and returns a <see cref="GraphResponse{ServiceAnnouncement}"/> object.
        /// </summary>
        /// <param name="serviceAnnouncementToCreate">The ServiceAnnouncement to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ServiceAnnouncement}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceAnnouncement>> CreateResponseAsync(ServiceAnnouncement serviceAnnouncementToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ServiceAnnouncement.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ServiceAnnouncement and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ServiceAnnouncement.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ServiceAnnouncement.</returns>
        System.Threading.Tasks.Task<ServiceAnnouncement> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ServiceAnnouncement and returns a <see cref="GraphResponse{ServiceAnnouncement}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ServiceAnnouncement}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceAnnouncement>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceAnnouncement using PATCH.
        /// </summary>
        /// <param name="serviceAnnouncementToUpdate">The ServiceAnnouncement to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ServiceAnnouncement.</returns>
        System.Threading.Tasks.Task<ServiceAnnouncement> UpdateAsync(ServiceAnnouncement serviceAnnouncementToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceAnnouncement using PATCH and returns a <see cref="GraphResponse{ServiceAnnouncement}"/> object.
        /// </summary>
        /// <param name="serviceAnnouncementToUpdate">The ServiceAnnouncement to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ServiceAnnouncement}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceAnnouncement>> UpdateResponseAsync(ServiceAnnouncement serviceAnnouncementToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceAnnouncement using PUT.
        /// </summary>
        /// <param name="serviceAnnouncementToUpdate">The ServiceAnnouncement object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ServiceAnnouncement> PutAsync(ServiceAnnouncement serviceAnnouncementToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceAnnouncement using PUT and returns a <see cref="GraphResponse{ServiceAnnouncement}"/> object.
        /// </summary>
        /// <param name="serviceAnnouncementToUpdate">The ServiceAnnouncement object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ServiceAnnouncement}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceAnnouncement>> PutResponseAsync(ServiceAnnouncement serviceAnnouncementToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IServiceAnnouncementRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IServiceAnnouncementRequest Expand(Expression<Func<ServiceAnnouncement, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IServiceAnnouncementRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IServiceAnnouncementRequest Select(Expression<Func<ServiceAnnouncement, object>> selectExpression);

    }
}
