// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IServiceUpdateMessageRequest.
    /// </summary>
    public partial interface IServiceUpdateMessageRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ServiceUpdateMessage using POST.
        /// </summary>
        /// <param name="serviceUpdateMessageToCreate">The ServiceUpdateMessage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ServiceUpdateMessage.</returns>
        System.Threading.Tasks.Task<ServiceUpdateMessage> CreateAsync(ServiceUpdateMessage serviceUpdateMessageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ServiceUpdateMessage using POST and returns a <see cref="GraphResponse{ServiceUpdateMessage}"/> object.
        /// </summary>
        /// <param name="serviceUpdateMessageToCreate">The ServiceUpdateMessage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ServiceUpdateMessage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceUpdateMessage>> CreateResponseAsync(ServiceUpdateMessage serviceUpdateMessageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ServiceUpdateMessage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ServiceUpdateMessage and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ServiceUpdateMessage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ServiceUpdateMessage.</returns>
        System.Threading.Tasks.Task<ServiceUpdateMessage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ServiceUpdateMessage and returns a <see cref="GraphResponse{ServiceUpdateMessage}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ServiceUpdateMessage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceUpdateMessage>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceUpdateMessage using PATCH.
        /// </summary>
        /// <param name="serviceUpdateMessageToUpdate">The ServiceUpdateMessage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ServiceUpdateMessage.</returns>
        System.Threading.Tasks.Task<ServiceUpdateMessage> UpdateAsync(ServiceUpdateMessage serviceUpdateMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceUpdateMessage using PATCH and returns a <see cref="GraphResponse{ServiceUpdateMessage}"/> object.
        /// </summary>
        /// <param name="serviceUpdateMessageToUpdate">The ServiceUpdateMessage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ServiceUpdateMessage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceUpdateMessage>> UpdateResponseAsync(ServiceUpdateMessage serviceUpdateMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceUpdateMessage using PUT.
        /// </summary>
        /// <param name="serviceUpdateMessageToUpdate">The ServiceUpdateMessage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ServiceUpdateMessage> PutAsync(ServiceUpdateMessage serviceUpdateMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceUpdateMessage using PUT and returns a <see cref="GraphResponse{ServiceUpdateMessage}"/> object.
        /// </summary>
        /// <param name="serviceUpdateMessageToUpdate">The ServiceUpdateMessage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ServiceUpdateMessage}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceUpdateMessage>> PutResponseAsync(ServiceUpdateMessage serviceUpdateMessageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IServiceUpdateMessageRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IServiceUpdateMessageRequest Expand(Expression<Func<ServiceUpdateMessage, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IServiceUpdateMessageRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IServiceUpdateMessageRequest Select(Expression<Func<ServiceUpdateMessage, object>> selectExpression);

    }
}
