// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface ISignInRequest.
    /// </summary>
    public partial interface ISignInRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified SignIn using POST.
        /// </summary>
        /// <param name="signInToCreate">The SignIn to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created SignIn.</returns>
        System.Threading.Tasks.Task<SignIn> CreateAsync(SignIn signInToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified SignIn using POST and returns a <see cref="GraphResponse{SignIn}"/> object.
        /// </summary>
        /// <param name="signInToCreate">The SignIn to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{SignIn}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<SignIn>> CreateResponseAsync(SignIn signInToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified SignIn.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified SignIn and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified SignIn.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The SignIn.</returns>
        System.Threading.Tasks.Task<SignIn> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified SignIn and returns a <see cref="GraphResponse{SignIn}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{SignIn}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<SignIn>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SignIn using PATCH.
        /// </summary>
        /// <param name="signInToUpdate">The SignIn to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated SignIn.</returns>
        System.Threading.Tasks.Task<SignIn> UpdateAsync(SignIn signInToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SignIn using PATCH and returns a <see cref="GraphResponse{SignIn}"/> object.
        /// </summary>
        /// <param name="signInToUpdate">The SignIn to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{SignIn}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<SignIn>> UpdateResponseAsync(SignIn signInToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SignIn using PUT.
        /// </summary>
        /// <param name="signInToUpdate">The SignIn object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<SignIn> PutAsync(SignIn signInToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SignIn using PUT and returns a <see cref="GraphResponse{SignIn}"/> object.
        /// </summary>
        /// <param name="signInToUpdate">The SignIn object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{SignIn}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<SignIn>> PutResponseAsync(SignIn signInToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        ISignInRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        ISignInRequest Expand(Expression<Func<SignIn, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        ISignInRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        ISignInRequest Select(Expression<Func<SignIn, object>> selectExpression);

    }
}
