// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IMethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface ISiteGetApplicableContentTypesForListRequestBuilder.
    /// </summary>
    public partial interface ISiteGetApplicableContentTypesForListRequestBuilder : IBaseRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        ISiteGetApplicableContentTypesForListRequest Request(IEnumerable<Option> options = null);
        /// <summary>
        /// Gets the request builder for ContentTypeAddCopyRequestBuilder.
        /// </summary>
        /// <param name="contentType">A contentType parameter for the OData method call.</param>
        /// <returns>The <see cref="IContentTypeAddCopyRequestBuilder"/>.</returns>
        IContentTypeAddCopyRequestBuilder AddCopy(
            string contentType);
        /// <summary>
        /// Gets the request builder for ContentTypeAssociateWithHubSitesRequestBuilder.
        /// </summary>
        /// <param name="hubSiteUrls">A hubSiteUrls parameter for the OData method call.</param>
        /// <param name="propagateToExistingLists">A propagateToExistingLists parameter for the OData method call.</param>
        /// <returns>The <see cref="IContentTypeAssociateWithHubSitesRequestBuilder"/>.</returns>
        IContentTypeAssociateWithHubSitesRequestBuilder AssociateWithHubSites(
            IEnumerable<string> hubSiteUrls,
            bool? propagateToExistingLists);
        /// <summary>
        /// Gets the request builder for ContentTypeCopyToDefaultContentLocationRequestBuilder.
        /// </summary>
        /// <param name="sourceFile">A sourceFile parameter for the OData method call.</param>
        /// <param name="destinationFileName">A destinationFileName parameter for the OData method call.</param>
        /// <returns>The <see cref="IContentTypeCopyToDefaultContentLocationRequestBuilder"/>.</returns>
        IContentTypeCopyToDefaultContentLocationRequestBuilder CopyToDefaultContentLocation(
            ItemReference sourceFile,
            string destinationFileName);
        /// <summary>
        /// Gets the request builder for ContentTypeIsPublishedRequestBuilder.
        /// </summary>
        /// <returns>The <see cref="IContentTypeIsPublishedRequestBuilder"/>.</returns>
        IContentTypeIsPublishedRequestBuilder IsPublished();
        /// <summary>
        /// Gets the request builder for ContentTypePublishRequestBuilder.
        /// </summary>
        /// <returns>The <see cref="IContentTypePublishRequestBuilder"/>.</returns>
        IContentTypePublishRequestBuilder Publish();
        /// <summary>
        /// Gets the request builder for ContentTypeUnpublishRequestBuilder.
        /// </summary>
        /// <returns>The <see cref="IContentTypeUnpublishRequestBuilder"/>.</returns>
        IContentTypeUnpublishRequestBuilder Unpublish();
        /// <summary>
        /// Gets the request builder for Base.
        /// Parent contentType from which this content type is derived.
        /// </summary>
        /// <returns>The <see cref="IContentTypeRequestBuilder"/>.</returns>
        IContentTypeRequestBuilder Base  { get; }
        /// <summary>
        /// Gets the request builder for BaseTypes.
        /// The collection of content types that are ancestors of this content type.
        /// </summary>
        /// <returns>The <see cref="IContentTypeRequestBuilder"/>.</returns>
        IContentTypeRequestBuilder BaseTypes  { get; }
        /// <summary>
        /// Gets the request builder for ColumnLinks.
        /// The collection of columns that are required by this content type
        /// </summary>
        /// <returns>The <see cref="IColumnLinkRequestBuilder"/>.</returns>
        IColumnLinkRequestBuilder ColumnLinks  { get; }
        /// <summary>
        /// Gets the request builder for ColumnPositions.
        /// Column order information in a content type.
        /// </summary>
        /// <returns>The <see cref="IColumnDefinitionRequestBuilder"/>.</returns>
        IColumnDefinitionRequestBuilder ColumnPositions  { get; }
        /// <summary>
        /// Gets the request builder for Columns.
        /// The collection of column definitions for this contentType.
        /// </summary>
        /// <returns>The <see cref="IColumnDefinitionRequestBuilder"/>.</returns>
        IColumnDefinitionRequestBuilder Columns  { get; }
    }
}
