// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IStopHoldMusicOperationRequest.
    /// </summary>
    public partial interface IStopHoldMusicOperationRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified StopHoldMusicOperation using POST.
        /// </summary>
        /// <param name="stopHoldMusicOperationToCreate">The StopHoldMusicOperation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created StopHoldMusicOperation.</returns>
        System.Threading.Tasks.Task<StopHoldMusicOperation> CreateAsync(StopHoldMusicOperation stopHoldMusicOperationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified StopHoldMusicOperation using POST and returns a <see cref="GraphResponse{StopHoldMusicOperation}"/> object.
        /// </summary>
        /// <param name="stopHoldMusicOperationToCreate">The StopHoldMusicOperation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{StopHoldMusicOperation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<StopHoldMusicOperation>> CreateResponseAsync(StopHoldMusicOperation stopHoldMusicOperationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified StopHoldMusicOperation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified StopHoldMusicOperation and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified StopHoldMusicOperation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The StopHoldMusicOperation.</returns>
        System.Threading.Tasks.Task<StopHoldMusicOperation> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified StopHoldMusicOperation and returns a <see cref="GraphResponse{StopHoldMusicOperation}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{StopHoldMusicOperation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<StopHoldMusicOperation>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified StopHoldMusicOperation using PATCH.
        /// </summary>
        /// <param name="stopHoldMusicOperationToUpdate">The StopHoldMusicOperation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated StopHoldMusicOperation.</returns>
        System.Threading.Tasks.Task<StopHoldMusicOperation> UpdateAsync(StopHoldMusicOperation stopHoldMusicOperationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified StopHoldMusicOperation using PATCH and returns a <see cref="GraphResponse{StopHoldMusicOperation}"/> object.
        /// </summary>
        /// <param name="stopHoldMusicOperationToUpdate">The StopHoldMusicOperation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{StopHoldMusicOperation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<StopHoldMusicOperation>> UpdateResponseAsync(StopHoldMusicOperation stopHoldMusicOperationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified StopHoldMusicOperation using PUT.
        /// </summary>
        /// <param name="stopHoldMusicOperationToUpdate">The StopHoldMusicOperation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<StopHoldMusicOperation> PutAsync(StopHoldMusicOperation stopHoldMusicOperationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified StopHoldMusicOperation using PUT and returns a <see cref="GraphResponse{StopHoldMusicOperation}"/> object.
        /// </summary>
        /// <param name="stopHoldMusicOperationToUpdate">The StopHoldMusicOperation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{StopHoldMusicOperation}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<StopHoldMusicOperation>> PutResponseAsync(StopHoldMusicOperation stopHoldMusicOperationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IStopHoldMusicOperationRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IStopHoldMusicOperationRequest Expand(Expression<Func<StopHoldMusicOperation, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IStopHoldMusicOperationRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IStopHoldMusicOperationRequest Select(Expression<Func<StopHoldMusicOperation, object>> selectExpression);

    }
}
