// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface ITeamsTabRequest.
    /// </summary>
    public partial interface ITeamsTabRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified TeamsTab using POST.
        /// </summary>
        /// <param name="teamsTabToCreate">The TeamsTab to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created TeamsTab.</returns>
        System.Threading.Tasks.Task<TeamsTab> CreateAsync(TeamsTab teamsTabToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified TeamsTab using POST and returns a <see cref="GraphResponse{TeamsTab}"/> object.
        /// </summary>
        /// <param name="teamsTabToCreate">The TeamsTab to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{TeamsTab}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<TeamsTab>> CreateResponseAsync(TeamsTab teamsTabToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified TeamsTab.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified TeamsTab and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified TeamsTab.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The TeamsTab.</returns>
        System.Threading.Tasks.Task<TeamsTab> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified TeamsTab and returns a <see cref="GraphResponse{TeamsTab}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{TeamsTab}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<TeamsTab>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TeamsTab using PATCH.
        /// </summary>
        /// <param name="teamsTabToUpdate">The TeamsTab to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated TeamsTab.</returns>
        System.Threading.Tasks.Task<TeamsTab> UpdateAsync(TeamsTab teamsTabToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TeamsTab using PATCH and returns a <see cref="GraphResponse{TeamsTab}"/> object.
        /// </summary>
        /// <param name="teamsTabToUpdate">The TeamsTab to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{TeamsTab}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<TeamsTab>> UpdateResponseAsync(TeamsTab teamsTabToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TeamsTab using PUT.
        /// </summary>
        /// <param name="teamsTabToUpdate">The TeamsTab object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<TeamsTab> PutAsync(TeamsTab teamsTabToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TeamsTab using PUT and returns a <see cref="GraphResponse{TeamsTab}"/> object.
        /// </summary>
        /// <param name="teamsTabToUpdate">The TeamsTab object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{TeamsTab}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<TeamsTab>> PutResponseAsync(TeamsTab teamsTabToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        ITeamsTabRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        ITeamsTabRequest Expand(Expression<Func<TeamsTab, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        ITeamsTabRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        ITeamsTabRequest Select(Expression<Func<TeamsTab, object>> selectExpression);

    }
}
