// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface ITeamworkHostedContentRequest.
    /// </summary>
    public partial interface ITeamworkHostedContentRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified TeamworkHostedContent using POST.
        /// </summary>
        /// <param name="teamworkHostedContentToCreate">The TeamworkHostedContent to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created TeamworkHostedContent.</returns>
        System.Threading.Tasks.Task<TeamworkHostedContent> CreateAsync(TeamworkHostedContent teamworkHostedContentToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified TeamworkHostedContent using POST and returns a <see cref="GraphResponse{TeamworkHostedContent}"/> object.
        /// </summary>
        /// <param name="teamworkHostedContentToCreate">The TeamworkHostedContent to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{TeamworkHostedContent}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<TeamworkHostedContent>> CreateResponseAsync(TeamworkHostedContent teamworkHostedContentToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified TeamworkHostedContent.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified TeamworkHostedContent and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified TeamworkHostedContent.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The TeamworkHostedContent.</returns>
        System.Threading.Tasks.Task<TeamworkHostedContent> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified TeamworkHostedContent and returns a <see cref="GraphResponse{TeamworkHostedContent}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{TeamworkHostedContent}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<TeamworkHostedContent>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TeamworkHostedContent using PATCH.
        /// </summary>
        /// <param name="teamworkHostedContentToUpdate">The TeamworkHostedContent to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated TeamworkHostedContent.</returns>
        System.Threading.Tasks.Task<TeamworkHostedContent> UpdateAsync(TeamworkHostedContent teamworkHostedContentToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TeamworkHostedContent using PATCH and returns a <see cref="GraphResponse{TeamworkHostedContent}"/> object.
        /// </summary>
        /// <param name="teamworkHostedContentToUpdate">The TeamworkHostedContent to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{TeamworkHostedContent}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<TeamworkHostedContent>> UpdateResponseAsync(TeamworkHostedContent teamworkHostedContentToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TeamworkHostedContent using PUT.
        /// </summary>
        /// <param name="teamworkHostedContentToUpdate">The TeamworkHostedContent object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<TeamworkHostedContent> PutAsync(TeamworkHostedContent teamworkHostedContentToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TeamworkHostedContent using PUT and returns a <see cref="GraphResponse{TeamworkHostedContent}"/> object.
        /// </summary>
        /// <param name="teamworkHostedContentToUpdate">The TeamworkHostedContent object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{TeamworkHostedContent}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<TeamworkHostedContent>> PutResponseAsync(TeamworkHostedContent teamworkHostedContentToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        ITeamworkHostedContentRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        ITeamworkHostedContentRequest Expand(Expression<Func<TeamworkHostedContent, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        ITeamworkHostedContentRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        ITeamworkHostedContentRequest Select(Expression<Func<TeamworkHostedContent, object>> selectExpression);

    }
}
