// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface ITodoRequest.
    /// </summary>
    public partial interface ITodoRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified Todo using POST.
        /// </summary>
        /// <param name="todoToCreate">The Todo to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Todo.</returns>
        System.Threading.Tasks.Task<Todo> CreateAsync(Todo todoToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Todo using POST and returns a <see cref="GraphResponse{Todo}"/> object.
        /// </summary>
        /// <param name="todoToCreate">The Todo to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Todo}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Todo>> CreateResponseAsync(Todo todoToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Todo.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Todo and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Todo.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Todo.</returns>
        System.Threading.Tasks.Task<Todo> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Todo and returns a <see cref="GraphResponse{Todo}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Todo}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Todo>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Todo using PATCH.
        /// </summary>
        /// <param name="todoToUpdate">The Todo to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Todo.</returns>
        System.Threading.Tasks.Task<Todo> UpdateAsync(Todo todoToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Todo using PATCH and returns a <see cref="GraphResponse{Todo}"/> object.
        /// </summary>
        /// <param name="todoToUpdate">The Todo to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Todo}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Todo>> UpdateResponseAsync(Todo todoToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Todo using PUT.
        /// </summary>
        /// <param name="todoToUpdate">The Todo object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Todo> PutAsync(Todo todoToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Todo using PUT and returns a <see cref="GraphResponse{Todo}"/> object.
        /// </summary>
        /// <param name="todoToUpdate">The Todo object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Todo}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Todo>> PutResponseAsync(Todo todoToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        ITodoRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        ITodoRequest Expand(Expression<Func<Todo, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        ITodoRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        ITodoRequest Select(Expression<Func<Todo, object>> selectExpression);

    }
}
