// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IUserFlowLanguageConfigurationRequest.
    /// </summary>
    public partial interface IUserFlowLanguageConfigurationRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified UserFlowLanguageConfiguration using POST.
        /// </summary>
        /// <param name="userFlowLanguageConfigurationToCreate">The UserFlowLanguageConfiguration to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created UserFlowLanguageConfiguration.</returns>
        System.Threading.Tasks.Task<UserFlowLanguageConfiguration> CreateAsync(UserFlowLanguageConfiguration userFlowLanguageConfigurationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified UserFlowLanguageConfiguration using POST and returns a <see cref="GraphResponse{UserFlowLanguageConfiguration}"/> object.
        /// </summary>
        /// <param name="userFlowLanguageConfigurationToCreate">The UserFlowLanguageConfiguration to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserFlowLanguageConfiguration}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserFlowLanguageConfiguration>> CreateResponseAsync(UserFlowLanguageConfiguration userFlowLanguageConfigurationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserFlowLanguageConfiguration.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserFlowLanguageConfiguration and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserFlowLanguageConfiguration.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The UserFlowLanguageConfiguration.</returns>
        System.Threading.Tasks.Task<UserFlowLanguageConfiguration> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserFlowLanguageConfiguration and returns a <see cref="GraphResponse{UserFlowLanguageConfiguration}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserFlowLanguageConfiguration}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserFlowLanguageConfiguration>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserFlowLanguageConfiguration using PATCH.
        /// </summary>
        /// <param name="userFlowLanguageConfigurationToUpdate">The UserFlowLanguageConfiguration to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated UserFlowLanguageConfiguration.</returns>
        System.Threading.Tasks.Task<UserFlowLanguageConfiguration> UpdateAsync(UserFlowLanguageConfiguration userFlowLanguageConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserFlowLanguageConfiguration using PATCH and returns a <see cref="GraphResponse{UserFlowLanguageConfiguration}"/> object.
        /// </summary>
        /// <param name="userFlowLanguageConfigurationToUpdate">The UserFlowLanguageConfiguration to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{UserFlowLanguageConfiguration}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserFlowLanguageConfiguration>> UpdateResponseAsync(UserFlowLanguageConfiguration userFlowLanguageConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserFlowLanguageConfiguration using PUT.
        /// </summary>
        /// <param name="userFlowLanguageConfigurationToUpdate">The UserFlowLanguageConfiguration object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<UserFlowLanguageConfiguration> PutAsync(UserFlowLanguageConfiguration userFlowLanguageConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserFlowLanguageConfiguration using PUT and returns a <see cref="GraphResponse{UserFlowLanguageConfiguration}"/> object.
        /// </summary>
        /// <param name="userFlowLanguageConfigurationToUpdate">The UserFlowLanguageConfiguration object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{UserFlowLanguageConfiguration}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserFlowLanguageConfiguration>> PutResponseAsync(UserFlowLanguageConfiguration userFlowLanguageConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserFlowLanguageConfigurationRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserFlowLanguageConfigurationRequest Expand(Expression<Func<UserFlowLanguageConfiguration, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IUserFlowLanguageConfigurationRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IUserFlowLanguageConfigurationRequest Select(Expression<Func<UserFlowLanguageConfiguration, object>> selectExpression);

    }
}
