// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IUserScopeTeamsAppInstallationRequest.
    /// </summary>
    public partial interface IUserScopeTeamsAppInstallationRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified UserScopeTeamsAppInstallation using POST.
        /// </summary>
        /// <param name="userScopeTeamsAppInstallationToCreate">The UserScopeTeamsAppInstallation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created UserScopeTeamsAppInstallation.</returns>
        System.Threading.Tasks.Task<UserScopeTeamsAppInstallation> CreateAsync(UserScopeTeamsAppInstallation userScopeTeamsAppInstallationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified UserScopeTeamsAppInstallation using POST and returns a <see cref="GraphResponse{UserScopeTeamsAppInstallation}"/> object.
        /// </summary>
        /// <param name="userScopeTeamsAppInstallationToCreate">The UserScopeTeamsAppInstallation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserScopeTeamsAppInstallation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserScopeTeamsAppInstallation>> CreateResponseAsync(UserScopeTeamsAppInstallation userScopeTeamsAppInstallationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserScopeTeamsAppInstallation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserScopeTeamsAppInstallation and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserScopeTeamsAppInstallation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The UserScopeTeamsAppInstallation.</returns>
        System.Threading.Tasks.Task<UserScopeTeamsAppInstallation> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserScopeTeamsAppInstallation and returns a <see cref="GraphResponse{UserScopeTeamsAppInstallation}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserScopeTeamsAppInstallation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserScopeTeamsAppInstallation>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserScopeTeamsAppInstallation using PATCH.
        /// </summary>
        /// <param name="userScopeTeamsAppInstallationToUpdate">The UserScopeTeamsAppInstallation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated UserScopeTeamsAppInstallation.</returns>
        System.Threading.Tasks.Task<UserScopeTeamsAppInstallation> UpdateAsync(UserScopeTeamsAppInstallation userScopeTeamsAppInstallationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserScopeTeamsAppInstallation using PATCH and returns a <see cref="GraphResponse{UserScopeTeamsAppInstallation}"/> object.
        /// </summary>
        /// <param name="userScopeTeamsAppInstallationToUpdate">The UserScopeTeamsAppInstallation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{UserScopeTeamsAppInstallation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserScopeTeamsAppInstallation>> UpdateResponseAsync(UserScopeTeamsAppInstallation userScopeTeamsAppInstallationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserScopeTeamsAppInstallation using PUT.
        /// </summary>
        /// <param name="userScopeTeamsAppInstallationToUpdate">The UserScopeTeamsAppInstallation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<UserScopeTeamsAppInstallation> PutAsync(UserScopeTeamsAppInstallation userScopeTeamsAppInstallationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserScopeTeamsAppInstallation using PUT and returns a <see cref="GraphResponse{UserScopeTeamsAppInstallation}"/> object.
        /// </summary>
        /// <param name="userScopeTeamsAppInstallationToUpdate">The UserScopeTeamsAppInstallation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{UserScopeTeamsAppInstallation}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserScopeTeamsAppInstallation>> PutResponseAsync(UserScopeTeamsAppInstallation userScopeTeamsAppInstallationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserScopeTeamsAppInstallationRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserScopeTeamsAppInstallationRequest Expand(Expression<Func<UserScopeTeamsAppInstallation, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IUserScopeTeamsAppInstallationRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IUserScopeTeamsAppInstallationRequest Select(Expression<Func<UserScopeTeamsAppInstallation, object>> selectExpression);

    }
}
