// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IVppTokenRequest.
    /// </summary>
    public partial interface IVppTokenRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified VppToken using POST.
        /// </summary>
        /// <param name="vppTokenToCreate">The VppToken to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created VppToken.</returns>
        System.Threading.Tasks.Task<VppToken> CreateAsync(VppToken vppTokenToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified VppToken using POST and returns a <see cref="GraphResponse{VppToken}"/> object.
        /// </summary>
        /// <param name="vppTokenToCreate">The VppToken to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{VppToken}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<VppToken>> CreateResponseAsync(VppToken vppTokenToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified VppToken.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified VppToken and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified VppToken.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The VppToken.</returns>
        System.Threading.Tasks.Task<VppToken> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified VppToken and returns a <see cref="GraphResponse{VppToken}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{VppToken}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<VppToken>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified VppToken using PATCH.
        /// </summary>
        /// <param name="vppTokenToUpdate">The VppToken to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated VppToken.</returns>
        System.Threading.Tasks.Task<VppToken> UpdateAsync(VppToken vppTokenToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified VppToken using PATCH and returns a <see cref="GraphResponse{VppToken}"/> object.
        /// </summary>
        /// <param name="vppTokenToUpdate">The VppToken to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{VppToken}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<VppToken>> UpdateResponseAsync(VppToken vppTokenToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified VppToken using PUT.
        /// </summary>
        /// <param name="vppTokenToUpdate">The VppToken object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<VppToken> PutAsync(VppToken vppTokenToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified VppToken using PUT and returns a <see cref="GraphResponse{VppToken}"/> object.
        /// </summary>
        /// <param name="vppTokenToUpdate">The VppToken object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{VppToken}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<VppToken>> PutResponseAsync(VppToken vppTokenToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IVppTokenRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IVppTokenRequest Expand(Expression<Func<VppToken, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IVppTokenRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IVppTokenRequest Select(Expression<Func<VppToken, object>> selectExpression);

    }
}
