// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IWindowsAutopilotDeviceIdentityRequest.
    /// </summary>
    public partial interface IWindowsAutopilotDeviceIdentityRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified WindowsAutopilotDeviceIdentity using POST.
        /// </summary>
        /// <param name="windowsAutopilotDeviceIdentityToCreate">The WindowsAutopilotDeviceIdentity to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created WindowsAutopilotDeviceIdentity.</returns>
        System.Threading.Tasks.Task<WindowsAutopilotDeviceIdentity> CreateAsync(WindowsAutopilotDeviceIdentity windowsAutopilotDeviceIdentityToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified WindowsAutopilotDeviceIdentity using POST and returns a <see cref="GraphResponse{WindowsAutopilotDeviceIdentity}"/> object.
        /// </summary>
        /// <param name="windowsAutopilotDeviceIdentityToCreate">The WindowsAutopilotDeviceIdentity to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{WindowsAutopilotDeviceIdentity}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<WindowsAutopilotDeviceIdentity>> CreateResponseAsync(WindowsAutopilotDeviceIdentity windowsAutopilotDeviceIdentityToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified WindowsAutopilotDeviceIdentity.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified WindowsAutopilotDeviceIdentity and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified WindowsAutopilotDeviceIdentity.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The WindowsAutopilotDeviceIdentity.</returns>
        System.Threading.Tasks.Task<WindowsAutopilotDeviceIdentity> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified WindowsAutopilotDeviceIdentity and returns a <see cref="GraphResponse{WindowsAutopilotDeviceIdentity}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{WindowsAutopilotDeviceIdentity}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<WindowsAutopilotDeviceIdentity>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WindowsAutopilotDeviceIdentity using PATCH.
        /// </summary>
        /// <param name="windowsAutopilotDeviceIdentityToUpdate">The WindowsAutopilotDeviceIdentity to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated WindowsAutopilotDeviceIdentity.</returns>
        System.Threading.Tasks.Task<WindowsAutopilotDeviceIdentity> UpdateAsync(WindowsAutopilotDeviceIdentity windowsAutopilotDeviceIdentityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WindowsAutopilotDeviceIdentity using PATCH and returns a <see cref="GraphResponse{WindowsAutopilotDeviceIdentity}"/> object.
        /// </summary>
        /// <param name="windowsAutopilotDeviceIdentityToUpdate">The WindowsAutopilotDeviceIdentity to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{WindowsAutopilotDeviceIdentity}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<WindowsAutopilotDeviceIdentity>> UpdateResponseAsync(WindowsAutopilotDeviceIdentity windowsAutopilotDeviceIdentityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WindowsAutopilotDeviceIdentity using PUT.
        /// </summary>
        /// <param name="windowsAutopilotDeviceIdentityToUpdate">The WindowsAutopilotDeviceIdentity object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<WindowsAutopilotDeviceIdentity> PutAsync(WindowsAutopilotDeviceIdentity windowsAutopilotDeviceIdentityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WindowsAutopilotDeviceIdentity using PUT and returns a <see cref="GraphResponse{WindowsAutopilotDeviceIdentity}"/> object.
        /// </summary>
        /// <param name="windowsAutopilotDeviceIdentityToUpdate">The WindowsAutopilotDeviceIdentity object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{WindowsAutopilotDeviceIdentity}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<WindowsAutopilotDeviceIdentity>> PutResponseAsync(WindowsAutopilotDeviceIdentity windowsAutopilotDeviceIdentityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsAutopilotDeviceIdentityRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsAutopilotDeviceIdentityRequest Expand(Expression<Func<WindowsAutopilotDeviceIdentity, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsAutopilotDeviceIdentityRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsAutopilotDeviceIdentityRequest Select(Expression<Func<WindowsAutopilotDeviceIdentity, object>> selectExpression);

    }
}
