// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityCollectionRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IWindowsInformationProtectionExemptAppLockerFilesCollectionRequest.
    /// </summary>
    public partial interface IWindowsInformationProtectionExemptAppLockerFilesCollectionRequest : IBaseRequest
    {
        /// <summary>
        /// Adds the specified WindowsInformationProtectionAppLockerFile to the collection via POST.
        /// </summary>
        /// <param name="windowsInformationProtectionAppLockerFile">The WindowsInformationProtectionAppLockerFile to add.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created WindowsInformationProtectionAppLockerFile.</returns>
        System.Threading.Tasks.Task<WindowsInformationProtectionAppLockerFile> AddAsync(WindowsInformationProtectionAppLockerFile windowsInformationProtectionAppLockerFile, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified WindowsInformationProtectionAppLockerFile to the collection via POST and returns a <see cref="GraphResponse{WindowsInformationProtectionAppLockerFile}"/> object of the request.
        /// </summary>
        /// <param name="windowsInformationProtectionAppLockerFile">The WindowsInformationProtectionAppLockerFile to add.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{WindowsInformationProtectionAppLockerFile}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<WindowsInformationProtectionAppLockerFile>> AddResponseAsync(WindowsInformationProtectionAppLockerFile windowsInformationProtectionAppLockerFile, CancellationToken cancellationToken = default);


        /// <summary>
        /// Gets the collection page.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The collection page.</returns>
        System.Threading.Tasks.Task<IWindowsInformationProtectionExemptAppLockerFilesCollectionPage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the collection page and returns a <see cref="GraphResponse{WindowsInformationProtectionExemptAppLockerFilesCollectionResponse}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{WindowsInformationProtectionExemptAppLockerFilesCollectionResponse}"/> object.</returns>
        System.Threading.Tasks.Task<GraphResponse<WindowsInformationProtectionExemptAppLockerFilesCollectionResponse>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsInformationProtectionExemptAppLockerFilesCollectionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsInformationProtectionExemptAppLockerFilesCollectionRequest Expand(Expression<Func<WindowsInformationProtectionAppLockerFile, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsInformationProtectionExemptAppLockerFilesCollectionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsInformationProtectionExemptAppLockerFilesCollectionRequest Select(Expression<Func<WindowsInformationProtectionAppLockerFile, object>> selectExpression);

        /// <summary>
        /// Adds the specified top value to the request.
        /// </summary>
        /// <param name="value">The top value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsInformationProtectionExemptAppLockerFilesCollectionRequest Top(int value);

        /// <summary>
        /// Adds the specified filter value to the request.
        /// </summary>
        /// <param name="value">The filter value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsInformationProtectionExemptAppLockerFilesCollectionRequest Filter(string value);

        /// <summary>
        /// Adds the specified skip value to the request.
        /// </summary>
        /// <param name="value">The skip value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsInformationProtectionExemptAppLockerFilesCollectionRequest Skip(int value);

        /// <summary>
        /// Adds the specified orderby value to the request.
        /// </summary>
        /// <param name="value">The orderby value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsInformationProtectionExemptAppLockerFilesCollectionRequest OrderBy(string value);
    }
}
