// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IWindowsUpdateForBusinessConfigurationRequest.
    /// </summary>
    public partial interface IWindowsUpdateForBusinessConfigurationRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified WindowsUpdateForBusinessConfiguration using POST.
        /// </summary>
        /// <param name="windowsUpdateForBusinessConfigurationToCreate">The WindowsUpdateForBusinessConfiguration to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created WindowsUpdateForBusinessConfiguration.</returns>
        System.Threading.Tasks.Task<WindowsUpdateForBusinessConfiguration> CreateAsync(WindowsUpdateForBusinessConfiguration windowsUpdateForBusinessConfigurationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified WindowsUpdateForBusinessConfiguration using POST and returns a <see cref="GraphResponse{WindowsUpdateForBusinessConfiguration}"/> object.
        /// </summary>
        /// <param name="windowsUpdateForBusinessConfigurationToCreate">The WindowsUpdateForBusinessConfiguration to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{WindowsUpdateForBusinessConfiguration}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<WindowsUpdateForBusinessConfiguration>> CreateResponseAsync(WindowsUpdateForBusinessConfiguration windowsUpdateForBusinessConfigurationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified WindowsUpdateForBusinessConfiguration.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified WindowsUpdateForBusinessConfiguration and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified WindowsUpdateForBusinessConfiguration.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The WindowsUpdateForBusinessConfiguration.</returns>
        System.Threading.Tasks.Task<WindowsUpdateForBusinessConfiguration> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified WindowsUpdateForBusinessConfiguration and returns a <see cref="GraphResponse{WindowsUpdateForBusinessConfiguration}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{WindowsUpdateForBusinessConfiguration}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<WindowsUpdateForBusinessConfiguration>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WindowsUpdateForBusinessConfiguration using PATCH.
        /// </summary>
        /// <param name="windowsUpdateForBusinessConfigurationToUpdate">The WindowsUpdateForBusinessConfiguration to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated WindowsUpdateForBusinessConfiguration.</returns>
        System.Threading.Tasks.Task<WindowsUpdateForBusinessConfiguration> UpdateAsync(WindowsUpdateForBusinessConfiguration windowsUpdateForBusinessConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WindowsUpdateForBusinessConfiguration using PATCH and returns a <see cref="GraphResponse{WindowsUpdateForBusinessConfiguration}"/> object.
        /// </summary>
        /// <param name="windowsUpdateForBusinessConfigurationToUpdate">The WindowsUpdateForBusinessConfiguration to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{WindowsUpdateForBusinessConfiguration}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<WindowsUpdateForBusinessConfiguration>> UpdateResponseAsync(WindowsUpdateForBusinessConfiguration windowsUpdateForBusinessConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WindowsUpdateForBusinessConfiguration using PUT.
        /// </summary>
        /// <param name="windowsUpdateForBusinessConfigurationToUpdate">The WindowsUpdateForBusinessConfiguration object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<WindowsUpdateForBusinessConfiguration> PutAsync(WindowsUpdateForBusinessConfiguration windowsUpdateForBusinessConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WindowsUpdateForBusinessConfiguration using PUT and returns a <see cref="GraphResponse{WindowsUpdateForBusinessConfiguration}"/> object.
        /// </summary>
        /// <param name="windowsUpdateForBusinessConfigurationToUpdate">The WindowsUpdateForBusinessConfiguration object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{WindowsUpdateForBusinessConfiguration}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<WindowsUpdateForBusinessConfiguration>> PutResponseAsync(WindowsUpdateForBusinessConfiguration windowsUpdateForBusinessConfigurationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsUpdateForBusinessConfigurationRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsUpdateForBusinessConfigurationRequest Expand(Expression<Func<WindowsUpdateForBusinessConfiguration, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsUpdateForBusinessConfigurationRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IWindowsUpdateForBusinessConfigurationRequest Select(Expression<Func<WindowsUpdateForBusinessConfiguration, object>> selectExpression);

    }
}
