// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IWorkbookRequestBuilder.
    /// </summary>
    public partial interface IWorkbookRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IWorkbookRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IWorkbookRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for Application.
        /// </summary>
        /// <returns>The <see cref="IWorkbookApplicationRequestBuilder"/>.</returns>
        IWorkbookApplicationRequestBuilder Application { get; }

        /// <summary>
        /// Gets the request builder for Comments.
        /// </summary>
        /// <returns>The <see cref="IWorkbookCommentsCollectionRequestBuilder"/>.</returns>
        IWorkbookCommentsCollectionRequestBuilder Comments { get; }

        /// <summary>
        /// Gets the request builder for Functions.
        /// </summary>
        /// <returns>The <see cref="IWorkbookFunctionsRequestBuilder"/>.</returns>
        IWorkbookFunctionsRequestBuilder Functions { get; }

        /// <summary>
        /// Gets the request builder for Names.
        /// </summary>
        /// <returns>The <see cref="IWorkbookNamesCollectionRequestBuilder"/>.</returns>
        IWorkbookNamesCollectionRequestBuilder Names { get; }

        /// <summary>
        /// Gets the request builder for Operations.
        /// </summary>
        /// <returns>The <see cref="IWorkbookOperationsCollectionRequestBuilder"/>.</returns>
        IWorkbookOperationsCollectionRequestBuilder Operations { get; }

        /// <summary>
        /// Gets the request builder for Tables.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTablesCollectionRequestBuilder"/>.</returns>
        IWorkbookTablesCollectionRequestBuilder Tables { get; }

        /// <summary>
        /// Gets the request builder for Worksheets.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetsCollectionRequestBuilder"/>.</returns>
        IWorkbookWorksheetsCollectionRequestBuilder Worksheets { get; }
    
        /// <summary>
        /// Gets the request builder for WorkbookCloseSession.
        /// </summary>
        /// <returns>The <see cref="IWorkbookCloseSessionRequestBuilder"/>.</returns>
        IWorkbookCloseSessionRequestBuilder CloseSession();

        /// <summary>
        /// Gets the request builder for WorkbookCreateSession.
        /// </summary>
        /// <returns>The <see cref="IWorkbookCreateSessionRequestBuilder"/>.</returns>
        IWorkbookCreateSessionRequestBuilder CreateSession(
            bool persistChanges);

        /// <summary>
        /// Gets the request builder for WorkbookRefreshSession.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRefreshSessionRequestBuilder"/>.</returns>
        IWorkbookRefreshSessionRequestBuilder RefreshSession();

        /// <summary>
        /// Gets the request builder for WorkbookSessionInfoResource.
        /// </summary>
        /// <returns>The <see cref="IWorkbookSessionInfoResourceRequestBuilder"/>.</returns>
        IWorkbookSessionInfoResourceRequestBuilder SessionInfoResource(
            string key);

        /// <summary>
        /// Gets the request builder for WorkbookTableRowOperationResult.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableRowOperationResultRequestBuilder"/>.</returns>
        IWorkbookTableRowOperationResultRequestBuilder TableRowOperationResult(
            string key);
    
    }
}
