// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IWorkbookWorksheetRequestBuilder.
    /// </summary>
    public partial interface IWorkbookWorksheetRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IWorkbookWorksheetRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IWorkbookWorksheetRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for Charts.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetChartsCollectionRequestBuilder"/>.</returns>
        IWorkbookWorksheetChartsCollectionRequestBuilder Charts { get; }

        /// <summary>
        /// Gets the request builder for Names.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetNamesCollectionRequestBuilder"/>.</returns>
        IWorkbookWorksheetNamesCollectionRequestBuilder Names { get; }

        /// <summary>
        /// Gets the request builder for PivotTables.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetPivotTablesCollectionRequestBuilder"/>.</returns>
        IWorkbookWorksheetPivotTablesCollectionRequestBuilder PivotTables { get; }

        /// <summary>
        /// Gets the request builder for Protection.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetProtectionRequestBuilder"/>.</returns>
        IWorkbookWorksheetProtectionRequestBuilder Protection { get; }

        /// <summary>
        /// Gets the request builder for Tables.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetTablesCollectionRequestBuilder"/>.</returns>
        IWorkbookWorksheetTablesCollectionRequestBuilder Tables { get; }
    
        /// <summary>
        /// Gets the request builder for WorkbookWorksheetCell.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetCellRequestBuilder"/>.</returns>
        IWorkbookWorksheetCellRequestBuilder Cell(
            Int32 row,
            Int32 column);

        /// <summary>
        /// Gets the request builder for WorkbookWorksheetUsedRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetUsedRangeRequestBuilder"/>.</returns>
        IWorkbookWorksheetUsedRangeRequestBuilder UsedRange();

        /// <summary>
        /// Gets the request builder for WorkbookWorksheetUsedRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetUsedRangeRequestBuilder"/>.</returns>
        IWorkbookWorksheetUsedRangeRequestBuilder UsedRange(
            bool valuesOnly);

        /// <summary>
        /// Gets the request builder for WorkbookWorksheetRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetRangeRequestBuilder"/>.</returns>
        IWorkbookWorksheetRangeRequestBuilder Range();

        /// <summary>
        /// Gets the request builder for WorkbookWorksheetRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetRangeRequestBuilder"/>.</returns>
        IWorkbookWorksheetRangeRequestBuilder Range(
            string address = null);
    
    }
}
