// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type IdentityGovernanceRequestBuilder.
    /// </summary>
    public partial class IdentityGovernanceRequestBuilder : BaseRequestBuilder, IIdentityGovernanceRequestBuilder
    {

        /// <summary>
        /// Constructs a new IdentityGovernanceRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public IdentityGovernanceRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IIdentityGovernanceRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IIdentityGovernanceRequest Request(IEnumerable<Option> options)
        {
            return new IdentityGovernanceRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for AccessReviews.
        /// </summary>
        /// <returns>The <see cref="IAccessReviewSetRequestBuilder"/>.</returns>
        public IAccessReviewSetRequestBuilder AccessReviews
        {
            get
            {
                return new AccessReviewSetRequestBuilder(this.AppendSegmentToRequestUrl("accessReviews"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AppConsent.
        /// </summary>
        /// <returns>The <see cref="IAppConsentApprovalRouteRequestBuilder"/>.</returns>
        public IAppConsentApprovalRouteRequestBuilder AppConsent
        {
            get
            {
                return new AppConsentApprovalRouteRequestBuilder(this.AppendSegmentToRequestUrl("appConsent"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for TermsOfUse.
        /// </summary>
        /// <returns>The <see cref="ITermsOfUseContainerRequestBuilder"/>.</returns>
        public ITermsOfUseContainerRequestBuilder TermsOfUse
        {
            get
            {
                return new TermsOfUseContainerRequestBuilder(this.AppendSegmentToRequestUrl("termsOfUse"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for EntitlementManagement.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementRequestBuilder"/>.</returns>
        public IEntitlementManagementRequestBuilder EntitlementManagement
        {
            get
            {
                return new EntitlementManagementRequestBuilder(this.AppendSegmentToRequestUrl("entitlementManagement"), this.Client);
            }
        }
    
    }
}
