// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ListItemVersionRequestBuilder.
    /// </summary>
    public partial class ListItemVersionRequestBuilder : BaseItemVersionRequestBuilder, IListItemVersionRequestBuilder
    {

        /// <summary>
        /// Constructs a new ListItemVersionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ListItemVersionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IListItemVersionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IListItemVersionRequest Request(IEnumerable<Option> options)
        {
            return new ListItemVersionRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Fields.
        /// </summary>
        /// <returns>The <see cref="IFieldValueSetRequestBuilder"/>.</returns>
        public IFieldValueSetRequestBuilder Fields
        {
            get
            {
                return new FieldValueSetRequestBuilder(this.AppendSegmentToRequestUrl("fields"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for ListItemVersionRestoreVersion.
        /// </summary>
        /// <returns>The <see cref="IListItemVersionRestoreVersionRequestBuilder"/>.</returns>
        public IListItemVersionRestoreVersionRequestBuilder RestoreVersion()
        {
            return new ListItemVersionRestoreVersionRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.restoreVersion"),
                this.Client);
        }
    
    }
}
