// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ListRequestBuilder.
    /// </summary>
    public partial class ListRequestBuilder : BaseItemRequestBuilder, IListRequestBuilder
    {

        /// <summary>
        /// Constructs a new ListRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ListRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IListRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IListRequest Request(IEnumerable<Option> options)
        {
            return new ListRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Columns.
        /// </summary>
        /// <returns>The <see cref="IListColumnsCollectionRequestBuilder"/>.</returns>
        public IListColumnsCollectionRequestBuilder Columns
        {
            get
            {
                return new ListColumnsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("columns"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ContentTypes.
        /// </summary>
        /// <returns>The <see cref="IListContentTypesCollectionRequestBuilder"/>.</returns>
        public IListContentTypesCollectionRequestBuilder ContentTypes
        {
            get
            {
                return new ListContentTypesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("contentTypes"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Drive.
        /// </summary>
        /// <returns>The <see cref="IDriveRequestBuilder"/>.</returns>
        public IDriveRequestBuilder Drive
        {
            get
            {
                return new DriveRequestBuilder(this.AppendSegmentToRequestUrl("drive"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Items.
        /// </summary>
        /// <returns>The <see cref="IListItemsCollectionRequestBuilder"/>.</returns>
        public IListItemsCollectionRequestBuilder Items
        {
            get
            {
                return new ListItemsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("items"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Subscriptions.
        /// </summary>
        /// <returns>The <see cref="IListSubscriptionsCollectionRequestBuilder"/>.</returns>
        public IListSubscriptionsCollectionRequestBuilder Subscriptions
        {
            get
            {
                return new ListSubscriptionsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("subscriptions"), this.Client);
            }
        }
    
    }
}
