// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ListSubscriptionsCollectionRequestBuilder.
    /// </summary>
    public partial class ListSubscriptionsCollectionRequestBuilder : BaseRequestBuilder, IListSubscriptionsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ListSubscriptionsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ListSubscriptionsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IListSubscriptionsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IListSubscriptionsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new ListSubscriptionsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ISubscriptionRequestBuilder"/> for the specified ListSubscription.
        /// </summary>
        /// <param name="id">The ID for the ListSubscription.</param>
        /// <returns>The <see cref="ISubscriptionRequestBuilder"/>.</returns>
        public ISubscriptionRequestBuilder this[string id]
        {
            get
            {
                return new SubscriptionRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
