// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ManagedAppPolicyRequestBuilder.
    /// </summary>
    public partial class ManagedAppPolicyRequestBuilder : EntityRequestBuilder, IManagedAppPolicyRequestBuilder
    {

        /// <summary>
        /// Constructs a new ManagedAppPolicyRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ManagedAppPolicyRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IManagedAppPolicyRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IManagedAppPolicyRequest Request(IEnumerable<Option> options)
        {
            return new ManagedAppPolicyRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for ManagedAppPolicyTargetApps.
        /// </summary>
        /// <returns>The <see cref="IManagedAppPolicyTargetAppsRequestBuilder"/>.</returns>
        public IManagedAppPolicyTargetAppsRequestBuilder TargetApps(
            IEnumerable<ManagedMobileApp> apps = null)
        {
            return new ManagedAppPolicyTargetAppsRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.targetApps"),
                this.Client,
                apps);
        }
    
    }
}
