// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ManagedAppRegistrationOperationsCollectionRequestBuilder.
    /// </summary>
    public partial class ManagedAppRegistrationOperationsCollectionRequestBuilder : BaseRequestBuilder, IManagedAppRegistrationOperationsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ManagedAppRegistrationOperationsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ManagedAppRegistrationOperationsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IManagedAppRegistrationOperationsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IManagedAppRegistrationOperationsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new ManagedAppRegistrationOperationsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IManagedAppOperationRequestBuilder"/> for the specified ManagedAppRegistrationManagedAppOperation.
        /// </summary>
        /// <param name="id">The ID for the ManagedAppRegistrationManagedAppOperation.</param>
        /// <returns>The <see cref="IManagedAppOperationRequestBuilder"/>.</returns>
        public IManagedAppOperationRequestBuilder this[string id]
        {
            get
            {
                return new ManagedAppOperationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
