// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type MobileAppRequestBuilder.
    /// </summary>
    public partial class MobileAppRequestBuilder : EntityRequestBuilder, IMobileAppRequestBuilder
    {

        /// <summary>
        /// Constructs a new MobileAppRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public MobileAppRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IMobileAppRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IMobileAppRequest Request(IEnumerable<Option> options)
        {
            return new MobileAppRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Assignments.
        /// </summary>
        /// <returns>The <see cref="IMobileAppAssignmentsCollectionRequestBuilder"/>.</returns>
        public IMobileAppAssignmentsCollectionRequestBuilder Assignments
        {
            get
            {
                return new MobileAppAssignmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("assignments"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Categories.
        /// </summary>
        /// <returns>The <see cref="IMobileAppCategoriesCollectionWithReferencesRequestBuilder"/>.</returns>
        public IMobileAppCategoriesCollectionWithReferencesRequestBuilder Categories
        {
            get
            {
                return new MobileAppCategoriesCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("categories"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for MobileAppAssign.
        /// </summary>
        /// <returns>The <see cref="IMobileAppAssignRequestBuilder"/>.</returns>
        public IMobileAppAssignRequestBuilder Assign(
            IEnumerable<MobileAppAssignment> mobileAppAssignments = null)
        {
            return new MobileAppAssignRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.assign"),
                this.Client,
                mobileAppAssignments);
        }
    
    }
}
