// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type OnenoteRequestBuilder.
    /// </summary>
    public partial class OnenoteRequestBuilder : EntityRequestBuilder, IOnenoteRequestBuilder
    {

        /// <summary>
        /// Constructs a new OnenoteRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public OnenoteRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IOnenoteRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IOnenoteRequest Request(IEnumerable<Option> options)
        {
            return new OnenoteRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Notebooks.
        /// </summary>
        /// <returns>The <see cref="IOnenoteNotebooksCollectionRequestBuilder"/>.</returns>
        public IOnenoteNotebooksCollectionRequestBuilder Notebooks
        {
            get
            {
                return new OnenoteNotebooksCollectionRequestBuilder(this.AppendSegmentToRequestUrl("notebooks"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Operations.
        /// </summary>
        /// <returns>The <see cref="IOnenoteOperationsCollectionRequestBuilder"/>.</returns>
        public IOnenoteOperationsCollectionRequestBuilder Operations
        {
            get
            {
                return new OnenoteOperationsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("operations"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Pages.
        /// </summary>
        /// <returns>The <see cref="IOnenotePagesCollectionRequestBuilder"/>.</returns>
        public IOnenotePagesCollectionRequestBuilder Pages
        {
            get
            {
                return new OnenotePagesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("pages"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Resources.
        /// </summary>
        /// <returns>The <see cref="IOnenoteResourcesCollectionRequestBuilder"/>.</returns>
        public IOnenoteResourcesCollectionRequestBuilder Resources
        {
            get
            {
                return new OnenoteResourcesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("resources"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for SectionGroups.
        /// </summary>
        /// <returns>The <see cref="IOnenoteSectionGroupsCollectionRequestBuilder"/>.</returns>
        public IOnenoteSectionGroupsCollectionRequestBuilder SectionGroups
        {
            get
            {
                return new OnenoteSectionGroupsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("sectionGroups"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Sections.
        /// </summary>
        /// <returns>The <see cref="IOnenoteSectionsCollectionRequestBuilder"/>.</returns>
        public IOnenoteSectionsCollectionRequestBuilder Sections
        {
            get
            {
                return new OnenoteSectionsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("sections"), this.Client);
            }
        }
    
    }
}
