// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PlannerTasksCollectionRequestBuilder.
    /// </summary>
    public partial class PlannerTasksCollectionRequestBuilder : BaseRequestBuilder, IPlannerTasksCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new PlannerTasksCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PlannerTasksCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPlannerTasksCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPlannerTasksCollectionRequest Request(IEnumerable<Option> options)
        {
            return new PlannerTasksCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPlannerTaskRequestBuilder"/> for the specified PlannerPlannerTask.
        /// </summary>
        /// <param name="id">The ID for the PlannerPlannerTask.</param>
        /// <returns>The <see cref="IPlannerTaskRequestBuilder"/>.</returns>
        public IPlannerTaskRequestBuilder this[string id]
        {
            get
            {
                return new PlannerTaskRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
