// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PolicyRootConditionalAccessPoliciesCollectionRequestBuilder.
    /// </summary>
    public partial class PolicyRootConditionalAccessPoliciesCollectionRequestBuilder : BaseRequestBuilder, IPolicyRootConditionalAccessPoliciesCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new PolicyRootConditionalAccessPoliciesCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PolicyRootConditionalAccessPoliciesCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPolicyRootConditionalAccessPoliciesCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPolicyRootConditionalAccessPoliciesCollectionRequest Request(IEnumerable<Option> options)
        {
            return new PolicyRootConditionalAccessPoliciesCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IConditionalAccessPolicyRequestBuilder"/> for the specified PolicyRootConditionalAccessPolicy.
        /// </summary>
        /// <param name="id">The ID for the PolicyRootConditionalAccessPolicy.</param>
        /// <returns>The <see cref="IConditionalAccessPolicyRequestBuilder"/>.</returns>
        public IConditionalAccessPolicyRequestBuilder this[string id]
        {
            get
            {
                return new ConditionalAccessPolicyRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
