// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PolicyRootPermissionGrantPoliciesCollectionRequestBuilder.
    /// </summary>
    public partial class PolicyRootPermissionGrantPoliciesCollectionRequestBuilder : BaseRequestBuilder, IPolicyRootPermissionGrantPoliciesCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new PolicyRootPermissionGrantPoliciesCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PolicyRootPermissionGrantPoliciesCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPolicyRootPermissionGrantPoliciesCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPolicyRootPermissionGrantPoliciesCollectionRequest Request(IEnumerable<Option> options)
        {
            return new PolicyRootPermissionGrantPoliciesCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPermissionGrantPolicyRequestBuilder"/> for the specified PolicyRootPermissionGrantPolicy.
        /// </summary>
        /// <param name="id">The ID for the PolicyRootPermissionGrantPolicy.</param>
        /// <returns>The <see cref="IPermissionGrantPolicyRequestBuilder"/>.</returns>
        public IPermissionGrantPolicyRequestBuilder this[string id]
        {
            get
            {
                return new PermissionGrantPolicyRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
