// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type PresenceSetPresenceRequestBuilder.
    /// </summary>
    public partial class PresenceSetPresenceRequestBuilder : BaseActionMethodRequestBuilder<IPresenceSetPresenceRequest>, IPresenceSetPresenceRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="PresenceSetPresenceRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="availability">A availability parameter for the OData method call.</param>
        /// <param name="activity">A activity parameter for the OData method call.</param>
        /// <param name="sessionId">A sessionId parameter for the OData method call.</param>
        /// <param name="expirationDuration">A expirationDuration parameter for the OData method call.</param>
        public PresenceSetPresenceRequestBuilder(
            string requestUrl,
            IBaseClient client,
            string availability,
            string activity,
            string sessionId,
            Duration expirationDuration)
            : base(requestUrl, client)
        {
            this.SetParameter("availability", availability, false);
            this.SetParameter("activity", activity, false);
            this.SetParameter("sessionId", sessionId, true);
            this.SetParameter("expirationDuration", expirationDuration, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IPresenceSetPresenceRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new PresenceSetPresenceRequest(functionUrl, this.Client, options);

            if (this.HasParameter("availability"))
            {
                request.RequestBody.Availability = this.GetParameter<string>("availability");
            }

            if (this.HasParameter("activity"))
            {
                request.RequestBody.Activity = this.GetParameter<string>("activity");
            }

            if (this.HasParameter("sessionId"))
            {
                request.RequestBody.SessionId = this.GetParameter<string>("sessionId");
            }

            if (this.HasParameter("expirationDuration"))
            {
                request.RequestBody.ExpirationDuration = this.GetParameter<Duration>("expirationDuration");
            }

            return request;
        }
    }
}
