// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PrintConnectorsCollectionRequestBuilder.
    /// </summary>
    public partial class PrintConnectorsCollectionRequestBuilder : BaseRequestBuilder, IPrintConnectorsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new PrintConnectorsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrintConnectorsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPrintConnectorsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPrintConnectorsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new PrintConnectorsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPrintConnectorRequestBuilder"/> for the specified PrintPrintConnector.
        /// </summary>
        /// <param name="id">The ID for the PrintPrintConnector.</param>
        /// <returns>The <see cref="IPrintConnectorRequestBuilder"/>.</returns>
        public IPrintConnectorRequestBuilder this[string id]
        {
            get
            {
                return new PrintConnectorRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
