// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type PrintDocumentRequestBuilder.
    /// </summary>
    public partial class PrintDocumentRequestBuilder : EntityRequestBuilder, IPrintDocumentRequestBuilder
    {

        /// <summary>
        /// Constructs a new PrintDocumentRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrintDocumentRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IPrintDocumentRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IPrintDocumentRequest Request(IEnumerable<Option> options)
        {
            return new PrintDocumentRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Content.
        /// </summary>
        /// <returns>The <see cref="IPrintDocumentContentRequestBuilder"/>.</returns>
        public IPrintDocumentContentRequestBuilder Content
        {
            get
            {
                return new PrintDocumentContentRequestBuilder(this.AppendSegmentToRequestUrl("$value"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for PrintDocumentCreateUploadSession.
        /// </summary>
        /// <returns>The <see cref="IPrintDocumentCreateUploadSessionRequestBuilder"/>.</returns>
        public IPrintDocumentCreateUploadSessionRequestBuilder CreateUploadSession(
            PrintDocumentUploadProperties properties)
        {
            return new PrintDocumentCreateUploadSessionRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.createUploadSession"),
                this.Client,
                properties);
        }
    
    }
}
