// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PrintOperationsCollectionRequestBuilder.
    /// </summary>
    public partial class PrintOperationsCollectionRequestBuilder : BaseRequestBuilder, IPrintOperationsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new PrintOperationsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrintOperationsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPrintOperationsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPrintOperationsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new PrintOperationsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPrintOperationRequestBuilder"/> for the specified PrintPrintOperation.
        /// </summary>
        /// <param name="id">The ID for the PrintPrintOperation.</param>
        /// <returns>The <see cref="IPrintOperationRequestBuilder"/>.</returns>
        public IPrintOperationRequestBuilder this[string id]
        {
            get
            {
                return new PrintOperationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
