// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PrintTaskDefinitionsCollectionRequestBuilder.
    /// </summary>
    public partial class PrintTaskDefinitionsCollectionRequestBuilder : BaseRequestBuilder, IPrintTaskDefinitionsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new PrintTaskDefinitionsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrintTaskDefinitionsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPrintTaskDefinitionsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPrintTaskDefinitionsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new PrintTaskDefinitionsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPrintTaskDefinitionRequestBuilder"/> for the specified PrintPrintTaskDefinition.
        /// </summary>
        /// <param name="id">The ID for the PrintPrintTaskDefinition.</param>
        /// <returns>The <see cref="IPrintTaskDefinitionRequestBuilder"/>.</returns>
        public IPrintTaskDefinitionRequestBuilder this[string id]
        {
            get
            {
                return new PrintTaskDefinitionRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
