// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type PrinterBaseRequestBuilder.
    /// </summary>
    public partial class PrinterBaseRequestBuilder : EntityRequestBuilder, IPrinterBaseRequestBuilder
    {

        /// <summary>
        /// Constructs a new PrinterBaseRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrinterBaseRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IPrinterBaseRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IPrinterBaseRequest Request(IEnumerable<Option> options)
        {
            return new PrinterBaseRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Jobs.
        /// </summary>
        /// <returns>The <see cref="IPrinterBaseJobsCollectionRequestBuilder"/>.</returns>
        public IPrinterBaseJobsCollectionRequestBuilder Jobs
        {
            get
            {
                return new PrinterBaseJobsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("jobs"), this.Client);
            }
        }
    
    }
}
