// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionWithReferencesRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PrinterConnectorsCollectionWithReferencesRequestBuilder.
    /// </summary>
    public partial class PrinterConnectorsCollectionWithReferencesRequestBuilder : BaseRequestBuilder, IPrinterConnectorsCollectionWithReferencesRequestBuilder
    {

        /// <summary>
        /// Constructs a new PrinterConnectorsCollectionWithReferencesRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrinterConnectorsCollectionWithReferencesRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPrinterConnectorsCollectionWithReferencesRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPrinterConnectorsCollectionWithReferencesRequest Request(IEnumerable<Option> options)
        {
            return new PrinterConnectorsCollectionWithReferencesRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPrintConnectorWithReferenceRequestBuilder"/> for the specified PrinterPrintConnector.
        /// </summary>
        /// <param name="id">The ID for the PrinterPrintConnector.</param>
        /// <returns>The <see cref="IPrintConnectorWithReferenceRequestBuilder"/>.</returns>
        public IPrintConnectorWithReferenceRequestBuilder this[string id]
        {
            get
            {
                return new PrintConnectorWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
        /// <summary>
        /// Gets an <see cref="IPrinterConnectorsCollectionReferencesRequestBuilder"/> for the references in the collection.
        /// </summary>
        /// <returns>The <see cref="IPrinterConnectorsCollectionReferencesRequestBuilder"/>.</returns>
        public IPrinterConnectorsCollectionReferencesRequestBuilder References
        {
            get
            {
                return new PrinterConnectorsCollectionReferencesRequestBuilder(this.AppendSegmentToRequestUrl("$ref"), this.Client);
            }
        }

    }
}
