// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ScheduleChangeRequestRequestBuilder.
    /// </summary>
    public partial class ScheduleChangeRequestRequestBuilder : ChangeTrackedEntityRequestBuilder, IScheduleChangeRequestRequestBuilder
    {

        /// <summary>
        /// Constructs a new ScheduleChangeRequestRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ScheduleChangeRequestRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IScheduleChangeRequestRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IScheduleChangeRequestRequest Request(IEnumerable<Option> options)
        {
            return new ScheduleChangeRequestRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for ScheduleChangeRequestDecline.
        /// </summary>
        /// <returns>The <see cref="IScheduleChangeRequestDeclineRequestBuilder"/>.</returns>
        public IScheduleChangeRequestDeclineRequestBuilder Decline(
            string message = null)
        {
            return new ScheduleChangeRequestDeclineRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.decline"),
                this.Client,
                message);
        }

        /// <summary>
        /// Gets the request builder for ScheduleChangeRequestApprove.
        /// </summary>
        /// <returns>The <see cref="IScheduleChangeRequestApproveRequestBuilder"/>.</returns>
        public IScheduleChangeRequestApproveRequestBuilder Approve(
            string message = null)
        {
            return new ScheduleChangeRequestApproveRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.approve"),
                this.Client,
                message);
        }
    
    }
}
