// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type SectionGroupRequestBuilder.
    /// </summary>
    public partial class SectionGroupRequestBuilder : OnenoteEntityHierarchyModelRequestBuilder, ISectionGroupRequestBuilder
    {

        /// <summary>
        /// Constructs a new SectionGroupRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public SectionGroupRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ISectionGroupRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ISectionGroupRequest Request(IEnumerable<Option> options)
        {
            return new SectionGroupRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for ParentNotebook.
        /// </summary>
        /// <returns>The <see cref="INotebookRequestBuilder"/>.</returns>
        public INotebookRequestBuilder ParentNotebook
        {
            get
            {
                return new NotebookRequestBuilder(this.AppendSegmentToRequestUrl("parentNotebook"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ParentSectionGroup.
        /// </summary>
        /// <returns>The <see cref="ISectionGroupRequestBuilder"/>.</returns>
        public ISectionGroupRequestBuilder ParentSectionGroup
        {
            get
            {
                return new SectionGroupRequestBuilder(this.AppendSegmentToRequestUrl("parentSectionGroup"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for SectionGroups.
        /// </summary>
        /// <returns>The <see cref="ISectionGroupSectionGroupsCollectionRequestBuilder"/>.</returns>
        public ISectionGroupSectionGroupsCollectionRequestBuilder SectionGroups
        {
            get
            {
                return new SectionGroupSectionGroupsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("sectionGroups"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Sections.
        /// </summary>
        /// <returns>The <see cref="ISectionGroupSectionsCollectionRequestBuilder"/>.</returns>
        public ISectionGroupSectionsCollectionRequestBuilder Sections
        {
            get
            {
                return new SectionGroupSectionsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("sections"), this.Client);
            }
        }
    
    }
}
