// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ServiceAnnouncementRequestBuilder.
    /// </summary>
    public partial class ServiceAnnouncementRequestBuilder : EntityRequestBuilder, IServiceAnnouncementRequestBuilder
    {

        /// <summary>
        /// Constructs a new ServiceAnnouncementRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ServiceAnnouncementRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IServiceAnnouncementRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IServiceAnnouncementRequest Request(IEnumerable<Option> options)
        {
            return new ServiceAnnouncementRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for HealthOverviews.
        /// </summary>
        /// <returns>The <see cref="IServiceAnnouncementHealthOverviewsCollectionRequestBuilder"/>.</returns>
        public IServiceAnnouncementHealthOverviewsCollectionRequestBuilder HealthOverviews
        {
            get
            {
                return new ServiceAnnouncementHealthOverviewsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("healthOverviews"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Issues.
        /// </summary>
        /// <returns>The <see cref="IServiceAnnouncementIssuesCollectionRequestBuilder"/>.</returns>
        public IServiceAnnouncementIssuesCollectionRequestBuilder Issues
        {
            get
            {
                return new ServiceAnnouncementIssuesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("issues"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Messages.
        /// </summary>
        /// <returns>The <see cref="IServiceAnnouncementMessagesCollectionRequestBuilder"/>.</returns>
        public IServiceAnnouncementMessagesCollectionRequestBuilder Messages
        {
            get
            {
                return new ServiceAnnouncementMessagesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("messages"), this.Client);
            }
        }
    
    }
}
