// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ServicePrincipalRequestBuilder.
    /// </summary>
    public partial class ServicePrincipalRequestBuilder : DirectoryObjectRequestBuilder, IServicePrincipalRequestBuilder
    {

        /// <summary>
        /// Constructs a new ServicePrincipalRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ServicePrincipalRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IServicePrincipalRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IServicePrincipalRequest Request(IEnumerable<Option> options)
        {
            return new ServicePrincipalRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for AppRoleAssignedTo.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalAppRoleAssignedToCollectionRequestBuilder"/>.</returns>
        public IServicePrincipalAppRoleAssignedToCollectionRequestBuilder AppRoleAssignedTo
        {
            get
            {
                return new ServicePrincipalAppRoleAssignedToCollectionRequestBuilder(this.AppendSegmentToRequestUrl("appRoleAssignedTo"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AppRoleAssignments.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalAppRoleAssignmentsCollectionRequestBuilder"/>.</returns>
        public IServicePrincipalAppRoleAssignmentsCollectionRequestBuilder AppRoleAssignments
        {
            get
            {
                return new ServicePrincipalAppRoleAssignmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("appRoleAssignments"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ClaimsMappingPolicies.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalClaimsMappingPoliciesCollectionWithReferencesRequestBuilder"/>.</returns>
        public IServicePrincipalClaimsMappingPoliciesCollectionWithReferencesRequestBuilder ClaimsMappingPolicies
        {
            get
            {
                return new ServicePrincipalClaimsMappingPoliciesCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("claimsMappingPolicies"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for CreatedObjects.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalCreatedObjectsCollectionWithReferencesRequestBuilder"/>.</returns>
        public IServicePrincipalCreatedObjectsCollectionWithReferencesRequestBuilder CreatedObjects
        {
            get
            {
                return new ServicePrincipalCreatedObjectsCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("createdObjects"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for DelegatedPermissionClassifications.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalDelegatedPermissionClassificationsCollectionRequestBuilder"/>.</returns>
        public IServicePrincipalDelegatedPermissionClassificationsCollectionRequestBuilder DelegatedPermissionClassifications
        {
            get
            {
                return new ServicePrincipalDelegatedPermissionClassificationsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("delegatedPermissionClassifications"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Endpoints.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalEndpointsCollectionRequestBuilder"/>.</returns>
        public IServicePrincipalEndpointsCollectionRequestBuilder Endpoints
        {
            get
            {
                return new ServicePrincipalEndpointsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("endpoints"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for HomeRealmDiscoveryPolicies.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalHomeRealmDiscoveryPoliciesCollectionWithReferencesRequestBuilder"/>.</returns>
        public IServicePrincipalHomeRealmDiscoveryPoliciesCollectionWithReferencesRequestBuilder HomeRealmDiscoveryPolicies
        {
            get
            {
                return new ServicePrincipalHomeRealmDiscoveryPoliciesCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("homeRealmDiscoveryPolicies"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for MemberOf.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalMemberOfCollectionWithReferencesRequestBuilder"/>.</returns>
        public IServicePrincipalMemberOfCollectionWithReferencesRequestBuilder MemberOf
        {
            get
            {
                return new ServicePrincipalMemberOfCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("memberOf"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Oauth2PermissionGrants.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalOauth2PermissionGrantsCollectionWithReferencesRequestBuilder"/>.</returns>
        public IServicePrincipalOauth2PermissionGrantsCollectionWithReferencesRequestBuilder Oauth2PermissionGrants
        {
            get
            {
                return new ServicePrincipalOauth2PermissionGrantsCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("oauth2PermissionGrants"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for OwnedObjects.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalOwnedObjectsCollectionWithReferencesRequestBuilder"/>.</returns>
        public IServicePrincipalOwnedObjectsCollectionWithReferencesRequestBuilder OwnedObjects
        {
            get
            {
                return new ServicePrincipalOwnedObjectsCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("ownedObjects"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Owners.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalOwnersCollectionWithReferencesRequestBuilder"/>.</returns>
        public IServicePrincipalOwnersCollectionWithReferencesRequestBuilder Owners
        {
            get
            {
                return new ServicePrincipalOwnersCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("owners"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for TokenIssuancePolicies.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalTokenIssuancePoliciesCollectionWithReferencesRequestBuilder"/>.</returns>
        public IServicePrincipalTokenIssuancePoliciesCollectionWithReferencesRequestBuilder TokenIssuancePolicies
        {
            get
            {
                return new ServicePrincipalTokenIssuancePoliciesCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("tokenIssuancePolicies"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for TokenLifetimePolicies.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalTokenLifetimePoliciesCollectionWithReferencesRequestBuilder"/>.</returns>
        public IServicePrincipalTokenLifetimePoliciesCollectionWithReferencesRequestBuilder TokenLifetimePolicies
        {
            get
            {
                return new ServicePrincipalTokenLifetimePoliciesCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("tokenLifetimePolicies"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for TransitiveMemberOf.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalTransitiveMemberOfCollectionWithReferencesRequestBuilder"/>.</returns>
        public IServicePrincipalTransitiveMemberOfCollectionWithReferencesRequestBuilder TransitiveMemberOf
        {
            get
            {
                return new ServicePrincipalTransitiveMemberOfCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("transitiveMemberOf"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for ServicePrincipalAddKey.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalAddKeyRequestBuilder"/>.</returns>
        public IServicePrincipalAddKeyRequestBuilder AddKey(
            KeyCredential keyCredential,
            string proof,
            PasswordCredential passwordCredential = null)
        {
            return new ServicePrincipalAddKeyRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.addKey"),
                this.Client,
                keyCredential,
                proof,
                passwordCredential);
        }

        /// <summary>
        /// Gets the request builder for ServicePrincipalAddPassword.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalAddPasswordRequestBuilder"/>.</returns>
        public IServicePrincipalAddPasswordRequestBuilder AddPassword(
            PasswordCredential passwordCredential = null)
        {
            return new ServicePrincipalAddPasswordRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.addPassword"),
                this.Client,
                passwordCredential);
        }

        /// <summary>
        /// Gets the request builder for ServicePrincipalRemoveKey.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalRemoveKeyRequestBuilder"/>.</returns>
        public IServicePrincipalRemoveKeyRequestBuilder RemoveKey(
            Guid keyId,
            string proof)
        {
            return new ServicePrincipalRemoveKeyRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.removeKey"),
                this.Client,
                keyId,
                proof);
        }

        /// <summary>
        /// Gets the request builder for ServicePrincipalRemovePassword.
        /// </summary>
        /// <returns>The <see cref="IServicePrincipalRemovePasswordRequestBuilder"/>.</returns>
        public IServicePrincipalRemovePasswordRequestBuilder RemovePassword(
            Guid keyId)
        {
            return new ServicePrincipalRemovePasswordRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.removePassword"),
                this.Client,
                keyId);
        }
    
    }
}
