// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ServiceUpdateMessageMarkReadRequestBuilder.
    /// </summary>
    public partial class ServiceUpdateMessageMarkReadRequestBuilder : BaseActionMethodRequestBuilder<IServiceUpdateMessageMarkReadRequest>, IServiceUpdateMessageMarkReadRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="ServiceUpdateMessageMarkReadRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="messageIds">A messageIds parameter for the OData method call.</param>
        public ServiceUpdateMessageMarkReadRequestBuilder(
            string requestUrl,
            IBaseClient client,
            IEnumerable<string> messageIds)
            : base(requestUrl, client)
        {
            this.SetParameter("messageIds", messageIds, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IServiceUpdateMessageMarkReadRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new ServiceUpdateMessageMarkReadRequest(functionUrl, this.Client, options);

            if (this.HasParameter("messageIds"))
            {
                request.RequestBody.MessageIds = this.GetParameter<IEnumerable<string>>("messageIds");
            }

            return request;
        }
    }
}
