// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ServiceUpdateMessageRequestBuilder.
    /// </summary>
    public partial class ServiceUpdateMessageRequestBuilder : ServiceAnnouncementBaseRequestBuilder, IServiceUpdateMessageRequestBuilder
    {

        /// <summary>
        /// Constructs a new ServiceUpdateMessageRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ServiceUpdateMessageRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IServiceUpdateMessageRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IServiceUpdateMessageRequest Request(IEnumerable<Option> options)
        {
            return new ServiceUpdateMessageRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Attachments.
        /// </summary>
        /// <returns>The <see cref="IServiceUpdateMessageAttachmentsCollectionRequestBuilder"/>.</returns>
        public IServiceUpdateMessageAttachmentsCollectionRequestBuilder Attachments
        {
            get
            {
                return new ServiceUpdateMessageAttachmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("attachments"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for AttachmentsArchive.
        /// </summary>
        /// <returns>The <see cref="IServiceUpdateMessageAttachmentsArchiveRequestBuilder"/>.</returns>
        public IServiceUpdateMessageAttachmentsArchiveRequestBuilder AttachmentsArchive
        {
            get
            {
                return new ServiceUpdateMessageAttachmentsArchiveRequestBuilder(this.AppendSegmentToRequestUrl("attachmentsArchive"), this.Client);
            }
        }
    
        
    
    }
}
