// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type SharedDriveItemRequestBuilder.
    /// </summary>
    public partial class SharedDriveItemRequestBuilder : BaseItemRequestBuilder, ISharedDriveItemRequestBuilder
    {

        /// <summary>
        /// Constructs a new SharedDriveItemRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public SharedDriveItemRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ISharedDriveItemRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ISharedDriveItemRequest Request(IEnumerable<Option> options)
        {
            return new SharedDriveItemRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for DriveItem.
        /// </summary>
        /// <returns>The <see cref="IDriveItemRequestBuilder"/>.</returns>
        public IDriveItemRequestBuilder DriveItem
        {
            get
            {
                return new DriveItemRequestBuilder(this.AppendSegmentToRequestUrl("driveItem"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Items.
        /// </summary>
        /// <returns>The <see cref="ISharedDriveItemItemsCollectionRequestBuilder"/>.</returns>
        public ISharedDriveItemItemsCollectionRequestBuilder Items
        {
            get
            {
                return new SharedDriveItemItemsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("items"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for List.
        /// </summary>
        /// <returns>The <see cref="IListRequestBuilder"/>.</returns>
        public IListRequestBuilder List
        {
            get
            {
                return new ListRequestBuilder(this.AppendSegmentToRequestUrl("list"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ListItem.
        /// </summary>
        /// <returns>The <see cref="IListItemRequestBuilder"/>.</returns>
        public IListItemRequestBuilder ListItem
        {
            get
            {
                return new ListItemRequestBuilder(this.AppendSegmentToRequestUrl("listItem"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Permission.
        /// </summary>
        /// <returns>The <see cref="IPermissionRequestBuilder"/>.</returns>
        public IPermissionRequestBuilder Permission
        {
            get
            {
                return new PermissionRequestBuilder(this.AppendSegmentToRequestUrl("permission"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Root.
        /// </summary>
        /// <returns>The <see cref="IDriveItemRequestBuilder"/>.</returns>
        public IDriveItemRequestBuilder Root
        {
            get
            {
                return new DriveItemRequestBuilder(this.AppendSegmentToRequestUrl("root"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Site.
        /// </summary>
        /// <returns>The <see cref="ISiteRequestBuilder"/>.</returns>
        public ISiteRequestBuilder Site
        {
            get
            {
                return new SiteRequestBuilder(this.AppendSegmentToRequestUrl("site"), this.Client);
            }
        }
    
    }
}
