// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type SiteColumnsCollectionRequestBuilder.
    /// </summary>
    public partial class SiteColumnsCollectionRequestBuilder : BaseRequestBuilder, ISiteColumnsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new SiteColumnsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public SiteColumnsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ISiteColumnsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ISiteColumnsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new SiteColumnsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IColumnDefinitionRequestBuilder"/> for the specified SiteColumnDefinition.
        /// </summary>
        /// <param name="id">The ID for the SiteColumnDefinition.</param>
        /// <returns>The <see cref="IColumnDefinitionRequestBuilder"/>.</returns>
        public IColumnDefinitionRequestBuilder this[string id]
        {
            get
            {
                return new ColumnDefinitionRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
