// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type TargetedManagedAppProtectionRequestBuilder.
    /// </summary>
    public partial class TargetedManagedAppProtectionRequestBuilder : ManagedAppProtectionRequestBuilder, ITargetedManagedAppProtectionRequestBuilder
    {

        /// <summary>
        /// Constructs a new TargetedManagedAppProtectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public TargetedManagedAppProtectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ITargetedManagedAppProtectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ITargetedManagedAppProtectionRequest Request(IEnumerable<Option> options)
        {
            return new TargetedManagedAppProtectionRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Assignments.
        /// </summary>
        /// <returns>The <see cref="ITargetedManagedAppProtectionAssignmentsCollectionRequestBuilder"/>.</returns>
        public ITargetedManagedAppProtectionAssignmentsCollectionRequestBuilder Assignments
        {
            get
            {
                return new TargetedManagedAppProtectionAssignmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("assignments"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for TargetedManagedAppProtectionAssign.
        /// </summary>
        /// <returns>The <see cref="ITargetedManagedAppProtectionAssignRequestBuilder"/>.</returns>
        public ITargetedManagedAppProtectionAssignRequestBuilder Assign(
            IEnumerable<TargetedManagedAppPolicyAssignment> assignments = null)
        {
            return new TargetedManagedAppProtectionAssignRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.assign"),
                this.Client,
                assignments);
        }

        /// <summary>
        /// Gets the request builder for TargetedManagedAppProtectionTargetApps.
        /// </summary>
        /// <returns>The <see cref="ITargetedManagedAppProtectionTargetAppsRequestBuilder"/>.</returns>
        public ITargetedManagedAppProtectionTargetAppsRequestBuilder TargetApps(
            IEnumerable<ManagedMobileApp> apps = null,
            TargetedManagedAppGroupType? appGroupType = null)
        {
            return new TargetedManagedAppProtectionTargetAppsRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.targetApps"),
                this.Client,
                apps,
                appGroupType);
        }
    
    }
}
