// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type TargetedManagedAppProtectionTargetAppsRequestBuilder.
    /// </summary>
    public partial class TargetedManagedAppProtectionTargetAppsRequestBuilder : BaseActionMethodRequestBuilder<ITargetedManagedAppProtectionTargetAppsRequest>, ITargetedManagedAppProtectionTargetAppsRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="TargetedManagedAppProtectionTargetAppsRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="apps">A apps parameter for the OData method call.</param>
        /// <param name="appGroupType">A appGroupType parameter for the OData method call.</param>
        public TargetedManagedAppProtectionTargetAppsRequestBuilder(
            string requestUrl,
            IBaseClient client,
            IEnumerable<ManagedMobileApp> apps,
            TargetedManagedAppGroupType? appGroupType)
            : base(requestUrl, client)
        {
            this.SetParameter("apps", apps, true);
            this.SetParameter("appGroupType", appGroupType, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override ITargetedManagedAppProtectionTargetAppsRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new TargetedManagedAppProtectionTargetAppsRequest(functionUrl, this.Client, options);

            if (this.HasParameter("apps"))
            {
                request.RequestBody.Apps = this.GetParameter<IEnumerable<ManagedMobileApp>>("apps");
            }

            if (this.HasParameter("appGroupType"))
            {
                request.RequestBody.AppGroupType = this.GetParameter<TargetedManagedAppGroupType?>("appGroupType");
            }

            return request;
        }
    }
}
