// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type TrendingRequestBuilder.
    /// </summary>
    public partial class TrendingRequestBuilder : EntityRequestBuilder, ITrendingRequestBuilder
    {

        /// <summary>
        /// Constructs a new TrendingRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public TrendingRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ITrendingRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ITrendingRequest Request(IEnumerable<Option> options)
        {
            return new TrendingRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Resource.
        /// </summary>
        /// <returns>The <see cref="IEntityWithReferenceRequestBuilder"/>.</returns>
        public IEntityWithReferenceRequestBuilder Resource
        {
            get
            {
                return new EntityWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("resource"), this.Client);
            }
        }
    
    }
}
