// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type UserGetMailTipsRequestBuilder.
    /// </summary>
    public partial class UserGetMailTipsRequestBuilder : BaseActionMethodRequestBuilder<IUserGetMailTipsRequest>, IUserGetMailTipsRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="UserGetMailTipsRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="EmailAddresses">A EmailAddresses parameter for the OData method call.</param>
        /// <param name="MailTipsOptions">A MailTipsOptions parameter for the OData method call.</param>
        public UserGetMailTipsRequestBuilder(
            string requestUrl,
            IBaseClient client,
            IEnumerable<string> EmailAddresses,
            MailTipsType? MailTipsOptions)
            : base(requestUrl, client)
        {
            this.SetParameter("emailAddresses", EmailAddresses, false);
            this.SetParameter("mailTipsOptions", MailTipsOptions, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IUserGetMailTipsRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new UserGetMailTipsRequest(functionUrl, this.Client, options);

            if (this.HasParameter("emailAddresses"))
            {
                request.RequestBody.EmailAddresses = this.GetParameter<IEnumerable<string>>("emailAddresses");
            }

            if (this.HasParameter("mailTipsOptions"))
            {
                request.RequestBody.MailTipsOptions = this.GetParameter<MailTipsType?>("mailTipsOptions");
            }

            return request;
        }
    }
}
