// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type UserScopeTeamsAppInstallationRequestBuilder.
    /// </summary>
    public partial class UserScopeTeamsAppInstallationRequestBuilder : TeamsAppInstallationRequestBuilder, IUserScopeTeamsAppInstallationRequestBuilder
    {

        /// <summary>
        /// Constructs a new UserScopeTeamsAppInstallationRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public UserScopeTeamsAppInstallationRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IUserScopeTeamsAppInstallationRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IUserScopeTeamsAppInstallationRequest Request(IEnumerable<Option> options)
        {
            return new UserScopeTeamsAppInstallationRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Chat.
        /// </summary>
        /// <returns>The <see cref="IChatWithReferenceRequestBuilder"/>.</returns>
        public IChatWithReferenceRequestBuilder Chat
        {
            get
            {
                return new ChatWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("chat"), this.Client);
            }
        }
    
    }
}
