// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type UserSendMailRequestBuilder.
    /// </summary>
    public partial class UserSendMailRequestBuilder : BaseActionMethodRequestBuilder<IUserSendMailRequest>, IUserSendMailRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="UserSendMailRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="Message">A Message parameter for the OData method call.</param>
        /// <param name="SaveToSentItems">A SaveToSentItems parameter for the OData method call.</param>
        public UserSendMailRequestBuilder(
            string requestUrl,
            IBaseClient client,
            Message Message,
            bool? SaveToSentItems)
            : base(requestUrl, client)
        {
            this.SetParameter("message", Message, false);
            this.SetParameter("saveToSentItems", SaveToSentItems, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IUserSendMailRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new UserSendMailRequest(functionUrl, this.Client, options);

            if (this.HasParameter("message"))
            {
                request.RequestBody.Message = this.GetParameter<Message>("message");
            }

            if (this.HasParameter("saveToSentItems"))
            {
                request.RequestBody.SaveToSentItems = this.GetParameter<bool?>("saveToSentItems");
            }

            return request;
        }
    }
}
