// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WindowsAutopilotDeviceIdentityUpdateDevicePropertiesRequestBuilder.
    /// </summary>
    public partial class WindowsAutopilotDeviceIdentityUpdateDevicePropertiesRequestBuilder : BaseActionMethodRequestBuilder<IWindowsAutopilotDeviceIdentityUpdateDevicePropertiesRequest>, IWindowsAutopilotDeviceIdentityUpdateDevicePropertiesRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WindowsAutopilotDeviceIdentityUpdateDevicePropertiesRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="userPrincipalName">A userPrincipalName parameter for the OData method call.</param>
        /// <param name="addressableUserName">A addressableUserName parameter for the OData method call.</param>
        /// <param name="groupTag">A groupTag parameter for the OData method call.</param>
        /// <param name="displayName">A displayName parameter for the OData method call.</param>
        public WindowsAutopilotDeviceIdentityUpdateDevicePropertiesRequestBuilder(
            string requestUrl,
            IBaseClient client,
            string userPrincipalName,
            string addressableUserName,
            string groupTag,
            string displayName)
            : base(requestUrl, client)
        {
            this.SetParameter("userPrincipalName", userPrincipalName, true);
            this.SetParameter("addressableUserName", addressableUserName, true);
            this.SetParameter("groupTag", groupTag, true);
            this.SetParameter("displayName", displayName, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWindowsAutopilotDeviceIdentityUpdateDevicePropertiesRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WindowsAutopilotDeviceIdentityUpdateDevicePropertiesRequest(functionUrl, this.Client, options);

            if (this.HasParameter("userPrincipalName"))
            {
                request.RequestBody.UserPrincipalName = this.GetParameter<string>("userPrincipalName");
            }

            if (this.HasParameter("addressableUserName"))
            {
                request.RequestBody.AddressableUserName = this.GetParameter<string>("addressableUserName");
            }

            if (this.HasParameter("groupTag"))
            {
                request.RequestBody.GroupTag = this.GetParameter<string>("groupTag");
            }

            if (this.HasParameter("displayName"))
            {
                request.RequestBody.DisplayName = this.GetParameter<string>("displayName");
            }

            return request;
        }
    }
}
