// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookApplicationRequestBuilder.
    /// </summary>
    public partial class WorkbookApplicationRequestBuilder : EntityRequestBuilder, IWorkbookApplicationRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookApplicationRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookApplicationRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookApplicationRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookApplicationRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookApplicationRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for WorkbookApplicationCalculate.
        /// </summary>
        /// <returns>The <see cref="IWorkbookApplicationCalculateRequestBuilder"/>.</returns>
        public IWorkbookApplicationCalculateRequestBuilder Calculate(
            string calculationType)
        {
            return new WorkbookApplicationCalculateRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.calculate"),
                this.Client,
                calculationType);
        }
    
    }
}
