// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookChartAxisRequestBuilder.
    /// </summary>
    public partial class WorkbookChartAxisRequestBuilder : EntityRequestBuilder, IWorkbookChartAxisRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookChartAxisRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookChartAxisRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookChartAxisRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookChartAxisRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookChartAxisRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Format.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartAxisFormatRequestBuilder"/>.</returns>
        public IWorkbookChartAxisFormatRequestBuilder Format
        {
            get
            {
                return new WorkbookChartAxisFormatRequestBuilder(this.AppendSegmentToRequestUrl("format"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for MajorGridlines.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartGridlinesRequestBuilder"/>.</returns>
        public IWorkbookChartGridlinesRequestBuilder MajorGridlines
        {
            get
            {
                return new WorkbookChartGridlinesRequestBuilder(this.AppendSegmentToRequestUrl("majorGridlines"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for MinorGridlines.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartGridlinesRequestBuilder"/>.</returns>
        public IWorkbookChartGridlinesRequestBuilder MinorGridlines
        {
            get
            {
                return new WorkbookChartGridlinesRequestBuilder(this.AppendSegmentToRequestUrl("minorGridlines"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Title.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartAxisTitleRequestBuilder"/>.</returns>
        public IWorkbookChartAxisTitleRequestBuilder Title
        {
            get
            {
                return new WorkbookChartAxisTitleRequestBuilder(this.AppendSegmentToRequestUrl("title"), this.Client);
            }
        }
    
    }
}
