// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookChartFillRequestBuilder.
    /// </summary>
    public partial class WorkbookChartFillRequestBuilder : EntityRequestBuilder, IWorkbookChartFillRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookChartFillRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookChartFillRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookChartFillRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookChartFillRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookChartFillRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for WorkbookChartFillClear.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartFillClearRequestBuilder"/>.</returns>
        public IWorkbookChartFillClearRequestBuilder Clear()
        {
            return new WorkbookChartFillClearRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.clear"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookChartFillSetSolidColor.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartFillSetSolidColorRequestBuilder"/>.</returns>
        public IWorkbookChartFillSetSolidColorRequestBuilder SetSolidColor(
            string color = null)
        {
            return new WorkbookChartFillSetSolidColorRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.setSolidColor"),
                this.Client,
                color);
        }
    
    }
}
