// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFilterApplyCustomFilterRequestBuilder.
    /// </summary>
    public partial class WorkbookFilterApplyCustomFilterRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFilterApplyCustomFilterRequest>, IWorkbookFilterApplyCustomFilterRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFilterApplyCustomFilterRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="oper">A oper parameter for the OData method call.</param>
        /// <param name="criteria1">A criteria1 parameter for the OData method call.</param>
        /// <param name="criteria2">A criteria2 parameter for the OData method call.</param>
        public WorkbookFilterApplyCustomFilterRequestBuilder(
            string requestUrl,
            IBaseClient client,
            string oper,
            string criteria1,
            string criteria2)
            : base(requestUrl, client)
        {
            this.SetParameter("oper", oper, false);
            this.SetParameter("criteria1", criteria1, true);
            this.SetParameter("criteria2", criteria2, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFilterApplyCustomFilterRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFilterApplyCustomFilterRequest(functionUrl, this.Client, options);

            if (this.HasParameter("oper"))
            {
                request.RequestBody.Oper = this.GetParameter<string>("oper");
            }

            if (this.HasParameter("criteria1"))
            {
                request.RequestBody.Criteria1 = this.GetParameter<string>("criteria1");
            }

            if (this.HasParameter("criteria2"))
            {
                request.RequestBody.Criteria2 = this.GetParameter<string>("criteria2");
            }

            return request;
        }
    }
}
