// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsAtan2RequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsAtan2RequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsAtan2Request>, IWorkbookFunctionsAtan2RequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsAtan2RequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="xNum">A xNum parameter for the OData method call.</param>
        /// <param name="yNum">A yNum parameter for the OData method call.</param>
        public WorkbookFunctionsAtan2RequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument xNum,
            System.Text.Json.JsonDocument yNum)
            : base(requestUrl, client)
        {
            this.SetParameter("xNum", xNum, true);
            this.SetParameter("yNum", yNum, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsAtan2Request CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsAtan2Request(functionUrl, this.Client, options);

            if (this.HasParameter("xNum"))
            {
                request.RequestBody.XNum = this.GetParameter<System.Text.Json.JsonDocument>("xNum");
            }

            if (this.HasParameter("yNum"))
            {
                request.RequestBody.YNum = this.GetParameter<System.Text.Json.JsonDocument>("yNum");
            }

            return request;
        }
    }
}
