// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsBesselJRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsBesselJRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsBesselJRequest>, IWorkbookFunctionsBesselJRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsBesselJRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="x">A x parameter for the OData method call.</param>
        /// <param name="n">A n parameter for the OData method call.</param>
        public WorkbookFunctionsBesselJRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument x,
            System.Text.Json.JsonDocument n)
            : base(requestUrl, client)
        {
            this.SetParameter("x", x, true);
            this.SetParameter("n", n, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsBesselJRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsBesselJRequest(functionUrl, this.Client, options);

            if (this.HasParameter("x"))
            {
                request.RequestBody.X = this.GetParameter<System.Text.Json.JsonDocument>("x");
            }

            if (this.HasParameter("n"))
            {
                request.RequestBody.N = this.GetParameter<System.Text.Json.JsonDocument>("n");
            }

            return request;
        }
    }
}
