// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsBitandRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsBitandRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsBitandRequest>, IWorkbookFunctionsBitandRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsBitandRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="number1">A number1 parameter for the OData method call.</param>
        /// <param name="number2">A number2 parameter for the OData method call.</param>
        public WorkbookFunctionsBitandRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument number1,
            System.Text.Json.JsonDocument number2)
            : base(requestUrl, client)
        {
            this.SetParameter("number1", number1, true);
            this.SetParameter("number2", number2, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsBitandRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsBitandRequest(functionUrl, this.Client, options);

            if (this.HasParameter("number1"))
            {
                request.RequestBody.Number1 = this.GetParameter<System.Text.Json.JsonDocument>("number1");
            }

            if (this.HasParameter("number2"))
            {
                request.RequestBody.Number2 = this.GetParameter<System.Text.Json.JsonDocument>("number2");
            }

            return request;
        }
    }
}
