// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsComplexRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsComplexRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsComplexRequest>, IWorkbookFunctionsComplexRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsComplexRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="realNum">A realNum parameter for the OData method call.</param>
        /// <param name="iNum">A iNum parameter for the OData method call.</param>
        /// <param name="suffix">A suffix parameter for the OData method call.</param>
        public WorkbookFunctionsComplexRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument realNum,
            System.Text.Json.JsonDocument iNum,
            System.Text.Json.JsonDocument suffix)
            : base(requestUrl, client)
        {
            this.SetParameter("realNum", realNum, true);
            this.SetParameter("iNum", iNum, true);
            this.SetParameter("suffix", suffix, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsComplexRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsComplexRequest(functionUrl, this.Client, options);

            if (this.HasParameter("realNum"))
            {
                request.RequestBody.RealNum = this.GetParameter<System.Text.Json.JsonDocument>("realNum");
            }

            if (this.HasParameter("iNum"))
            {
                request.RequestBody.INum = this.GetParameter<System.Text.Json.JsonDocument>("iNum");
            }

            if (this.HasParameter("suffix"))
            {
                request.RequestBody.Suffix = this.GetParameter<System.Text.Json.JsonDocument>("suffix");
            }

            return request;
        }
    }
}
