// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsDateRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsDateRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsDateRequest>, IWorkbookFunctionsDateRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsDateRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="year">A year parameter for the OData method call.</param>
        /// <param name="month">A month parameter for the OData method call.</param>
        /// <param name="day">A day parameter for the OData method call.</param>
        public WorkbookFunctionsDateRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument year,
            System.Text.Json.JsonDocument month,
            System.Text.Json.JsonDocument day)
            : base(requestUrl, client)
        {
            this.SetParameter("year", year, true);
            this.SetParameter("month", month, true);
            this.SetParameter("day", day, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsDateRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsDateRequest(functionUrl, this.Client, options);

            if (this.HasParameter("year"))
            {
                request.RequestBody.Year = this.GetParameter<System.Text.Json.JsonDocument>("year");
            }

            if (this.HasParameter("month"))
            {
                request.RequestBody.Month = this.GetParameter<System.Text.Json.JsonDocument>("month");
            }

            if (this.HasParameter("day"))
            {
                request.RequestBody.Day = this.GetParameter<System.Text.Json.JsonDocument>("day");
            }

            return request;
        }
    }
}
