// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsFindBRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsFindBRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsFindBRequest>, IWorkbookFunctionsFindBRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsFindBRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="findText">A findText parameter for the OData method call.</param>
        /// <param name="withinText">A withinText parameter for the OData method call.</param>
        /// <param name="startNum">A startNum parameter for the OData method call.</param>
        public WorkbookFunctionsFindBRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument findText,
            System.Text.Json.JsonDocument withinText,
            System.Text.Json.JsonDocument startNum)
            : base(requestUrl, client)
        {
            this.SetParameter("findText", findText, true);
            this.SetParameter("withinText", withinText, true);
            this.SetParameter("startNum", startNum, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsFindBRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsFindBRequest(functionUrl, this.Client, options);

            if (this.HasParameter("findText"))
            {
                request.RequestBody.FindText = this.GetParameter<System.Text.Json.JsonDocument>("findText");
            }

            if (this.HasParameter("withinText"))
            {
                request.RequestBody.WithinText = this.GetParameter<System.Text.Json.JsonDocument>("withinText");
            }

            if (this.HasParameter("startNum"))
            {
                request.RequestBody.StartNum = this.GetParameter<System.Text.Json.JsonDocument>("startNum");
            }

            return request;
        }
    }
}
