// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsLookupRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsLookupRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsLookupRequest>, IWorkbookFunctionsLookupRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsLookupRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="lookupValue">A lookupValue parameter for the OData method call.</param>
        /// <param name="lookupVector">A lookupVector parameter for the OData method call.</param>
        /// <param name="resultVector">A resultVector parameter for the OData method call.</param>
        public WorkbookFunctionsLookupRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument lookupValue,
            System.Text.Json.JsonDocument lookupVector,
            System.Text.Json.JsonDocument resultVector)
            : base(requestUrl, client)
        {
            this.SetParameter("lookupValue", lookupValue, true);
            this.SetParameter("lookupVector", lookupVector, true);
            this.SetParameter("resultVector", resultVector, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsLookupRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsLookupRequest(functionUrl, this.Client, options);

            if (this.HasParameter("lookupValue"))
            {
                request.RequestBody.LookupValue = this.GetParameter<System.Text.Json.JsonDocument>("lookupValue");
            }

            if (this.HasParameter("lookupVector"))
            {
                request.RequestBody.LookupVector = this.GetParameter<System.Text.Json.JsonDocument>("lookupVector");
            }

            if (this.HasParameter("resultVector"))
            {
                request.RequestBody.ResultVector = this.GetParameter<System.Text.Json.JsonDocument>("resultVector");
            }

            return request;
        }
    }
}
