// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsMirrRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsMirrRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsMirrRequest>, IWorkbookFunctionsMirrRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsMirrRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="values">A values parameter for the OData method call.</param>
        /// <param name="financeRate">A financeRate parameter for the OData method call.</param>
        /// <param name="reinvestRate">A reinvestRate parameter for the OData method call.</param>
        public WorkbookFunctionsMirrRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument values,
            System.Text.Json.JsonDocument financeRate,
            System.Text.Json.JsonDocument reinvestRate)
            : base(requestUrl, client)
        {
            this.SetParameter("values", values, true);
            this.SetParameter("financeRate", financeRate, true);
            this.SetParameter("reinvestRate", reinvestRate, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsMirrRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsMirrRequest(functionUrl, this.Client, options);

            if (this.HasParameter("values"))
            {
                request.RequestBody.Values = this.GetParameter<System.Text.Json.JsonDocument>("values");
            }

            if (this.HasParameter("financeRate"))
            {
                request.RequestBody.FinanceRate = this.GetParameter<System.Text.Json.JsonDocument>("financeRate");
            }

            if (this.HasParameter("reinvestRate"))
            {
                request.RequestBody.ReinvestRate = this.GetParameter<System.Text.Json.JsonDocument>("reinvestRate");
            }

            return request;
        }
    }
}
