// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsRowsRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsRowsRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsRowsRequest>, IWorkbookFunctionsRowsRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsRowsRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="array">A array parameter for the OData method call.</param>
        public WorkbookFunctionsRowsRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument array)
            : base(requestUrl, client)
        {
            this.SetParameter("array", array, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsRowsRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsRowsRequest(functionUrl, this.Client, options);

            if (this.HasParameter("array"))
            {
                request.RequestBody.Array = this.GetParameter<System.Text.Json.JsonDocument>("array");
            }

            return request;
        }
    }
}
