// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookNamedItemAddFormulaLocalRequestBuilder.
    /// </summary>
    public partial class WorkbookNamedItemAddFormulaLocalRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookNamedItemAddFormulaLocalRequest>, IWorkbookNamedItemAddFormulaLocalRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookNamedItemAddFormulaLocalRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="name">A name parameter for the OData method call.</param>
        /// <param name="formula">A formula parameter for the OData method call.</param>
        /// <param name="comment">A comment parameter for the OData method call.</param>
        public WorkbookNamedItemAddFormulaLocalRequestBuilder(
            string requestUrl,
            IBaseClient client,
            string name,
            string formula,
            string comment)
            : base(requestUrl, client)
        {
            this.SetParameter("name", name, true);
            this.SetParameter("formula", formula, true);
            this.SetParameter("comment", comment, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookNamedItemAddFormulaLocalRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookNamedItemAddFormulaLocalRequest(functionUrl, this.Client, options);

            if (this.HasParameter("name"))
            {
                request.RequestBody.Name = this.GetParameter<string>("name");
            }

            if (this.HasParameter("formula"))
            {
                request.RequestBody.Formula = this.GetParameter<string>("formula");
            }

            if (this.HasParameter("comment"))
            {
                request.RequestBody.Comment = this.GetParameter<string>("comment");
            }

            return request;
        }
    }
}
