// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type WorkbookOperationsCollectionRequestBuilder.
    /// </summary>
    public partial class WorkbookOperationsCollectionRequestBuilder : BaseRequestBuilder, IWorkbookOperationsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new WorkbookOperationsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookOperationsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IWorkbookOperationsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IWorkbookOperationsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookOperationsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IWorkbookOperationRequestBuilder"/> for the specified WorkbookWorkbookOperation.
        /// </summary>
        /// <param name="id">The ID for the WorkbookWorkbookOperation.</param>
        /// <returns>The <see cref="IWorkbookOperationRequestBuilder"/>.</returns>
        public IWorkbookOperationRequestBuilder this[string id]
        {
            get
            {
                return new WorkbookOperationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
