// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookRangeSortRequestBuilder.
    /// </summary>
    public partial class WorkbookRangeSortRequestBuilder : EntityRequestBuilder, IWorkbookRangeSortRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookRangeSortRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookRangeSortRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookRangeSortRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookRangeSortRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookRangeSortRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for WorkbookRangeSortApply.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeSortApplyRequestBuilder"/>.</returns>
        public IWorkbookRangeSortApplyRequestBuilder Apply(
            bool matchCase,
            bool hasHeaders,
            string orientation,
            string method,
            IEnumerable<WorkbookSortField> fields = null)
        {
            return new WorkbookRangeSortApplyRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.apply"),
                this.Client,
                matchCase,
                hasHeaders,
                orientation,
                method,
                fields);
        }
    
    }
}
