// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookRangeVisibleViewRequestBuilder.
    /// </summary>
    public partial class WorkbookRangeVisibleViewRequestBuilder : BaseFunctionMethodRequestBuilder<IWorkbookRangeVisibleViewRequest>, IWorkbookRangeVisibleViewRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookRangeVisibleViewRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookRangeVisibleViewRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
            this.SetFunctionParameters();
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookRangeVisibleViewRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookRangeVisibleViewRequest(functionUrl, this.Client, options);

            return request;
        }
        /// <summary>
        /// Gets the request builder for WorkbookRangeViewItemAtRequestBuilder.
        /// </summary>
        /// <param name="index">A index parameter for the OData method call.</param>
        /// <returns>The <see cref="IWorkbookRangeViewItemAtRequestBuilder"/>.</returns>
        public IWorkbookRangeViewItemAtRequestBuilder ItemAt(
            Int32 index)
        {
            return new WorkbookRangeViewItemAtRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.itemAt"),
                this.Client,
                index);
        }
        /// <summary>
        /// Gets the request builder for WorkbookRangeViewRangeRequestBuilder.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeViewRangeRequestBuilder"/>.</returns>
        public IWorkbookRangeViewRangeRequestBuilder Range()
        {
            return new WorkbookRangeViewRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.range"),
                this.Client);
        }
        /// <summary>
        /// Gets the request builder for Rows.
        /// Represents a collection of range views associated with the range. Read-only. Read-only.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeViewRequestBuilder"/>.</returns>
        public IWorkbookRangeViewRequestBuilder Rows
        {
            get
            {
                return new WorkbookRangeViewRequestBuilder(this.AppendSegmentToRequestUrl("rows"), this.Client);
            }
        }
    }
}
