// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookTableColumnRequestBuilder.
    /// </summary>
    public partial class WorkbookTableColumnRequestBuilder : EntityRequestBuilder, IWorkbookTableColumnRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookTableColumnRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookTableColumnRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookTableColumnRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookTableColumnRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookTableColumnRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Filter.
        /// </summary>
        /// <returns>The <see cref="IWorkbookFilterRequestBuilder"/>.</returns>
        public IWorkbookFilterRequestBuilder Filter
        {
            get
            {
                return new WorkbookFilterRequestBuilder(this.AppendSegmentToRequestUrl("filter"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for WorkbookTableColumnDataBodyRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableColumnDataBodyRangeRequestBuilder"/>.</returns>
        public IWorkbookTableColumnDataBodyRangeRequestBuilder DataBodyRange()
        {
            return new WorkbookTableColumnDataBodyRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.dataBodyRange"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookTableColumnHeaderRowRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableColumnHeaderRowRangeRequestBuilder"/>.</returns>
        public IWorkbookTableColumnHeaderRowRangeRequestBuilder HeaderRowRange()
        {
            return new WorkbookTableColumnHeaderRowRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.headerRowRange"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookTableColumnRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableColumnRangeRequestBuilder"/>.</returns>
        public IWorkbookTableColumnRangeRequestBuilder Range()
        {
            return new WorkbookTableColumnRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.range"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookTableColumnTotalRowRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableColumnTotalRowRangeRequestBuilder"/>.</returns>
        public IWorkbookTableColumnTotalRowRangeRequestBuilder TotalRowRange()
        {
            return new WorkbookTableColumnTotalRowRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.totalRowRange"),
                this.Client);
        }
    
    }
}
