// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph.TermStore
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Relation.
    /// </summary>
    [JsonConverter(typeof(Microsoft.Graph.DerivedTypeConverter<Relation>))]
    public partial class Relation : Microsoft.Graph.Entity
    {
    
        /// <summary>
        /// Gets or sets relationship.
        /// The type of relation. Possible values are: pin, reuse.
        /// </summary>
        [JsonPropertyName("relationship")]
        public RelationType? Relationship { get; set; }
    
        /// <summary>
        /// Gets or sets from term.
        /// The from [term] of the relation. The term from which the relationship is defined. A null value would indicate the relation is directly with the [set].
        /// </summary>
        [JsonPropertyName("fromTerm")]
        public Term FromTerm { get; set; }
    
        /// <summary>
        /// Gets or sets set.
        /// The [set] in which the relation is relevant.
        /// </summary>
        [JsonPropertyName("set")]
        public Set Set { get; set; }
    
        /// <summary>
        /// Gets or sets to term.
        /// The to [term] of the relation. The term to which the relationship is defined.
        /// </summary>
        [JsonPropertyName("toTerm")]
        public Term ToTerm { get; set; }
    
    }
}

