// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph.TermStore
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface ISetRequest.
    /// </summary>
    public partial interface ISetRequest : Microsoft.Graph.IBaseRequest
    {
        /// <summary>
        /// Creates the specified Set using POST.
        /// </summary>
        /// <param name="setToCreate">The Set to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Set.</returns>
        System.Threading.Tasks.Task<Set> CreateAsync(Set setToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Set using POST and returns a <see cref="GraphResponse{Set}"/> object.
        /// </summary>
        /// <param name="setToCreate">The Set to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Set}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Set>> CreateResponseAsync(Set setToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Set.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Set and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Set.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Set.</returns>
        System.Threading.Tasks.Task<Set> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Set and returns a <see cref="GraphResponse{Set}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Set}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Set>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Set using PATCH.
        /// </summary>
        /// <param name="setToUpdate">The Set to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="Microsoft.Graph.ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Set.</returns>
        System.Threading.Tasks.Task<Set> UpdateAsync(Set setToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Set using PATCH and returns a <see cref="GraphResponse{Set}"/> object.
        /// </summary>
        /// <param name="setToUpdate">The Set to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="Microsoft.Graph.ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Set}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Set>> UpdateResponseAsync(Set setToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Set using PUT.
        /// </summary>
        /// <param name="setToUpdate">The Set object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Set> PutAsync(Set setToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Set using PUT and returns a <see cref="GraphResponse{Set}"/> object.
        /// </summary>
        /// <param name="setToUpdate">The Set object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Set}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Set>> PutResponseAsync(Set setToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        ISetRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        ISetRequest Expand(Expression<Func<Set, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        ISetRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        ISetRequest Select(Expression<Func<Set, object>> selectExpression);

    }
}
